#include "main-scene.h"
#include "scene/text.h"

// sub scenes

#include "odyssee/scene-odyssee.h"
#include "objects/scene-text-3d.h"
#include "objects/background-scene.h"
#include "odyssee/scene-3.h"
#include "odyssee/scene-1.h"
#include "odyssee/scene-2.h"
#include "odyssee/scene-0.h"
#include "odyssee/scene-text.h"
#include "objects/movie-scene.h"
#include "objects/image-scene.h"
#include "objects/plane-scene.h"
#include "objects/image.h"
#include "lectures/scene-test.h"


#include "lectures/lecture-imm.h"
#include "lectures/lecture-eca.h"

//
// Globals
//





//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
static int testmode = 0;

main_scene::main_scene() 
{


//fullscreen = 0;
fullscreen = 0;



count = 2;
_exclude[0] = 0;
_exclude[1] = 0;
_exclude[2] = 1;
_exclude[3] = 1; 
_exclude[4] = 1; 
_exclude[5] = 1;

loop = 1;
end(120);

//scenes[1] = new scene_1();
//scenes[1] = new scene_text_3d();
//scenes[1] = new scene_odyssee();
scenes[1] = new lecture_imm();

//scenes[1] = new plane_scene();
//scenes[1] = new scene_test();
scenes[0] = new background_scene();

//scenes[0] = new image();
//scenes[0]->translation(0.0f,0.61f,3.0f);
//scenes[0]->scale(1.5,1.5,1.5);
//scenes[0]->translation(0,0,2);
//scenes[2] = new scene_text(24);
/*
scenes[2] = new movie_scene(".\\pictures\\life","life",1,5);
//scenes[2] = new image_scene();
scenes[2]->scale(0.4f,0.4f,0.4f);
scenes[2]->translation(0.0f,0.5f,-2.0f);
scenes[2]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
scenes[2]->mode(0); // 0 = absolute
scenes[2]->rate(0.5);
*/
}

main_scene::~main_scene()
{
//delete scenes[];
}

HRESULT 
main_scene::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	// anything else ?

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
main_scene::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	if (1) {
	
	D3DXMATRIXA16 matWorld;
	D3DXMatrixIdentity( &matWorld );
	device->SetTransform(D3DTS_WORLD,&matWorld);

    // Set up our view matrix. A view matrix can be defined given an eye point,
    // a point to lookat, and a direction for which way is up. Here, we set the
    // eye five units back along the z-axis and up three units, look at the
    // origin, and define "up" to be in the y-direction.
    
	//D3DXVECTOR3 vEyePt( 0.0f, 3.0f,-5.0f );
	D3DXVECTOR3 vEyePt( 0.0f, 3.0f,-4.0f );

    D3DXVECTOR3 vLookatPt( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );
    D3DXMATRIXA16 matView;
    D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &vUpVec );
    device->SetTransform( D3DTS_VIEW, &matView );

    // For the projection matrix, we set up a perspective transform (which
    // transforms geometry from 3D view space to 2D viewport space, with
    // a perspective divide making objects smaller in the distance). To build
    // a perpsective transform, we need the field of view (1/4 pi is common),
    // the aspect ratio, and the near and far clipping planes (which define at
    // what distances geometry should be no longer be rendered).
    D3DXMATRIXA16 matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 100.0f );
    device->SetTransform( D3DTS_PROJECTION, &matProj );
    }



    return hr;
}


HRESULT 
main_scene::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

		// Render
		//

	//	Device->Clear(0, 0, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, 0xffffffff, 1.0f, 0);
	//	Device->BeginScene();

		


	restore(device);

	render_begin(device);

	// begin the main_scene

	double xtime = current();
/*
	if (xtime < 1.0) scenes[0]->Render(device,texture); 
	else if (xtime > 1.0 && xtime < 30.0) scenes[1]->Render(device,texture);
	else if (xtime > 30) scenes[0]->Render(device,texture);
*/
    

if (0) {
	if (xtime < 20.0) {
		_exclude[0]=0;
		_exclude[1]=0;
		_exclude[2]=1;
	} else if (xtime > 20.0 && xtime < 50.0) {
		_exclude[0]=0;
		_exclude[1]=0;
		_exclude[2]=0;
	} else if (xtime > 50) {
		_exclude[0]=0;
		_exclude[1]=0;
		_exclude[2]=1;
	}
}
	
    //scenes[0]->draw(device,texture);
	hr = scene::render(device,texture); // calls restore, compose, render
    
	char buf[256];
	sprintf(buf,"time: %3.1f (%2.1f)",current(), fps());
	if (testmode) message(50,500,0xff1ff1ff0,buf);

	render_end(device);

 
    return hr;
}

/*

  // don t bother, is inherited as is

void
main_scene::rectangle( float fTU, float fTV )
{
	m_fTU = fTU;
	m_fTV = fTV;
    
	for (int i=0; i < count; i++) {
            scenes[i]->rectangle(fTU,fTV);
	}
	

}
*/
