//------------------------------------------------------------------------------
// File: vmr9allocator.cpp
//
// Desc: DirectShow sample code - main implementation file
//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//------------------------------------------------------------------------------


#pragma warning(disable: 4710)  // "function not inlined"

#include <hush/source.h>
#include "vmr/stdafx.h"
#include "vmr/resource.h"
//#include "util.h"
//#include "allocator.h"

#include "vmr/vmrutil.h"
#include <vip.h>
//#include <scene/find.h>
//#include "scene/scene.h"
#include "main/main-scene.h"
#include "main-win32.h"
#include "winuser.h"

#define MAX_LOADSTRING 100

static int vip_on = 0;

//int IO::silent = 0;
// Global Variables:
HINSTANCE hInst;                       
TCHAR szTitle[MAX_LOADSTRING];         
TCHAR szWindowClass[MAX_LOADSTRING];  

extern void doit();



// Forward declarations of functions included in this code module:
BOOL                MyRegisterClass(HINSTANCE hInstance);
BOOL                InitInstance(HINSTANCE, int, HWND& );
void                PaintWindow(HWND hWnd);
LRESULT CALLBACK    WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK    About(HWND, UINT, WPARAM, LPARAM);
HRESULT             StartGraph(HWND window);
HRESULT             CloseGraph(HWND window);

//HRESULT             SetAllocatorPresenter( CComPtr<IBaseFilter> filter, HWND window );

//DWORD_PTR                       g_userId = 0xACDCACDC;
HWND                            g_hWnd;

// DirectShow interfaces
//extern CComPtr<IGraphBuilder>          g_graph;
//extern CComPtr<IBaseFilter>            g_filter;
extern CComPtr<IMediaControl>          g_mediaControl;
//extern CComPtr<IVMRSurfaceAllocator9>  g_allocator;


#ifndef MULTI
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
    int ret = -1;

	vip_on = 1;

    CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
	//CoInitialize(NULL); //, COINIT_APARTMENTTHREADED);

    // Verify that the VMR9 is present on this system
    if(!VerifyVMR9())
    {
        CoUninitialize();
        return FALSE;
    }

    __try 
    {
        MSG msg;
        HACCEL hAccelTable;

        // Initialize global strings
        LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
        LoadString(hInstance, IDC_ALLOCATOR9, szWindowClass, MAX_LOADSTRING);
        MyRegisterClass(hInstance);

        // Perform application initialization:
        if (!InitInstance (hInstance, nCmdShow, g_hWnd)) 
        {
            // Exit the try block gracefully.  Returning FALSE here would
            // lead to a performance penalty unwinding the stack.
            __leave;
        }

        hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_ALLOCATOR9);

        // Main message loop:
        while (GetMessage(&msg, NULL, 0, 0)) 
        {
            if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
            {
                TranslateMessage(&msg);
                DispatchMessage(&msg);
            }
        }

        ret = (int) msg.wParam;
    }
    __finally
    {
        // make sure to release everything at the end
        // regardless of what's happening
        CloseGraph(g_hWnd);
        CoUninitialize();
    }

    return ret;
}


#endif
//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
BOOL MyRegisterClass(HINSTANCE hInstance)
{
    WNDCLASS wc;
    ZeroMemory(&wc, sizeof(wc));

    // Set the members of the window class structure.
    //
    // Don't provide a background brush, because we process the WM_PAINT
    // messages in OnPaint().  If a movie is active, we tell the VMR to
    // repaint the window; otherwise, we repaint with COLOR_WINDOW+1.
    // If a background brush is provided, you will see a white flicker
    // whenever you resize the main application window, because Windows
    // will repaint the window before the application also repaints.
    wc.hInstance     = hInstance;
    wc.lpfnWndProc   = WndProc;
    wc.lpszClassName = szWindowClass;
    //wc.lpszMenuName  = (LPCTSTR)IDC_ALLOCATOR9;
    wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
    wc.hbrBackground = NULL;        // No background brush
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ALLOCATOR9));
    if(!RegisterClass(&wc))
    {
        return FALSE;
    }

    return TRUE;
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//

vip* VP = 0;

BOOL InitInstance(HINSTANCE hInstance, int nCmdShow, HWND& hWnd)
{
   hInst = hInstance; // Store instance handle in our global variable

  //scene::_embedded = 0;

   //AE
  VP = new vip("capture",0,0); // name embed video?
   
   //scene::_main = new scene(); 
   //scene::_main->_scene = new main_scene();

   int x = 0;
   int y = -25;
   int w = VP->width(); //scene::width;
   int h = VP->height(); // scene::height + 25;

   if (w == 800) { x = 100; y = 100; }
   else if (w == 640) { x = 200; y = 200; }
   

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
                       x,y,w,h,
                       NULL, NULL, hInstance, NULL);

   if (!hWnd)
      return FALSE;

   //ShowWindow(hWnd, nCmdShow);
   //AnimateWindow(hWnd, 200,AW_SLIDE);
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   /*
   scene::_embedded = 0;
   scene::_main = new scene(); 
   scene::_main->_scene = new main_scene();
   */
	
  StartGraph(hWnd); // AE

   //g_scene = new CPlaneScene();
   return TRUE;
}

void PaintWindow(HWND hWnd)
{
    bool bNeedPaint = false;

    PAINTSTRUCT ps;
    HDC hdc = BeginPaint(hWnd, &ps);

    if( g_mediaControl == NULL ) // we know that there is nothing loaded
    {
        bNeedPaint = true;
    }
    else
    {
        // If we have a movie loaded, we only need to repaint
        // when the graph is stopped
        OAFilterState state;
        if( SUCCEEDED( g_mediaControl->GetState(0, & state ) ) )
        {
            bNeedPaint = ( state == State_Stopped );
        }
    }

    if ( bNeedPaint ) 
    {
        RECT rc2;
        GetClientRect(hWnd, &rc2);
        FillRect(hdc, &rc2, (HBRUSH)(COLOR_WINDOW+1));
    }

    EndPaint( hWnd, &ps );
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND  - process the application menu
//  WM_PAINT    - Paint the main window
//  WM_DESTROY  - post a quit message and return
//
//

static void _handle(char* s1, char* s2) {
	//dxscene::handle_event(s1,s2);
	VP->handle(s1,s2);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    HRESULT hr;
    int wmId, wmEvent;

    switch (message) 
    {
        case WM_COMMAND:
            wmId    = LOWORD(wParam); 
            wmEvent = HIWORD(wParam); 

            // Parse the menu selections:
            switch (wmId)
            {
                case IDM_PLAY_FILE:
                    hr = StartGraph(g_hWnd);
                    if( FAILED(hr) )
                    {
                        return 0;
                    }
                    break;

                case ID_FILE_CLOSE:
                    CloseGraph( hWnd );
                    break;

                case IDM_ABOUT:
                   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
                   break;

                case IDM_EXIT:
                   DestroyWindow(hWnd);
                   break;

                default:
                   return DefWindowProc(hWnd, message, wParam, lParam);
            }
            break;

		case WM_LBUTTONDOWN: //_handle("button","down"); break;
		case WM_LBUTTONUP:_handle("button","down"); break;
        case WM_KEYUP:
			if (wParam == VK_CONTROL) { VP->ctrl(0); } //scene::_ctrl = 0; }
			else if (wParam == VK_SHIFT) { VP->shift(0); } //scene::_shift = 0; }
			break;
		case WM_KEYDOWN:
			if (wParam == VK_ESCAPE) {
				::DestroyWindow(hWnd);
				return 0;
			}
			else if (wParam == VK_SPACE) 
				//MessageBox(0,"space","odyssee",MB_OK);
				_handle("key","space");
			else if (wParam == VK_TAB) {
				//MessageBox(0,"tab","odyssee",MB_OK);
				  _handle("key","tab");
				  //doit();
			}
			else if (wParam == VK_RETURN) _handle("key","return");
			else if (wParam == VK_BACK) _handle("key","back");

			else if (wParam == VK_CONTROL) { VP->ctrl(1); } //scene::_ctrl = 1; }
			else if (wParam == VK_SHIFT) { VP->shift(1); 
			  if (VP->ctrl() && VP->shift()) {
		        if (vip_on) vip_on = 0;
		        else vip_on = 1;
				dxscene* sc = (dxscene*) scene::lookup("background");
				sc->exclude(vip_on);
			  }
			
			} //scene::_shift = 1; }
			else if (wParam == VK_MENU) {
				_handle("alt","down");
				doit();
            }
			else if (wParam == VK_UP) _handle("arrow","up");
			else if (wParam == VK_LEFT) _handle("arrow","left");
			else if (wParam == VK_RIGHT) _handle("arrow","right");
			else if (wParam == VK_DOWN) _handle("arrow","down");

			else {
			   char buf[64];
			   int x = wParam; char c ='-';
			   if (x > 47 && x < 48+10) c = '0' + x - 48;
			   else if (x > 64 && x < 65+26 ) c = 'a' + x - 65;
			   if (c != '-') sprintf(buf,"%c",c);
			   else sprintf(buf,"%3d",wParam);
			      _handle("key",buf);
			}
			break;

        case WM_PAINT:
            PaintWindow(hWnd);
            break;

        case WM_DESTROY:
            PostQuitMessage(0);
            break;

        default:
            return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
                return TRUE;

        case WM_COMMAND:
            if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
            {
                EndDialog(hDlg, LOWORD(wParam));
                return TRUE;
            }
            break;
    }

    return FALSE;
}
