
#ifndef vip_anim_h
#define vip_anim_h

#include <hush/export.h>
#include "scene/scene.h"



#include <vector>
#include "d3dutil.h"
#include "tiny.h"
//class CTiny;
using namespace std;

//#include "MultiAnimation.h"

class vip_anim : public scene  
{
public:

    vip_anim(char* opts = 0);

	int operator()();
    virtual ~vip_anim();
    virtual int _load();
	virtual int _restore();
    virtual int _render();

	//int ch(char* x=0);

	int handle(char* type, char* ev);

	void    SetMenuStates();

	idevice*              m_pd3dDevice;
	float m_fTime;
	
    LPD3DXMESH            m_pMeshFloor;               // floor geometry
    D3DXMATRIX            m_mxFloor;                  // floor world xform
    D3DMATERIAL9          m_MatFloor;                 // floor material
    LPDIRECT3DTEXTURE9    m_pTxFloor;                 // floor texture

    ID3DXFont*            m_pFont;                    // framework font
    CFirstPersonCamera    m_Camera;                   // Camera for interactive character nagivation
    float                 m_fAspectRatio;             // Aspect ratio used by the FPS camera
    CSoundManager         m_DSound;                   // DSound class

    CMultiAnim            m_MultiAnim;                // the MultiAnim class for holding Tiny's mesh and frame hierarchy
	vector< CTiny* >      m_v_pCharacters;            // array of character objects; each can be associated with any of the CMultiAnims

    DWORD                 m_dwFollow;                 // which character the camera should follow; 0xffffffff for static camera
    bool                  m_bDrawReflection;          // reflection-drawing option
    bool                  m_bDisplayText;             // whether to display text
    bool                  m_bDisplayHelp;             // whether to display help text

    bool                  m_bPlaySounds;              // whether to play sounds

    float                 m_fLastAnimTime;            // Time for the animations


};
#endif 
