#include <hush/source.h>

#include "morph.h"
#include <scene/mesh.h>
#include <scene/shader.h>
#include <scene/background.h>
#include <scene/face.h>


#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>




//#include "shader.h"




static char* _help = "(vip) morph";
static scene* dolphin;


scene* vip_morph::create(char* opts) {
	return new vip_morph(opts);
}


int vip_morph::handle(char* type, char* ev) {
	if (check(type,ev,"shift","down")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","a")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","0")) {
		int s = 0;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","1")) {
		int s = 1;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","2")) {
		int s = 2;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



int vip_morph::operator()()
{
  

state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

vip_morph::vip_morph(char* opts) 
{
count = 12;




_size = 20; //size;
wsprintf(_type,"vip_morph");
_display = _type;

if (opts) process(opts);


//translation(-2,0,0);
end(60);
loop = 1;
scene* sc;
//scale(0.7,0.7,0.7);
sc = new mesh("sphere");
//sc->translation(-1.5,0,0);
scenes[1] =   new shader(sc,"src=basic");
scenes[1]->translation(-1.5,0,0);
scenes[1]->scale(0.3,0.3,0.3);
scenes[2] = new shader(new mesh("acube"),"src=morph-color");
//scenes[2] = new mesh("acube"); //,"src=morph-color");
scenes[2]->_factor = 1.5;
scenes[2]->translation(0,0,2);
scenes[2]->scale(1.0,1,1);
scenes[2]->rotation(1,0,0 , 0.5 * 3.14);
sc = new mesh("sphere");
scenes[3] = new shader(sc,"src=project-color");
scenes[3] = sc; //new shader(sc,"src=project-color");
scenes[3] = new shader(sc,"src=color-red");
scenes[3]->translation(1.5,0,0);
scenes[3]->scale(0.3,0.3,0.3);

sc = new mesh("plane");
scenes[0] = new shader(sc,"src=align-color");
scenes[0]->_factor = 2.0;
scenes[0]->translation(0,0,2);
scenes[0]->scale(1.0,1,1);
//scenes[4]->rotation(1,0,0,3.14);
//_shader = "basic";
_exclude[0] = 1;
_exclude[1] = 1;
_exclude[2] = 0;
_exclude[3] = 1;
 if (embedded()) _exclude[0] = 1;
 if (opt("text")) {
	 _text = scr(opt("text")) -> create();
     _sim->schedule(_text,0);
	 scenes[5] = _text;
 }

 

 
  
}




vip_morph::~vip_morph()
{
//delete scenes[];
}

int 
vip_morph::_load()
{
    int hr = S_OK;

    dolphin = ((dxscene*) dvscene::lookup("menu/dots"))->scenes[10];
	dolphin->exclude(1);

	hr = scene::init(_device); // loops through scenes

	

	
    return hr;
}

int
vip_morph::_restore()
{
    HRESULT hr = S_OK;
	if (0 && _effect) {
	_effect->SetMatrix( "view_proj_matrix", _wvp()); //  &mWorldViewProjection );
    _effect->SetMatrix( "view_matrix", _view()); //&mWorld );
    _effect->SetFloat( "time_0_X",dxtime() );
	_effect->SetTexture("g_MeshTexture",_texture);
	}

	

    return hr;
}


int
vip_morph::_render( ) 
{
HRESULT hr = S_OK;

    //fx("walk",fx("project-color"));
	
  
	render_begin(_device);
	dolphin->state = 1;
	//_select(_active());
	_texture = scene::_captures(_active());
	
	_device->SetTexture( 0, _texture );
       //int i = 0;

	if (fraction() < 0.5) {
	scenes[2]->_factor = 0.4 + 2.0 * fraction();
	} else {
	scenes[2]->_factor = 0.4 + (2.0 - 2.0 * fraction());
	}
 
	

	hr = scene::render(_device,_texture); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (1) {
		
		message(100,_y-200,argb(255,255,120,120),fm("%s [%d]",_help,state));
	} 
	
	

	//display(_display);
   
	render_end(_device);

 

    return hr;
}

