#include <hush/source.h>
#include "object-dolphin.h"
#include <atlbase.h>
#include "common/d3dfile.h"
#include "common/dxutil.h"


const DWORD object_dolphin::D3DVERTEX::FVF = D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1;

int object_dolphin::handle(char* type, char* ev) {

	if (0) {
	} else return scene::handle(type,ev);
	sprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}

scene* object_dolphin::create(char* opts) { return new object_dolphin(opts); }


object_dolphin::object_dolphin(char* opts) {
	  m_pDolphinTexture        = NULL;
    m_pDolphinVB1            = NULL;
    m_pDolphinVB2            = NULL;
    m_pDolphinVB3            = NULL;
    m_pDolphinIB             = NULL;
    m_pDolphinVertexDeclaration = NULL;
    m_pDolphinVertexShader   = NULL;
    m_pDolphinVertexShader2  = NULL;

    // SeaFloor object
    m_pSeaFloorTexture       = NULL;
    m_pSeaFloorVB            = NULL;
    m_pSeaFloorIB            = NULL;
    m_pSeaFloorVertexDeclaration = NULL;
    m_pSeaFloorVertexShader  = NULL;
    m_pSeaFloorVertexShader2 = NULL;

    // Water caustics
    for( DWORD t=0; t<32; t++ )
        m_pCausticTextures[t] = NULL;

	_stack = 1;
  }


object_dolphin::~object_dolphin()
{
//delete scenes[];
}

HRESULT 
object_dolphin::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    // fm("d:\\vip\\models\\%s.x",opt("model"))
     
    TCHAR strPath[MAX_PATH];
    LPD3DXBUFFER pCode = NULL;
    LPDIRECT3DVERTEXBUFFER9 pMeshSourceVB;
    LPDIRECT3DINDEXBUFFER9  pMeshSourceIB;
    D3DVERTEX*              pSrc;
    D3DVERTEX*              pDst;
    CD3DMesh                DolphinMesh01;
    CD3DMesh                DolphinMesh02;
    CD3DMesh                DolphinMesh03;
    CD3DMesh                SeaFloorMesh;

    // Initialize the font's internal textures
    //m_pFont->InitDeviceObjects( device );

	//debug("dolphin:init 0",1);

    // Get the path to the texture
	//if( FAILED( hr = DXUtil_FindMediaFileCb( strPath, sizeof(strPath), _T(loc("\\vip\\models\\Dolphin.bmp")) ) ) )
    //    return hr;
    // Create texture for the dolphin
    //if( FAILED( 
		D3DXCreateTextureFromFileEx( device, 
		//strPath,
        _T(loc("\\vip\\models\\Dolphin.bmp")),
        D3DX_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, 0, D3DFMT_UNKNOWN, 
                     D3DPOOL_MANAGED, D3DX_FILTER_TRIANGLE|D3DX_FILTER_MIRROR, 
                     D3DX_FILTER_TRIANGLE|D3DX_FILTER_MIRROR, 0, NULL, NULL, &m_pDolphinTexture );
        //return -1;//D3DAPPERR_MEDIANOTFOUND;
    //debug("dolphin:init 1",1);
    // Get the path to the texture
    //if( FAILED( hr = DXUtil_FindMediaFileCb( strPath, sizeof(strPath), _T(loc("\\vip\\models\\SeaFloor.bmp")) ) ) )
      //  return hr;
    // Create textures for the seafloor
    //if( FAILED( 
	D3DXCreateTextureFromFileEx( device, 
		//strPath,
		_T(loc("\\vip\\models\\SeaFloor.bmp")),
        D3DX_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, 0, D3DFMT_UNKNOWN, 
                     D3DPOOL_MANAGED, D3DX_FILTER_TRIANGLE|D3DX_FILTER_MIRROR, 
                     D3DX_FILTER_TRIANGLE|D3DX_FILTER_MIRROR, 0, NULL, NULL, &m_pSeaFloorTexture );
      //  return -1;//D3DAPPERR_MEDIANOTFOUND;
    //debug("dolphin:init 2",1);
    // Create textures for the water caustics
    for( DWORD t=0; t<32; t++ )
    {
        TCHAR strName[80];
		sprintf( strName, _T("%s\\vip\\effects\\Caust%02ld.tga"),_drive(), t );
        // Get the path to the texture
        //if( FAILED( DXUtil_FindMediaFileCb( strPath, sizeof(strPath), strName ) ) )
          //  return -1;//D3DAPPERR_MEDIANOTFOUND;
        //if( FAILED( 
			D3DXCreateTextureFromFileEx( device, strPath, 
                         D3DX_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, 0, D3DFMT_UNKNOWN, 
                         D3DPOOL_MANAGED, D3DX_FILTER_TRIANGLE|D3DX_FILTER_MIRROR, 
                         D3DX_FILTER_TRIANGLE|D3DX_FILTER_MIRROR, 0, NULL, NULL, &m_pCausticTextures[t] );
            //return -1;//D3DAPPERR_MEDIANOTFOUND;
    }
    //debug("dolphin:init 3",1);
    // Load the file-based mesh objects
    if( FAILED( DolphinMesh01.Create( device, TEXT(loc("\\vip\\models\\dolphin1.x")) ) ) )
        ;//return -1;//D3DAPPERR_MEDIANOTFOUND;
    if( FAILED( DolphinMesh02.Create( device, TEXT(loc("\\vip\\models\\dolphin2.x")) ) ) )
        ;//return -1;//D3DAPPERR_MEDIANOTFOUND;
    if( FAILED( DolphinMesh03.Create( device, TEXT(loc("\\vip\\models\\dolphin3.x")) ) ) )
        ;//return -1;//D3DAPPERR_MEDIANOTFOUND;
    if( FAILED( SeaFloorMesh.Create( device, TEXT(loc("\\vip\\models\\SeaFloor.x")) ) ) )
        ;//return -1;//D3DAPPERR_MEDIANOTFOUND;
     //debug("dolphin:init 4",1);
    // Set the FVF type to match the vertex format we want
    DolphinMesh01.SetFVF( device, D3DVERTEX::FVF );
    DolphinMesh02.SetFVF( device, D3DVERTEX::FVF );
    DolphinMesh03.SetFVF( device, D3DVERTEX::FVF );
    SeaFloorMesh.SetFVF(  device, D3DVERTEX::FVF );

	//debug("dolphin:init",1);

    // Get the number of vertices and faces for the meshes
    m_dwNumDolphinVertices  = DolphinMesh01.GetSysMemMesh()->GetNumVertices();
    m_dwNumDolphinFaces     = DolphinMesh01.GetSysMemMesh()->GetNumFaces();
    m_dwNumSeaFloorVertices = SeaFloorMesh.GetSysMemMesh()->GetNumVertices();
    m_dwNumSeaFloorFaces    = SeaFloorMesh.GetSysMemMesh()->GetNumFaces();

    // Create the dolphin and seafloor vertex and index buffers
    device->CreateVertexBuffer( m_dwNumDolphinVertices * sizeof(D3DVERTEX),
                                      D3DUSAGE_WRITEONLY, 0, D3DPOOL_MANAGED,
                                      &m_pDolphinVB1, NULL );
    device->CreateVertexBuffer( m_dwNumDolphinVertices * sizeof(D3DVERTEX),
                                      D3DUSAGE_WRITEONLY, 0, D3DPOOL_MANAGED,
                                      &m_pDolphinVB2, NULL );
    device->CreateVertexBuffer( m_dwNumDolphinVertices * sizeof(D3DVERTEX),
                                      D3DUSAGE_WRITEONLY, 0, D3DPOOL_MANAGED,
                                      &m_pDolphinVB3, NULL );
    device->CreateVertexBuffer( m_dwNumSeaFloorVertices * sizeof(D3DVERTEX),
                                      D3DUSAGE_WRITEONLY, 0, D3DPOOL_MANAGED,
                                      &m_pSeaFloorVB, NULL );
    device->CreateIndexBuffer( m_dwNumDolphinFaces * 3 * sizeof(WORD),
                                      D3DUSAGE_WRITEONLY,
                                      D3DFMT_INDEX16, D3DPOOL_MANAGED,
                                      &m_pDolphinIB, NULL );
    device->CreateIndexBuffer( m_dwNumSeaFloorFaces * 3 * sizeof(WORD),
                                      D3DUSAGE_WRITEONLY,
                                      D3DFMT_INDEX16, D3DPOOL_MANAGED,
                                      &m_pSeaFloorIB, NULL );

    // Copy vertices for mesh 01
    DolphinMesh01.GetSysMemMesh()->GetVertexBuffer( &pMeshSourceVB );
    m_pDolphinVB1->Lock( 0, 0, (void**)&pDst, 0 );
    pMeshSourceVB->Lock( 0, 0, (void**)&pSrc, 0 );
    memcpy( pDst, pSrc, m_dwNumDolphinVertices * sizeof(D3DVERTEX) );
    m_pDolphinVB1->Unlock();
    pMeshSourceVB->Unlock();
    pMeshSourceVB->Release();

    // Copy vertices for mesh 2
    DolphinMesh02.GetSysMemMesh()->GetVertexBuffer( &pMeshSourceVB );
    m_pDolphinVB2->Lock( 0, 0, (void**)&pDst, 0 );
    pMeshSourceVB->Lock( 0, 0, (void**)&pSrc, 0 );
    memcpy( pDst, pSrc, m_dwNumDolphinVertices * sizeof(D3DVERTEX) );
    m_pDolphinVB2->Unlock();
    pMeshSourceVB->Unlock();
    pMeshSourceVB->Release();

    // Copy vertices for mesh 3
    DolphinMesh03.GetSysMemMesh()->GetVertexBuffer( &pMeshSourceVB );
    m_pDolphinVB3->Lock( 0, 0, (void**)&pDst, 0 );
    pMeshSourceVB->Lock( 0, 0, (void**)&pSrc, 0 );
    memcpy( pDst, pSrc, m_dwNumDolphinVertices * sizeof(D3DVERTEX) );
    m_pDolphinVB3->Unlock();
    pMeshSourceVB->Unlock();
    pMeshSourceVB->Release();

    // Copy vertices for the seafloor mesh, and add some bumpiness
    SeaFloorMesh.GetSysMemMesh()->GetVertexBuffer( &pMeshSourceVB );
    m_pSeaFloorVB->Lock( 0, 0, (void**)&pDst, 0 );
    pMeshSourceVB->Lock( 0, 0, (void**)&pSrc, 0 );
    memcpy( pDst, pSrc, m_dwNumSeaFloorVertices * sizeof(D3DVERTEX) );
    srand(5);
    for( DWORD i=0; i<m_dwNumSeaFloorVertices; i++ )
    {
        ((D3DVERTEX*)pDst)[i].p.y += (rand()/(FLOAT)RAND_MAX);
        ((D3DVERTEX*)pDst)[i].p.y += (rand()/(FLOAT)RAND_MAX);
        ((D3DVERTEX*)pDst)[i].p.y += (rand()/(FLOAT)RAND_MAX);
        ((D3DVERTEX*)pDst)[i].tu  *= _tu * 10;
        ((D3DVERTEX*)pDst)[i].tv  *= _tv * 10;
    }
    m_pSeaFloorVB->Unlock();
    pMeshSourceVB->Unlock();
    pMeshSourceVB->Release();

    // Copy indices for the dolphin mesh
    DolphinMesh01.GetSysMemMesh()->GetIndexBuffer( &pMeshSourceIB );
    m_pDolphinIB->Lock( 0, 0, (void**)&pDst, 0 );
    pMeshSourceIB->Lock( 0, 0, (void**)&pSrc, 0 );
    memcpy( pDst, pSrc, 3 * m_dwNumDolphinFaces * sizeof(WORD) );
    m_pDolphinIB->Unlock();
    pMeshSourceIB->Unlock();
    pMeshSourceIB->Release();

    // Copy indices for the seafloor mesh
    SeaFloorMesh.GetSysMemMesh()->GetIndexBuffer( &pMeshSourceIB );
    m_pSeaFloorIB->Lock( 0, 0, (void**)&pDst, 0 );
    pMeshSourceIB->Lock( 0, 0, (void**)&pSrc, 0 );
    memcpy( pDst, pSrc, 3 * m_dwNumSeaFloorFaces * sizeof(WORD) );
    m_pSeaFloorIB->Unlock();
    pMeshSourceIB->Unlock();
    pMeshSourceIB->Release();

    // Create vertex shader for the dolphin
    D3DVERTEXELEMENT9 declDolphin[] =
    {
        // First stream is first mesh
        { 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_POSITION, 0}, 
        { 0, 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_NORMAL,   0}, 
        { 0, 24, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_TEXCOORD, 0}, 
        // Second stream is second mesh
        { 1,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_POSITION, 1}, 
        { 1, 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_NORMAL,   1}, 
        { 1, 24, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_TEXCOORD, 1}, 
        // Third stream is third mesh
        { 2,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_POSITION, 2}, 
        { 2, 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_NORMAL,   2}, 
        { 2, 24, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_TEXCOORD, 2}, 
        D3DDECL_END()
    };
    if( FAILED( hr = device->CreateVertexDeclaration( declDolphin, &m_pDolphinVertexDeclaration ) ) )
        return hr;

    if( FAILED( hr = DXUtil_FindMediaFileCb( strPath, sizeof(strPath), TEXT(loc("\\vip\\effects\\DolphinTween.vsh")) ) ) )
        return hr;
    if( FAILED( hr = D3DXAssembleShaderFromFile( strPath, NULL, NULL, 0, &pCode, NULL ) ) )
        return hr;
    if( FAILED( hr = device->CreateVertexShader( (DWORD*)pCode->GetBufferPointer(),
                                                       &m_pDolphinVertexShader ) ) )
    {
        SAFE_RELEASE( pCode );
        return hr;
    }
    SAFE_RELEASE( pCode );

    if( FAILED( hr = DXUtil_FindMediaFileCb( strPath, sizeof(strPath), TEXT(loc("\\vip\\effects\\DolphinTween2.vsh")) ) ) )
        return hr;
    if( FAILED( hr = D3DXAssembleShaderFromFile( strPath, NULL, NULL, 0, &pCode, NULL ) ) )
        return hr;
    if( FAILED( hr = device->CreateVertexShader( (DWORD*)pCode->GetBufferPointer(),
                                                       &m_pDolphinVertexShader2 ) ) )
    {
        SAFE_RELEASE( pCode );
        return hr;
    }
    SAFE_RELEASE( pCode );

        // Create vertex shader for the seafloor
    D3DVERTEXELEMENT9 declSeaFloor[] =
    {
        { 0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_POSITION, 0}, 
        { 0, 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_NORMAL,   0}, 
        { 0, 24, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT,  D3DDECLUSAGE_TEXCOORD, 0}, 
        D3DDECL_END()
    };
    if( FAILED( hr = device->CreateVertexDeclaration( declSeaFloor, &m_pSeaFloorVertexDeclaration ) ) )
        return hr;

    if( FAILED( hr = DXUtil_FindMediaFileCb( strPath, sizeof(strPath), TEXT(loc("\\vip\\effects\\SeaFloor.vsh")) ) ) )
        return hr;
    if( FAILED( hr = D3DXAssembleShaderFromFile( strPath, NULL, NULL, 0, &pCode, NULL ) ) )
        return hr;
    if( FAILED( hr = device->CreateVertexShader( (DWORD*)pCode->GetBufferPointer(),
                                                       &m_pSeaFloorVertexShader ) ) )
    {
        SAFE_RELEASE( pCode );
        return hr;
    }
    SAFE_RELEASE( pCode );

    if( FAILED( hr = DXUtil_FindMediaFileCb( strPath, sizeof(strPath), TEXT(loc("\\vip\\effects\\SeaFloor2.vsh")) ) ) )
        return hr;
    if( FAILED( hr = D3DXAssembleShaderFromFile( strPath, NULL, NULL, 0, &pCode, NULL ) ) )
        return hr;
    if( FAILED( hr = device->CreateVertexShader( (DWORD*)pCode->GetBufferPointer(),
                                                       &m_pSeaFloorVertexShader2 ) ) )
    {
        SAFE_RELEASE( pCode );
        return hr;
    }
    SAFE_RELEASE( pCode );

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
object_dolphin::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	
   // Setup render states
 // Set the transform matrices
    D3DXVECTOR3 vEyePt      = D3DXVECTOR3( 0.0f, 0.0f, -4.0f );
    D3DXVECTOR3 vLookatPt   = D3DXVECTOR3( 0.0f, 0.0f,  0.0f );
    D3DXVECTOR3 vUpVec      = D3DXVECTOR3( 0.0f, 1.0f,  0.0f );
    FLOAT       fAspect = ((FLOAT)800) / 600;
    D3DXMatrixIdentity( &m_matWorld );
    D3DXMatrixLookAtLH( &m_matView, &vEyePt, &vLookatPt, &vUpVec );
    D3DXMatrixPerspectiveFovLH( &m_matProj, D3DX_PI/3, fAspect, 1.0f, 10000.0f );

	

    // Set default render states

	if (1 && ds("full")) {
    device->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
    device->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );
    device->SetRenderState( D3DRS_ZENABLE,        TRUE );
    device->SetRenderState( D3DRS_FOGENABLE,      TRUE );
    device->SetRenderState( D3DRS_FOGCOLOR,       WATER_COLOR );
	}

	if (1) {
	    //hr = device->SetSamplerState( 0, D3DSAMP_ADDRESSU,  D3DTADDRESS_CLAMP );
        //hr = device->SetSamplerState( 0, D3DSAMP_ADDRESSV,  D3DTADDRESS_CLAMP );

        // Set linear filtering quality
        hr = device->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
        hr = device->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );

        // set maximum ambient light
        hr = device->SetRenderState(D3DRS_AMBIENT,RGB(255,255,255));

        // Turn off culling
        hr = device->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

        // Turn on the zbuffer
       if (state != 1) hr = device->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );

        // Turn off lights
        hr = device->SetRenderState(D3DRS_LIGHTING,FALSE);

        // Enable dithering
        //hr = device->SetRenderState(D3DRS_DITHERENABLE, TRUE);

        // disable stencil
        hr = device->SetRenderState(D3DRS_STENCILENABLE, FALSE);

        // manage blending
        // hr = device->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
		
		
		//hr = device->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);

        //hr = device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);

        //hr = device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);

        //hr = device->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);

        //hr = device->SetRenderState(D3DRS_ALPHAREF, 0x10);

        //hr = device->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATER);


        // Set texture states:

        // Modulate diffuse color of the vertex with texture color (50% and 50%)
        // then when we set color of lower vertices of the flag to background color,
        // it blends with texture and gives coloring of the lower part of the flag
        // correspondent to the background
        hr = device->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
        hr = device->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
        hr = device->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );

        // turn off alpha operation
        //hr = device->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );

	}

    return hr;
}


HRESULT object_dolphin::compose(IDirect3DDevice9* device,DWORD t) {
	HRESULT hr = S_OK;
	 // Animation attributes for the dolphin
	FLOAT m_fTime = dxtime();
    FLOAT fKickFreq    = 2*m_fTime;
    FLOAT fPhase       = m_fTime/3;
    FLOAT fBlendWeight = sinf( fKickFreq );

	

    // Move the dolphin in a circle
    D3DXMATRIXA16 matDolphin, matTrans, matRotate1, matRotate2;
    D3DXMatrixScaling( &matDolphin, 0.01f, 0.01f, 0.01f );
    D3DXMatrixRotationZ( &matRotate1, -cosf(fKickFreq)/6 );
    D3DXMatrixMultiply( &matDolphin, &matDolphin, &matRotate1 );
    D3DXMatrixRotationY( &matRotate2, fPhase );
    D3DXMatrixMultiply( &matDolphin, &matDolphin, &matRotate2 );
    D3DXMatrixTranslation( &matTrans, -5*sinf(fPhase), sinf(fKickFreq)/2, 10-10*cosf(fPhase) );
    D3DXMatrixMultiply( &matDolphin, &matDolphin, &matTrans );

	
    // Animate the caustic textures
    DWORD tex = ((DWORD)(m_fTime*32))%32;
    m_pCurrentCausticTexture = m_pCausticTextures[tex];

    // Set the vertex shader constants. Note: outside of the blend matrices,
    // most of these values don't change, so don't need to really be set every
    // frame. It's just done here for clarity
    {
        // Some basic constants
        D3DXVECTOR4 vZero( 0.0f, 0.0f, 0.0f, 0.0f );
        D3DXVECTOR4 vOne( 1.0f, 0.5f, 0.2f, 0.05f );

        FLOAT fWeight1;
        FLOAT fWeight2;
        FLOAT fWeight3;

        if( fBlendWeight > 0.0f )
        {
            fWeight1 = fabsf(fBlendWeight);
            fWeight2 = 1.0f - fabsf(fBlendWeight);
            fWeight3 = 0.0f;
        }
        else
        {
            fWeight1 = 0.0f;
            fWeight2 = 1.0f - fabsf(fBlendWeight);
            fWeight3 = fabsf(fBlendWeight);
        }
        D3DXVECTOR4 vWeight( fWeight1, fWeight2, fWeight3, 0.0f );

        // Lighting vectors (in world space and in dolphin model space)
        // and other constants
        FLOAT fLight[]    = { 0.0f,  1.0f, 0.0f, 0.0f };
        FLOAT fLightDolphinSpace[]    = { 0.0f,  1.0f, 0.0f, 0.0f };
        FLOAT fDiffuse[]  = { 1.00f, 1.00f, 1.00f, 1.00f };
        FLOAT fAmbient[]  = { 0.25f, 0.25f, 0.25f, 0.25f };
        FLOAT fFog[]      = { 0.5f, 50.0f, 1.0f/(50.0f-1.0f), 1.0f }; // 0.0
        FLOAT fCaustics[] = { 0.05f, 0.05f, sinf(m_fTime)/8, cosf(m_fTime)/10 };

        D3DXMATRIXA16 matDolphinInv;
        D3DXMatrixInverse(&matDolphinInv, NULL, &matDolphin);
        D3DXVec4Transform((D3DXVECTOR4*)fLightDolphinSpace, (D3DXVECTOR4*)fLight, &matDolphinInv);
        D3DXVec4Normalize((D3DXVECTOR4*)fLightDolphinSpace, (D3DXVECTOR4*)fLightDolphinSpace);

        // Vertex shader operations use transposed matrices
        D3DXMATRIXA16 mat, matCamera, matTranspose, matCameraTranspose;
        D3DXMATRIXA16 matViewTranspose, matProjTranspose;
        D3DXMatrixMultiply(&matCamera, &matDolphin, &m_matView);
        D3DXMatrixMultiply(&mat, &matCamera, &m_matProj);
        D3DXMatrixTranspose(&matTranspose, &mat);
        D3DXMatrixTranspose(&matCameraTranspose, &matCamera);
        D3DXMatrixTranspose(&matViewTranspose, &m_matView);
        D3DXMatrixTranspose(&matProjTranspose, &m_matProj);

        // Set the vertex shader constants
        device->SetVertexShaderConstantF(  0, (float*)&vZero,     1 );
        device->SetVertexShaderConstantF(  1, (float*)&vOne,      1 );
        device->SetVertexShaderConstantF(  2, (float*)&vWeight,   1 );
        device->SetVertexShaderConstantF(  4, (float*)&matTranspose, 4 );
        device->SetVertexShaderConstantF(  8, (float*)&matCameraTranspose,  4 );
        device->SetVertexShaderConstantF( 12, (float*)&matViewTranspose,  4 );
        device->SetVertexShaderConstantF( 19, (float*)fLightDolphinSpace,   1 );
        device->SetVertexShaderConstantF( 20, (float*)fLight,    1 );
        device->SetVertexShaderConstantF( 21, (float*)fDiffuse,  1 );
        device->SetVertexShaderConstantF( 22, (float*)fAmbient,  1 );
        device->SetVertexShaderConstantF( 23, (float*)fFog,      1 );
        device->SetVertexShaderConstantF( 24, (float*)fCaustics, 1 );
        device->SetVertexShaderConstantF( 28, (float*)&matProjTranspose,  4 );
    }

    
	
    return S_OK;
}


HRESULT 
object_dolphin::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

//return hr;

if (opt("tx") && tx(opt("tx"))) _texture = tx(opt("tx"));
if(_texture) texture = _texture;

int _floor = 0;
int _caustics = 1;

if (state == 2) _caustics = 0;
//if (state == 1) _floor = 1;


	render_begin(device);
	   device->SetTexture( 0, texture );


	  
            FLOAT fAmbientLight[]  = { 0.25f, 0.25f, 0.25f, 0.25f };
        device->SetVertexShaderConstantF( 22, (float*)fAmbientLight, 1 );
		if (_floor) {
        // Render the seafloor
        device->SetTexture( 0, m_pSeaFloorTexture );
        //device->SetTexture( 0, texture );
        device->SetVertexDeclaration( m_pSeaFloorVertexDeclaration );
        device->SetVertexShader( m_pSeaFloorVertexShader );
        device->SetStreamSource( 0, m_pSeaFloorVB, 0, sizeof(D3DVERTEX) );
        device->SetIndices( m_pSeaFloorIB );
        device->DrawIndexedPrimitive( D3DPT_TRIANGLELIST, 0,
                                            0, m_dwNumSeaFloorVertices,
                                            0, m_dwNumSeaFloorFaces );
		}
        // Render the dolphin
        device->SetTexture( 0, m_pDolphinTexture );
		device->SetTexture( 0, texture );
        device->SetVertexDeclaration( m_pDolphinVertexDeclaration );
        device->SetVertexShader( m_pDolphinVertexShader );
        device->SetStreamSource( 0, m_pDolphinVB1, 0, sizeof(D3DVERTEX) );
        device->SetStreamSource( 1, m_pDolphinVB2, 0, sizeof(D3DVERTEX) );
        device->SetStreamSource( 2, m_pDolphinVB3, 0, sizeof(D3DVERTEX) );
        device->SetIndices( m_pDolphinIB );
        device->DrawIndexedPrimitive( D3DPT_TRIANGLELIST, 0,
                                            0, m_dwNumDolphinVertices,
                                            0, m_dwNumDolphinFaces );

        // Now, we are going to do a 2nd pass, to alpha-blend in the caustics.
        // The caustics use a 2nd set of texture coords that are generated
        // by the vertex shaders. Lighting from the light above is used, but
        // ambient is turned off to avoid lighting objects from below (for
        // instance, we don't want caustics appearing on the dolphin's
        // underbelly). Finally, fog color is set to black, so that caustics
        // fade in distance.

        // Turn on alpha blending
        device->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
        
        //device->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_ONE );
        //device->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE );

        // Setup the caustic texture
        //device->SetTexture( 0, m_pCurrentCausticTexture );
		
		
		//AE device->SetTexture( 0, m_pSeaFloorTexture );
		device->SetTexture( 0, texture );

        // Set ambient and fog colors to black
        FLOAT fAmbientDark[] = { 0.0f, 0.0f, 0.0f, 0.0f };
        device->SetVertexShaderConstantF( 22, (float*)fAmbientDark, 1 );
        //device->SetRenderState( D3DRS_FOGCOLOR, 0x00000000 );
		if (_floor && _caustics) {
        // Render the caustic effects for the seafloor
        device->SetVertexDeclaration( m_pSeaFloorVertexDeclaration );
        device->SetVertexShader( m_pSeaFloorVertexShader2 );
        device->SetStreamSource( 0, m_pSeaFloorVB, 0, sizeof(D3DVERTEX) );
        device->SetIndices( m_pSeaFloorIB );
        device->DrawIndexedPrimitive( D3DPT_TRIANGLELIST, 0,
                                            0, m_dwNumSeaFloorVertices,
                                            0, m_dwNumSeaFloorFaces );
		}
        // Finally, render the caustic effects for the dolphin

		if (_caustics) {
        device->SetVertexDeclaration( m_pDolphinVertexDeclaration );
        device->SetVertexShader( m_pDolphinVertexShader2 );
        device->SetStreamSource( 0, m_pDolphinVB1, 0, sizeof(D3DVERTEX) );
        device->SetStreamSource( 1, m_pDolphinVB2, 0, sizeof(D3DVERTEX) );
        device->SetStreamSource( 2, m_pDolphinVB3, 0, sizeof(D3DVERTEX) );
        device->SetIndices( m_pDolphinIB );
        device->DrawIndexedPrimitive( D3DPT_TRIANGLELIST, 0,
                                            0, m_dwNumDolphinVertices,
                                            0, m_dwNumDolphinFaces );

		}


        // Restore modified render states
        device->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );
        //device->SetRenderState( D3DRS_FOGCOLOR, WATER_COLOR );
		device->SetRenderState( D3DRS_FOGENABLE,      FALSE );

		device->SetVertexShader( 0 );
	

	hr = scene::render(device,texture); // calls compose, restore,  render

    //  device->SetVertexShader(0 );
    
    //_selection = 0;

	hr = device->SetRenderState( D3DRS_ZENABLE, D3DZB_TRUE );
    
	render_end(device);

	



 

    return hr;
}

