
#include "object-spectrum.h"
#include <atlbase.h>
#include <assert.h>

int object_spectrum::handle(char* type, char* ev) {

	if (0) {
	} else return scene::handle(type,ev);
	sprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}


scene* object_spectrum::create(char* opts) { return new object_spectrum(opts); }

object_spectrum::object_spectrum(char* opts) {

	  ZeroMemory( &m_vertices, sizeof(m_vertices) );
    ZeroMemory( &m_velocities, sizeof(m_velocities) );

	//scene::_embedded = 1;
	//scene::_main = new scene();
	//scene::_main->_scene = new main_scene();
    
    m_pVB = NULL;
    m_pIB = NULL;

    m_pCubeTex = NULL;

    m_vCameraPos = D3DXVECTOR3( 0, 0, 0 );

    m_colorInner = D3DXCOLOR(1.0f, 0.0f, 0.0f, 0.5f); // was 8
    m_colorOuter = D3DXCOLOR(1.0f, 1.0f, 1.0f, 0.5f);
    
    CalculateColors();
	_stack = 1;
	onetime = 0;

  }


object_spectrum::~object_spectrum()
{
//delete scenes[];
}

HRESULT 
object_spectrum::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	 int p, s, t, i; // loop variables

	 //MessageBox(0,"1","check",MB_YESNO | MB_ICONQUESTION );
    
    // For each pass
    for( p=0; p < RENDER_PASSES; p++ )
    {
        // For each track
        for( t=0; t < NUM_TRACKS; t++ )
        {
            double r1 = INNER_RADIUS + (t * DISTANCE_PER_TRACK) + SPACING_PER_TRACK;
            double r2 = INNER_RADIUS + ((t+1) * DISTANCE_PER_TRACK) - SPACING_PER_TRACK;

            // For each sector
            for( s=0; s < NUM_SECTORS; s++ )
            {
                double theta1 = (s * RADIANS_PER_SECTOR) + SPACING_PER_SECTOR;
                double theta2 = ((s+1) * RADIANS_PER_SECTOR) - SPACING_PER_SECTOR;    

                D3DXVECTOR3 FRONT_RIGHT    = D3DXVECTOR3( (FLOAT) (r1 * cos( theta1 )), 
                                                          0.0f, 
                                                          (FLOAT) (r1 * sin( theta1 )) );

                D3DXVECTOR3 FRONT_LEFT     = D3DXVECTOR3( (FLOAT) (r1 * cos( theta2 )), 
                                                          0.0f, 
                                                          (FLOAT) (r1 * sin( theta2 )) );

                D3DXVECTOR3 BACK_LEFT      = D3DXVECTOR3( (FLOAT) (r2 * cos( theta2 )), 
                                                          0.0f, 
                                                          (FLOAT) (r2 * sin( theta2 )) );

                D3DXVECTOR3 BACK_RIGHT     = D3DXVECTOR3( (FLOAT) (r2 * cos( theta1 )), 
                                                          0.0f, 
                                                          (FLOAT) (r2 * sin( theta1 )) );


                CopyMemory( &m_vertices[p][t][s][0],   &FRONT_RIGHT,    sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][1],   &FRONT_LEFT,     sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][2],   &BACK_LEFT,      sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][3],   &BACK_RIGHT,     sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][4],   &FRONT_RIGHT,    sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][5],   &FRONT_LEFT,     sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][6],   &FRONT_LEFT,     sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][7],   &FRONT_RIGHT,    sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][8],   &FRONT_LEFT,     sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][9],   &BACK_LEFT,      sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][10],  &BACK_LEFT,      sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][11],  &FRONT_LEFT,     sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][12],  &BACK_LEFT,      sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][13],  &BACK_RIGHT,     sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][14],  &BACK_RIGHT,     sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][15],  &BACK_LEFT,      sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][16],  &BACK_RIGHT,     sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][17],  &FRONT_RIGHT,    sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][18],  &FRONT_RIGHT,    sizeof(D3DXVECTOR3) );
                CopyMemory( &m_vertices[p][t][s][19],  &BACK_RIGHT,     sizeof(D3DXVECTOR3) );

                for( i=3; i < VERTS_PER_CUBE; i += 4 )
                {
                    m_vertices[p][t][s][i-3].u = _tu; //1.0f;
                    m_vertices[p][t][s][i-3].v = _tv; //1.0f;

                    m_vertices[p][t][s][i-2].u = 0.0f;
                    m_vertices[p][t][s][i-2].v = _tv; //1.0f;

                    m_vertices[p][t][s][i-1].u = 0.0f;
                    m_vertices[p][t][s][i-1].v = 0.0f;

                    m_vertices[p][t][s][i].u = _tu; //1.0f;
                    m_vertices[p][t][s][i].v = 0.0f;
                }
                

                for( i=0; i < VERTS_PER_CUBE; i++ )
                {
                    m_vertices[p][t][s][i].color = D3DXCOLOR(0.0f, 0.0f, 0.0f, 0.0f);;
                }

            }
        }
    }

     // Create a texture
	/*
    hr = D3DXCreateTextureFromResource( device, g_hInstance, MAKEINTRESOURCE(IDR_CUBEFACE), &m_pCubeTex );
    if( FAILED(hr) )
    {
        return DXTRACE_ERR( TEXT("D3DXCreateTextureFromFile"), hr );
    }
    */
   

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
object_spectrum::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
   // Setup render states
	//initialize(device);

	//MessageBox(0,"2","check",MB_YESNO | MB_ICONQUESTION );

	m_pd3dDevice = device;

	  UINT i;
    int t, s, p; // Loop variables

    D3DXMATRIXA16 matWorld;
    D3DXMatrixIdentity( &matWorld );
    m_pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );
	//MessageBox(0,"x","check",MB_YESNO | MB_ICONQUESTION );

    D3DXMATRIXA16 matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 0.5f, 10.0f );
   m_pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );

    const WORD anIndices[] = { 0,  1,  2,  0,  2,  3,
                               4,  5,  6,  4,  6,  7,
                               8,  9,  10, 8,  10, 11,
                               12, 13, 14, 12, 14, 15,
                               16, 17, 18, 16, 18, 19, };
    const WORD nNumIndices = sizeof(anIndices) / sizeof(anIndices[0]);
    //assert(0!=0);
    // Create the vertex buffer.
    hr = m_pd3dDevice->CreateVertexBuffer( sizeof(m_vertices),
                                           D3DUSAGE_WRITEONLY | D3DUSAGE_DYNAMIC, D3DFVF_SPECTRUMVERTEX,
                                           D3DPOOL_DEFAULT, &m_pVB, NULL );

	if (!m_pVB) assert(3!=3);
   if( FAILED(hr) ) assert(1!=1);
      //  return DXTRACE_ERR( TEXT("CreateVertexBuffer"), hr );
  
    

    // Create the index buffer
    hr = m_pd3dDevice->CreateIndexBuffer( RENDER_PASSES * 3 * TRIS_PER_CUBE * sizeof(WORD) * NUM_SECTORS * NUM_TRACKS,
                                          D3DUSAGE_WRITEONLY,
                                          D3DFMT_INDEX16,
                                          D3DPOOL_DEFAULT, 
                                          &m_pIB, NULL );
    
    //if( FAILED(hr) )
      //  return DXTRACE_ERR( TEXT("CreateIndexBuffer"), hr );


    // Fill the index buffer
    WORD* pIndices;
    if( FAILED( hr = m_pIB->Lock( 0, 0, 
                             (void**)&pIndices, 0 ) ) )
    {
        return hr; //DXTRACE_ERR( TEXT("m_pIB->Lock"), hr );
    }

    WORD curIndex = 0;

    // For each track
    for( t=0; t < NUM_TRACKS; t++ )
    {
        // For each sector
        for( s=0; s < NUM_SECTORS; s++ )
        {
            // For each render pass
            for( p=RENDER_PASSES-1; p >= 0; p-- )
            {
                for( i=0; i < nNumIndices; i++ )
                {
                    *pIndices++ = curIndex + anIndices[i];
                }

                curIndex += VERTS_PER_CUBE;
            }
        }
    }
    
    m_pIB->Unlock();

	if (0) {

    // Turn off culling, so we see the front and back of the triangle
    m_pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE);

    // Turn off D3D lighting, since we are providing our own vertex colors
    m_pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE);
    
    m_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );
    m_pd3dDevice->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_SRCALPHA );
    m_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE);

    m_pd3dDevice->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );

	//MessageBox(0,"3","check",MB_YESNO | MB_ICONQUESTION );
	}


	m_pd3dDevice = device;



	  // int i, s, t; // loop variables
	  // int  t;

    const float fAcceleration = -2.8f; // Meters per millisecond
    
    // Change all the colors based on the current levels
    int freqPerSector = 200.0; //(SA_BUFFER_SIZE-1) / (NUM_SECTORS+4);
    float levelPerTrack = (MAX_LEVEL - MIN_LEVEL) / NUM_TRACKS;

    RotateColors();
    CalculateColors();

	m_fTime = dxtime();

    
    D3DXMATRIXA16 matView;
    D3DXVECTOR3 vEyePt( cosf( m_fTime/10.0f ), 0.7f, sinf( m_fTime/10.0f ) );
	float x = sinf( m_fTime/10.0f )/3.0f;
	if ( scene::_width == 1280 && x < 3.0f ) x = 3.0f;
    D3DXVECTOR3 vLookAt( cosf( m_fTime/10.0f )/3.0f, 0.0f, x );
    D3DXVECTOR3 vUp( 0.0f, 1.0f, 0.0f );
    D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookAt, &vUp );
    m_pd3dDevice->SetTransform( D3DTS_VIEW, &matView );
	

    const int anActiveVertices[] = { 0, 1, 2, 3, 6, 7, 10, 11, 14, 15, 18, 19 };
    const int nNumActiveVertices = sizeof(anActiveVertices) / sizeof(anActiveVertices[0]);
            
    // For each track
    for( t=0; t < NUM_TRACKS; t++ )
    {
        // For each sector
        for( s=0; s < NUM_SECTORS; s++ )
        {
            
            D3DXCOLOR curColor = m_vertices[1][t][s][0].color;
            FLOAT yValue = m_vertices[1][t][s][0].y;

			m_fElapsedTime = delta();
            
            // Decrement the alpha
            // Based on 30-frames per second, persist 97% of current alpha
            // each frame
            curColor.a *= powf( .97f, 30 * m_fElapsedTime );

            // Emit a new cube in the frequency is above the threshold, there isn't already
            // an active cube, and the reserve falling cube has already fallen a certain
            // distance
            if( (rand()%10 > 8) && // m_pAudioLevels->frequency[1][(s+2) * freqPerSector] > t * levelPerTrack + MIN_LEVEL && 
                yValue < 0.0f && 
                m_vertices[0][t][s][0].y < -0.75f )
            {   
                CopyMemory( &m_vertices[0][t][s][0], &m_vertices[1][t][s][0], 4 * sizeof(SPECTRUMVERTEX) );
                m_velocities[0][t][s] = m_velocities[1][t][s];
                yValue = 0.01f;
                m_velocities[1][t][s] = 1.5f * (rand()%3); // * (m_pAudioLevels->frequency[1][(s+2) * freqPerSector] / 256.0f);
                curColor = m_colorsOn[t];   
            }
         
            
            // Refresh active cubes
            yValue += m_velocities[1][t][s] * m_fElapsedTime;
            m_velocities[1][t][s] += fAcceleration * m_fElapsedTime;

            for( i=0; i < nNumActiveVertices; i++ )
            {
                m_vertices[1][t][s][ anActiveVertices[i] ].color = curColor;
                m_vertices[1][t][s][ anActiveVertices[i] ].y = yValue;
            }
            
            // Refresh falling cubes
            curColor = m_vertices[0][t][s][0].color;
            yValue = m_vertices[0][t][s][0].y;

            // Decrement the alpha
            // Based on 30-frames per second, persist 85% of current alpha
            // each frame
            curColor.a *= powf( 0.85f, 30 * m_fElapsedTime );

            yValue += m_velocities[0][t][s] * m_fElapsedTime;
            m_velocities[0][t][s] += fAcceleration * m_fElapsedTime;
            
            for( i=0; i < nNumActiveVertices; i++ )
            {
                m_vertices[0][t][s][ anActiveVertices[i] ].color = curColor;
                m_vertices[0][t][s][ anActiveVertices[i] ].y = yValue;
            }
        }
    }
    
    
    // Fill the vertex buffer.
    VOID* pVertices;
	if (!m_pVB) assert(2!=2);
    if( FAILED(hr = m_pVB->Lock( 0, 0, (void**)&pVertices, D3DLOCK_DISCARD ) ) )
    {
        return hr; //DXTRACE_ERR( TEXT("m_pVB->Lock"), hr );
    }
    memcpy( pVertices, m_vertices, sizeof(m_vertices) );
    m_pVB->Unlock();
	
 

    return hr;
}


HRESULT object_spectrum::compose(IDirect3DDevice9* device,DWORD tx) {
	//return S_OK;
	HRESULT hr = S_OK;
	//initialize(device);
	//static int once = 0;
	//if (!once++) init(device);

	
    return S_OK;
}


HRESULT 
object_spectrum::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

m_pd3dDevice = device;

if (opt("tx") && tx(opt("tx"))) _texture = tx(opt("tx"));
if(_texture) texture = _texture;

	render_begin(device);
	   device->SetTexture( 0, texture );
	  
        m_pd3dDevice->SetStreamSource( 0, m_pVB, 0, sizeof(SPECTRUMVERTEX) );
        m_pd3dDevice->SetIndices( m_pIB );
        m_pd3dDevice->SetFVF( D3DFVF_SPECTRUMVERTEX );

			if (1) { // AE
	    //hr = device->SetSamplerState( 0, D3DSAMP_ADDRESSU,  D3DTADDRESS_CLAMP );
        //hr = device->SetSamplerState( 0, D3DSAMP_ADDRESSV,  D3DTADDRESS_CLAMP );

        // Set linear filtering quality
        hr = device->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
        hr = device->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );

        // set maximum ambient light
        hr = device->SetRenderState(D3DRS_AMBIENT,RGB(255,255,255));

        // Turn off culling
        hr = device->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

        // Turn on the zbuffer
        //hr = device->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );

        // Turn off lights
        hr = device->SetRenderState(D3DRS_LIGHTING,FALSE);

        // Enable dithering
        hr = device->SetRenderState(D3DRS_DITHERENABLE, TRUE);

        // disable stencil
        hr = device->SetRenderState(D3DRS_STENCILENABLE, FALSE);

        // manage blending
        //int _blend = 0; 
		if (_blend) { // AE
        hr = device->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);

        hr = device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);

        hr = device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);

        hr = device->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);

        hr = device->SetRenderState(D3DRS_ALPHAREF, 0x10);

        hr = device->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATER);
		}

        // Set texture states:

        // Modulate diffuse color of the vertex with texture color (50% and 50%)
        // then when we set color of lower vertices of the flag to background color,
        // it blends with texture and gives coloring of the lower part of the flag
        // correspondent to the background
        hr = device->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
        hr = device->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
        hr = device->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );

        // turn off alpha operation
        hr = device->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );

}

       // m_pd3dDevice->SetTexture( 0, m_pCubeTex );
        m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP, D3DTOP_MODULATE );
        m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
        m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
        m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG2 );
        m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
        m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE );
		//hr = device->SetRenderState( D3DRS_ZENABLE, D3DZB_TRUE );

        m_pd3dDevice->DrawIndexedPrimitive( D3DPT_TRIANGLELIST, 0, 0,
                                            sizeof(m_vertices) / sizeof(SPECTRUMVERTEX),
                                            0, RENDER_PASSES * NUM_SECTORS * NUM_TRACKS * TRIS_PER_CUBE );

	

	hr = scene::render(device,texture); // calls compose, restore,  render

	hr = device->SetRenderState( D3DRS_ZENABLE, D3DZB_TRUE);

    //  device->SetVertexShader(0 );
    
    //_selection = 0;

	
    
	render_end(device);

 

    return hr;
}

void object_spectrum::CalculateColors()
{   
    // For each track
    for( int t=0; t < NUM_TRACKS; t++ )
    {
        float radius = INNER_RADIUS + (t * DISTANCE_PER_TRACK) + SPACING_PER_TRACK;

        m_colorsOn[t] = ((m_colorInner * (WHEEL_RADIUS - radius)) + 
                         (m_colorOuter * radius)) / WHEEL_RADIUS;
    }
}




//-----------------------------------------------------------------------------
// Name: ShiftColor()
// Desc: Per color channel helper for RotateColors
//-----------------------------------------------------------------------------
void object_spectrum::ShiftColor( DWORD& dwColor, int& offset )
{
    // Have a new offset ready if the current one will send the color out of
    // bounds. This offset must be at least 1 to make sure the color is
    // changed and should take into account framerate to make sure colors
    // change at consistent rates across different hardware.
    int newOffset = 1 + (int)( rand()%5 * 30*m_fElapsedTime );
    
    if( (int)dwColor + offset > 255 )
        offset = newOffset;
    else if( (int)dwColor + offset < 0 )
        offset = -newOffset;

    dwColor += offset;
}




//-----------------------------------------------------------------------------
// Name: RotateColors()
// Desc: Simple color cycling between frames
//-----------------------------------------------------------------------------
HRESULT object_spectrum::RotateColors()
{
    static offset[3] = {256, 256, 256};

    DWORD dwColor = m_colorInner;
    DWORD dwRed = (dwColor & 0x00ff0000) >> 16;
    DWORD dwGreen = (dwColor & 0x0000ff00) >> 8;
    DWORD dwBlue = (dwColor & 0x000000ff);

    ShiftColor( dwRed, offset[0] );
    ShiftColor( dwGreen, offset[1] );
    ShiftColor( dwBlue, offset[2] );

    m_colorInner = D3DCOLOR_ARGB( 255, dwRed, dwGreen, dwBlue );
    
    return S_OK;
}

