
#include "object-vsh.h"
#include <atlbase.h>

int object_vsh::handle(char* type, char* ev) {

	if (0) {
	} else return scene::handle(type,ev);
	sprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}




object_vsh::object_vsh() {
	m_pIB                = NULL;
    m_pVB                = NULL;
    m_dwSize             = 64;
    m_dwNumIndices       = (m_dwSize - 1) * (m_dwSize - 1) * 6;
    m_dwNumVertices      = m_dwSize * m_dwSize;
    m_pVertexShader      = NULL;
    m_pConstantTable     = NULL;
    m_pVertexDeclaration = NULL;
	_end = 10; loop = 1;
  }


object_vsh::~object_vsh()
{
//delete scenes[];
}

HRESULT 
object_vsh::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    
    // Create vertex shader
	TCHAR        tszPath[512] = "D:\\ViP\\effects\\HLSLwithoutEffects.vsh";
    LPD3DXBUFFER pCode;

    D3DVERTEXELEMENT9 decl[] =
    {
        { 0, 0, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0 },
        D3DDECL_END()
    };

    if( FAILED( hr = device->CreateVertexDeclaration( decl, &m_pVertexDeclaration ) ) )
    {
        //return DXTRACE_ERR( TEXT("CreateVertexDeclaration"), hr );
    }

    // Find the vertex shader file
	/*
    if( FAILED( hr = DXUtil_FindMediaFileCb( tszPath, 
        sizeof(tszPath), _T("HLSLwithoutEffects.vsh") ) ) )
    {
        //return DXTRACE_ERR( TEXT("DXUtil_FindMediaFileCb"), hr );
    }
	*/


	   // Define DEBUG_VS and/or DEBUG_PS to debug vertex and/or pixel shaders with the shader debugger.  
    // Debugging vertex shaders requires either REF or software vertex processing, and debugging 
    // pixel shaders requires REF.  The D3DXSHADER_FORCE_*_SOFTWARE_NOOPT flag improves the debug 
    // experience in the shader debugger.  It enables source level debugging, prevents instruction 
    // reordering, prevents dead code elimination, and forces the compiler to compile against the next 
    // higher available software target, which ensures that the unoptimized shaders do not exceed 
    // the shader model limitations.  Setting these flags will cause slower rendering since the shaders 
    // will be unoptimized and forced into software.  See the DirectX documentation for more information 
    // about using the shader debugger.
    DWORD dwShaderFlags = 0;
    #ifdef DEBUG_VS
        dwShaderFlags |= D3DXSHADER_FORCE_VS_SOFTWARE_NOOPT;
    #endif
    #ifdef DEBUG_PS
        dwShaderFlags |= D3DXSHADER_FORCE_PS_SOFTWARE_NOOPT;
    #endif

    // Assemble the vertex shader from the file
    if( FAILED( hr = D3DXCompileShaderFromFile( tszPath, NULL, NULL, "Ripple",
                                                //"vs_1_1", dwShaderFlags, &pCode,
												 "vs_2_0", dwShaderFlags, &pCode,
                                                NULL, &m_pConstantTable ) ) )
    {
        //return DXTRACE_ERR( TEXT("D3DXCompileShaderFromFile"), hr );
    }

    // Create the vertex shader
    hr = device->CreateVertexShader( (DWORD*)pCode->GetBufferPointer(),
                                            &m_pVertexShader );
    pCode->Release();

	m_handle = m_pConstantTable->GetConstantByName(NULL,"tex0");
    if( FAILED(hr) )
        ;//return DXTRACE_ERR( TEXT("CreateVertexShader"), hr );
 
    

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
object_vsh::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
   // Setup render states
    device->SetRenderState( D3DRS_LIGHTING, FALSE );
    device->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

    // Create and initialize index buffer
    WORD* pIndices;

    if( FAILED( hr = device->CreateIndexBuffer( m_dwNumIndices * sizeof(WORD),
                                                      0, D3DFMT_INDEX16,
                                                      D3DPOOL_DEFAULT, &m_pIB, NULL ) ) )
        ;//return DXTRACE_ERR( TEXT("CreateIndexBuffer"), hr );

    if( FAILED( hr = m_pIB->Lock( 0, 0, (void**)&pIndices, 0 ) ) )
        ;//return DXTRACE_ERR( TEXT("Lock"), hr );

    DWORD y;
    for( y = 1; y < m_dwSize; y++ )
    {
        for( DWORD x = 1; x < m_dwSize; x++ )
        {
            *pIndices++ = (WORD)( (y-1)*m_dwSize + (x-1) );
            *pIndices++ = (WORD)( (y-0)*m_dwSize + (x-1) );
            *pIndices++ = (WORD)( (y-1)*m_dwSize + (x-0) );

            *pIndices++ = (WORD)( (y-1)*m_dwSize + (x-0) );
            *pIndices++ = (WORD)( (y-0)*m_dwSize + (x-1) );
            *pIndices++ = (WORD)( (y-0)*m_dwSize + (x-0) );
        }
    }

    if( FAILED( hr = m_pIB->Unlock() ) )
        ;//return DXTRACE_ERR( TEXT("Unlock"), hr );

    // Create and initialize vertex buffer
    if( FAILED( hr = device->CreateVertexBuffer( m_dwNumVertices * sizeof(D3DXVECTOR2),
                                                       0, 0,
                                                       D3DPOOL_DEFAULT, &m_pVB, NULL ) ) )
        ;//return DXTRACE_ERR( TEXT("CreateVertexBuffer"), hr );

    D3DXVECTOR2 *pVertices;
    if( FAILED( hr = m_pVB->Lock( 0, 0, (void**)&pVertices, 0 ) ) )
        ;//return DXTRACE_ERR( TEXT("Lock"), hr );

    for( y = 0; y < m_dwSize; y++ )
    {
        for( DWORD x = 0; x < m_dwSize; x++ )
        {
            *pVertices++ = D3DXVECTOR2( ((float)x / (float)(m_dwSize-1) - 0.5f) * D3DX_PI,
                                        ((float)y / (float)(m_dwSize-1) - 0.5f) * D3DX_PI );
        }
    }

    if( FAILED( hr = m_pVB->Unlock() ) )
        ;//return DXTRACE_ERR( TEXT("Unlock"), hr );
	 // Setup the camera
    FLOAT fAspectRatio = (FLOAT)800 / (FLOAT)600;
    m_Camera.SetProjParams( D3DX_PI / 3, fAspectRatio, 0.1f, 100.0f );
    m_Camera.SetWindow( 800, 600 );
    m_Camera.SetViewQuat( D3DXQUATERNION(-0.275f, 0.3f, 0.0f, 0.9f) );

	if (1) {
	   //  hr = device->SetSamplerState( 0, D3DSAMP_ADDRESSU,  D3DTADDRESS_CLAMP );
       // hr = device->SetSamplerState( 0, D3DSAMP_ADDRESSV,  D3DTADDRESS_CLAMP );

        // Set linear filtering quality
        hr = device->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
        hr = device->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );

        // set maximum ambient light
        hr = device->SetRenderState(D3DRS_AMBIENT,RGB(255,255,255));

        // Turn off culling
        hr = device->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

        // Turn on the zbuffer
        hr = device->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );

        // Turn off lights
        hr = device->SetRenderState(D3DRS_LIGHTING,FALSE);

        // Enable dithering
        hr = device->SetRenderState(D3DRS_DITHERENABLE, TRUE);

        // disable stencil
        hr = device->SetRenderState(D3DRS_STENCILENABLE, FALSE);

        // manage blending
        hr = device->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);

        hr = device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);

        hr = device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);

        hr = device->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);

        hr = device->SetRenderState(D3DRS_ALPHAREF, 0x10);

        hr = device->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATER);


        // Set texture states:

        // Modulate diffuse color of the vertex with texture color (50% and 50%)
        // then when we set color of lower vertices of the flag to background color,
        // it blends with texture and gives coloring of the lower part of the flag
        // correspondent to the background
        hr = device->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
        hr = device->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
        hr = device->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );

        // turn off alpha operation
        hr = device->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );

}
 


    return hr;
}


HRESULT object_vsh::compose(IDirect3DDevice9* device,DWORD t) {
	//return S_OK;
	    // Update the camera
    m_Camera.FrameMove( timeGetTime() );

    // Set up the vertex shader constants
    D3DXMATRIXA16 mWorldViewProj;
    D3DXMATRIXA16 mWorld;
    D3DXMATRIXA16 mView;
    D3DXMATRIXA16 mProj;

	D3DXMATRIXA16 mWVP;

	
	device->GetTransform( D3DTS_WORLD, __world );
	device->GetTransform( D3DTS_VIEW, __view );
	device->GetTransform( D3DTS_PROJECTION, __projection );

    mWorld = *m_Camera.GetWorldMatrix();
    mView  = *m_Camera.GetViewMatrix();
    mProj  = *m_Camera.GetProjMatrix();

    //mWorldViewProj = mWorld * mView * mProj;
	mWVP = *_world() *  *_view() *  *_projection();  // AE _combined(); ??

    //m_pConstantTable->SetMatrix( device, "mWorldViewProj",&mWorldViewProj );
	m_pConstantTable->SetMatrix( device, "mWorldViewProj",&mWVP );
    m_pConstantTable->SetFloat( device, "fTime", dxtime() );
    return S_OK;
}


HRESULT 
object_vsh::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

if (opt("tx") && tx(opt("tx"))) _texture = tx(opt("tx"));
if(_texture) texture = _texture;

    m_pConstantTable->SetValue( device, m_handle, texture, sizeof(texture) );
    //m_handle->SetConstantByName(m_handle,"tex0");

	render_begin(device);
	   device->SetTexture( 0, texture );
	  
        device->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
        device->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
        device->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
        //device->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );

/*
	  D3DXMATRIXA16 mat;
		if (_embedded) {
        mat._11 = 0.25f; mat._12 = 0.00f; mat._13 = 0.00f; mat._14 = 0.00f;
        mat._21 = 0.00f; mat._22 =-0.25f; mat._23 = 0.00f; mat._24 = 0.00f;
        mat._31 = 0.00f; mat._32 = 0.00f; mat._33 = 1.00f; mat._34 = 0.00f;
        mat._41 = 0.50f; mat._42 = 0.50f; mat._43 = 0.00f; mat._44 = 1.00f;
		} else {
		mat._11 = 0.25*m_fTU; mat._12 = 0.00f; mat._13 = 0.00f; mat._14 = 0.00f;
        mat._21 = 0.00f; mat._22 = -0.25f*m_fTV; mat._23 = 0.00f; mat._24 = 0.00f;
        mat._31 = 0.00f; mat._32 = 0.00f; mat._33 = m_fTV;  mat._34 = 0.00f;
        mat._41 = 0.50 * m_fTU; mat._42 = 0.5 * m_fTV; mat._43 = 0.00f; mat._44 = m_fTU;
		}
        device->SetTransform( D3DTS_TEXTURE0, &mat );
        device->SetTextureStageState( 0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2 );
        device->SetTextureStageState( 0, D3DTSS_TEXCOORDINDEX, D3DTSS_TCI_CAMERASPACEPOSITION );
*/
        device->SetVertexDeclaration( m_pVertexDeclaration );
        device->SetVertexShader( m_pVertexShader );
        device->SetStreamSource( 0, m_pVB, 0, sizeof(D3DXVECTOR2) );
        device->SetIndices( m_pIB );

        hr = device->DrawIndexedPrimitive( D3DPT_TRIANGLELIST, 0, 0, m_dwNumVertices,
                                            0, m_dwNumIndices/3 );
	

	hr = scene::render(device,texture); // calls compose, restore,  render

      device->SetVertexShader(0 );
	  hr = device->SetRenderState( D3DRS_ZENABLE, D3DZB_TRUE );
    
    //_selection = 0;

	
    
	render_end(device);

 

    return hr;
}

