

#include "lectures/lecture-eca.h"
#include "scene/image.h"

// sub scenes

#include "odyssee/scene-0.h"
#include "odyssee/scene-1.h"
#include "odyssee/scene-2.h"
#include "odyssee/scene-3.h"

//#include "lectures/lecture-eca-text.h"
#include "objects/scene-text-3d.h"
#include "objects/background-scene.h"
//#include "lectures/lecture-eca-0.h"
//#include "lectures/scene-test.h"
#include "scene/text.h"
#include "scene/slides.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



//static char _key[256];

static char* msg[12][12];



int lecture_eca::handle(char* type, char* ev) {
	if (check(type,ev,"lbutton","down")) {
		if (_condition == WAIT) _condition = RUNNING;
		else (_condition = WAIT);
	} else if (check(type,ev,"arrow","down")) {
		if (_text) _text->next();
	} else if (check(type,ev,"arrow","up")) {
		if (_text) _text->next(-1);
	} else if (check(type,ev,"key","back")) {
		if (_slides) _slides->next(-1);
	} else if (check(type,ev,"key","tab")) {
		if (0 && state == 5) {
			int x = _exclude[4];
			if (x == 0) x = 1; else x = 0;
			_exclude[4] = x;
			//if (!x) _slides = scenes[4];
		}
		if (state == 5) {
			int x = _slides->exclude();
			if (x == 0) x = 1; else x = 0;
			_slides->exclude(x);
			//if (!x) _show = scenes[4];
		}
    } else if (check(type,ev,"key","space")) {
		if (state == 4) {
			if (0) {
			_idx = 0;
			scenes[4]->rate(-1);
			scenes[4]->state = 1;
			state = 5;
			_show = 1;
			scenes[4]->index(_idx);
			} else {
				//_idx = 0;
				_show = 1;
				_slides->rate(-1);
				_slides->state = 1;
				_slides->index(0);
				state = 5;
			}
		} else if (state == 5) {
			//_idx = scenes[4]->next();
			//_idx = _slides->next();
			 _idx = _slides->next();
			//scenes[4]->state = 1;
		}
		else _condition = START;
	} else 
		return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}


lecture_eca::lecture_eca() 
{

    clear(&msg);
	_select(1);

	msg[0][1] = "embodied conversational agents";
	msg[0][3] = "need content";
	msg[0][5] = "must be meaningfully";
	msg[0][7] = "embedded in relevant context";
	msg[0][9] = "centered around function";
	msg[0][11] = "developed with intelligent multimedia";
	


	msg[2][0] = "embodied agents must enhance";
	msg[2][1] = " user experience";
	msg[2][2] = "provide a wide range of";
	msg[2][3] = " agent functionality";
	msg[2][4] = "conform to stringent";
	msg[2][5] = " platform criteria";
	msg[2][6] = "and provide sufficient";
	msg[2][7] = " information support";
	msg[2][8] = "to become a";
	msg[2][9] = " natural assistant";
	msg[2][10] = "for the human user";


	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];


	msg[3][0] = "in this presentation ";
	msg[3][3] = " we will look at ";
	msg[3][4] = "requirements, applications and technology";
	msg[3][7] = " for agent development platform(s)";
	msg[3][8] = "shamelessly plugging our";
	msg[3][11] = " intelligent multimedia technology";

	
	msg[4][1] = "      ECA perspectives 2004";
	msg[4][6] = "           Anton Eliens";	
	msg[4][8] = "        Vrije Universiteit";
	msg[4][9] = "             Amsterdam";


_master(this);
_handler(this);
_display = "ECA perspectives 2004";
scale(0.9f,0.9f,0.9f);
//translation(100,100,0);

loop = 0;
end(125); // seconds
_event = 1;

count = 12; //8;
_text3d = 5;
_text3ds = 6;
_txt = 7;

_exclude[0] = 1;
_exclude[1] = 1;
_exclude[2] = 1;
_exclude[3] = 1; 
_exclude[4] = 1;
_exclude[5] = 1;
_exclude[6] = 1;
_exclude[7] = 1;
_exclude[8] = 1; 
_exclude[9] = 1;
_exclude[10] = 1;
_exclude[11] = 1;


//scenes[count-1] = new scene_text();
//_exclude[count-1] = 0;


//_background = new background_scene();

scenes[0] = new scene_0();
scenes[1] = new scene_1();
scenes[2] = new scene_2();
scenes[3] = new scene_1(); //scene_3();

//scenes[4] = new lecture_eca_0();
//scenes[4] = new slides("imm-intro",1,6);
scenes[4] = new slides(loc("\\vip\\present\\eca"),"img0",1,8,"jpg");
//scenes[4] = new scene_test();
//_exclude[4] = 0;
_slides = scenes[4];
//_slides->exclude(1);
//scenes[0]->exclude();
//scenes[1]->exclude(); 
//scenes[2]->exclude(); 
//scenes[3]->exclude(); 


scenes[_text3d] = new scene_text_3d("ECA");
scenes[_text3d]->scale(0.5,0.5,0.5);
scenes[_text3d]->translation(-0.5,2.2,-2.5);
scenes[_text3d]->rotation(0,1,0,-0.2);

scenes[_text3ds] = new scene_text_3d("perspectives");
scenes[_text3ds]->scale(0.3,0.3,0.3);
scenes[_text3ds]->translation(-0.7,1.5,-2.5);
//_text = new lecture_eca_text(24);
scenes[_txt] = new text(&msg);
_text = scenes[_txt];
}

lecture_eca::~lecture_eca()
{
//delete scenes[];
}

HRESULT lecture_eca::compose(IDirect3DDevice9* device,DWORD t) {
HRESULT hr = S_OK;

return hr;
}


HRESULT 
lecture_eca::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;



	// set transform and render

render_begin(device);
	

// begin the lecture_eca

//float f = fraction();


int states = 4;
 
//_background -> draw(device,texture);

if (condition() == START) {
        interval(now(),_end);
		_condition = RUNNING;
		_event = 1;
}

//if (inbetween(2,12)) {
if (1 && !condition() && inbetween(15,26)) {
	 if (state != previous || event() > 0) scenes[_text3ds]->interval(now(),8);
	_exclude[_text3d] = 0;
	_exclude[_text3ds] = 0;
	float f = scenes[_text3ds]->fraction();
	scenes[_text3ds]->rotation(0,0,1,3.14 * f);
} else {
	_exclude[_text3d] = 1;
	_exclude[_text3ds] = 1;
}

if (0 && !condition() && inbetween(5,15)) {
	_exclude[4] = 0;
	 _show = 1;
	 if (state != previous) {
	      scenes[4]->interval(now(),40);
	 }
}

if (!condition() && inbetween(5,15)) {
	_text->state = 0;
	_exclude[_txt] = 0;
} else if (!condition() && inbetween(40,50)) {
	_text->state = 1;
	_exclude[_txt] = 0;
} else if (!condition() && inbetween(50,60)) {
	_text->state = 2;
	//_text->index(2);
	_exclude[_txt] = 0;
} else if (!condition() && inbetween(90,100)) {
	_text->state = 3;
	_exclude[_txt] = 0;
} else if (!condition() && inbetween(115,150)) {
	_text->state = 4;
	_exclude[_txt] = 0;
} else {
	_exclude[_txt] = 1;
}


if (condition() > 0) {
	_project( _active() );
	//if (_project) _backdrop = 1 - _active;

	state = 0;
	if (condition() != WAIT)
		 for (int i = 0; i < count; i++) _exclude[i] = 1;
} else if (!condition() && inbetween(0,15)) {
	_project( _active() );
	if (_project()) _backdrop( 1 - _active() );
    state = 0;
	_exclude[0] = 1;
	_exclude[1] = 1;
	_exclude[2] = 1;
	_exclude[3] = 1;
	_exclude[4] = 1;
	_a = (int) 180 - current() * 12;
	_ultra()->message(_x,_y,argb(_a,133,197,235),"ECA perspectives");
 
    
} else if (!condition() && inbetween(15,26)) {
	_project( _active() );
	_index = _select();
	 state = 0;
	 _exclude[3] = 1;
	 _exclude[0] = 0;
	 if (state != previous) {
		 scenes[0]->interval(now(),30); // until 
		 scenes[_text3d]->interval(now(),8);
	 }
	
} else if (!condition() && inbetween(26,50)) {
	_project( _select() );
     state = 1;
	 _exclude[0] = 1;
	 _exclude[1] = 0;
	 if (state != previous) {
	      scenes[1]->interval(now(),20);
     }
} else if (!condition() && inbetween(50,60)) {
     state = 2;
	 _exclude[1] = 1;
	 _exclude[2] = 0;
	 if (state != previous) {
	      scenes[2]->interval(now(),10);
	
	 }
}  else if (!condition() && inbetween(60,110)) {
     state = 3;
	 if (current()>95) _exclude[0] = 0; 
	 if (current()>80) _exclude[1] = 0;
	 
	 //if (current()>85) _exclude[2] = 0;
	 _exclude[2] = 1;
	 _exclude[3] = 1;
	 _exclude[4] = 0;
	 _show = 1;
	 if (state != previous) {
	      scenes[4]->interval(now(),40);
	 }
	 if (current()>90) { _exclude[4] = 1; _show = 0; }
}  else if (!condition() && current() > 110 && state < 5) {
	//_condition = END;
	_select( 0 );
	_project( _active() );
	_backdrop( 1 - _active() );
	state = 4;
	_exclude[0] = 1;
	_exclude[1] = 1;
	_exclude[2] = 1;
	_exclude[3] = 1;
	if (!scene::_source()) _exclude[4] = 0;
	_show = 1;
	if (state != previous) {
	      scenes[4]->interval(now(),20);
	 }
	//state = 4;
}  else if (!condition() && current() > 110 && state == 5) {
	//_condition = END;
	state = 5;
	_exclude[0] = 1;
	_exclude[1] = 1;
	_exclude[2] = 1;
	_exclude[3] = 1;
	if (!scene::_source()) _exclude[4] = 0;
	
	 scenes[4]->rate(0);
	
	//state = 4;
}





	hr = scene::render(device,texture); // calls restore, compose, render

if (!condition() && inbetween(15,30)) {
	float f = (current()-15.0)/15.0;
	_a = 255 - 100.0*f;
	_r = 255 - 100.0 * f;
	_g = 197;// - 5 * f;
	_b = 235;// - 5 * f;
	scene::_large()->message(_x-_tab*8,height()-_inc*8,argb(_a,_r,_g,_b),
			  "Requirements, Applications, Technology");
	}
if (!condition() && inbetween(20,40)) {
	float f = (current()-20.0)/20.0;
	_a = 100 + 100.0 * f * 2;
	_r = 133;+ 100.0 * f * 2;
	_g = 197;+ 40.0 * f * 2;
	_b = 235 + 10.0 * f * 2; // * current();
	if (current() > 30) {
	_a = 255; _r = 255; _g =255; _b = 255;
	}
	scene::_plain()->message(_x-_tab*3,_y,argb(_a,_r,_g,_b),
			  "A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	scene::_small()->message(_x+_tab+50,_y+_inc*3,argb(_a,_r,_g,_b),
		      "Intelligent Multimedia");
	scene::_large()->message(_x+30,_y+_inc*6,argb(_a,_r,_g,_b),
		      "VU Amsterdam");
	
}

display(_display);


if (0) {
	char buf[256];
	wsprintf(buf,TEXT("[%d:%d] %3.1f (%0.2f) : %2.1f"), _condition, state,
		(float)current(), 
		fraction(), fps());// ,_idx+1,_slides->maxs());
	
	message(_lx,_ly,0xff1ff1ff0,buf);
	//message(_lx,_ly,D3DCOLOR_ARGB(180,133,197,235),buf);
	//D3DCOLOR_ARGB(180,133,197,235)
	wsprintf(buf,"(%d/%d)",_slides->index()+1,_slides->maxs());
    message(_rx+50,_ly,argb(180,133,197,235),buf);

	wsprintf(buf,"%s",_key);
	if (0) message(width()-115,_y,0xff1ff1ff0,buf);
}
	//if (scene::_text) {
	//scene::_text->message(300,200,D3DCOLOR_ARGB(180,133,197,235),"ECA perspectives");
	//}
	render_end(device);

 

    return hr;
}

