#include <hush/source.h>

#include "lectures/lecture-vip.h"
#include "scene/image.h"
#include <scene/satelite.h>
#include <scene/shader.h>
#include <scene/mesh.h>

#include <hush/string.h>

// sub scenes

#include "odyssee/scene-0.h"
#include "odyssee/scene-1.h"
#include "odyssee/scene-2.h"
#include "odyssee/scene-3x.h"

//#include "extra/object-vsh.h"
#include "extra/object-dolphin.h"
#include "extra/object-water.h"
#include "extra/object-flag.h"

#include "extra/object-spectrum.h"

static scene* _hold = 0;
static scene* _water = 0;
static scene* _spectrum = 0;
static scene* _bulb = 0;
static scene* _flag = 0;
static scene* dolphin1;
static scene* dolphin2;


//#include "lectures/lecture-eca-text.h"
#include "objects/scene-text-3d.h"
#include "objects/background-scene.h"
//#include "lectures/lecture-eca-0.h"
//#include "lectures/scene-test.h"
#include "scene/text.h"
#include "scene/slides.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



//static char _key[256];

static char* msg[12][12];



int lecture_vip::handle(char* type, char* ev) {
	if (check(type,ev,"lbutton","down")) {
		if (_condition == WAIT) _condition = RUNNING;
		else (_condition = WAIT);
	} else if (check(type,ev,"arrow","down")) {
		if (_text) _text->next();
	} else if (check(type,ev,"arrow","up")) {
		if (_text) _text->next(-1);
	} else if (check(type,ev,"key","back")) {
		if (_slides) _slides->next(-1);
	} else if (check(type,ev,"key","return")) {
		_slides->exclude(1);
		_exclude[4] = 1;
		_condition = WAIT; state = 0;
		_exclude[0] = 1;
		_exclude[1] = 1;

	} else if (check(type,ev,"key","tab")) {
	
		if (state == 5 || state == 4) {
			int x = _slides->exclude();
			if (x == 0) x = 1; else x = 0;
			_slides->exclude(x);
			//if (!x) _show = scenes[4];
		} else { state = 0; _condition = WAIT; }
    } else if (check(type,ev,"key","space")) {
		if (state == 4) {
			if (0) {
			_idx = 0;
			scenes[4]->rate(-1);
			//scenes[4]->state = 1;
			state = 5;
			_show = 1;
			scenes[4]->index(_idx);
			} else {
				//_idx = 0;
				_show = 1;
				_slides->rate(-1);
				_slides->state = 1;
				_slides->index(0);
				state = 5;
			}
		} else if (state == 5) {
			//_idx = scenes[4]->next();
			//_idx = _slides->next();
			 _idx = _slides->next();
			//scenes[4]->state = 1;
		}
		else _condition = START;
	} else 
		return scene::handle(type,ev);
	sprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}


lecture_vip::lecture_vip() 
{

	_debug = 0;
    
	_select(1);
	_cx(40); _cy(0);
	sprintf(_type,"lecture");

	opt("type","lecture");
	opt("lecture","vip");
	//opt("lecture","eca");

	opt("text",fm("text/%s",opt("lecture")));

	opt("phase(0)","<0.15>");

	string instance = opt("lecture");

	if (instance == "vip") {

	opt("display","ViP 2004");
	opt("text(title)","   ViP 2004 ");
	opt("text(sub)","webcams           video             images");

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","virtual");
	opt("logo(3ds)","poetry");
	opt("logo(vip)","ViP");

	} else if (instance == "eca") {
    _cx(0); // _cy(10);
	_x -= 100;
	opt("display","ECA perspectives 2004");
	opt("text(title)","ECA perspectives 2004 ");
	opt("text(sub)","Requirements, Applications, Technology");

	opt("text(authors)","A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","ECA");
	opt("logo(3ds)","perspectives");
	opt("logo(vip)","ECA");
	}
	
	_display = opt("display");
	


_master(this);
_handler(this);
//_display = "ViP 2004";
scale(0.9f,0.9f,0.9f);
//translation(100,100,0);

loop = 0;
end(125); // seconds
_event = 1;

count = 12; //8;
_text3d = 7;
_text3ds = 8;
_text3d2 = 9;
_txt = 10;

_exclude[0] = 1;
_exclude[1] = 1;
_exclude[2] = 1;
_exclude[3] = 1; 
_exclude[4] = 1;
_exclude[5] = 1;
_exclude[6] = 0;
_exclude[7] = 1;
_exclude[8] = 1; 
_exclude[9] = 1;
_exclude[10] = 1;
_exclude[11] = 0;


//scenes[count-1] = new scene_text();
//_exclude[count-1] = 0;



if (1) {
scene* s = new scene();
s->count = 6;

//s->mode(1);



s->scenes[4] = new satelite("mesh=circle factor=0.2 distort=1"); //satelite();
s->scenes[4]->translation(2,0.8,2.0);
s->scenes[4]->scale(0.1,0.1,0.1);
s->_exclude[4] = 0;
s->scenes[5] = new satelite("distort=1 mesh=tiger scale=0.8 distance=2.0 factor=0.2");
s->scenes[5]->translation(2.0,0.8,2.0);
s->scenes[5]->scale(0.1,0.1,0.1);
s->_exclude[5] = 1;

s->translation(1,-2,0);
//}
//s->scale(0.1,0.1,1);
//s->scenes[1] = new shader(s);
//scenes[1]->scale(0.1,0.1,1);

s->scenes[2] = new satelite();
s->scenes[2]->propagate("mesh=circle distort=1");
s->scenes[2]->translation(0,0,0);

//s->propagate("mesh=circle");
s->scale(0.4,0.4,0.4);

poption("vip(x)",s);
_bulb = (scene*) poption("vip(x)");
} 


//_background = new background_scene();

scenes[0] = new scene_0();
popt("scene/0",scenes[0]);
(*this)[1] = new scene_1();
//scopt("2",new scene_2());
(*this)[2] = new scene_2();
//scenes[2] = new scene_2();
scenes[3] = new scene_3x(); //scene_3();
_stack = 1;

//scenes[4] = new lecture_vip_0();
if (instance == "vip") {
scenes[4] = new slides(opt("slides"));
} else if (instance == "eca") {
	scenes[4] = new slides("d:\\vip\\present\\eca","img0",1,8,"jpg");
}

//scenes[0] = scenes[4];
_slides = scenes[4]; // 4

_slides->exclude(1); 

//scenes[0] = scenes[4]; _slides->exclude(0);

scenes[5] = // _bulb;
   new object_flag();


(*this)[11] = new object_dolphin();


_water = new object_water();

/*
scenes[11]->scenes[0] = _water;
scenes[11]->_exclude[0] = 1;
scenes[11]->scenes[1] = _bulb; // (scene*) poption("vip(x)");
scenes[11]->_exclude[1] = 1;
scenes[11]->count = 3;
*/
//_lst = 1;
lst("bulb",_bulb);
lst("water",_water);

//scenes[11]->count = 2;
_spectrum = _scene = new object_spectrum();

_scene->translation(0,0,1); // no op

//scenes[11]->scale(2,2,2);
scenes[6] = _flag = new object_flag();
scenes[6]->rotation(0,1,0,0.5 * 3.14);
scenes[6]->scale(2.3,0.9,0.5);
scenes[6]->translation(0,-16.2,10); // no op

scenes[5]->translation(0,0,-4);


scenes[_text3d2] = new scene_text_3d(opt("logo(vip)"));
scenes[_text3d2]->scale(0.8,0.8,0.8);
scenes[_text3d2]->translation(-0.5,1.5,-2.5);

if (!is("lecture","eca")) {

scenes[_text3d] = new scene_text_3d(opt("logo(3d)"));
scenes[_text3d]->scale(0.4,0.4,0.4);
scenes[_text3d]->translation(-0.4,2.3,-2.5);
scenes[_text3d]->rotation(0,1,0,-0.2);

scenes[_text3ds] = new scene_text_3d(opt("logo(3ds)"));
scenes[_text3ds]->scale(0.6,0.6,0.6);
scenes[_text3ds]->translation(-0.6,1.4,-2.5);

} else {

scenes[_text3d] = new scene_text_3d(opt("logo(3d)"));
scenes[_text3d]->scale(0.5,0.5,0.5);
scenes[_text3d]->translation(-0.5,2.2,-2.5);
scenes[_text3d]->rotation(0,1,0,-0.2);

scenes[_text3ds] = new scene_text_3d(opt("logo(3ds)"));
scenes[_text3ds]->scale(0.3,0.3,0.3);
scenes[_text3ds]->translation(-0.7,1.5,-2.5);

}

scenes[_txt] = scr(opt("text")); //new text(&msg);
_text = scenes[_txt];
debug(fm("text = %d",(int)_text),0);
}

lecture_vip::~lecture_vip()
{
//delete scenes[];
}


HRESULT lecture_vip::init(IDirect3DDevice9* device) {
HRESULT hr = S_OK;


//_tk->load("text");


hr = scene::init(device);

return hr;
}

HRESULT lecture_vip::compose(IDirect3DDevice9* device,DWORD t) {
HRESULT hr = S_OK;


if (!dolphin1) dolphin1 = ((dxscene*) dvscene::lookup("object/dolphin"));
//if (!dolphin2) dolphin2 = (scene*) ((dxscene*) dvscene::lookup("menu/vip"))->poption("dolphin");
dolphin2 = (*this)[11];
//dolphin2 = scenes[11];

dolphin1->state = 1;
dolphin2->state = 1;


return hr;
}


HRESULT 
lecture_vip::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;


if (1) {
_bulb->_texture = _capture;
_water->_texture = _capture;
_spectrum->_texture = _capture;
_flag->_texture = _capture;

texture = _captures(_select());
}

	// set transform and render

render_begin(device);

scenes[0] = sc("scene/0");
scene::_main()->_scene->_exclude[10] = 0;
//_parent->_exclude[10] = 0;
//dolphin2 = _parent->scenes[10];
dolphin1->state = 1;
dolphin2->state = 1;

if (current()>95) {
	//dolphin1->state = 0;
	//dolphin2->state = 0;
}
	

// begin the lecture_vip

//float f = fraction();


int states = 4;
 
//_background -> draw(device,texture);

if (condition() == START) {
	    _slides->rate(3);
		_slides->state = 0;
		_slides->exclude(0);
        interval(now(),_end);
		
		_condition = RUNNING;
		_event = 1;
}

//if (inbetween(2,12)) {
if (1 && !condition() && inbetween(106,115)) {
	static int _not = 0;
	if (!_not++) scenes[_text3d2]->interval(now(),8);
	_exclude[_text3d2] = 0;
	float f = scenes[_text3d2]->fraction();
	scenes[_text3d2]->rotation(0,0,1,3.14 * f);
} else {
	_exclude[_text3d2] = 1;
	//_exclude[_text3ds] = 1;
}

if (1 && !condition() && inbetween(15,26)) {
	if (is("lecture","eca")) {
	 if (state != previous || event() > 0) scenes[_text3ds]->interval(now(),8);
	_exclude[_text3d] = 0;
	_exclude[_text3ds] = 0;
	float f = scenes[_text3ds]->fraction();
	scenes[_text3ds]->rotation(0,0,1,3.14 * f);
	} else {
			if (state != previous || event() > 0) {
		       scenes[_text3ds]->interval(now(),8);
	        }
	_exclude[_text3d] = 0;
	_exclude[_text3ds] = 0;
	float f = scenes[_text3ds]->fraction();
	scenes[_text3ds]->rotation(0,0,1,3.14 * f);
	}
} else {
	_exclude[_text3d] = 1;
	_exclude[_text3ds] = 1;
}



if (0 && !condition() && inbetween(5,15)) {
	_exclude[4] = 0;
	 _show = 1;
	 if (state != previous) {
	      scenes[4]->interval(now(),40);
	 }
}

if (!condition() && inbetween(5,15)) {
	_text->state = 0;
	_exclude[_txt] = 0;
} else if (!condition() && inbetween(40,50)) {
	_text->state = 1;
	_exclude[_txt] = 0;
} else if (!condition() && inbetween(50,60)) {
	_text->state = 2;
	//_text->index(2);
	_exclude[_txt] = 0;
} else if (!condition() && inbetween(90,100)) {
	_text->state = 3;
	_exclude[_txt] = 0;
} else if (!condition() && inbetween(118,150)) {
	_text->state = 4;
	_exclude[_txt] = 0;
} else {
	_exclude[_txt] = 1;
}


if (_total()) _project( _active() % _total() );
_blend = 0;
_scene = _bulb;

if (condition() > 0) {
	//_project = _active;
	//if (_project) _backdrop = 1 - _active;

	state = 0;
	if (condition() != WAIT)
		 for (int i = 0; i < count; i++) _exclude[i] = 1;
	if (current() > 10 && current() < 10.5) _bulb->scenes[2]->propagate("distort=1");
} else if (!condition() && in("phase(0)")) {
	//} else if (!condition() && inbetween(0,15)) {
	//_project = _active;
	_scene = _bulb; //(scene*) poption("vip(x)");
	if (current() > 5) _bulb->_exclude[2] = 1;
	//_bulb->scale(0.3,0.3,0.3);
	//_exclude[5] = 0;
	if (_project()) _backdrop( 1 - _project() );
    state = 0;
	_exclude[0] = 1;
	_exclude[1] = 1;
	_exclude[2] = 1;
	_exclude[3] = 1;
	_exclude[4] = 1;
	//_a = (int) 255 - current() * 20;
	//if (_a > 0) _ultra()->message(_x,_y,argb(_a,133,197,235),"  ViP 2004 ");
 
    
} else if (!condition() && inbetween(15,26)) {
	//_parent->_exclude[0] = 0;
	//_project = _active;
	_index = _select();
	 state = 0;
	 _exclude[3] = 1;
	 _exclude[0] = 0;
	 _exclude[5] = 0;
	 if (state != previous) {
		 scenes[0]->interval(now(),30); // until 
		 scenes[_text3d]->interval(now(),8);
		 //if (_hold) _scene = _hold;
	 }
	 dolphin1->state = 0;
	 dolphin2->state = 0;
	 if ((current()>20)) {
	 _bulb->_exclude[4] = 1;
	 _bulb->_exclude[5] = 0;
	 }
} else if (!condition() && inbetween(26,50)) {
	_scene = _spectrum;
	_scene->_blend = 0;
	//_project = _select;
     state = 1;
	 _exclude[0] = 1;
	 _exclude[1] = 0;
	 _exclude[5] = 1;
	 scenes[10]->state = 1;
	 if (current() > 45.0) _scene->_blend = 1;
	 if (state != previous) {
	      scenes[1]->interval(now(),20);
     }
} else if (!condition() && inbetween(50,60)) {
	
     state = 2;
	 _exclude[1] = 1;
	 _exclude[2] = 0;
	  //scenes[11]->state = 0;
	 //dolpin2->state = 0;
	 
	 if (state != previous) {
	      scenes[2]->interval(now(),10);
	
	 }
}  else if (!condition() && inbetween(60,118)) {
     state = 3;
	 //_scene->_blend = 0;
	 _scene = 0;
	 _scene = _bulb;

	 scenes[6]->_lights = 1;
	 
	 if (state != previous) {
	      scenes[3]->interval(now(),30);
	
	 }

	 _exclude[3] = 0;
	 if (current()>95) _exclude[0] = 0; 
	 if (current()>80) _exclude[1] = 0;
	 if (current()>90) _exclude[3] = 1;
	 
	 //if (current()>85) _exclude[2] = 0;
	 _exclude[2] = 0;
	 
	 _exclude[4] = 0;
	 _show = 1;
	 if (state != previous) {
	      scenes[4]->interval(now(),40);
	 }
	 if (current()>85) { _exclude[4] = 1; _show = 0; }

}  else if (!condition() && current() > 110 && state < 5) {
	//_parent->_exclude[0] = 1;
	//_condition = END;
	_scene = _water; //(scene*) poption("vip(x)");
	//_scene->translation(1,1,0);
	_select(0);
	scenes[6]->_lights = 0;
	//_project = _active;
	_backdrop( 1 - _active() );
	state = 4;
	_exclude[0] = 1;
	_exclude[1] = 1;
	_exclude[2] = 1;
	_exclude[3] = 1;
	_exclude[4] = 0;
	_show = 1;
	if (state != previous) {
	      scenes[4]->interval(now(),20);
	 }

	
	//state = 4;
}  else if (!condition() && current() > 110 && state == 5) {
	//_condition = END;
	state = 5;
	//_project = _active;
	_exclude[0] = 1;
	_exclude[1] = 1;
	_exclude[2] = 1;
	_exclude[3] = 1;
	_exclude[4] = 0;

	static int once = 0;
	//_hold = _scene;

	_scene = _water;
	_bulb->_exclude[4] = 0;
	_bulb->_exclude[5] = 1;
	_bulb->_exclude[2] = 0;
	_bulb->translation(0,1,-2);
	//_scene->_scene = _bulb;
	scenes[0] = _bulb;
	_exclude[0] = 0;
	
	//if (!once++) _scene = new object_water();
	
	 scenes[4]->rate(0);

	if (dxtime() > 125) _scene->_max = 15;
	if (dxtime() > 140) _scene->_max = 25;
	if (dxtime() > 145) _scene->_max = 100;

	if (strcmp(opt("lecture"),"vip")) {
	if (dxtime() > 125 ) {  _exclude[6] = 1; }
	if (dxtime() > 150) {
		_scene = 0;
		dolphin1->exclude(1);
		dolphin2->exclude(1);
		_bulb->_exclude[5] = 0;
		_slides->scale(1.2,1.2,1);

	}
	}
	if (dxtime() > 160) {
		_scene = 0;
		_exclude[0] = 1;
	}
	//if (dxtime() > 160) _scene->_max = 1000;


	
	//state = 4;
}




	hr = scene::render(device,texture); // calls restore, compose, render


if (1 && !condition() && inbetween(1,15)) {
	_a = (int) 255 - current() * 20;
	if (_a > 0) _ultra()->message(_x,_y,argb(_a,133,197,235),opt("text(title)")); //"  ViP 2004 ");
}

if (1 && !condition() && inbetween(15,40)) {
	float f = (current()-15.0)/25.0;
	_a = 250.0;//*f;
	_r = 133 + 120.0 * f;// + 5 * current();
	_g = 197;// - 150 * f;
	_b = 235;// - 200 * f;;
	scene::_large()->message(100+_x-_tab*10,height()-_inc*6,argb(_a,_r,_g,_b), opt("text(sub)"));
			//  "webcams           video             images");
	}
if (!condition() && inbetween(20,40)) {
	float f = (current()-20.0)/20.0;
	_a = 255 - 200.0 * f;
	_r = 255;// + 122.0 * f;
	_g = 80;// - 80.0 * f;
	_b = 80;// - 125.0 * current();
	
	scene::_small()->message(50+_x+_tab+100,_y+_inc*5,argb(_a,_r,_g,_b), opt("text(title)"));
		      //"ViP 2004");
	
	
}

if (!condition() && inbetween(20,40) && opt("text(authors)")) {
	float f = (current()-20.0)/20.0;
	_a = 100 + 100.0 * f * 2;
	_r = 133;+ 100.0 * f * 2;
	_g = 197;+ 40.0 * f * 2;
	_b = 235 + 10.0 * f * 2; // * current();
	if (current() > 30) {
	_a = 255; _r = 255; _g =255; _b = 255;
	}
	scene::_plain()->message(100+_x-_tab*3,_y,argb(_a,_r,_g,_b),opt("text(authors)"));
			 // "A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	scene::_small()->message(100+_x+_tab+50,_y+_inc*3,argb(_a,_r,_g,_b),
		      "Intelligent Multimedia");
	scene::_large()->message(100+_x+30,_y+_inc*6,argb(_a,_r,_g,_b),
		      "VU Amsterdam");
	
}

    display(_display);


	render_end(device);

 

    return hr;
}

