#include <hush/source.h>
#include "main-scene.h"

// sub scenes

//#include "stdafx.h"
//#include "objects/scene-text-3d.h"
#include "lectures/lecture-eca.h"
#include "lectures/lecture-imm.h"
#include "lectures/lecture-vip.h"
//#include "odyssee/scene-test.h"
#include "objects/background-scene.h"
#include "odyssee/scene-odyssee.h"
//#include <string.h>
#include "scene/menu.h"
#include "main/menu-media.h"
#include "main/menu-present.h"
#include "main/menu-dots.h"
#include "main/menu-vip.h"
#include "extra/object-dolphin.h"
#include "extra/object-water.h"
#include "extra/object-spectrum.h"
#include "scene/video.h"

#include <atlbase.h>


//static msg_array msg; //[12][12];


static int preset = 4;
static int enable = 0;

static int testmode =0; // change this on delivery
static msg_array msg;

main_scene::main_scene() 
{

//width = 1280;
//fullscreen = 0;
fullscreen = 0;
//_embedded = 1;
_parent = _main;
//_stack = 1;
//_lazy = 0;
_msg = &msg;

_selection = preset;
_enabled = enable;

clear(&msg);

//msg[1][1] = "visualpoetry.tv";
msg[1][2] = "multimedia";
msg[1][3] = "presentations";
msg[1][4] = "    ...";

if (!_embedded)
msg[1][6] = "virtualpoetry.tv";
else
msg[1][6] = "virtualpoetry.tv";

_states = 7;
//count = 12;

_display = "ViP";

scenes[0] = new background_scene();
//count =  12;//states + 2;
if (_embedded || testmode) {

_exclude[0] = 1;
} else {
_exclude[0] = 0;
}


if (_video) _scene = _video; else _video = this;


scenes[6] = new menu_vip();
scenes[2] = new menu_media();
scenes[3] = new menu_present();
scenes[4] = new menu_dots();

//scenes[10] = new object_water();
scenes[10] = new object_dolphin();
//_exclude[10] = 0;
//scenes[10] = new object_spectrum();
_exclude[10] = 1;



}

main_scene::~main_scene()
{
//delete scenes[];
}

HRESULT 
main_scene::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	// anything else ?

	hr = menu::init(device); // loops through scenes
	if (_scene) rectangle(_scene->_tu,_scene->_tv);

    return hr;
}


HRESULT 
main_scene::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    
	_exclude[10] = 0;
	//if (_enabled && _selection != preset) _exclude[10] = 1; 
	if (_enabled ) _exclude[10] = 1; 

	//scale(100,100,1);
	set_mode(0);

	//device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1);
	//device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE);
	device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_DISABLE);
	//DISABLE
	if (1) {
	
	D3DXMATRIXA16 matWorld;
	D3DXMatrixIdentity( &matWorld );
	device->SetTransform(D3DTS_WORLD,&matWorld);
    //scale(150,150,150);

    // Set up our view matrix. A view matrix can be defined given an eye point,
    // a point to lookat, and a direction for which way is up. Here, we set the
    // eye five units back along the z-axis and up three units, look at the
    // origin, and define "up" to be in the y-direction.
    
	if (1) {
	//D3DXVECTOR3 vEyePt( 0.0f, 3.0f,-5.0f );
	D3DXVECTOR3 vEyePt( 0.0f, 3.0f,-4.0f );

    D3DXVECTOR3 vLookatPt( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );
    D3DXMATRIXA16 matView;
    D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &vUpVec );
    device->SetTransform( D3DTS_VIEW, &matView );

    // For the projection matrix, we set up a perspective transform (which
    // transforms geometry from 3D view space to 2D viewport space, with
    // a perspective divide making objects smaller in the distance). To build
    // a perpsective transform, we need the field of view (1/4 pi is common),
    // the aspect ratio, and the near and far clipping planes (which define at
    // what distances geometry should be no longer be rendered).
    D3DXMATRIXA16 matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 100.0f );
    device->SetTransform( D3DTS_PROJECTION, &matProj );
    }
	}

//device->SetRenderState( D3DRS_ZENABLE, FALSE );

    return hr;
}



HRESULT 
main_scene::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;
    
if (_scene) {
	_texture = texture = _scene->_texture;
	scene::load_captures(_texture);

}
	_texture = texture;

	hr = menu::render(device,_texture); // calls restore, compose, render
   

 
    return hr;
}

/*

  // don t bother, is inherited as is

void
main_scene::rectangle( float fTU, float fTV )
{
	m_fTU = fTU;
	m_fTV = fTV;
    
	for (int i=0; i < count; i++) {
            scenes[i]->rectangle(fTU,fTV);
	}
	

}
*/
