//------------------------------------------------------------------------------
// File: PlaneScene.cpp
//
// Desc: DirectShow sample code - implementation of the movie_scene class
//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//------------------------------------------------------------------------------


#include "movie-scene.h"
#include "scene/util.h"

#include <D3DX9.h>
#include "common/D3DUtil.h"
#include "common/DXUtil.h"
//#include "D3DEnumeration.h"
//#include "D3DSettings.h"
//#include "D3DApp.h"
//#include "D3DFile.h"
//#include "D3DFont.h"


extern HINSTANCE hInst;
extern IDirect3D9* g_d3d; 
extern IDirect3DDevice9* g_d3dd;
extern HWND  g_hWnd;


//const DWORD FVF = (D3DFVF_XYZRHW | D3DFVF_TEX1);
const DWORD FVF = ( D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1 );

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

movie_scene::movie_scene(char* s)
{
	init();
	

	if (s) { // image
	    //state = 1;
	    image = s;
	}
	init();
}

movie_scene::movie_scene(char* path, char* name, int from, int to, char* ext) {
init();
	_path = path;
_name = name;
_from = from;
_to = to;
_ext = ext;
}


void movie_scene::init() {
image = 0;
_path = 0;
_name = 0;
_from = 0;
_ext = "jpg";
_to = 0;
//_cnt = 0;
//_idx = -1;
//_rate = 0;
//_xtime = 0;

//for (int i = 0;  i < MAXTEXTURES; i++) _textures = 0;

	m_vertices[0].position = CUSTOMVERTEX::Position(-1.0f,  1.0f, 0.0f); // top left
    m_vertices[1].position = CUSTOMVERTEX::Position(-1.0f, -1.0f, 0.0f); // bottom left
    m_vertices[2].position = CUSTOMVERTEX::Position( 1.0f,  1.0f, 0.0f); // top right
    m_vertices[3].position = CUSTOMVERTEX::Position( 1.0f, -1.0f, 0.0f); // bottom right

    // set up diffusion:
  /*  m_vertices[0].color = 0xfffffff; // 0xffffffff;
    m_vertices[1].color = 0xfffffff; //0xff0000ff;
    m_vertices[2].color = 0xfffffff; //0xffffffff;
    m_vertices[3].color = 0xfffffff; // 0xff0000ff;
*/
		 m_vertices[0].color =  0xffffffff;
    m_vertices[1].color = 0xff0000ff;
    m_vertices[2].color = 0xffffffff;
    m_vertices[3].color = 0xff0000ff;

    // set up texture coordinates
    m_vertices[0].tu = 0.0f; m_vertices[0].tv = 0.0f; // low left
    m_vertices[1].tu = 0.0f; m_vertices[1].tv = 1.0f; // high left
    m_vertices[2].tu = 1.0f; m_vertices[2].tv = 0.0f; // low right
    m_vertices[3].tu = 1.0f; m_vertices[3].tv = 1.0f; // high right
}

movie_scene::~movie_scene()
{

}

//int movie_scene::index() { return _idx; }
//void movie_scene::index(int k) { if (k < _cnt) _idx = k; else _idx = 0; }

HRESULT 
movie_scene::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;


    m_vertexBuffer = NULL;


    hr = device->CreateVertexBuffer(sizeof(m_vertices),
		0,FVF,D3DPOOL_DEFAULT,& m_vertexBuffer.p, NULL );

	 
    if (image) {
	if( FAILED( D3DUtil_CreateTexture( device, image,
		&_texture) ) ) {
		//ASSERT(10!=10);
        return -1; // D3DAPPERR_MEDIANOTFOUND;
	}
	}

	if (_path && _name) {
		int k = 0;
		for(int i = _from; i <= _to; i++) {
			char buf[1024];
			if (i < 10) sprintf(buf,"%s\\%s0%d.%s",_path,_name,i,_ext);
			else sprintf(buf,"%s\\%s%d.%s",_path,_name,i,_ext);
			hr = D3DUtil_CreateTexture( device, buf,&_textures[k]);
			if (!FAILED(hr)) k++;
			//else //ASSERT(9!=9);
			//MessageBox(0,buf,"odyssee",MB_OK);
		}
		if (k > 0) _idx = 0;
		_max = k;
		//image = path; //??
	}

	hr = scene::init(device);
    m_time = GetTickCount();

    return hr;
}

HRESULT 
movie_scene::restore(IDirect3DDevice9* device)
{
	HRESULT hr = S_OK;

	// get the difference in time
    DWORD dwCurrentTime;
    dwCurrentTime = GetTickCount();
    double difference = m_time - dwCurrentTime ;
	
    void* pData;
    FAIL_RET( m_vertexBuffer->Lock(0,sizeof(pData), &pData,0) );
    memcpy(pData,m_vertices,sizeof(m_vertices));  
	//ASSERT(0);
    FAIL_RET( m_vertexBuffer->Unlock() ); 

	return hr;
}


HRESULT 
movie_scene::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
    HRESULT hr = S_OK;
 
    char buf[512];
	sprintf(buf,"movie");

	render_begin(device);


    //_idx = 0;
	// Set up texture stage states for the image
    //device->SetTexture( 0, 0 );
	if (_path) {// && _idx >= 0 ) {
		//_event = 1;
		if (0 && event()) { _idx++; index(_idx);
		sprintf(buf,"%s: %d (%1.1f) %0.2f",_path,_idx,(float)_rate,
					(float) delta());
		}
		if (_rate > 0) {
			_elapsed += delta();

			if (_elapsed > _rate) {
				_elapsed = 0;
				_idx++; index(_idx);
				
				sprintf(buf,"%s: %d (%1.1f) %0.2f",_path,_idx,(float)_rate,
					(float) delta());
			}
		}
		device->SetTexture(0, _textures[_idx]);
	}
	else if (image && _texture)
	       device->SetTexture( 0, _texture );
	else device->SetTexture( 0, texture );
	
	sprintf(buf,"%s: %d (%1.1f) %0.2f",_path,_idx,(float)_rate,
					(float) delta());
		
//	device->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
//	device->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );

		
    FAIL_RET(hr = device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE));
    FAIL_RET(hr = device->SetTextureStageState(0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE));
    FAIL_RET(hr = device->SetTextureStageState(0, D3DTSS_ALPHAARG2, D3DTA_DIFFUSE));
    FAIL_RET(hr = device->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE));


	FAIL_RET( device->SetFVF( FVF ) );
    FAIL_RET( device->SetStreamSource(0, m_vertexBuffer.p, 0,
		                              sizeof(movie_scene::CUSTOMVERTEX)  ) ); 	
    FAIL_RET( device->DrawPrimitive(D3DPT_TRIANGLESTRIP,0,2) );  //draw quad 

    //char buf[256];
	//sprintf(buf,"texture: %d", _idx);
	//message(_x,_y,0xff1ff1ff0,buf);
	render_end(device);

    return hr;
}

void
movie_scene::rectangle( float fTU, float fTV )
{
	if (!image && !_path) {
    m_vertices[0].tu = 0.0f; m_vertices[0].tv = 0.0f; // low left
    m_vertices[1].tu = 0.0f; m_vertices[1].tv = fTV;  // high left
    m_vertices[2].tu = fTU;  m_vertices[2].tv = 0.0f; // low right
    m_vertices[3].tu = fTU;  m_vertices[3].tv = fTV;  // high right
	}
}
