
#include "background-scene.h"
#include "scene-text-3d.h"
#include "util/d3dUtility.h"
// sub scenes




//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


scene* scene_text_3d::create(char* opts) { return new scene_text_3d(opts); }

scene_text_3d::scene_text_3d(char* txt) 
{

if (txt) sprintf(_txt,"%s",txt);
else sprintf(_txt,"Odyssee");
scale(0.9f,0.9f,0.9f);
//translation(100,100,0);



count = 1;
_exclude[0] = 1;
_exclude[1] = 0;
_exclude[2] = 1;
_exclude[3] = 0; 
_exclude[1] = 0;
_exclude[5] = 0;

scenes[0] = new background_scene();
end(8);
loop = 0;

scale(0.5,0.5,0.5);
translation(-0.8,1.5,-2.5);

}

scene_text_3d::~scene_text_3d()
{
//delete scenes[];
	
}

HRESULT 
scene_text_3d::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

		//
	// Get a handle to a device context.
	//
	HDC hdc = CreateCompatibleDC( 0 );
    HFONT hFont;
    HFONT hFontOld;

	//
	// Describe the font we want.
	//

    LOGFONT lf;
	ZeroMemory(&lf, sizeof(LOGFONT));

	lf.lfHeight         = 25;    // in logical units
	lf.lfWidth          = 12;    // in logical units
	lf.lfEscapement     = 0;        
	lf.lfOrientation    = 0;     
	lf.lfWeight         = 500;   // boldness, range 0(light) - 1000(bold)
	lf.lfItalic         = false;   
	lf.lfUnderline      = false;    
	lf.lfStrikeOut      = false;    
	lf.lfCharSet        = DEFAULT_CHARSET;
	lf.lfOutPrecision   = 0;              
	lf.lfClipPrecision  = 0;          
	lf.lfQuality        = 0;           
	lf.lfPitchAndFamily = 0;    
	strcpy(lf.lfFaceName, "Times New Roman"); // font style

	//
	// Create the font and select it with the device context.
	//
    hFont = CreateFontIndirect(&lf);
    hFontOld = (HFONT)SelectObject(hdc, hFont); 

	//
	// Create the text mesh based on the selected font in the HDC.
	//
    D3DXCreateText(device, hdc, _txt, 
        0.001f, 0.4f, &Text, 0, 0);

	//
	// Restore the old font and free the acquired HDC.
	//
    SelectObject(hdc, hFontOld);
    DeleteObject( hFont );
    DeleteDC( hdc );

	
	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
scene_text_3d::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;


	//
	// Lights.
	//

	D3DXVECTOR3 dir(0.0f, -0.5f, 1.0f);
	D3DXCOLOR col = d3d::MAGENTA;// d3d::WHITE;
	D3DLIGHT9 light = d3d::InitDirectionalLight(&dir, &col);

	device->SetLight(0, &light);
	//device->LightEnable(0, true);

	device->SetRenderState(D3DRS_NORMALIZENORMALS, true);
	device->SetRenderState(D3DRS_SPECULARENABLE, true);

    //if (fraction() >= 1) exclude();

    return hr;
}


HRESULT 
scene_text_3d::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

  
	float f = fraction();

	//scale(3-f*3,3-f*3,3-f*3);
	//translation(-10*f,-3*f,2*f);
    //rotation(0,0,1,3.14 * f);

	render_begin(device);

	//ASSERT(12!=12);

    // begin the scene_text_3d



	hr = scene::render(device,texture); // calls compose, restore,  render
	//if (current() < 12) {
	//device->SetTexture( 0, texture);
	device->SetTexture( 0, 0);
    Text->DrawSubset(0);
	//}
    //char buf[256];
	//sprintf(buf,"fraction: %1.2f (%2.1f) %2.1f",fraction(), time(), current());
	//message(20,50,0xff1ff1ff0,buf); 
	render_end(device);

 

    return hr;
}

