

#include "scene-odyssee.h"

// sub scenes

#include "scene-0.h"
#include "scene-1.h"
#include "scene-2.h"
#include "scene-3.h"

#include "scene-text.h"
#include "objects/scene-text-3d.h"
#include "objects/background-scene.h"

#include <atlbase.h>
//#define START 1
//#define RESTART 1
//#define WAIT 2
//#define END 3;
//#define RUNNING 0


static int check(char* type, char* ev, char* xt, char* xe) {
	return !strcmp(type,xt) && !strcmp(ev,xe);
}

int scene_odyssee::handle(char* type, char* ev) {
	if (check(type,ev,"lbutton","down")) {
		if (state == 0 && _condition == WAIT) _condition = START;
		if (state == 0 && _condition == WAIT) _condition = RUNNING;
		else (_condition = WAIT);
    } else if (check(type,ev,"key","tab")) {
		_condition = END;
	} else if (check(type,ev,"key","space")) {
		_condition = START;
	} else if (check(type,ev,"key","return")) {
		_condition = START;
	} else return scene::handle(type,ev);
	sprintf(_key(),"%s: %s",type,ev);
    return _event = _condition;
}


scene_odyssee::scene_odyssee() 
{

_handler(this); // set event handler
_condition = WAIT;

if (width() == 1024) { _x = 50; _y = height() - 75; }
else if (width() == 800) { _x = 20; _y = height() - 50; }
else if (width() == 640) { _x = 20; _y = height() - 50; _size = 16; }

scale(0.9f,0.9f,0.9f);
//translation(100,100,0);

loop = 1;
end(120); // seconds

count = 6;
_text3d = 4;
_text = 5;

_display = "Odyssee 2004";

_exclude[0] = 1;
_exclude[1] = 1;
_exclude[2] = 1;
_exclude[3] = 1; 
_exclude[4] = 1;
_exclude[5] = 1;
_exclude[6] = 1;
_exclude[7] = 1;
_exclude[8] = 1; 
_exclude[9] = 1;
_exclude[10] = 0;
_exclude[11] = 0;


//scenes[count-1] = new scene_text();
//_exclude[count-1] = 0;


//_background = new background_scene();

scenes[0] = new scene_0();
scenes[1] = new scene_1();
scenes[2] = new scene_2();
scenes[3] = new scene_3();

//scenes[0]->exclude();
//scenes[1]->exclude(); 
//scenes[2]->exclude(); 
//scenes[3]->exclude(); 


scenes[_text3d] = new scene_text_3d("Odyssee");
scenes[_text] = new scene_text(24);
}

scene_odyssee::~scene_odyssee()
{
//delete scenes[];
}

HRESULT scene_odyssee::compose(IDirect3DDevice9* device,DWORD t) {
HRESULT hr = S_OK;

return hr;
}


HRESULT 
scene_odyssee::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

if (opt("tx")) _texture = tx(opt("tx"));
if (_texture) texture = _texture;



	// set transform and render

render_begin(device);
	

// begin the scene_odyssee

//float f = fraction();


int states = 4;
 
//_background -> draw(device,texture);

if (condition() == START) {
        interval(now(),_end);
		_condition = RUNNING;
		_event = 1;
}

//if (inbetween(2,12)) {
if (!condition() && inbetween(15,26)) {
	 if (state != previous || event() > 0) scenes[_text3d]->interval(now(),8);
	_exclude[_text3d] = 0;
	float f = scenes[_text3d]->fraction();
	scenes[_text3d]->rotation(0,0,1,3.14 * f);
} else {
	_exclude[_text3d] = 1;
}

if (!condition() && inbetween(5,15)) {
	scenes[_text]->state = 0;
	_exclude[_text] = 0;
} else if (!condition() && inbetween(40,50)) {
	scenes[_text]->state = 1;
	_exclude[_text] = 0;
} else if (!condition() && inbetween(50,60)) {
	scenes[_text]->state = 2;
	_exclude[_text] = 0;
} else if (!condition() && inbetween(90,100)) {
	scenes[_text]->state = 3;
	_exclude[_text] = 0;
} else if (!condition() && inbetween(110,115)) {
	scenes[_text]->state = 4;
	_exclude[_text] = 0;
} else {
	_exclude[_text] = 1;
}

if (state == states || condition() > 0) {
	state = 0;
	if (condition() != WAIT)
		 for (int i = 0; i < count; i++) _exclude[i] = 1;
} else if (!condition() && inbetween(0,15)) {
    state = 0;
	_exclude[0] = 1;
	_exclude[1] = 1;
	_exclude[2] = 1;
	_exclude[3] = 1;
	//_exclude[4] = 1;
 
    
} else if (!condition() && inbetween(15,26)) {
	 state = 0;
	 _exclude[3] = 1;
	 _exclude[0] = 0;
	 if (state != previous) {
		 scenes[0]->interval(now(),30); // until 
		 scenes[_text3d]->interval(now(),8);
	 }
	
} else if (!condition() && inbetween(26,50)) {
     state = 1;
	 _exclude[0] = 1;
	 _exclude[1] = 0;
	 if (state != previous) {
	      scenes[1]->interval(now(),20);
     }
} else if (!condition() && inbetween(50,60)) {
     state = 2;
	 _exclude[1] = 1;
	 _exclude[2] = 0;
	 if (state != previous) {
	      scenes[2]->interval(now(),10);
	 }
}  else if (!condition() && inbetween(60,118)) {
     state = 3;
	 if (current()>95) _exclude[0] = 0; 
	 if (current()>80) _exclude[1] = 0;
	 
	 //if (current()>85) _exclude[2] = 0;
	 _exclude[2] = 1;
	 _exclude[3] = 0;
	 if (state != previous) {
	      scenes[3]->interval(now(),20);
	 }
	 if (current()>100) _exclude[3] = 1;
}  else if (!condition() && current() > 118) {
	_condition = END;
	state = 4;
}





	hr = scene::render(device,texture); // calls restore, compose, render

	display(_display);
	//char buf[256];
	//wsprintf(buf,"[%d:%d] %3.1f (%0.2f) : %2.1f", _condition, state, current(), fraction(), fps());
	//message(_x,_y,0xff1ff1ff0,buf); 
   
	render_end(device);

 

    return hr;
}

