#include <hush/source.h>

#include "display.h"
#include "scene/image.h"
#include "scene/shader.h"
#include "scene/mesh.h"

#include <hush/dictionary.h>
#include <hush/string.h>

#define sclst ((dictionary<scene>*)_sclst)

void display::reset() {

	    int x = iopt("layout");

		for (int i = 0; i <= 10; i++) _exclude[i] = 1;	
		iter<string>& it = *sclst;
			scene* sc = 0;
			string* p = 0;
			while (p = it()) {
				char* sp = *p;
				char c = *sp;
				sc = (*sclst)[p];
				if ((c - '0') != x)  sc->exclude(1);
				else sc->exclude(0);
			}
}

static float _zcorr[] = { 0,0,-0.7,0.7, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

static float zcorr(int i) {
	return _zcorr[i];
}

static char* ds3[] = { "3:1", "3:2", "3:3", 0};
static char* ds4[] = { "4:1", "4:2", "4:3", "4:4", 0};


// void f3val(char* k, float* x, float* y, float* z);	


display::display(char* opts) 
{

	opt("scale(3)","<0.3,0.3,0.3>");
	opt("scale(3:1)","<0.3,0.3,0.3>");
	opt("scale(3:2)","<0.3,0.3,0.3>");
	opt("scale(3:3)","<0.4,0.4,0.4>");
	opt("translation(3:1)","<-1.0,1.3,0.0>");
	opt("translation(3:2)","<1.0,1.3,0.0>");
	opt("translation(3:3)","<0.0,-0.7,0.0>");

	opt("scale(4)","<0.4,0.4,0.4>");
	opt("scale(4:1)","<0.4,0.4,0.4>");
	opt("scale(4:2)","<0.4,0.4,0.4>");
	opt("scale(4:3)","<0.4,0.4,0.4>");
	opt("scale(4:4)","<0.4,0.4,0.4>");
	opt("translation(4:1)","<-0.5,1.4,0.0>");
	opt("translation(4:2)","<0.5,1.4,0.0>");
	opt("translation(4:3)",fm("<-0.5,0.4,%f>",-0.8));
	opt("translation(4:4)",fm("<0.5.0,0.4,%f>",-0.8));
	float x,y,z,w;

_end = 20;
loop = 1;
//scale(0.9f,0.9f,0.9f);
//translation(100,100,0);
//rotation(1.0f,0.0f,0.0f,0.5f);

count = 7;
_exclude[0] = 1; //0
_exclude[1] = 1; //0
_exclude[2] = 1; 
_exclude[3] = 1; //0 
_exclude[4] = 1;
_exclude[5] = 1;
_exclude[6] = 1;


//scenes[2] = new image();
//_exclude[2] = 1;

scene* xx = sc("text/casus");
sc("slides",xx->sc("slides"));
sc("image",new image());
//sc("image",new mesh("plane"));
opt("scene","image");
//opt("scene","slides");

//float zcorr[] = { 0,0,-0.7,-0.5, 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

string sds3 = "3:1 3:2 3:3"; 
char* p;
int i;

/*
if (1) {
	string* ps;
	iter<string>& it = sds3;
	while (ps = it()) {
	char* p = *ps;
	lst(p, sc(opt("scene"))->create());
    lst(p)->scale(0.3,0.3,0.3);
	f3val(fm("translation(%s)",p),&x,&y,&z);
	lst(p)->translation(x,y,z);
	}
} else
*/

int xmax = 20;
//for ( i = 0; i < xmax; i++ ) {
//	lst(fm("item:%2d",i+1),sc(opt("scene"))->create());
//}

opt("layout","4");
popt("layout(3)", &ds3);
popt("layout(4)", &ds4);


for (int k = 0; k < 21; k++) {
char** q = (char**) popt(fm("layout(%d)",k));
if (q) for ( i = 0; i < k; i++ ) {
	p = q[i];
	//lst(p, new shader(sc(opt("scene"))->create(opt(fm("opt(%d)",k))),"color-blue"));
	lst(p, sc(opt("scene"))->create(opt(fm("opt(%d)",k))));
	f3val(fm("scale(%s)",p),&x,&y,&z);
    lst(p)->scale(x,y,z);
	f3val(fm("translation(%s)",p),&x,&y,&z);
	lst(p)->translation(x,y,z);
	//lst(p)->opt("fx","color-blue");
	//lst(p)->set_mode(0);
}
}

reset();

_lst = 1;


_shader = "scene";
opt("nofx","0");
iopt("overlay",1);



}

display::~display()
{
//delete scenes[];
}

scene* display::create(char* opts) { return new display(opts); }

int 
display::_load()
{
    HRESULT hr = S_OK;

	// anything else ?

	hr = scene::_load(); // loops through scenes

    return hr;
}



int
display::_render( ) 
{

HRESULT hr;

if (opt("tx")) _texture = tx(opt("tx"));
if (!_texture) _texture = tx("active");
//_texture = tx("active");

static int odd = 0;
static int fac = 3;

if (1) {
int k = iopt("layout");
char** q = (char**) popt(fm("layout(%d)",k));
if (q) for (int i = 0; i < k; i++ ) {
	float x,y,z,w;
    char* p = q[i];
	//lst(p, sc(opt("scene"))->create(opt(fm("opt(%d)",k))));
	//char* q = eq(p);
	f3val(fm("scale(%s)",p),&x,&y,&z);
    lst(p)->scale(x,y,z);
	f3val(fm("translation(%s)",p),&x,&y,&z);
	lst(p)->translation(x,y,z);
	char* is = fm("fx(%s)",p);
	if( opt(is) ) lst(p)->opt("effect", opt(is));
	//opt("fx","0");
	
}
}

	render_begin(_device);

	


	hr = scene::render(_device,_texture); // calls restore, compose, render

    
	render_end(_device);

 

    

    return hr;
}


