#include <hush/source.h>

#include <scene/mesh.h>
#include <scene/shader.h>
#include <scene/background.h>
#include "face.h"

#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>

#include <util/Direct3D.h>




//#include "shader.h"





static char* _help = "(vip) sm";
static scene* dolphin;


int face::ch(char* x) {
int status = 0;


	return status;

}


int face::handle(char* type, char* ev) {
	if (check(type,ev,"shift","down")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","a")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","0")) {
		int s = 0;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","1")) {
		int s = 1;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","2")) {
		int s = 2;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



int face::operator()()
{
  

state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

face::face(char* opts) 
{
	
	count = 12;

	ch();

_size = 20; //size;
wsprintf(_type,"face");
_display = _type;


// Base, target morphing, and blended mesh objects
g_BaseMesh    = NULL;
g_Mesh1       = NULL;
g_Mesh2       = NULL;
g_Mesh3       = NULL;
g_Mesh4       = NULL;
g_BlendedMesh = NULL;

// Flags to toggle blending
g_BlendMesh1 = TRUE;
g_BlendMesh2 = TRUE;
g_BlendMesh3 = TRUE;
g_BlendMesh4 = TRUE;

// Guide texture and sprite interface
g_GuideTexture = NULL;
g_Guide        = NULL;
  
}




face::~face()
{
//delete scenes[];
}

int 
face::_load()
{
    int hr = S_OK;

	 // Load the base and target meshes using the blended morphing FVF
  LoadMesh(&g_BaseMesh, _device, "..\\data\\Base.x",  "..\\data\\", BLENDFVF);
  LoadMesh(&g_Mesh1,    _device, "..\\data\\Mesh1.x", "..\\data\\", BLENDFVF);
  LoadMesh(&g_Mesh2,    _device, "..\\data\\Mesh2.x", "..\\data\\", BLENDFVF);
  LoadMesh(&g_Mesh3,    _device, "..\\data\\Mesh3.x", "..\\data\\", BLENDFVF);
  LoadMesh(&g_Mesh4,    _device, "..\\data\\Mesh4.x", "..\\data\\", BLENDFVF);

  // Reload the base mesh to use as blended mesh
  LoadMesh(&g_BlendedMesh, _device, "..\\data\\Base.x",  "..\\data\\", BLENDFVF);

  // Load the guide texture and create the sprite interface
  D3DXCreateTextureFromFileEx(_device, "..\\data\\Guide.bmp", 
                              D3DX_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, 0,
                              D3DFMT_A1R5G5B5, D3DPOOL_DEFAULT, D3DX_DEFAULT, 
                              D3DX_DEFAULT, 0xFF000000,
                              NULL, NULL, &g_GuideTexture);
  D3DXCreateSprite(_device, &g_Guide);


	hr = scene::init(_device); // loops through scenes

	
    return hr;
}

int
face::_restore()
{
    HRESULT hr = S_OK;

	


    return hr;
}


int
face::_render( ) 
{
HRESULT hr = S_OK;
   

	render_begin(_device);
	
	_device->SetTexture( 0, _texture );
       //int i = 0;

 
	

	hr = scene::_render(); // calls compose, restore,  render


    
      // Set a view transformation
    D3DXMATRIX matView;
    D3DXMatrixLookAtLH(&matView,
                       &D3DXVECTOR3(-5.0f, 4.0f, -12.0f),
                       &D3DXVECTOR3(0.0f, 0.0f, 0.0f),
                       &D3DXVECTOR3(0.0f, 1.0f, 0.0f));
    _device->SetTransform(D3DTS_VIEW, &matView);

    // Set a world transformation
    D3DXMATRIX matWorld;
    D3DXMatrixIdentity(&matWorld);
    //_device->SetTransform(D3DTS_WORLD, &matWorld);

    // Calculate the blending scalar values based on time
    DWORD Time = timeGetTime();
    float Mesh1Blend = (float)(Time %  501) /  250.0f;
    float Mesh2Blend = (float)(Time % 1001) /  500.0f;
    float Mesh3Blend = (float)(Time % 2001) / 1000.0f;
    float Mesh4Blend = (float)(Time % 3001) / 1500.0f;

    // Apply toggles to meshes
    if(g_BlendMesh1 == FALSE)
      Mesh1Blend = 0.0f;
    if(g_BlendMesh2 == FALSE)
      Mesh2Blend = 0.0f;
    if(g_BlendMesh3 == FALSE)
      Mesh3Blend = 0.0f;
    if(g_BlendMesh4 == FALSE)
      Mesh4Blend = 0.0f;

    // Draw the blended mesh
    DrawBlendedMesh(g_BaseMesh,
                    g_Mesh1, ((Mesh1Blend<=1.0f)?Mesh1Blend:(2.0f-Mesh1Blend)),
                    g_Mesh2, ((Mesh2Blend<=1.0f)?Mesh2Blend:(2.0f-Mesh2Blend)),
                    g_Mesh3, ((Mesh3Blend<=1.0f)?Mesh3Blend:(2.0f-Mesh3Blend)),
                    g_Mesh4, ((Mesh4Blend<=1.0f)?Mesh4Blend:(2.0f-Mesh4Blend)));

    // Draw the guide
   // g_Guide->Draw(g_GuideTexture, NULL,NULL,NULL, NULL, &D3DXVECTOR2(0.0f, 0.0f), 0xFFFFFFFF);
	 //g_Guide->Draw(g_GuideTexture, NULL, NULL, &D3DXVECTOR2(0.0f, 0.0f), 0xFFFFFFFF);

	
	if (1) {
		
		//message(100,_y-200,argb(255,255,120,120),fm("%s [%d]",_help,state));
	} 
	
	

	//display(_display);
    //dolphin->state = hold;
	render_end(_device);

 

    return hr;
}

void face::DrawBlendedMesh(D3DXMESHCONTAINER_EX *BaseMesh,
                     D3DXMESHCONTAINER_EX *Mesh1, float Blend1,
                     D3DXMESHCONTAINER_EX *Mesh2, float Blend2,
                     D3DXMESHCONTAINER_EX *Mesh3, float Blend3,
                     D3DXMESHCONTAINER_EX *Mesh4, float Blend4)
{
  // Lock all meshes and get pointers
  sVertex *pBaseVertices,  *pBlendedVertices;
  sVertex *pMesh1Vertices, *pMesh2Vertices;
  sVertex *pMesh3Vertices, *pMesh4Vertices;
  
  BaseMesh->MeshData.pMesh->LockVertexBuffer(D3DLOCK_READONLY, (void**)&pBaseVertices);
  g_Mesh1->MeshData.pMesh->LockVertexBuffer(D3DLOCK_READONLY, (void**)&pMesh1Vertices);
  g_Mesh2->MeshData.pMesh->LockVertexBuffer(D3DLOCK_READONLY, (void**)&pMesh2Vertices);
  g_Mesh3->MeshData.pMesh->LockVertexBuffer(D3DLOCK_READONLY, (void**)&pMesh3Vertices);
  g_Mesh4->MeshData.pMesh->LockVertexBuffer(D3DLOCK_READONLY, (void**)&pMesh4Vertices);
  g_BlendedMesh->MeshData.pMesh->LockVertexBuffer(0, (void**)&pBlendedVertices);

  // Iterate all vertices
  for(DWORD i=0;i<g_BaseMesh->MeshData.pMesh->GetNumVertices();i++) {

    // Get the difference in vertex coordinates 
    D3DXVECTOR3 vecXYZDiff1 = pMesh1Vertices->vecPos - pBaseVertices->vecPos;
    D3DXVECTOR3 vecXYZDiff2 = pMesh2Vertices->vecPos - pBaseVertices->vecPos;
    D3DXVECTOR3 vecXYZDiff3 = pMesh3Vertices->vecPos - pBaseVertices->vecPos;
    D3DXVECTOR3 vecXYZDiff4 = pMesh4Vertices->vecPos - pBaseVertices->vecPos;

    // Get the difference in normals
    D3DXVECTOR3 vecNormDiff1 = pMesh1Vertices->vecNormal - pBaseVertices->vecNormal;
    D3DXVECTOR3 vecNormDiff2 = pMesh2Vertices->vecNormal - pBaseVertices->vecNormal;
    D3DXVECTOR3 vecNormDiff3 = pMesh3Vertices->vecNormal - pBaseVertices->vecNormal;
    D3DXVECTOR3 vecNormDiff4 = pMesh4Vertices->vecNormal - pBaseVertices->vecNormal;

    // Apply blending values
    vecXYZDiff1 *= Blend1; vecNormDiff1 *= Blend1;
    vecXYZDiff2 *= Blend2; vecNormDiff2 *= Blend2;
    vecXYZDiff3 *= Blend3; vecNormDiff3 *= Blend3;
    vecXYZDiff4 *= Blend4; vecNormDiff4 *= Blend4;

    // Get tallied blended difference values
    D3DXVECTOR3 vecXYZBlended = vecXYZDiff1 + vecXYZDiff2 + vecXYZDiff3 + vecXYZDiff4;
    D3DXVECTOR3 vecNormBlended = vecNormDiff1 + vecNormDiff2 + vecNormDiff3 + vecNormDiff4;

    // Add the differences back to base mesh values and store
    pBlendedVertices->vecPos = vecXYZBlended + pBaseVertices->vecPos;

    // Add the differences in normals to based mesh values,
    // normalize the values, and store in resulting mesh!
    vecNormBlended += pBaseVertices->vecNormal;
    D3DXVec3Normalize(&pBlendedVertices->vecNormal, &vecNormBlended);

    // Go to next vertices
    pBaseVertices++;  pBlendedVertices++;
    pMesh1Vertices++; pMesh2Vertices++;
    pMesh3Vertices++; pMesh4Vertices++;
  }  // Next loop iteration

  // Unlock the vertex buffers
  g_BlendedMesh->MeshData.pMesh->UnlockVertexBuffer();
  g_Mesh4->MeshData.pMesh->UnlockVertexBuffer();
  g_Mesh3->MeshData.pMesh->UnlockVertexBuffer();
  g_Mesh2->MeshData.pMesh->UnlockVertexBuffer();
  g_Mesh1->MeshData.pMesh->UnlockVertexBuffer();
  g_BaseMesh->MeshData.pMesh->UnlockVertexBuffer();

  // Set a light for the scene 
  D3DLIGHT9 Light;
  ZeroMemory(&Light, sizeof(D3DLIGHT9));
  Light.Type = D3DLIGHT_DIRECTIONAL;
  Light.Diffuse.r = Light.Diffuse.g = Light.Diffuse.b = Light.Diffuse.a = 1.0f;
  Light.Direction.x = 0.0f;
  Light.Direction.y = 0.0f;
  Light.Direction.z = 1.0f;
  _device->SetLight(0, &Light);
  _device->LightEnable(0, TRUE);

  // Enable lighting and zbuffering
  _device->SetRenderState(D3DRS_LIGHTING, TRUE);
  _device->SetRenderState(D3DRS_ZENABLE, D3DZB_TRUE);

  // Render the blended mesh
  DrawMesh(g_BlendedMesh);

}

