#include <hush/source.h>
#include "shader.h"
//#include <atlbase.h>
#include <streams.h>

//#define _UNICODE
//#include <tchar.h>
//#include <comutil.h>

#include <hush/sim/sim.h>

#include "common/d3dfile.h"
#include "common/dxutil.h"
#include <comutil.h>
#include <scene/video.h>



const DWORD shader::D3DVERTEX::FVF = D3DFVF_XYZ | D3DFVF_NORMAL| D3DFVF_TEX1;



shader::shader(scene* x, char* opts) 
//shader::shader(char* opts) 
{

	process("shader=basic");
	if (opts) process(opts);

_stack = 1;
_size = 20; //size;
wsprintf(_type,"shader");
//_letterset = "Times New Roman";
_display = _type;

/*
if (name) strcpy(_name,name);
else wsprintf(_name,"circle.x");

    m_pMeshSysMem     = NULL;
    m_pMeshEnhanced   = NULL;
    m_pMaterials      = NULL;
    m_ppTextures      = NULL;
    m_dwNumMaterials  = NULL;
    m_pbufMaterials   = NULL;
    m_pbufAdjacency   = NULL;
    m_dwNumSegs       = 2;
    m_bUseHWNPatches  = FALSE;
    m_bWireframe      = FALSE;
   // m_bShowHelp       = FALSE;

	m_hWorld = NULL;
    m_hMeshTexture = NULL;
    m_hWorldViewProjection = NULL;
    m_hTechniqueRenderScene = NULL;

    m_pMesh = NULL;
    m_pMeshTexture = NULL;
	*/
	if (x) _scene = x;
	if (opt("scene")) _scene = scopt("scene");

}



shader::~shader()
{
//delete scenes[];
}

HRESULT 
shader::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
	LPDIRECT3DVERTEXBUFFER9 pVB = NULL;
    void*      pVertices = NULL;
    LPD3DXMESH pTempMesh;
	TCHAR strPath[1024];


/*
    D3DVERTEX*              pSrc;
    D3DVERTEX*              pDst;

	if (0) {
    if (_name[0] == '\0') return hr;
	char buf[1024];
    
	wsprintf(buf,"\\vip\\models\\%s",_name);
	DXUtil_FindMediaFileCb( strPath, sizeof(strPath), 
	 _T(loc(buf)));
	 //_T(loc("\\vip\\models\\circle.x")) );

	hr = D3DXLoadMeshFromX( strPath, D3DXMESH_SYSTEMMEM, device, 
                            &m_pbufAdjacency, &m_pbufMaterials, NULL, &m_dwNumMaterials, 
                            &m_pMeshSysMem );

	
	hr = m_pMeshSysMem->GetVertexBuffer( &pVB );
    if( FAILED(hr) )
        return hr;

    hr = pVB->Lock( 0, 0, &pVertices, 0 );
    if( FAILED(hr) )
    {
        SAFE_RELEASE( pVB );
        return hr;
    }

    hr = D3DXComputeBoundingSphere( (D3DXVECTOR3*)pVertices, m_pMeshSysMem->GetNumVertices(), 
                                    D3DXGetFVFVertexSize(m_pMeshSysMem->GetFVF()), &m_vObjectCenter, 
                                    &m_fObjectRadius );
    if( FAILED(hr) )
    {
        pVB->Unlock();
        SAFE_RELEASE( pVB );
        return hr;
    }
	

    if( 0 == m_dwNumMaterials )
    {
        pVB->Unlock();
        SAFE_RELEASE( pVB );
        return E_INVALIDARG;
    }

    // Get the array of materials out of the returned buffer, allocate a
    // texture array, and load the textures
    m_pMaterials = (D3DXMATERIAL*)m_pbufMaterials->GetBufferPointer();
    m_ppTextures = new LPDIRECT3DTEXTURE9[m_dwNumMaterials];

    for( UINT i=0; i<m_dwNumMaterials; i++ )
    {
        TCHAR strTexturePath[512] = _T("");
        TCHAR *tszName;
#ifdef UNICODE
        TCHAR tszBuf[MAX_PATH];
        tszName = tszBuf;
        MultiByteToWideChar( CP_ACP, 0, m_pMaterials[i].pTextureFilename, -1, tszBuf, MAX_PATH );
        tszBuf[MAX_PATH - 1] = _T('\0');
#else
        tszName = m_pMaterials[i].pTextureFilename;
#endif
        DXUtil_FindMediaFileCb( strTexturePath, sizeof(strTexturePath), tszName );
        if( FAILED( D3DXCreateTextureFromFile( device, strTexturePath, 
                                               &m_ppTextures[i] ) ) )
            m_ppTextures[i] = NULL;
    }

    pVB->Unlock();
    SAFE_RELEASE( pVB );

    // Make sure there are normals, which are required for the tesselation
    // enhancement
    if( !(m_pMeshSysMem->GetFVF() & D3DFVF_NORMAL) )
    {
        hr = m_pMeshSysMem->CloneMeshFVF( m_pMeshSysMem->GetOptions(), 
			                              D3DVERTEX::FVF,
                                          // m_pMeshSysMem->GetFVF() | D3DFVF_NORMAL | D3DFVF_TEX1 , 
                                          device, &pTempMesh );
        if( FAILED(hr) )
            return hr;

        D3DXComputeNormals( pTempMesh, NULL );

        SAFE_RELEASE( m_pMeshSysMem );
        m_pMeshSysMem = pTempMesh;
    }

	//DWORD GetNumBytesPerVertex(VOID);
	if (1) {
	  hr = m_pMeshSysMem->GetVertexBuffer( &pVB);
    if( FAILED(hr) )
        return hr;

    hr = pVB->Lock( 0, 0, (void**) &pSrc, 0 );
    if( FAILED(hr) )
    {
        SAFE_RELEASE( pVB );
        return hr;
    }
	if (1) {
	int n = m_pMeshSysMem->GetNumVertices();
    //memcpy( pDst, pSrc, n * sizeof(D3DVERTEX) );
    srand(5);
	int _distort = 0;
	int limit = 200;
	int xdir = rand() % 2; if (xdir == 0) xdir = -1;
	int ydir = rand() % 2; if (ydir == 0) ydir = -1;
	int zdir = rand() % 2; if (zdir == 0) zdir = -1;
	//xdir = 1; ydir = 1; zdir = 1;
	if (!_distort) xdir = 0; ydir = 0; zdir = 0;
    if (1) for( DWORD i=0; i<n; i++ )
    {
        ((D3DVERTEX*)pSrc)[i].p.x += xdir * (rand() % limit)/100.0;  ///(FLOAT)RAND_MAX);
        ((D3DVERTEX*)pSrc)[i].p.y += ydir * (rand() % limit)/100.0; ///(FLOAT)RAND_MAX);
        ((D3DVERTEX*)pSrc)[i].p.z += zdir * (rand() % limit)/100.0; ///(FLOAT)RAND_MAX);
        ((D3DVERTEX*)pSrc)[i].tu  *= _tu;
        ((D3DVERTEX*)pSrc)[i].tv  *= _tv; //* 1.5; 
    }
    //pVB->Unlock();
    //pMeshSourceVB->Unlock();
    //pMeshSourceVB->Release();
	}   
        pVB->Unlock();
        SAFE_RELEASE( pVB );
      
	}

	} // end mesh
*/
	// Define DEBUG_VS and/or DEBUG_PS to debug vertex and/or pixel shaders with the shader debugger.  
    // Debugging vertex shaders requires either REF or software vertex processing, and debugging 
    // pixel shaders requires REF.  The D3DXSHADER_FORCE_*_SOFTWARE_NOOPT flag improves the debug 
    // experience in the shader debugger.  It enables source level debugging, prevents instruction 
    // reordering, prevents dead code elimination, and forces the compiler to compile against the next 
    // higher available software target, which ensures that the unoptimized shaders do not exceed 
    // the shader model limitations.  Setting these flags will cause slower rendering since the shaders 
    // will be unoptimized and forced into software.  See the DirectX documentation for more information 
    // about using the shader debugger.
	if (1) {
    DWORD dwShaderFlags = 0;
    #ifdef DEBUG_VS
        dwShaderFlags |= D3DXSHADER_FORCE_VS_SOFTWARE_NOOPT;
    #endif
    #ifdef DEBUG_PS
        dwShaderFlags |= D3DXSHADER_FORCE_PS_SOFTWARE_NOOPT;
    #endif

    // Read the D3DX effect file
		// loc("\\vip\\effects\\BasicHSL.fx")
    TCHAR str[MAX_PATH];
	//char* shadfx = "BasicHLSL";
	if (opt("fx")) option("shader",opt("fx"));
	char* shadfx = opt("shader"); // = "material";
	char xb[1024];
	sprintf(xb,"d:\\vip\\effects\\%s.fx",shadfx);
	//hr = DXUtil_FindMediaFileCb( str, sizeof(str), TEXT("d:\\vip\\effects\\BasicHLSL.fx") );
    //if( FAILED(hr) );
        //return DXTRACE_ERR( TEXT("DXUtil_FindMediaFileCb"), D3DAPPERR_MEDIANOTFOUND );
    //hr = D3DXCreateEffectFromFile(device, str, NULL, NULL, dwShaderFlags, NULL, &m_pEffect, NULL );
	hr = D3DXCreateEffectFromFile(device, xb, NULL, NULL, dwShaderFlags, NULL, &m_pEffect, NULL );

    // If this fails, there should be debug output as to 
    // they the .fx file failed to compile
    if( FAILED( hr ) );
        //return DXTRACE_ERR( TEXT("D3DXCreateEffectFromFile"), hr );
	}

	hr = scene::init(device); // loops through scenes

	_stack = 1;

    return hr;
}

HRESULT 
shader::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
	if (1) {
	  // Set effect variables as needed
    D3DXCOLOR colorMtrlDiffuse(1.0f, 1.0f, 1.0f, 1.0f);
    D3DXCOLOR colorMtrlAmbient(0.35f, 0.35f, 0.35f, 0);
    m_pEffect->SetVector("g_MaterialAmbientColor", (D3DXVECTOR4*)&colorMtrlAmbient);
    m_pEffect->SetVector("g_MaterialDiffuseColor", (D3DXVECTOR4*)&colorMtrlDiffuse);

    // To read or write to D3DX effect variables we can use the string name 
    // instead of using handles, however it improves perf to use handles since then 
    // D3DX won't have to spend time doing string compares
    m_hTechniqueRenderScene         = m_pEffect->GetTechniqueByName( "RenderScene" );
    m_hTime                         = m_pEffect->GetParameterByName( NULL, "g_fTime" );
    m_hWorld                        = m_pEffect->GetParameterByName( NULL, "g_mWorld" );
    m_hWorldViewProjection          = m_pEffect->GetParameterByName( NULL, "g_mWorldViewProjection" );
    m_hMeshTexture                  = m_pEffect->GetParameterByName( NULL, "g_MeshTexture" );
	}

    return hr;
}


HRESULT 
shader::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

    if (_texture) texture = _texture;

    D3DXMATRIXA16 mWorld;
    D3DXMATRIXA16 mView;
    D3DXMATRIXA16 mProj;
    D3DXMATRIXA16 mWorldViewProjection;
    UINT iPass, cPasses;

     if (_name[0] == '\0') return hr;

    //state = 1;

    int dir = -2;
	if (state == 2) dir = 2;
	//scale(0.2,0.2,0.2);
	//rotation(0,1,0,3.14*0.8);

	render_begin(device);
	if (state == 1 || state == 2) {
	D3DXMATRIXA16 matWorld;
    
	D3DXMatrixIdentity( &matWorld );
    //D3DXMatrixRotationX( &matWorld, timeGetTime()/1000.0f );
	if (1) D3DXMatrixRotationY( &matWorld, dir * _sim->realtime());
	//if (option > 1) D3DXMatrixRotationZ( &matWorld, -timeGetTime()/1000.0f );
    //matWorld._43 = -1.50f;
	//matWorld._42 = 1.00f;
    device->MultiplyTransform( D3DTS_WORLD, &matWorld );  // relative
	}
    
	device->SetTexture( 0, texture );

	if (1) {
    m_pEffect->SetTechnique( m_hTechniqueRenderScene );
	device->GetTransform( D3DTS_WORLD, &mWorld );
	device->GetTransform( D3DTS_VIEW, &mView );
	device->GetTransform( D3DTS_PROJECTION, &mProj );
	mWorldViewProjection = mWorld * mView * mProj;
    //mWorldViewProjection = (*_world()) * (*_view()) * (*_projection());


  // Update the effect's variables 
        m_pEffect->SetMatrix( m_hWorldViewProjection, &mWorldViewProjection );
        m_pEffect->SetMatrix( m_hWorld, &mWorld );
        m_pEffect->SetFloat( m_hTime,dxtime() );
       m_pEffect->SetTexture( m_hMeshTexture, texture);

		hr = m_pEffect->Begin(&cPasses, 0);
		//if( FAILED( hr ) ) Msg(TEXT("begin effect"));
        
        for (iPass = 0; iPass < cPasses; iPass++)
        {
          hr = m_pEffect->Pass(iPass);
           //if( FAILED( hr ) ) Msg(TEXT("get passes"));
                //return DXTRACE_ERR( TEXT("Pass"), hr );

         //hr = m_pMeshSysMem->DrawSubset(0);

		   if (1) hr = scene::render(device,texture);

		if (0)  for( UINT i = 0; i < m_dwNumMaterials; i++ )
        {
            if (0) device->SetMaterial( &m_pMaterials[i].MatD3D );
            if (0) device->SetTexture( 0, m_ppTextures[i] );

           // m_pMeshEnhanced->DrawSubset( i );
			m_pMeshSysMem->DrawSubset( i );
        }
            if( FAILED( hr ) );
                //return DXTRACE_ERR( TEXT("DrawSubset"), hr );
        }
        m_pEffect->End();
	} else {

   device->SetTexture( 0, texture );
       //int i = 0;

   static int toggle = 0;
	  if (1)  for( UINT i = 0; i < m_dwNumMaterials; i++ )
        {
            if (0) device->SetMaterial( &m_pMaterials[i].MatD3D );
            if (0) device->SetTexture( 0, m_ppTextures[i] );

           // m_pMeshEnhanced->DrawSubset( i );
			m_pMeshSysMem->DrawSubset( i );
        }
	   // m_pMeshEnhanced->DrawSubset( i );
	  
	}

	hr = scene::render(device,texture); // calls compose, restore,  render


    
	
    
	render_end(device);

 

    return hr;
}

