#ifndef scene_h
#define scene_h
#include <hush/export.h>
#ifndef HUSH
#define HUSH
#endif
#include <hush/scene.h>
///#include <hush/list.h>


#ifndef PTCHAR
#define PTCHAR TCHAR*
#endif

//#include <Streams.h>
#include <time.h>
struct IMediaSample;
struct D3DXMATRIX;
class transform;
class event;

struct ID3DXEffect;
typedef ID3DXEffect ieffect;
typedef IDirect3DDevice9 idevice;
typedef IDirect3DTexture9 itexture;

//typedef D3DMATRIX imatrix;
#define cvector D3DXVECTOR4;
#define cmatrix D3DMATRIX;


#include "dx/common/d3dfont.h"

#ifndef scene
#define scene dxscene
#endif


#define START 1
#define RESTART 1
#define WAIT 2
#define END 3;
#define RUNNING 0

//#define CAPTURE 0
//#define FILE 1

typedef char* msg_array[12][12];


#define MAX_SCENE 12

#include <dx/direct/transform.h>
//#include <streams.h>
class CCritSec;
#include <hush/query.h>
class simulation;
class generator;
class event;


class scene;
class scene_entry;


class HUSH_API  scene_entry  {
public:
scene_entry( scene* raw, char* k, int i= -1);
scene* operator=( scene* v ); 
operator scene*(); 
private:
int _i;
char* _k;
scene* _raw;
};

//typedef IDirect3DTexture9 vip;

class HUSH_API scene  : public dvscene
{

public:

	virtual int supervise(int s); // state
	virtual int ready(); // loaded

	virtual int _load();
	virtual int _render();
	virtual int _restore();
	virtual int _compose();

public:
	static int random();
	static int random(int);
	static int random(int,int);
	int random(char* x);

public:
	
	query* _tk;
	static query* __tk;
	static query* tk(query* tk = 0);

	parser* _flt;
	static parser* __flt;
	static parser* flt(parser* x = 0);

	simulation* _sim;
	static simulation* __sim;
	static simulation* sim(simulation* sim = 0);

	generator* _gn;
	static generator* __gn;
	static generator* gn(generator* x = 0);

	static char __drive[256];
	static char* _drive(char* x = 0);
	static char* loc(char* x);

public:

    scene();
	scene(int top);
	scene(scene* x);
	scene(char* opts);

    virtual ~scene();

	char* opt(char* k, char* v = 0);
	int iopt(char* k, int v = 0);
	float fopt(char* k, float v = 0);
	void* popt(char* k, void* v = 0);
	scene* scopt(char* k, scene* v = 0);

	void* xopt(char* k, void* v = 0);

	scene* scr(char* k, scene* v = 0);

	scene* sc(char* k, scene* v = 0);
	scene* sc(int k, scene* v = 0); // in scene array

	scene_entry& operator[](const char* k);
	scene_entry& operator[](const int k);


	char* fval(char* k, int m, float* x);
    void f2val(char* k, float* x, float* y);
    void f3val(char* k, float* x, float* y, float* z);
    void f4val(char* k, float* x, float* y, float* z, float* a);

	static void* ptr(char* pre, char* k, void* v = 0);
	static void* ptr(char* pre, int k, void* v = 0); // int encoded

	static char* sptr(char* pre, char* k, char* v = 0);
	static char* sptr(char* pre, int k, char* v = 0); // int encoded

	char* lsptr(char* pre, char* k, char* v = 0);
	char* lsptr(char* pre, int k, char* v = 0); // int encoded

	static int iptr(char* pre, char* k, int v = -1);
	static int iptr(char* pre, int k, int v = -1); // int encoded

	static int ds(char* k, int v = -1);
	static int ds(int k, int v = -1);

	static ieffect* fx(char* k, ieffect* v = 0);
	static ieffect* fx(int k, ieffect* v = 0);

	static itexture* tx(char* k, itexture* v = 0);
	static itexture* tx(int k, itexture* v = 0);

	static itexture* cp(char* k, itexture* v = 0);
	static itexture* cp(int k, itexture* v = 0);

	char* cmd(char* k, char* v = 0);
	char* cmd(int k, char* v = 0);

    static char* cm(char* k, char* v = 0);
	static char* cm(int k, char* v = 0);

	char* eq(char* k, char* v = 0);
	char* eq(int k, char* v = 0);

	static void* xp(char* k, void* v = 0);
	static void* xp(int k, void* v = 0);


	

// creation

    
	virtual scene* create(char* opts = 0);
	virtual scene* type(char* x);

    virtual HRESULT init(IDirect3DDevice9* device);
    virtual HRESULT restore(IDirect3DDevice9* device);
	virtual HRESULT compose(IDirect3DDevice9* device, DWORD t);

	virtual HRESULT render_begin(IDirect3DDevice9* device = 0);
	virtual HRESULT render_end(IDirect3DDevice9* device = 0);


    virtual HRESULT render(IDirect3DDevice9*  device,
                               IDirect3DTexture9* texture );
	
	HRESULT draw(IDirect3DDevice9*  device,
                               IDirect3DTexture9* texture );


    static char* fm(char* szFormat, ...);

	// shader/effect support

	virtual int load_effect(char* type, char* name = "effect");
	virtual int update_effect();
	virtual LPD3DXEFFECT effect(char* s = 0, LPD3DXEFFECT fx = 0);


    //void set_state(int x);

    int exclude(); // to exclude
	void exclude(int t);

	int get_mode(); // 0 absolute, 1 relative (transform
	void set_mode(int t);

	virtual int index(); // index pictures
	virtual void index(int t);

	virtual double rate(); // index pictures
	virtual void rate(double t);

	void clear(msg_array* m);

	virtual int next(int t=0); 

    virtual float fraction(); //  0 .. 1

	int inbetween(float tb, float te);
	int inbetween(char* iv);
	int in(char* iv); // opt interval
	int in(float b, float e);
	int in(int s); // == state

	int is(char* opt, char* v);

	float speed(float x = -1);
	float _speed;

	float rx(float x = 0);
	float ry(float y = 0);
	float rz(float z = 0);

	void begin(double t = 0); // 0 = now()
	void end(double t = 0);
	double current(); // time within fraction interval
    double dxtime();
    double now(); // get_seconds
	double delta(); // difference
	void interval(double tbegin, double tend); // begin ... end (relative)

	void message(int x, int y, DWORD color, const char* m);

    virtual void rectangle( float fTU, float fTV ); // use as is
private:
	void __init();
public:
int state; // for switch
int previous; // to detect state changes


// text manip
protected:
IDirect3DDevice9* _device;
CD3DFont* _font;
char* _message[256];

public:
int _size;
char* _letterset;
DWORD _color;
DWORD _alt;
public:

DWORD argb(int a, int r, int g, int b);
DWORD rgb( int r, int g, int b);

static	scene* __small;
static	scene* __plain;
static  scene* __large;
static	scene* __ultra;
static int __cx;
static int __cy;

static scene* _small(scene* x = 0);
static scene* _plain(scene* x = 0);
static scene* _large(scene* x = 0);
static scene* _ultra(scene* x = 0);


static int _cx(int x = -1);
static int _cy(int x = -1);


float _x;
float _y;
float _lx;
float _ly;
float _rx;
float _ry;
int _inc;
int _a;
int _r;
int _g;
int _b;
int _tab;


public:
int _mode; // 0 absolute, 1 incremental (default);
// int _previous; // to store mode
D3DXMATRIX* __world; // stack model for world transforms
D3DXMATRIX* __view; // stack model for world transforms
D3DXMATRIX* __projection; // stack model for world transforms
D3DXMATRIX* __wvp; // stack model for world transforms


D3DXMATRIX* _world(D3DXMATRIX* x = 0);
D3DXMATRIX* _view(D3DXMATRIX* x = 0);
D3DXMATRIX* _projection(D3DXMATRIX* x = 0);

D3DXMATRIX* _wvp(D3DXMATRIX* x = 0);
//LPD3DXEFFECT _effect; 
ieffect* _effect; 
char* _shader;



public:
int _stack;
int _once;

float m_fTU; float m_fTV; // texture alignment
float _tu; float _tv; // texture alignment

int count; // number of sub scenes
int excl; // to exclude scene

double _begin;
double _end;
double _time;
double _last;
double _holdtime;

public:

float _fraction;
int loop; // looping
int _exclude[MAX_SCENE]; // to exclude components
scene* scenes[MAX_SCENE];
public:
static int rendering; // to determine nesting of scenes
protected:
static float _felapsed;
static int _frames;
static float _fps;
static float fps();

public:
	static void handle_event(char* type, char* ev);
	static scene* __handler;
	virtual int handle(char* type, char* ev);
protected:
	int _event;
	int _condition;
public:
static	char __key[128];
static char* _key(char* x = 0);
	int check(char* type, char* ev, char* xt, char* xe);
	int is(char*);
public:
	virtual int event();
	int condition();
public:
	static int fullscreen;
public:
	double _rate;
	double _elapsed;
	int _idx;
	int _max;
	int _debug;
	int _show;

public:
    virtual int maxs();
	static int __width;
	static int __height;

	static int width(int x = -1);
	static int height(int x = -1);


	void display(char* m = 0);
	//static 	int _source;
	char _type[12];
	char* _title;

	int _width;
	int _height;
	int _pitch;
public:
	int _bg;
public:
	static int _embedded;
	static int embedded();
public:
static int __hall;
static int __movies;
static int __game;
scene* _scene;
scene* _parent;
static scene* __main;
static scene* _main(scene* x = 0);


scene* _slides;
scene* _menu;
scene* _text;
int _txt;
static scene* __master;
static int __ctrl;
static int __shift;
char* _display;

static scene* _master(scene* x = 0);
static scene* _handler(scene* x = 0);

static int _ctrl(int x = -1);
static int _shift(int x = -1);

public: // AE ??
	static int __interactive;
	static void* __source;
	static void* __sources[12];
	static char* __name;
	static char* __names[12];

	static int _interactive(int x = -1);
	static  void* _source( void* x = 0);

	int _index;

	static int __project;
	static int __backdrop;
	static int __select;
	static int __active;

	static int _project(int x = -1);
	static int _backdrop(int x = -1);
	static int _select(int x = -1);
	static int _active(int x = -1);
	

	IDirect3DTexture9* _texture;
	static IDirect3DTexture9* __textures[256];
	IDirect3DTexture9* _capture;
	static IDirect3DTexture9* __captures[256];

	static IDirect3DTexture9* _textures(int i = 0, IDirect3DTexture9* x = 0);
	static IDirect3DTexture9* _captures(int i = 0, IDirect3DTexture9* x = 0);

	static int __total; 
	static int _total(int x = -1);
	
	static int __running[12];

	void* _buffer;

	D3DFORMAT _format;
    CCritSec* _cs;
	void check_cs();

	HRESULT get_buffer();

public:
	int _selection;
	int _enabled;
    //scene* _menu;
	//static int interactive;
	//static int machine;
	int _exclusive;


	public:
		virtual HRESULT initialize(IDirect3DDevice9* device);
		int _initialized;
		int _lazy;

public:

	virtual  void SetColor( D3DCOLOR color );
    virtual  IDirect3DDevice9 * GetDevice();

    virtual  HRESULT SetMediaFormat( GUID subtype);
    virtual  HRESULT CreateTexture( UINT Width, UINT Height, D3DFORMAT format);

    virtual  HRESULT BltToTexture(IDirect3DSurface9 *lpSurf, UINT Width, UINT Height);
    virtual  HRESULT CopyMediaSample( IMediaSample *pSample, LONG lSamplePitch );

public:
	int _absolute;
	
public:
	static scene* __video;
	HRESULT load_captures(IDirect3DTexture9* texture);

	int _blend;
	int _lights;
	int _drops;

	float _factor;

public:
	void translation(float x, float y, float z);
	void scale(float x, float y, float z);
	void rotation(float x, float y, float z, float r);
	//float[3] translation();
	//float[3] scale();
	//float[4] rotation();
	void set(IDirect3DDevice9* device, int t = 0); // 0 absolute, 1 relative

	void  get(IDirect3DDevice9* device, D3DXMATRIX* mat);
	void  set(IDirect3DDevice9* device, D3DXMATRIX* mat);
    
	void  get(D3DXMATRIX* mat);
protected:
	transform* _transform;

//#ifdef event
#undef event
//#endif
public:
	void options(char* x);
	void propagate(char* x, int d = -1);
	//void process(event* e = 0);
    
	int debug(char* x, int k = 0);
	int instring(char c, char* s);

	scene* lst(char* k, scene* v = 0); // dictionay -- available for init etc ..
	scene* unlst(char* k, scene* v = 0); 

	

//protected:
	int _lst;
	void* _sclst;
	void chlst();
	void chfx();
	//list<scene> lst;
	void* _fxlst;
};

//#undef _UNICODE
//#undef _MBCS
#endif 
