
#ifndef video_h
#define video_h

#include <hush/export.h>

#include "scene/scene.h"
#include "common90/d3d-util.h"
#include "video/textures.h"

class HUSH_API video : public scene  
{
public:

    video(scene* x = 0);
	
    virtual ~video();
    virtual HRESULT init(IDirect3DDevice9* device);
	virtual HRESULT restore(IDirect3DDevice9* device);
	virtual HRESULT compose(IDirect3DDevice9* device, DWORD t);
    

    virtual HRESULT render(  IDirect3DDevice9* device,
                        IDirect3DTexture9* texture );

	
	int handle(char* type, char* ev);

	
    //HRESULT Initialize();
    //HRESULT Render();
    void SetColor( D3DCOLOR color );
    IDirect3DDevice9 * GetDevice();

    //HRESULT SetMediaFormat( GUID subtype);
    HRESULT CreateTexture( UINT Width, UINT Height, D3DFORMAT format);

    HRESULT BltToTexture(IDirect3DSurface9 *lpSurf, UINT Width, UINT Height);
    HRESULT CopyMediaSample( IMediaSample *pSample, LONG lSamplePitch );

    //HWND    m_hwnd;         // video window

private:
    // methods
    void Cleanup(void);

    // Direct3D related
   

	
    //HRESULT SetupMatrices();
    //HRESULT SetupLights();
    //HRESULT CalculateVertices();
    
    // DirectShow related
    HRESULT InitDShowTextureRenderer();
    HRESULT CaptureVideo(IBaseFilter *pRenderer);
    HRESULT FindCaptureDevice(IBaseFilter ** ppSrcFilter);
    void CheckMovieStatus(void);

    // DirectShow debug
#ifdef REGISTER_FILTERGRAPH
    HRESULT AddToROT(IUnknown *pUnkGraph);
    void RemoveFromROT(void);
#endif

protected:
	CCritSec m_cs;
    CComPtr<IDirect3D9>             m_pD3D;         // Used to create the D3DDevice
    IDirect3DDevice9*       m_pd3dDevice;   // Our rendering device
    CComPtr<IDirect3DVertexBuffer9> m_pVB;          // Buffer to hold vertices
    CComPtr<IDirect3DTexture9>      m_pTexture;     // Our texture

    CComPtr<ICaptureGraphBuilder2>  m_pCapture;     // Helps to render capture graphs
    CComPtr<IGraphBuilder>          m_pGB;          // GraphBuilder
    CComPtr<IMediaControl>          m_pMC;          // Media Control
    CComPtr<IMediaEvent>            m_pME;          // Media Event

    FLOAT                   m_HAR;          // ratio of allocated width for m_pTexture to the 
                                            // actual width of the image it holds
    FLOAT                   m_VAR;          // ratio of allocated height for m_pTexture to the 
                                            // actual height of the image it holds

    UINT                    m_Width;        // actual image size
    UINT                    m_Height;

    D3DFORMAT               m_TextureFormat; // format of the texture we draw

    DWORD                   m_dwStartTime;  // start time for animation, 
                                            // animation current time = timeGetTime() - m_dwStartTime;

    D3DCOLOR                m_d3dcolorBackground; // background color

    // some constants

    DWORD m_dwROTReg;      

};
#endif 
