
#ifndef vip_actor_h
#define vip_actor_h

#include <hush/export.h>
#include "scene/scene.h"

//#include <cal3d/cal3d.h>


class vip_actor : public scene  
{
public:

    vip_actor(char* opts = 0);

    int operator()();
    virtual ~vip_actor();
    virtual int _load();
    virtual int _restore();
    virtual int _render();

    int handle(char* type, char* ev);

bool onInit();
	void onIdle();
  void onRender();

protected:
  LPDIRECT3DTEXTURE9  loadTexture(const char* strFilename);
  bool parseModelConfiguration(const char* strFilename);
  void renderCursor();
  void renderModel();
  bool loadVertexBuffer();
private:
	// D3D vertex & index buffer
	LPDIRECT3DVERTEXBUFFER9 m_pVB;
	int m_VBCursor;
	LPDIRECT3DINDEXBUFFER9  m_pIB;
	int m_IBCursor;
	LPD3DXFONT  m_pFont;


	
protected:
  int m_width;
  int m_height;
  bool m_bFullscreen;
  int m_mouseX;
  int m_mouseY;
  float m_tiltAngle;
  float m_twistAngle;
  float m_distance;
  bool m_bLeftMouseButtonDown;
  bool m_bRightMouseButtonDown;
  unsigned int m_lastTick;
  bool m_bPaused;
  class CalCoreModel* g_calCoreModel;
  class CalModel* g_calModel;
  float m_scale;
  int m_currentAnimationId;
  float m_leftAnimationTime;
  float m_blendTime;
  float m_lodLevel;
  int m_vertexCount;
  int m_faceCount;

  float m_fpsDuration;
  int m_fpsFrames;
  int m_fps;





};
#endif 
