#include <hush/source.h>

#include "mesh.h"
#include <scene/mesh.h>
#include <scene/shader.h>
#include <scene/background.h>
#include <scene/face.h>


#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>




//#include "shader.h"




static char* _help = "(vip) sm";
static scene* dolphin;


int vip_mesh::ch(char* x) {
int status = 0;


	return status;

}


int vip_mesh::handle(char* type, char* ev) {
	if (check(type,ev,"shift","down")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","a")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","0")) {
		int s = 0;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","1")) {
		int s = 1;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","2")) {
		int s = 2;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



int vip_mesh::operator()()
{
  

state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

vip_mesh::vip_mesh(char* opts) 
{
	
	count = 12;

	ch();

_size = 20; //size;
wsprintf(_type,"vip_mesh");
_display = _type;

end(20);
loop = 1;


// Mesh collection and frame hierarchy
g_Mesh  = NULL;
g_Frame = NULL;

// Bounding radius of mesh
g_MeshRadius = 0.0f;


 

 
  
}




vip_mesh::~vip_mesh()
{
//delete scenes[];
}

int 
vip_mesh::_load()
{
    int hr = S_OK;

	 // Load a skeletal mesh
  LoadMesh(&g_Mesh, &g_Frame, _device, "..\\Data\\poser-ae.x", "..\\Data\\");
  //LoadMesh(&g_Mesh, &g_Frame, _device, "..\\models\\nana.x", "..\\models\\");

  // Get the bounding radius of the object
  g_MeshRadius = 0.0f;
  D3DXMESHCONTAINER_EX *pMesh = g_Mesh;
  while(pMesh) {

    // Lock the vertex buffer, get its radius, and unlock buffer
  if(pMesh->MeshData.pMesh) {
      D3DXVECTOR3 *pVertices, vecCenter;
      float Radius;
      pMesh->MeshData.pMesh->LockVertexBuffer(D3DLOCK_READONLY, (void**)&pVertices);
      D3DXComputeBoundingSphere(pVertices, 
                                pMesh->MeshData.pMesh->GetNumVertices(),
                                D3DXGetFVFVertexSize(pMesh->MeshData.pMesh->GetFVF()),
                                &vecCenter, &Radius);
      pMesh->MeshData.pMesh->UnlockVertexBuffer();

      // Update radius
      if(Radius > g_MeshRadius)
        g_MeshRadius = Radius;
    }

    // Go to next mesh
    pMesh = (D3DXMESHCONTAINER_EX*)pMesh->pNextMeshContainer;
  }



	hr = scene::init(_device); // loops through scenes

	
    return hr;
}

int
vip_mesh::_restore()
{
    HRESULT hr = S_OK;

  float Distance = g_MeshRadius * 3.0f;
  float Angle = (float)timeGetTime() / 2000.0f;
  D3DXMATRIX matView;
  D3DXMatrixLookAtLH(&matView,
                     &D3DXVECTOR3((float)cos(Angle) * Distance, g_MeshRadius, (float)sin(Angle) * Distance),
                     &D3DXVECTOR3(0.0f, 0.0f, 0.0f),
                     &D3DXVECTOR3(0.0f, 1.0f, 0.0f));
  _device->SetTransform(D3DTS_VIEW, &matView);

  // Rebuild the frame hierarchy transformations
  if(g_Frame)
    g_Frame->UpdateHierarchy();

  // Rebuild the mesh
  UpdateMesh(g_Mesh);



    return hr;
}


int
vip_mesh::_render( ) 
{
HRESULT hr = S_OK;
  
	render_begin(_device);
	
	_device->SetTexture( 0, _texture );
       //int i = 0;

     DrawMesh(g_Mesh);
	

	hr = scene::_render(); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (1) {
		
		message(100,_y-200,argb(255,255,120,120),fm("%s [%d]",_help,state));
	} 
	
	

	display(_display);
   
	render_end(_device);

 

    return hr;
}

