#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "awc.h"


int text_awc::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_awc::create(char* opts) { return new text_awc(opts); }

text_awc::text_awc(char* opts) 
{
  
	clear(&msg);

	opt("display","Agents with Character");
	opt("text(title)","Agents with Character ");
	opt("text(sub)","Evaluation of empathic agents in digital dossiers ");

	opt("text(authors)","J.F. Hoorn, A. Eliens, Z. Huang, H.C. van Vugt, E.A. Konijn, C.T. Visser");
	

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","ECA");
	opt("logo(3ds)","perspectives");
	opt("logo(vip)","ECA");

	//sc("slides",new slides("d:\\vip\\present\\awc","img0",1,16,"jpg"));

	declare("local/slides/awc",new  slides(loc("\\vip\\present\\awc"),"img0",1,3,"jpg"));
    opt("slides","local/slides/awc");


	// --------------------------------------------------------

	msg[5][11] = "http://www.cs.vu.nl/~eliens/papers/title-awc.html";

   	msg[0][1] = "embodied conversational agents";
	msg[0][3] = "need content";
	msg[0][5] = "must be meaningfully";
	msg[0][7] = "embedded in relevant context";
	msg[0][9] = "centered around function";
	msg[0][11] = "developed with intelligent multimedia";
	


	msg[2][0] = "embodied agents must enhance";
	msg[2][1] = " user experience";
	msg[2][2] = "provide a wide range of";
	msg[2][3] = " agent functionality";
	msg[2][4] = "conform to stringent";
	msg[2][5] = " platform criteria";
	msg[2][6] = "and provide sufficient";
	msg[2][7] = " information support";
	msg[2][8] = "to become a";
	msg[2][9] = " natural assistant";
	msg[2][10] = "for the human user";


	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];


	msg[3][0] = "in this presentation ";
	msg[3][3] = " we will look at ";
	msg[3][4] = "requirements, applications and technology";
	msg[3][7] = " for agent development platform(s)";
	msg[3][8] = "shamelessly plugging our";
	msg[3][11] = " intelligent multimedia technology";

	
	msg[4][1] = "      ECA perspectives 2004";
	msg[4][6] = "           Anton Eliens";	
	msg[4][8] = "        Vrije Universiteit";
	msg[4][9] = "             Amsterdam";



}

text_awc::~text_awc()
{
//delete scenes[];
}

HRESULT 
text_awc::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
text_awc::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
 

    return hr;
}


HRESULT 
text_awc::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;


    _text->state = state;

	render_begin(device);

    
   

	hr = scene::render(device,texture); // calls compose, restore,  render

	
    
	render_end(device);

 

    return hr;
}

