#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "convergence.h"


int text_convergence::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_convergence::create(char* opts) { return new text_convergence(opts); }

text_convergence::text_convergence(char* opts) 
{
  
	clear(&msg);

	//opt("style","plain");
	opt("space","vip/morph");

	opt("lecture","digital convergence");
	opt("display","multimedia @VU");
	opt("text(title)","digital convergence ");
	opt("text(sub)","convergence     standards      retrieval");
	//opt("text(authors)","       A. Eliens");

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","media");
	opt("logo(3ds)","@VU");
	opt("logo(vip)","@VU");
	//sc("slides",new slides("..\\present\\imm-convergence","img0",1,20,"jpg"));

	declare("local/slides/convergence",new  slides(loc("\\vip\\present\\imm-convergence"),"img0",1,20,"jpg"));
    opt("slides","local/slides/convergence");

	// --------------------------------------------------------

		msg[5][11] = "http://www.cs.vu.nl/~eliens/media";

    msg[0][0] = "digital convergence";
	msg[0][2] = "characterizes";
	msg[0][4] = "the confluence of";
	msg[0][6] = "digital content";
	msg[0][8] = "presentation platforms";
	msg[0][10] = "networked delivery";
	

	msg[2][0] = "it covers";
	msg[2][1] = " content";
	msg[2][2] = "which must be presented on";
	msg[2][3] = " platforms";
    msg[2][4] = "and includes ";
	msg[2][5] = " delivery";
    msg[2][6] = "however, there is such";
	msg[2][7] = " a variety of";
	msg[2][8] = "possibly conflicting";
	msg[2][9] = " forms";
    msg[2][10] = "that we should think of divergence";

	
	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];

	msg[3][0] = "multimedia ";

	msg[3][3] = " are becoming mobile";
	msg[3][4] = "TV, PC, ...";

	msg[3][7] = " mobile phone, PDA";
	msg[3][8] = "mp3, wmv, ...";

	msg[3][11] = " a confusing lot ...";


	msg[4][1] = "    multimedia @VU";


	msg[4][6] = "  digital  convergence";
	
	msg[4][8] = "   Vrije Universiteit";
	msg[4][9] = "        Amsterdam";



}

text_convergence::~text_convergence()
{
//delete scenes[];
}

int 
text_convergence::_load()
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::_load(); // loops through scenes

    return hr;
}

int
text_convergence::_restore()
{
    HRESULT hr = S_OK;
 

    return hr;
}


int
text_convergence::_render( ) 
{
int hr = S_OK;


    _text->state = state;

	render_begin(_device);

    
   

	hr = scene::_render(); // calls compose, restore,  render

	
    
	render_end(_device);

 

    return hr;
}

