#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "eca.h"


int text_eca::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_eca::create(char* opts) { return new text_eca(opts); }

text_eca::text_eca(char* opts) 
{
  
	clear(&msg);

	opt("display","ECA perspectives 2004");
	opt("text(title)","ECA perspectives 2004 ");
	opt("text(sub)","Requirements, Applications, Technology");

	opt("text(authors)","A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","ECA");
	opt("logo(3ds)","perspectives");
	opt("logo(vip)","ECA");

	//sc("slides",new slides("d:\\vip\\present\\eca","img0",1,8,"jpg"));

	declare("local/slides/eca",new  slides(loc("\\vip\\present\\eca"),"img0",1,8,"jpg"));
    opt("slides","local/slides/eca");

	// --------------------------------------------------------

	msg[5][11] = "http://www.cs.vu.nl/~eliens/papers/title-eca.html";

   	msg[0][1] = "embodied conversational agents";
	msg[0][3] = "need content";
	msg[0][5] = "must be meaningfully";
	msg[0][7] = "embedded in relevant context";
	msg[0][9] = "centered around function";
	msg[0][11] = "developed with intelligent multimedia";
	


	msg[2][0] = "embodied agents must enhance";
	msg[2][1] = " user experience";
	msg[2][2] = "provide a wide range of";
	msg[2][3] = " agent functionality";
	msg[2][4] = "conform to stringent";
	msg[2][5] = " platform criteria";
	msg[2][6] = "and provide sufficient";
	msg[2][7] = " information support";
	msg[2][8] = "to become a";
	msg[2][9] = " natural assistant";
	msg[2][10] = "for the human user";


	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];


	msg[3][0] = "in this presentation ";
	msg[3][3] = " we will look at ";
	msg[3][4] = "requirements, applications and technology";
	msg[3][7] = " for agent development platform(s)";
	msg[3][8] = "shamelessly plugging our";
	msg[3][11] = " intelligent multimedia technology";

	
	msg[4][1] = "      ECA perspectives 2004";
	msg[4][6] = "           Anton Eliens";	
	msg[4][8] = "        Vrije Universiteit";
	msg[4][9] = "             Amsterdam";



}

text_eca::~text_eca()
{
//delete scenes[];
}

HRESULT 
text_eca::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
text_eca::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
 

    return hr;
}


HRESULT 
text_eca::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;


    _text->state = state;

	render_begin(device);

    
   

	hr = scene::render(device,texture); // calls compose, restore,  render

	
    
	render_end(device);

 

    return hr;
}

