#include <hush/source.h>
#include <scene/text.h>
#include <scene/slides.h>
#include <scene/sim.h>

#include "web3d.h"


int text_web3d::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_web3d::create(char* opts) { return new text_web3d(opts); }

text_web3d::text_web3d(char* opts) 
{
  
	clear(&msg);

	//opt("style","plain");
	opt("display","web3d/vrml");
	opt("text(title)","web3d/vrml");
	opt("text(sub)","      digital                          authoring");
	opt("space","vip/morph");

	//opt("text(authors)","A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","web3d");
	opt("logo(3ds)","vrml");
	opt("logo(vip)","web3d");

	//sc("slides",new slides("..\\present\\web3d","img0",1,3,"jpg"));
	declare("local/slides/web3d",new  slides(loc("\\vip\\present\\web3d"),"img0",1,10,"jpg"));
    opt("slides","local/slides/web3d");

	msg[5][11] = "http://www.cs.vu.nl/~eliens/mma1";

   	msg[0][1] = "3D infotainment spaces";
	msg[0][3] = "are generally accepted as";
	msg[0][5] = "meaningful";
	msg[0][7] = "and even commercially interesting";
	msg[0][9] = "toys for";
	msg[0][11] = "the digitally literate";
	


	msg[2][0] = "the breakthrough will come from";
	msg[2][1] = " game generation";
	msg[2][2] = "who will use the";
	msg[2][3] = " graphic machines";
	msg[2][4] = "and all facilities";
	msg[2][5] = " high performance computing";
	msg[2][6] = "as well as there (hopefully)";
	msg[2][7] = " creative minds";
	msg[2][8] = "to engage in the";
	msg[2][9] = " exploration";
	msg[2][10] = "of the new digital aesthetics";


	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];


	msg[3][0] = "in this course ";
	msg[3][3] = " we will look at ";
	msg[3][4] = "the craft of Web3D";
	msg[3][7] = " there will be no theory";
	msg[3][8] = "and other things distracting you";
	msg[3][11] = " from the (un)real 3D work";

	
	msg[4][1] = "            Web3D 2004";
	msg[4][6] = "           Anton Eliens";	
	msg[4][8] = "        Vrije Universiteit";
	msg[4][9] = "             Amsterdam";



}

text_web3d::~text_web3d()
{
//delete scenes[];
}

HRESULT 
text_web3d::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
text_web3d::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
 

    return hr;
}


HRESULT 
text_web3d::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;


    _text->state = state;

	render_begin(device);

    
   

	hr = scene::render(device,texture); // calls compose, restore,  render

	
    
	render_end(device);

 

    return hr;
}

