//------------------------------------------------------------------------------
// File: vmr9allocator.cpp
//
// Desc: DirectShow sample code - main implementation file
//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//------------------------------------------------------------------------------

#pragma warning(disable: 4710)  // "function not inlined"

#include "stdafx.h"
#include "resource.h"
#include "util.h"
#include "allocator.h"
//#include "vmrutil.h"
#include "capture.h"
#include <vip.h>
#define UNICODE
#include <tchar.h>

#define MAX_LOADSTRING 100

// Global Variables:
extern HINSTANCE hInst;                       
//TCHAR szTitle[MAX_LOADSTRING];         
//TCHAR szWindowClass[MAX_LOADSTRING];  


// Forward declarations of functions included in this code module:
//BOOL                MyRegisterClass(HINSTANCE hInstance);
//BOOL                InitInstance(HINSTANCE, int, HWND& );
//void                PaintWindow(HWND hWnd);
//LRESULT CALLBACK    WndProc(HWND, UINT, WPARAM, LPARAM);
//LRESULT CALLBACK    About(HWND, UINT, WPARAM, LPARAM);

HRESULT             StartGraph(HWND window);
HRESULT             CloseGraph(HWND window);
HRESULT             SetAllocatorPresenter( CComPtr<IBaseFilter> filter, HWND window );

DWORD_PTR                       g_userId = 0xACDCACDC;
extern HWND                            g_hWnd;
static HWND g_hwnd;
// DirectShow interfaces
CComPtr<IGraphBuilder>          g_graph;
CComPtr<IBaseFilter>            g_filter;
CComPtr<IMediaControl>          g_mediaControl;
CComPtr<IVMRSurfaceAllocator9>  g_allocator;




_bstr_t GetMoviePath()
{
    OPENFILENAME ofn;
    ZeroMemory(&ofn, sizeof(ofn));
    TCHAR  szBuffer[MAX_PATH];
    szBuffer[0] = NULL;

    static const TCHAR szFilter[]  
                            = TEXT("Video Files (.ASF, .AVI, .MPG, .MPEG, .VOB, .QT, .WMV)\0*.ASF;*.AVI;*.MPG;*.MPEG;*.VOB;*.QT;*.WMV\0") \
                              TEXT("All Files (*.*)\0*.*\0\0");
    ofn.lStructSize         = sizeof(OPENFILENAME);
    ofn.hwndOwner           = g_hWnd;
    ofn.hInstance           = NULL;
    ofn.lpstrFilter         = szFilter;
    ofn.nFilterIndex        = 1;
    ofn.lpstrCustomFilter   = NULL;
    ofn.nMaxCustFilter      = 0;
    ofn.lpstrFile           = szBuffer;
    ofn.nMaxFile            = MAX_PATH;
    ofn.lpstrFileTitle      = NULL;
    ofn.nMaxFileTitle       = 0;
    ofn.lpstrInitialDir     = NULL;
    ofn.lpstrTitle          = TEXT("Select a video file to play...");
    ofn.Flags               = OFN_HIDEREADONLY;
    ofn.nFileOffset         = 0;
    ofn.nFileExtension      = 0;
    ofn.lpstrDefExt         = TEXT("AVI");
    ofn.lCustData           = 0L;
    ofn.lpfnHook            = NULL;
    ofn.lpTemplateName  = NULL; 
    
    if (GetOpenFileName (&ofn))  // user specified a file
    {
        return _bstr_t( szBuffer );
    }

   return "";
}

HRESULT             
CloseGraph(HWND window)
{
    if( g_mediaControl != NULL ) 
    {
        OAFilterState state;
        do {
            g_mediaControl->Stop();
            g_mediaControl->GetState(0, & state );
        } while( state != State_Stopped ) ;
    }

    g_allocator    = NULL;        
    g_mediaControl = NULL;        
    g_filter       = NULL;        
    g_graph        = NULL;
    ::InvalidateRect( window, NULL, true );
    return S_OK;
}

/*
HRESULT GetVideoInputFilter(IBaseFilter** gottaFilter, wchar_t* matchName)
{
	BOOL done = false;

	// Create the System Device Enumerator.
	ICreateDevEnum *pSysDevEnum = NULL;
	HRESULT hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
		IID_ICreateDevEnum, (void **)&pSysDevEnum);
	if (FAILED(hr))
	{
		return hr;
	}

	// Obtain a class enumerator for the video input category.
	IEnumMoniker *pEnumCat = NULL;
	hr = pSysDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pEnumCat, 0);

	if (hr == S_OK) 
	{
		// Enumerate the monikers.
		IMoniker *pMoniker = NULL;
		ULONG cFetched;
		while ((pEnumCat->Next(1, &pMoniker, &cFetched) == S_OK) && (!done))
		{
			// Bind the first moniker to an object
			IPropertyBag *pPropBag;
			hr = pMoniker->BindToStorage(0, 0, IID_IPropertyBag, 
				(void **)&pPropBag);
			if (SUCCEEDED(hr))
			{
				// To retrieve the filter's friendly name, do the following:
				VARIANT varName;
				VariantInit(&varName);
				hr = pPropBag->Read(L"FriendlyName", &varName, 0);
					char buf[256];
					sprintf(buf,"%s", varName.bstrVal);
					//wprintf(L"Testing Video Input Device: %s\n", varName.bstrVal);
                HRESULT mb =   MessageBox(g_hwnd,buf,"device",MB_YESNO | MB_ICONQUESTION );
				if (mb == IDYES && SUCCEEDED(hr))
				{
					
					wprintf(L"Testing Video Input Device: %s\n", varName.bstrVal);
                   
					// Do a comparison, find out if it's the right one
					if (1 || (mb == IDYES && !matchName) || wcsncmp(varName.bstrVal, matchName, 
						wcslen(matchName)) == 0) {
                        //MessageBox(g_hwnd,buf,"found",MB_OK);
						// We found it, so send it back to the caller
						hr = pMoniker->BindToObject(NULL, NULL, IID_IBaseFilter, (void**) gottaFilter);
						done = true;
					}
				}
				VariantClear(&varName);	
				pPropBag->Release();
			}
			pMoniker->Release();
		}
		pEnumCat->Release();
	}
	pSysDevEnum->Release();
	if (done) {
		return hr;	// found it, return native error
	} else {
		return VFW_E_NOT_FOUND;	// didn't find it error
	}
}



HRESULT FindCaptureDevice(IBaseFilter ** ppSrcFilter)
{
    HRESULT hr;
    IBaseFilter * pSrc = NULL;
    CComPtr <IMoniker> pMoniker =NULL;
    ULONG cFetched;

    if (!ppSrcFilter)
        return E_POINTER;
   
    // Create the system device enumerator
    CComPtr <ICreateDevEnum> pDevEnum =NULL;

    hr = CoCreateInstance (CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC,
                           IID_ICreateDevEnum, (void **) &pDevEnum);
    if (FAILED(hr))
    {
        //Msg(TEXT("Couldn't create system enumerator!  hr=0x%x"), hr);
        return hr;
    }

    // Create an enumerator for the video capture devices
    CComPtr <IEnumMoniker> pClassEnum = NULL;

    hr = pDevEnum->CreateClassEnumerator (CLSID_VideoInputDeviceCategory, &pClassEnum, 0);
    if (FAILED(hr))
    {
        //Msg(TEXT("Couldn't create class enumerator!  hr=0x%x"), hr);
        return hr;
    }

    // If there are no enumerators for the requested type, then 
    // CreateClassEnumerator will succeed, but pClassEnum will be NULL.
    if (pClassEnum == NULL)
    {
        //MessageBox(ghApp,TEXT("No video capture device was detected.\r\n\r\n")
          //         TEXT("This sample requires a video capture device, such as a USB WebCam,\r\n")
            //       TEXT("to be installed and working properly.  The sample will now close."),
              //     TEXT("No Video Capture Hardware"), MB_OK | MB_ICONINFORMATION);
        return E_FAIL;
    }

    // Use the first video capture device on the device list.
    // Note that if the Next() call succeeds but there are no monikers,
    // it will return S_FALSE (which is not a failure).  Therefore, we
    // check that the return code is S_OK instead of using SUCCEEDED() macro.
    if (S_OK == (pClassEnum->Next (1, &pMoniker, &cFetched)))
    {
        // Bind Moniker to a filter object
        hr = pMoniker->BindToObject(0,0,IID_IBaseFilter, (void**)&pSrc);
        if (FAILED(hr))
        {
            //Msg(TEXT("Couldn't bind moniker to filter object!  hr=0x%x"), hr);
            return hr;
        }
    }
    else
    {
        //Msg(TEXT("Unable to access video capture device!"));   
        return E_FAIL;
    }

    // Copy the found filter pointer to the output parameter.
    // Do NOT Release() the reference, since it will still be used
    // by the calling function.
    *ppSrcFilter = pSrc;

    return hr;
}
*/

//ICaptureGraphBuilder2 *pBuild = NULL;
static ICaptureGraphBuilder2 *pBuild = NULL;
static IBaseFilter *pSource = 0;
static IBaseFilter *fSource = 0;
static _bstr_t path;

HRESULT StartGraph(HWND window)
{
    // Clear DirectShow interfaces (COM smart pointers)
    CloseGraph(window);

g_hwnd = window;
	//MessageBox(window,L"starting graph",L"capture",MB_YESNO);
	//AE
	IVMRWindowlessControl* pWc = NULL; 
	//EA

    //_bstr_t path = GetMoviePath();
    //if( ! path.length() )
    //{
      //  return E_FAIL;
    //}

    HRESULT hr;
		//AE
	
	
	CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, 
        CLSCTX_INPROC_SERVER, IID_ICaptureGraphBuilder2, (void**)&pBuild);

    
    FAIL_RET( g_graph.CoCreateInstance(CLSID_FilterGraph) );

	pBuild->SetFiltergraph(g_graph);

	//AE
    
    //FAIL_RET( g_graph.CoCreateInstance(CLSID_FilterGraph) );

    FAIL_RET( g_filter.CoCreateInstance(CLSID_VideoMixingRenderer9, NULL, CLSCTX_INPROC_SERVER) );

    CComPtr<IVMRFilterConfig9> filterConfig;
    FAIL_RET( g_filter->QueryInterface(IID_IVMRFilterConfig9, reinterpret_cast<void**>(&filterConfig)) );

    FAIL_RET( filterConfig->SetRenderingMode( VMR9Mode_Renderless ) );
	//FAIL_RET( filterConfig->SetRenderingMode( VMR9Mode_Windowless ) );

    FAIL_RET( filterConfig->SetNumberOfStreams(3) );

 


    FAIL_RET( SetAllocatorPresenter( g_filter, window ) );

    FAIL_RET( g_graph->AddFilter(g_filter, L"Video Mixing Renderer 9") );
    
    FAIL_RET( g_graph->QueryInterface(IID_IMediaControl, reinterpret_cast<void**>(&g_mediaControl)) );

	int cold = 0;
	hr = MessageBox(window,TEXT("play from capture?"),TEXT("capture"),MB_YESNO | MB_ICONQUESTION );
   //hr = g_graph->AddSourceFilter( L"C:\\AE\\media\\sebas.avi", L"Source1", &pSource);
    
	if (hr != IDYES) { 
		path = GetMoviePath();
		if (path.length()) cold = 1;
		//AE scene::_source = (char*) path;
		//find_capture(&pSource,0);
	//hr = g_graph->AddSourceFilter( L"media/isabelle-2.avi", L"Source1", &pSource);
	} else {
		machine::find_capture(&pSource,0,0,"capture");
    }

	
    if (cold) {
	//IBaseFilter *pSource;
	hr = g_graph->AddSourceFilter( (path),
		L"Source2", 
	//hr = g_graph->AddSourceFilter( L"..\\media\\coldshort.avi", L"Source2", 
		&fSource);

	if (pSource) g_graph->AddFilter(pSource, L"Video Capture");

	if (FAILED(hr)) ASSERT(0);

	WORD x1 = (WORD) 0;
	WORD x2 = 0;
	REFERENCE_TIME xt = 10*1000;

	//pBuild->ControlStream(&PIN_CATEGORY_VIDEOPORT,&MEDIATYPE_Video,pSourcev,
	//	0,&xt,0,0);
	
	//pBuild->RenderStream(0, 0, pSource, 0, g_filter);  
	pBuild->RenderStream(0, 0, fSource, 0, g_filter); 
	hr = pBuild->RenderStream(0, &MEDIATYPE_Audio, fSource, 0, NULL);
	} else if (pSource) hr = g_graph->AddFilter(pSource, L"Video Capture");

	if (pSource) {
    //hr = g_graph->AddFilter(pSource, L"Video Capture");
    pBuild->RenderStream(0, 0, pSource, 0, g_filter); 
    }
	

	

	//pBuild->ControlStream(&PIN_CATEGORY_VIDEOPORT,&MEDIATYPE_Video,pSource,
	//	&xt,0,0,0);
	//pBuild->ControlStream(&PIN_CATEGORY_CAPTURE,&MEDIATYPE_Video,pSource,&xt,0,0,0);

	//pBuild->RenderStream(0, 0, pSource, 0, g_filter); 
    //FAIL_RET( g_graph->RenderFile( path, NULL ) );

    FAIL_RET( g_mediaControl->Run() );

    return hr;
}

void doit() {
	HRESULT hr;
	hr = MessageBox(0,TEXT("replay?"),TEXT("capture"),MB_YESNO | MB_ICONQUESTION );
	if (fSource) {

	    fSource->Stop();
	    fSource->Run(0);
		//fSource->Release();
		//pBuild->RenderStream(0, 0, fSource, 0, g_filter);

	}
//pBuild->RenderStream(0, 0, fSource, 0, g_filter);
}


HRESULT SetAllocatorPresenter( CComPtr<IBaseFilter> filter, HWND window )
{
    if( filter == NULL )
    {
        return E_FAIL;
    }

    HRESULT hr;

    CComPtr<IVMRSurfaceAllocatorNotify9> lpIVMRSurfAllocNotify;
    FAIL_RET( filter->QueryInterface(IID_IVMRSurfaceAllocatorNotify9,
		         reinterpret_cast<void**>(&lpIVMRSurfAllocNotify)) );

    // create our surface allocator
    g_allocator.Attach(new CAllocator( hr, window ));
    if( FAILED( hr ) )
    {
        g_allocator = NULL;
        return hr;
    }
    
    // let the allocator and the notify know about each other
    FAIL_RET( lpIVMRSurfAllocNotify->AdviseSurfaceAllocator( g_userId, g_allocator ) );
    FAIL_RET( g_allocator->AdviseNotify(lpIVMRSurfAllocNotify) );

	//ASSERT(0);
    
    return hr;
}

