%%@ The institute

%%@ email

email(X,R) :- person(X), property(X,email:R).
email(X,R) :-
	person(X),
	atom(X), 
	domain(X,D),
	concat(X,'@',A),
	concat(A,D,R).

%%@ institute

institute(X,R) :- person(X), property(X,institute:R),!.
institute(X,R) :- default_institute(X,R).
	

default_institute(X,'VU') :- person(X,_),!.
default_institute(_,unknown).

%%@ division

division(X,R) :- person(X), property(X,division:R),!.
division(X,R) :- default_division(X,R).

default_division(X,'W&I') :- institute(X,'VU'),!.
default_division(_,unknown).

%%@ section

section(X,R) :- person(X), property(X,section:R),!.
section(X,R) :- default_section(X,R).

default_section(X,'IM&SE') :- division(X,'W&I'),!.
default_section(_,unknown).

%%@ domain

domain(X,R) :- person(X), institute(X,I),institute_domain(I,R),!.
domain(X,R) :- person(X), property(X,domain:R),!.
domain(X,R) :- default_domain(X,R).

default_domain(X,'cs.vu.nl') :- 
	institute(X,'VU'),
	division(X,'W&I'),!.

default_domain(_,unknown).

%%</>
