%%@ pointer.pl - examples

:- use(library([native,objects])).

:- dynamic object/7.

%%object(nil,nil,nil,0,[],[],_).
object(object:pointer,handler,nil,0,[],[],_).
object(event:object,event,nil,0,[handler],[],_).

%%@ I am just trying

handler_dispatch(This,Event) :-
	cerr(getting(dispatch(This,Event))),
	cerr(ok(go-on)),
	Event = event(P),
	event_arg(P,1,X),
	Event:arg(1,X).
	cerr(Event = X).

event_arg(This,X,R) :-
	cerr(doing(event_arg(This,X,R))),
	native(event:object,[ class=event, ref=This, method=arg(1) ], R).

hello_from(X,ok) :- hello_from(X).

hello_from(X) :-
	cerr(hello_from(X)).

hello(X,R) :-
	write(X),nl,
	query(my_query):bye(R).

handler_nobye(This,Result) :- Result = ok.               %% instead of query_...

%%@ this is all rather complicated, but it works

handler_bye(This,Result) :-                %% instead of query_...
	Self = query(This),         %%% down cast
	write(hi(objectid=This)),nl,
	object(H,_,This,REF,Anc,_,_),
	write(hi(ref=REF,anc=Anc)),nl,
	write(handler=H), nl,
	query(This):eval(hello),
	%%cerr(Self:eval(hello)),
	Self:eval(hello),
	eval(query(This):eval(hello)),
	%%cerr(eval(query(This):eval(hello))),
	query(This):result(X),
	new_query(final_query,R),
	%%cerr(query:R),
	%%query(This):query([kit=pl,cmd=member(X,[1,2,3])]),
	dummy(DD):dummy(R),
	%%cerr(called(R)),
	Self:bind(hello,R),
	%%cerr(dummy(DD):dummy(R)),
	Self:hello(Result),
	write(result(Result)),nl.

:- declare(object:pointer,class(query),[handler],[]).

%%@ there are dummies all around

dummy_dummy(This,R) :-
	declare(_,new(dummy(This)),[],[],R),
	write(dummy(This,R)).

dummy_operator(This) :-
	write(dummy_operator(This)).

%%@ and a pseudo query as well

query_bind(This,N,H) :-
	native(_,This,bind(N,H),_).

query_new(This) :-
	declare(object:pointer,new(query(This)),[],[],R).
	

new_query(X,R) :-
	H = object:pointer,
	declare(H,new(query(X)),[],[],R),
	query(X):query([]).

query_query(This,L) :- 
	write(query_query(in(construction:This:L))).

query_hello(This,R) :- native(_,This,hello(This),R).
query_eval(This,X) :- native(_,This,eval(X),_).
query_result(This,R) :- native(_,This,result,R).

%%</>
