#include "bulletin.h"
#include "query.h"


//@ ---------- ActiveObject::ActiveObject() constructor ----------

ActiveObject::ActiveObject ( GUI &gui ) :
bulletinBoard ( gui, "RootWindow" ),
buttonQuit    ( bulletinBoard, "QUIT" ),
buttonHello   ( bulletinBoard, "Hello" ) {
  //_query->eval("ok");
  //_query->result(1);
  id = 0;
  _query = active_query::_default;
  buttonQuit.SetXY( 100, 10 );
  buttonHello.SetXY( 100, 50 );
  bulletinBoard.Realize();
}

//@ ---------- ActiveObject::@ActiveObject() body ----------

void ActiveObject::go() {
	 cerr << "getting result" << endl;
	 _query->eval("some(X):member(X,[1,2])");
	 char* p = 0;
	 while (( p = _query->result(id))) 
		cerr << "result: " << p << endl;
	}

ActiveObject::@ActiveObject() {
  for(;;) {
    cerr << "ActiveObject::@ActiveObject()" << endl;
    select {
       buttonQuit.Pressed(); {
         printf("QUIT pressed, bye...\n");
	 char* p = 0;
	 while (( p = _query->result(id))) 
		cerr << "result: " << p << endl;
	 }
         accept ~ActiveObject;
    ||
        buttonHello.Pressed(); {
	 //cerr << "evaluate" << endl;
	 //char* p = _query->evaluate(":(write(qq),nl)");
	 //cerr << "evalled " << p << endl;
	 id = _query->eval("X:member(X,[1,2])");
	 }
         printf("Hello pressed\n");
    } 
  }
}

//@ init

int bulletin_main (int argc, char *argv[]) {
  GUI gui ( argc, argv );
  ActiveObject activeObject ( gui );
  return 0;
}
//</>
