#include <widgets/frame.h>

#include <hush/dv/gl/glx/glwin.h>
#include <hush/dv/gl/ogl/GL.h>
#include <hush/dv/gl/ogl/glob.h>

#include <hush/dv/gl/glx/handler.h>
#include <hush/widgets/tk/glxwin.h>

#include <hush/event.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#undef glwin

#define TYPE glwin
#define CLASS dv_glwin

#include <hush/widgets/tk/create.i>

/* Extra widgets */

typedef int Position;
typedef int Dimension;

/* View Area dependencies */

#include "GL/gl.h"
#include "GL/glx.h"

#include <math.h>
#include <stdio.h>


void            giveStatus(char* s) { cerr << s << endl; } 



const float PAN_SCALE = (M_PI / 500);



/* static variables */

static float		phi = 0, theta = 0, dolly, thezoom;



/* function prototypes */



static void initCB();



int CLASS::file(const char *)
{

    
  int result = 0;

  initCB();

  theta = 0.0f;
  phi = 0.0f;

  return result;
}



/* The dolly controls the field of view angle, which can be 
   adjested between 10 and 90 degrees. */

void CLASS::pan(float dx, float dy, float dz)
{
  float X, Y, Z;
  theta -= PAN_SCALE * (dx);
  phi += PAN_SCALE * (dy);
  
  if (phi > 0.95 * M_PI_2)
    phi = 0.95 * M_PI_2;
  else if (phi < - 0.95 * M_PI_2)
    phi = - 0.95 * M_PI_2;
  
  X = cos(phi) * sin(theta);
  Y = sin(phi);
  Z = cos(phi) * cos(theta);
  
    //cerr << "PANNING" << endl;
  
  redraw();
}


void CLASS::zoom(int value)
{
  char text[40];
   float val = (float) value;

  sprintf(text, "Zoom: %f degrees", thezoom);
  cerr << text << endl;
  
  redraw();

}




static void initCB()
{


  /* Create OpenGL context */


  /* Ready to render! */
  
  glClearColor(0.0, 0.0, 0.0, 0.0);
  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-1.0, 1.0,  -1.0, 1.0,  1.0, 10.0);
  glTranslatef(0.0, 0.0, -5.0);
  
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  glCullFace(GL_BACK);
  glEnable(GL_CULL_FACE);
  glEnable(GL_LIGHTING);
  glDepthFunc(GL_LESS);
  glEnable(GL_DEPTH_TEST);
  
  glShadeModel(GL_SMOOTH); /* Prv enten GL_FLAT eller GL_SMOOTH. */
}

static  Dimension _width = 300, _height = 300;

void 
CLASS::redraw()
{


  /* Execute graph redraw action */
  
  glob* x = (glob*) GL::_glob;
  x->_repaint();
  if (1) {
    
  } else {
    /* clear area */
    cerr << "Nothing to redraw" << endl;
    
    glClear(GL_COLOR_BUFFER_BIT);
  }
  
  //swap();
  //glFlush();
  //GLwDrawingAreaSwapBuffers(w);
}

/* readfile() returns nonzero on success */


void CLASS::init(const char* opt) {

  widget* root = new frame(path());
  _register(root);
  gl = new tk_glxwin(root, "gl",opt);

  gl->pack("-fill both -expand true");
  redirect( gl ); // not superfluous
  alias( this );

  vrh = new vr_handler(this);
  _register(vrh);
  gl->bind( vrh );
  }


void CLASS::loop(const char* s) {
char* arg = s;

static int one = 1;

if (!one) {
  one++;
  initCB();
  }
  if (!file(arg)) {
      printf("unable to read file: %s!\n", arg);
  }
  redraw();

}





/*
CLASS::CLASS() { }
CLASS::CLASS(const char* p, const char* options = "") : TYPE(p,0) {
	if (options) init(options);
	}
CLASS::CLASS( const widget* w, const char* p, const char* opt = "")
				: TYPE(w,p,0) {
	if (opt) init(opt);
	}
	*/

void CLASS::link() { GL::_window = this; gl->link(); }
void CLASS::swap() { gl->swap(); }

int CLASS::operator()() {
       int argc = _event->argc(); char** argv = _event->argv();
       if (!strcmp("self",argv[1]) ) tk->result(self()->path());
       else if ( !strcmp( "glwin" ,*argv) )
                                          create(--argc,++argv); 
       else if ( !strcmp( "file" ,argv[1]) ) file( argv[2] );
       else if ( !strcmp( "loop" ,argv[1]) ) loop( argv[2] );
       else if ( !strcmp( "draw" ,argv[1]) ) draw();
       else if ( !strcmp( "restore" ,argv[1]) ) restore();
       else if ( !strcmp( "redraw" ,argv[1]) ) redraw();
       else if ( !strcmp( "zoom" ,argv[1]) ) zoom( atoi( argv[2] ));
       else if ( !strcmp( "pan" ,argv[1]) ) 
				pan( atoi(argv[2]), atoi(argv[3]) );
       else self()->eval( flatten(--argc,++argv) );
       //link();
       //swap();
       return 0;
       }

void CLASS::loop(const char* name);

void CLASS::restore() { bind( vrh ); }

void CLASS::draw() { redraw(); }

void CLASS::install(dvbinding* ac, const char* args) {
	self()->bind("<Any-ButtonPress>",ac, args);
        self()->bind("<Any-ButtonRelease>",ac, args);
        self()->bind("<Any-Motion>",ac, args );
        self()->bind("<Enter>",ac, args );
        self()->bind("<Leave>",ac, args );
        }

void CLASS::create(int _argc, char* _argv[]) { /// (III)
        char* name = *_argv;
        new glwin(name, quote(--_argc,++_argv));
        }
