#ifndef _hush_dv_gl_glx_glwin_h
#define _hush_dv_gl_glx_glwin_h

#include <hush/widgets/glwin.h>
#include <hush/widgets/glxwin.h>
#include <hush/widgets/tk/tk.h>

#include <hush/dv/gl/glx/handler.h>

class dv_glwin : public glwin  {
public:

dv_glwin();
dv_glwin(const char* p, const char* options = "", glwin* = 0);
dv_glwin( const widget* w, const char* p, const char* opt = "", glwin* = 0);

~dv_glwin();

widget* _create(const char* p, const char* options = "", widget* = 0);
widget* _create( const widget* w, const char* p, const char* opt = "", widget* = 0);

char* category() const;

virtual void link();
virtual void swap();

int operator()();

virtual int file(const char* name);

virtual void loop(const char* name);
virtual void restore();
virtual void pan(float dx, float dy = 0 , float dz = 0);
virtual void zoom( int i = 1 );

virtual void draw();
virtual void redraw(); 

private:
glxwin* gl;
vr_handler* vrh;

void init(const char* opt = "");

void install(dvbinding* ac, const char* args);
void create(int _argc, char* _argv[]);
public:
public:
static glwin* _default;
static int initialized;
static int initialize();
};

#ifndef glwin
#define glwin dv_glwin
#endif

#endif
