#include <hush/dv/gl/glx/handler.h>
#include <hush/dv/gl/glx/glwin.h>

#include <hush/dv/gl/ogl/GL.h>
#include <hush/dv/gl/ogl/glob.h>

#include <hush/event.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#undef glwin

vr_handler::vr_handler(glwin* w) : vr(w) { dragging = 0; but = 0; }

void vr_handler::link() { vr->link(); }
void vr_handler::swap() { vr->swap(); }

void vr_handler::enter( event& e) { vr->link(); }

void vr_handler::press( event& e ) {
          but = e.button();
          x = e.x(); y = e.y();
          dragging = 1;
          }
 
void vr_handler::motion( event& e ) {  
  if (dragging) {
	glob* _glob = (glob*) GL::_glob;
	if (but==1) {
		cerr << "Panning:" << but << endl;
		vr->pan((x - e.x())/2, (y - e.y())/2);
        	x = e.x(); y = e.y();
	} else if (but==2) {
		cerr << "Zooming:" << but << endl;
		vr->zoom((y - e.y()) * 100 );
		//if ((y - e.y()) > 0) vr->zoom( 10 ); else vr->zoom( -10 );
		y = e.y();
	} else {
		cerr << "????:" << but << endl;
		//vr->pan(0,0, 10 );
		if ((y - e.y()) > 0)
			vr->zoom(2000);
		else vr->zoom(-200);
        	x = e.x(); y = e.y();
        }
  _glob->_repaint();
  //vr->swap();
  //vr->redraw();
  }
}
 
void vr_handler::release( event&  ) { dragging = 0; }
