#include <hush/dv/gl/ogl/glob.h>

#undef glob

#include <GL/gl.h>
#include <GL/glu.h>

#include <iostream.h>

static GLfloat spin = 0.0;

dv_glob::dv_glob(GL* x) : glob(x) {
if (x) gl = x; else gl = GL::_default;
gl->link();
GL::_glob = this;
world.init(50,50,1);
_resize(0,0);
}

void dv_glob::_init() {
  _make();
  _paint();
}

void dv_glob::_paint( void )
{
   //gl->link();
   glClear(GL_COLOR_BUFFER_BIT);
   glPushMatrix();
   glRotatef(spin, 0.0, 0.0, 1.0);
   glColor3f(0.3, 0.4, 0.5);
   glRectf(-25.0, -25.0, 25.0, 25.0);
   glPopMatrix();
   glFlush();
}

void dv_glob::_make( void )
{
   glEnable(GL_DEPTH_TEST);
   glDepthFunc(GL_LESS);
   glClearColor (0.0, 0.0, 0.0, 0.0);
   glShadeModel (GL_FLAT);
}

void dv_glob::_repaint() {
	cerr << "dv_glob::repaint" << endl;
	_paint(); _flush();
	}

void dv_glob::_flush() {
	cerr << "glob::flush" << endl;
	gl->swap();
	} 

void dv_glob::_action(event*) {
  spin = spin + 2.0;
  if (spin > 360.0)
  spin = spin - 360.0;
  _repaint();
  }


void dv_glob::_resize(int x, int y) {
   int wx = x?x:gl->width(); int wy = y?y:gl->height();
   int w = wx?wx:300; int h = wy?wy:300;
   cerr << "Resize " << w << " " << h << endl;
   glViewport (0, 0, (GLsizei) w, (GLsizei) h);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   //gluPerspective(60.0, (GLfloat) w/(GLfloat) h, 1.0, 30.0);
   //glLoadIdentity();
   //glFrustrum(world.x1, world.x2, world.y1,world.y2, world.z1, world.z2);
   glMatrixMode(GL_MODELVIEW);
   //glLoadIdentity();
   //glTranslatef(0.0, 0.0, -3.6);
   //glLoadIdentity();
   }
