#include "image.h"
#include "handler.h"
#include <iostream.h>
#include <GL/glut.h>

GLfloat diffuseMaterial[4] = { 0.5, 0.5, 0.5, 1.0 };

#undef image

#define TYPE glob
#define CLASS dv_image

CLASS::CLASS() {
	_resize(0,0);
	_make();
}


glob* CLASS::image(const char* nme) {
	kit* tk = kit::lookup("tk");
	glob* x = new dv_image();
	tk->_register(x);
	/*
	handler* h = new glob_handler(x);
	tk->_register(h);
	x->bind(h);
	*/
	return x;
	}

void CLASS::_make( )
{
   GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
   GLfloat light_position[] = { 1.0, 1.0, 1.0, 0.0 };

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    //glFrustum(-1.0, 1.0, -1.0, 1.0, 1.0, 10.0);
    //glTranslatef( 0.0, 0.0, -5.0 );
    glFrustum(-3.0, 3.0, -3.0, 3.0, -3.0, 3.0);
    glViewport(0, 0, gl->width(), gl->height()); 

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   glClearColor (0.0, 0.0, 0.0, 0.0);
   glShadeModel (GL_SMOOTH);
   glEnable(GL_DEPTH_TEST);
   glMaterialfv(GL_FRONT, GL_DIFFUSE, diffuseMaterial);
   glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
   glMaterialf(GL_FRONT, GL_SHININESS, 25.0);
   glLightfv(GL_LIGHT0, GL_POSITION, light_position);
   glEnable(GL_LIGHTING);
   glEnable(GL_LIGHT0);

   glColorMaterial(GL_FRONT, GL_DIFFUSE);
   glEnable(GL_COLOR_MATERIAL);

}

void CLASS::_paint() {
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glutSolidSphere(1.0, 20, 16);
   glFlush ();
   gl->swap();
}

void CLASS::change(int i) {
int b = i; // ev->button();
static int x = 0;
x = ( x + i ) % 3;
b = i; // x + 1;
cerr << "CLASS:: _action " << b <<  endl;
if (1) {
   switch (b) {
      case 1:
            diffuseMaterial[0] += 0.007;
            if (diffuseMaterial[0] > 1.0)
               diffuseMaterial[0] = 0.0;
            glColor4fv(diffuseMaterial);
            _repaint();
         break;
      case 2:
            diffuseMaterial[1] += 0.0025;
            if (diffuseMaterial[1] > 1.0)
               diffuseMaterial[1] = 0.0;
            glColor4fv(diffuseMaterial);
            _repaint();
         break;
      case 3:
            diffuseMaterial[2] += 0.003;
            if (diffuseMaterial[2] > 1.0)
               diffuseMaterial[2] = 0.0;
            glColor4fv(diffuseMaterial);
            _repaint();
         break;
      default:
         break;
   }



 }
}

void CLASS::_resize(int x, int y) {
  int wx = x?x:gl->width(); int wy = y?y:gl->height();
  int w = wx?wx:300; int h = wy?wy:300;
  cerr << "image: Resize " << w << " " << h << endl;
  glViewport (0, 0, (GLsizei) w, (GLsizei) h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);
 }

