#include <hush/dv/plugin/event.h>

#include <tcl.h>
#include <iostream.h>


//// event

plugin_event::plugin_event() : event(this) {
	tk = 0; __argc = 0; __argv = 0;
	}

plugin_event::plugin_event(class kit* _tk, int _argc, char* _argv[]) 
				    : event(this) {
	tk = _tk;
	__argc = _argc;
	__argv = _argv;
	}

event* plugin_event::create(kit* k,int argc, char** argv) {
	event* e = new plugin_event(k,argc,argv);
	return e; // AE?
	}


plugin_event::~plugin_event() { }
int plugin_event::eventclass() const { return event::tcl; }
int plugin_event::argc() const { return __argc; }
char* plugin_event::arg(int i  ) const { return  argv()[i]; }
char** plugin_event::argv(int i ) const { return  __argv+i; } 

event* plugin_event::get() const { return (event*) this; }




//// Callback funs

void plugin_timer_callback( void* data ) {
	 kit* tk = kit::_default;
	 cerr << "Calling timer" << endl;
	 plugin_event* ev = new plugin_event(tk,0,0);
	 handler* h = (handler*) data;
         h->dispatch(ev);
	 delete ev;
	 }


int plugin_callback(void* data , Tcl_Interp* , int argc , char** argv) {
	 kit* tk = kit::_default;
	 plugin_event* ev = new plugin_event(tk,argc,argv);
	 handler* h = (handler*) data;
	 h->dispatch(ev);
	 delete ev;
	 return 0;
}
