// file.c -- file event callbacks

#include <hush/dv/plugin/file.h>

#include <stdio.h>

//// event 

plugin_file_event::plugin_file_event(class kit* _tk,int _fd, int _mask,
			  int _argc, char* _argv[]) : event(this) {
	tk = _tk;
	__fd = _fd;
	__mask = _mask;
	__argc = _argc;
	__argv = _argv;
	}
plugin_file_event::~plugin_file_event() { }
int plugin_file_event::eventclass() const { return event::file; }
int plugin_file_event::argc() const { return __argc; }
char* plugin_file_event::arg(int i) const { return argv()[i]; }
char** plugin_file_event::argv(int i) const { return  __argv+i; } 
int plugin_file_event::fd() const { return __fd; }
int plugin_file_event::mask() const { return __mask; }
event* plugin_file_event::get() const { return (event*) this; }


//// callback struct

plugin_file_callback::plugin_file_callback(handler* h_, int fd_): filehandler(h_), fd(fd_) {}


//// callback fun

int plugin_file_handler_callback(void* data , int mask) {
        plugin_file_callback *s = (plugin_file_callback*) data;
        const int count = 2; char* args[count+1];
        char mstr[20]; char fdstr[20];
        switch (mask) {
           case kit::readable:  sprintf(mstr, "%s", "readable"); break;
           case kit::writable:  sprintf(mstr, "%s", "writable"); break;
           case kit::exception: sprintf(mstr, "%s", "exception"); break;
           default: sprintf(mstr, "%s", "unknown-mask-error");
        }
        sprintf(fdstr, "%d", s->fd);
        args[0]=fdstr; args[1]=mstr; args[2]=NULL;

	kit* tk = kit::_default;
	event* ev = new plugin_file_event(tk,s->fd,mask,count,args);
	handler* h = s->filehandler;
	h->dispatch(ev);
	delete ev;
	return 0;
}

