//@ query_broker.c -- adapted from Orbacus - hello World

#include <hush/dv/query/broker.h>
#include <hush/agent/event.h>

#include <hush/broker.h>

//#include <hush/idl.h> // is this needed

#include <hush/query.h>
#include <hush/string.h>

#include <hush/dv/query/out.h>

#include <stdio.h>

//@ main -- startup

static int __argc = 1;
static char* __argv[] = { "hush", 0 };


query_broker::query_broker() {
	_argc = 0; _argv = 0; _init_broker =0; _oracle = 0; _broker = 0;
	_handlers = 0; _handler = 0; _number = 0; _query = 0;
	bind(new query_out_handler(this));
	}

void query_broker::init(int argc, char* argv[]) {
	_argc = argc; _argv = argv;
	}

dvbinding* query_broker::bind(const char* name, handler* h) {
	if (name[0]==':') {
		if (!_query) {
			_query = new dictionary<query>();
			_register(_query);
			}
		(*_query)[name+1] = (query*) h;
		}
	else if (name) {
		if (!_handlers) {
			_handlers = new dictionary<handler>();
			_register(_handlers);
			}
		if (!_number) {
			_number = new dictionary<int>(1);
			_register(_number);
			}
		(*_handlers)[name] = h;
		if (!(*_number)[name]) (*_number)[name] = new int(0);
		}
	return 0;
	}

void query_broker::_send(const char* mode, const char* val) {
       if ((_handler = (*_handlers)[mode])) {
              char buf[8]; int& n = * (*_number)[mode]; 
	      sprintf(buf,"%d", n++);
	       event* e = new query_event(this,category(),mode,val,buf);
	       _register(e); //AE
	       _handler->dispatch(e);
	       }

	}

void query_broker::_reset(const char* mode) {
	int* n = 0;
	if (_number && ( n = (*_number)[mode] ))
		*n = 0;
	}

dvbinding* query_broker::bind(handler* h) {
	bind("ask",h);
	bind("ans",h);
	bind("tell",h);
	return 0;
	}

dvbinding* query_broker::bind(int fd, handler* h, int mask=kit::readable) {
	return 0;
	}


void query_broker::_check() {
    if (_handlers && (*_handlers)["cout"])
		_kit->bind("cout",(*_handlers)["cout"]);
    if (_handlers && (*_handlers)["cerr"])
		_kit->bind("cerr",(*_handlers)["cerr"]);
    }


int query_broker::prepare() {
    
    if (!_argc) _argc = __argc;
    if (!_argv) _argv = __argv;

    if (_init_broker) return 1;
    _init_broker = 1;
    _kit = new query("kit=pl");
    _register(_kit);
    if (option("src"))
		_kit->option("src",option("src")); 
    else
		_kit->option("src","query_broker.pl");
    if (option("cmd"))
		_kit->option("cmd",option("cmd"));

    this->bind(":default",_kit);

    if (!_broker) {
	_broker = new broker();
	_register(_broker);
	}
    _oracle = 0;

    try
    {
    _broker->init(_argc,_argv);
	
}
    catch(corba::exception& ex)
    {
	_broker->print(ex);
	return 1;
    }
    return 0;
}
	

int query_broker::source(const char* f) {
	//if (_kit) _kit->source(f);
	return 0;
	}


#ifndef NOMAIN
int main(int argc, char* argv[]) {
query_broker* _query_broker = new query_broker();
_query_broker->init(argc,argv);
(*_query_broker)();
}
#endif

//</>
