#ifndef _hush_dv_query_broker_h
#define _hush_dv_query_broker_h

#include <hush/query.h>
#include <hush/dictionary.h>
#include <hush/broker.h>

class query_broker : public query {

protected:

int _argc;
char** _argv;
int _init_broker;

query* _kit;
query* _oracle;

handler* _handler;

broker* _broker;
dictionary<int>* _number;
dictionary<handler>* _handlers;
dictionary<query>* _query;   // i.e. query objects

public:
query_broker();
char* category() const { return "query_broker"; }
void init(int argv,char** argv);

int prepare();

int source(const char*);

dvbinding* bind(const char* name, handler* h);
dvbinding* bind(handler* h); // anonymous
dvbinding* bind(int fd, handler* h, int mask=kit::readable); // jrvosse

public:
void _send(const char* mode, const char* value);
void _reset(const char* mode);
protected:
void _check();
};

#endif
