//@ client.c -- adapted from Orbacus - hello World

#include <hush/dv/query/client.h>

#include <hush/broker.h>
#include <hush/idl.h>

#include <hush/corba/clt/query.h>

#include <stdio.h>

#define ASKING 0
#define ANSING 1
#define TELLING 2

//@ main -- startup

client_query::client_query() {
	_state = ASKING;
	}

int client_query::operator()() {
	if (option("ask"))
		return (int) eval(option("ask"));
	return 0;
	}

int client_query::prepare() {
    
    _oracle = 0;

    try
    {
    query_broker::prepare();

    char* base = option("base")?option("base"):"";
    char* ref = option("ref")?option("ref"):"query.out";

    corba::object* objp = _broker->object(string(base) + ref);
    //hush_query* world = hush_query::_narrow(objp);
    //_oracle = new query_clt(world);

    _oracle = new query_clt(objp);
    _register((query*)_oracle);

}
    catch(corba::exception& ex)
    {
	_broker->print(ex);
	return 1;
    }
    return 0;
}
	
	

long client_query::eval( const char* _question ) {

 _state = ASKING;

 //cerr << "client::eval " << _question << endl;

 if (!_init_broker) prepare();

 _check();

 try {
    char c = _question[0];
    if (c != '\0' ) {
	_send("ask",_question);
        _id = _oracle -> eval(_question);
	_reset("ans");
	return _id;
	} 
    } catch(corba::exception& ex) {
	_broker->print(ex);
	return 1;
    }
    return 0;
 }

char* client_query::result( long id ) {

 //cerr << "client::result " << id << endl; // AE check id
 //AE if (id != _id) cerr << "warning  client::result  incorrect id " << _id << endl;

 _check();

 try {
 while(1) {
	if (_state == ASKING) {
		_ans = _oracle->result(_id);
		if (!_ans || !strcmp(_ans,"false") ) { _state=-1; return 0; }
		if (!strcmp(_ans,"halt")) {
			_oracle->halt();
			//exit(0);
			_state=-1;
			return 0; 
			}
		_send("ans",_ans);
		char buf[1024];
		char* _dispatch = "dispatch";
		if (option("dispatch")) _dispatch = option("dispatch");
	        sprintf(buf,"%s(%s)",_dispatch,_ans);
		_kit->eval(buf);
		_reset("tell");
		_state = TELLING;
		}
	if (_state == TELLING) {
		char* p = _kit->result();
		if (p)  {
			_send("tell",p);
			return p;
			}
		else _state=ASKING;
		}
	}
    } catch(corba::exception& ex) {
	_broker->print(ex);
	return 0;
    }
    return 0;
 }


char* client_query::ask( const char* _question ) {

 //cerr << "client::eval " << _question << endl;

 if (!_init_broker) prepare();

 _check();

 try {
    char c = _question[0];
    if (c != '\0' ) // && c != 'x')
	_send("ask",_question);
        char* _ans = _oracle -> ask(_question);
	_reset("ans");
	while (_ans) {
		_send("ans",_ans);
		char buf[1024];
	        sprintf(buf,"CTV=client_dispatch(_,%s)",_ans);
		if (strcmp(_question,"halt")) { // _question != halt
			_kit->eval(buf);
			_reset("tell");
			char* p = 0;
			while( ( p = _kit->result() ) ) {
				_send("tell",p);
			}
		} else {
			_oracle->halt();
			exit(0);
		}
		_ans = _oracle->result();
		if (_ans && !strcmp(_ans,"false")) _ans = 0;
	} 
    } catch(corba::exception& ex) {
	_broker->print(ex);
	return 0;
    }

    return 0;
}


#ifndef NOMAIN
int main(int argc, char* argv[]) {
client* _client = new client();
_client->init(argc,argv);
(*_client)();
}
#endif

//</>
