#include <hush/hush.h>
#include <hush/dv/sigma/kit.h>
#include <hush/dv/sigma/sigma.h>
#include <hush/dv/sigma/local-sigma.h>

#include <hush/export.h>


dictionary<handler>* sigma_kit::_handlers = 0;

#define HANDLERS ((dictionary<handler>*)_handlers)


int sigma_kit::initialized = 0;

int sigma_kit::initialize() {
        if ( sigma_kit::initialized ) return 1;
        if ( kit::lookup("sigma") ) return 1;
        kit* tk = new sigma_kit;
        session* s = session::_default;
        if (s) s->_register(tk);
        tk->rename("sigma");
        kit::declare("sigma",tk);
        kit::declare("eventgraphs",tk);
        if (!kit::_default) kit::_default = tk;
        return sigma_kit::initialized = 1;
        }


extern int sigma_main(int argc, char* argv[]);

static int argc = 0;
static char* argv[] = { 0, 0 };

sigma_kit::sigma_kit() {
        sigma_main(argc,argv);
	}

sigma_kit::~sigma_kit() { }

int sigma_kit::source(const char* s ) { return sigma_open_file(s); }
long sigma_kit::eval(const char* s ) { return sigma_eval_command(s); }
char* sigma_kit::result(long) { return sigma_result(); }
