////////////////////////////////////////////////////////////////////////
//                                                                    //
// list.c                                                             //
//                                                                    //
// the implementation of the list class, it provides members for      //
// creating a list and for adding and retrieving elements from this   //
// list.                                                              //
//                                                                    //
// (c) 1995 A.R. van der Valk, A. Eliens                              //
//                                                                    //
////////////////////////////////////////////////////////////////////////

#include <hush/dv/sigma/list.h>

#include <string.h>
#include <assert.h>
#include <iostream.h>
#include <stdlib.h>


// destructor of the list 

sigma_list::~sigma_list()
{
    while (is_empty() != true)
        (void) remove();
}


// removes the first element from the list

void
sigma_list::remove()
{
    if (is_empty() == true)
    {
        cout << "remove() on empty list \n";
        exit(-1);
    }

    sigma_list_item *pt = front;
    front = front->next;
    //AE delete pt;
}    


// add an element at the back of the list

void
sigma_list::add(char *item)
{
    sigma_list_item *pt = new sigma_list_item(item);

    if (is_empty())
        front = back = pt;
    else
    {
        back->next = pt;
        back = pt;
    }
}


// display the list's elements on screen

void
sigma_list::display()
{
    cout << "(";
    for (sigma_list_item *pt=front; pt; pt=pt->next)
        cout << pt->val << " ";

    cout << ")" << endl;
}

// get the real value from an element

char*
sigma_list::get_val(sigma_list_item *pt)
{
    return (pt->val);
}


// search for a certain element in the list

sigma_list_item*
sigma_list::search(char *pt)
{
    sigma_list_item *i = front;
    while (i != NULL)
    {
        if (strcmp(i->val, pt) == 0)
            return (i);
        else
            i = i->next;
    }
    return (NULL);
}



// constructor of a list element

sigma_list_item::sigma_list_item(char *value)
{
    val = new char[strlen(value) + 1];
    assert(val != 0);
    strcpy(val,value);
    next = 0;
}


// output operator for a list element

ostream& operator<<(ostream &os, sigma_list_item &str)
{
    os << "<";
    cout << "in overloaded operator van sigma_list_item" << endl;
    os << str;
    os << ">";
    return os;
}
