////////////////////////////////////////////////////////////////////////
//                                                                    //
// list.h                                                            //
//                                                                    //
// definition of a simple linked list.                                //
//                                                                    //
// (c) 1995 A.R. van der Valk, A. Eliens                              //
//                                                                    //
////////////////////////////////////////////////////////////////////////

#ifndef LIST_H
#define LIST_H

#include <iostream.h>
#include <hush/bool.h>

//enum Boolean { false=0, true };

class sigma_list_item 
{
friend class sigma_list;
friend ostream& 
operator<<(ostream&, sigma_list_item&);

private:
    sigma_list_item(char *value);
    ~sigma_list_item() { delete val; }
    char *val;
    sigma_list_item *next;
};


class sigma_list 
{
private:
    sigma_list_item *front;
    sigma_list_item *back;

public:
    sigma_list() { front = back = 0; }
    ~sigma_list();
          
    void remove();
    void add(char*);
    void display();
    bool is_empty() { return front==0 ? true : false; }
    sigma_list_item* get_front() { return front; }
    sigma_list_item* get_next(sigma_list_item *pt) { return pt->next; }
    char* get_val(sigma_list_item *pt);
    sigma_list_item* search(char *pt);

};

#endif
