#ifndef _hush_dv_sigma_h
#define _hush_dv_sigma_h

////////////////////////////////////////////////////////////////////////
//                                                                    //
// sigma.h                                                            //
//                                                                    //
// contains definitions for standard SIGMA functions.                 //
//                                                                    //
// (c) 1995 A.R. van der Valk, A. Eliens                              //
//                                                                    //
////////////////////////////////////////////////////////////////////////

#include <hush/sim/sim.h>

#define       SIN(a)      (sin(a))
#define       COS(a)      (cos(a))
#define       LN(a)       (log(a))
#define       MOD(a,b)    ( ((int) (a)) % ((int) b)) )
#define       MAX(a,b)    ( (a) > (b) ? (a) : (b) )
#define       MIN(a,b)    ( (a) < (b) ? (a) : (b) )

#define       CLK         sim->clock()
#define       RND         gen->uniform(0,1)

#endif
