#include <hush/dv/sp/kit.h>

#include <hush/dv/sp/sp.h>
#include <hush/dv/sp/event.h>
#include <hush/dv/sp/term.h>

#include <hush/hush.h>
#include <hush/dictionary.h>
#include <stdio.h>

#include <hush/io.h>
#include <dv/sp/cout.h>
	

dictionary<handler>* sp_kit::_handlers = 0;

//#define HANDLERS ((dictionary<handler>*)sp_kit::_handlers)
#define HANDLERS sp_kit::_handlers


int sp_kit::initialized = 0;

int sp_kit::initialize() {
	if ( sp_kit::initialized ) return 1;
        if ( kit::lookup("sp") ) return 1;
	dvsp::init();
        kit* tk = new sp_kit;
        session* s = session::_default;
        if (s) s->_register(tk);
        //tk->rename("sp");
        kit::declare("sp",tk);
        kit::declare("prolog",tk);
        if (!kit::_default) kit::_default = tk;
        return sp_kit::initialized = 1;
        }



//#define BP (dv_sp*) sp;

static int _period = 10;
static int _cycles = 10000;
static int _slices = 5;

static void dummy() { }

static int _initflag = 0;

static void _init(kit* tk) {
if (!_initflag) {
	_initflag = 1;
	char buf[256];
	sprintf(buf,"%s/hush.pl",LIBRARY);
	tk->consult(buf);
	handler* h = new sp_cout_handler();
	tk->_register(h);
	tk->bind("cout",h);
	h = new sp_cerr_handler();
	tk->_register(h);
	tk->bind("cerr",h);
	h = new sp_source_handler((sp_kit*)tk);
	tk->_register(h);
	tk->bind("source",h);
	}
}

sp_kit::sp_kit() : kit(this) {
	_period =  ::_period;
	_handler = (handler*) this;
	_slices  = ::_slices;
	_cycles  = ::_cycles;
	tk = kit::lookup("tcl"); // new kit("tcl");
	if (!tk) tk = kit::_default;
	_md = 0;
	::_init(this);
	}

sp_kit::~sp_kit() {  }


term* sp_kit::query(const char* pred, int md) {
	term* tmp = 0;
	int _mode = mode();
	if (md)  _md = md; //this->mode(md);
	this->eval(pred);
	tmp = (term*) result();
	_md = _mode; //this->mode(_mode);
	return tmp;
	}

int sp_kit::consult(const char* pred) {
	cerr << "sp_kit::consult " << pred << endl;
	return this->source(pred);
	}

int sp_kit::source(const char* s) {
	if (!sp_kit::initialized) sp_kit::initialize();
	cerr << "sp_kit::source " << s << endl;
	return dvsp::consult(s);
	}

long sp_kit::eval(const char* s ) {
	if (!sp_kit::initialized) sp_kit::initialize();
	//cerr << "Evaluating " << s << " " << mode() << endl;
	_result = 0;
	if (s[0]==':') {
		dvsp::exec("dv_exec",s+1);
		return 1;
	} else {
		term* sp = (term*) dvsp::eval(s, mode());
		_result = sp; 
		//cerr << "sp_kit::eval -> " << (void*) _result << endl;
		if (_result) _register(_result);
		return (long) _result;
	}
	return 0;
	}

char* sp_kit::result(long id) {
	if (id) {
		term* x = (term*) id;
		return x->next();
		}
	else
	return _result?((term*)_result)->next():0;
	}

void sp_kit::result(const char* s) {
	//cerr << "No result setting " << s << for << " sp_kit" << endl;
	}

/*
binding* kit::bind(int fd, handler* h, int mask) {
	if (fd && h && mask); //Wall
	cerr << "sp_kit binding error " << endl;
	return 0;
	}

binding* sp_kit::bind(handler*) {
	return 0;
	}

*/

binding* sp_kit::bind(const char* s, handler* h) {
	cerr << (const char*) "sp_kit binding " << s << endl;
	if (!HANDLERS) {
		sp_kit::_handlers = new dictionary<handler>();
		_register(HANDLERS);
	        //cerr << "sp_kit creating handler table" << endl;
		}
	(*HANDLERS)[s] = h;
	return 0;
	}

int sp_kit::schedule(int pd , handler* h , int cls, int sl ) {
	_period = pd?pd : ::_period;
	_handler = h?h: this;
	_slices  = sl?sl: ::_slices;
	_cycles  = cls?cls: ::_cycles;
	/*
	spref main_0;
	sp->init( main_0 );
	tk->after(_period,_handler);
	*/
	return _period;
	}

int sp_kit::operator()() {
   if (--_cycles) {
      //dp -> exec(_slices);       // start/continue execution.
      if (_cycles > 0 )
                tk->after(_period,this);
      }
   return 0;
   }
