#include <hush/dv/sp/sp.h>

#include <hush/session.h>
#include <hush/handler.h>

#include <hush/dictionary.h>

#include <hush/dv/sp/kit.h>
#include <hush/dv/sp/term.h>
#include <hush/dv/sp/event.h>

//#include <hush/io.h>
#include <stdio.h>

static session* _session = 0;
static int _running = 0;
static int _initialized = 0;

#include <hush/dv/sp/sicstus.h>
//#include <sicstus/sicstus.h>

SP_AEFun* sp_pre_linkage[12] = { 0 };
char* sp_pre_map[12] = { 0 };

#define HANDLERS ((dictionary<handler>*)sp_kit::_handlers)

static handler* _sp_handler = 0;

handler* set_sp_handler(handler* h) {
	handler* tmp = _sp_handler;
	_sp_handler = h;
	return tmp;
        }

static SP_qid _qid = 0; // to control queries
static SP_qid _qids[12];
static int _qidp = 0;

// dvsp -- direct interface to sp

static char _buf[2048];
static int __argc;
static char* __argv[3];

void dvsp::dummy() { }

void dvsp::reset() { _buf[0] = '\0'; }

void dvsp::destroy(void*) {  }

char* dvsp::unparse(term* x) {
SP_term_ref t = (SP_term_ref) x;
char *p = 0;
SP_get_string(t,&p);
strcpy(_buf,p);
return (char*) _buf;
}


char* dvsp::next(void* x,void* a) {
  if (!x) return 0;
  SP_qid goal = (SP_qid) x;
  SP_term_ref ans = (SP_term_ref) a;
  char* p = 0; // = "**no solution**"; //AE
  if (SP_next_solution(goal)) {
	dvsp::reset(); // puts _buf[0]=0;
	p = dvsp::unparse((term*)ans);
	//cerr << "*> " << p << endl;
	}
  else
	;//cerr << "No more solutions " << endl;
  if (!p) SP_close_query(goal);
  return p;
  }


void dvsp::init(void* x) {
	_session = (session*) x;
	if (!_initialized) {
		//SP_register_extensions(predicates);
		__argc = 1;
		__argv[0] = new char[64]; // is this needed
		__argv[1] = new char[64];
		__argv[2] = new char[64];
		strcpy(__argv[0],"hush");
		strcpy(__argv[1],"dummy");
		strcpy(__argv[2],"dummy");

		SP_initialize(__argc,
		__argv,
		//NULL);
		"/home/eliens/hush/prolog/sictsus/lib/bin");
		_initialized = 1;
		}
	_running = 1;
	}

void dvsp::load(const char* cmd) {
	cerr << "dvsp::loading nop " << cmd << endl;
	}

void* dvsp::eval(const char* cmd, int _mode) {
 SP_pred_ref pred;
 SP_qid goal;// _qid = &goal;
 SP_term_ref args[2];

 //cerr << "Calling " << _mode << " " << cmd << endl;
 SP_put_string(args[0]=SP_new_term_ref(), cmd);
 SP_put_variable(args[1]=SP_new_term_ref());
 if (_mode) // with result projection
 	pred = SP_predicate("dv_dispatch",2,"");
 else
	pred = SP_predicate("dv_dispatch",2,"");
 goal = SP_open_query(pred,args[0],args[1]);
 term* result = new sp_term((void*)goal,(void*)args+1);
 return (term*) result;
}


int dvsp::consult(const char* cmd) {
  cerr << "consulting (sp) " << cmd << endl;
  SP_pred_ref pred;
  SP_term_ref args = SP_new_term_ref(); //s(2);
  SP_put_string(args,cmd);
  pred = SP_predicate("write",1,NULL);
  int x = SP_query(pred,args);
  cerr << "consult: " << x << endl;
  return 1;
  }

int dvsp::exec(const char* goal, const char* cmd) {
  cerr << "dvsp::exec : " << goal << " " << cmd << endl;
  SP_pred_ref pred;
  SP_term_ref args = SP_new_term_ref(); //s(2);
  SP_put_string(args,cmd);
  SP_predicate(goal,1,NULL);
  SP_query(pred,args);
  return 1;
  }
