// session.c  -- (no session.c because of namemangling conflicts)
// rename into tclsession.c for old Cfront --  Richard A. Rausch

#include <hush/dv/tk/tcl/session.h>
#include <hush/dv/tk/tcl/kit.h>


#include <hush/dv/tk/tcl/tcl.h>

extern "C" {
#include <tcl.h>
}

#include <hush/assert.h>
#include <hush/string.h> // jrvosse
#include <hush/event.h>  // jrvosse

#include <stdlib.h>
#include <string.h>

//#define endl "\n"

tk_tcl_session::tk_tcl_session(int argc_, char** argv_, const char* name, int fl) : session(this) {  
	//AE tk_tcl_kit::initialize();
	rename("tcl");
	session::declare("tcl",this);
	_argc = argc_;
	_argv = argv_;
	_name = (char*) name;
	_init = 0;
	_flag = fl;
	_mode = 0;

	if (!name) _flag = 1;
	if (!name) _option("nowin",1);
	}

void tk_tcl_session::init(const char* f, void*) {  
	_init = new char[ strlen(f) + 1 ];
        strcpy(_init, f);
	}

void tk_tcl_session::install(void* p) {
	_session = (session*) p;
	tk = kit::lookup("tcl");
	if (!tk)
	   tk = _session->thekit(); //TODO tk = ?
	promise( tk && _session );
	}







// run map loop body

void tk_tcl_session::map(int fl) { }




int tk_tcl_session::mode() const { return _mode; }
int tk_tcl_session::mode(int i) { int tmp = _mode; _mode = i; return tmp; }
int tk_tcl_session::mode(const char* s) {
	int tmp = _mode;
	if (!strcmp(s,"real")) _mode = TCL_DONT_WAIT;
	else if (!strcmp(s,"dont_wait")) _mode = TCL_DONT_WAIT;
	else _mode = 0;
	return tmp;
	}


int tk_tcl_session::body(int fl) { return fl; }

int tk_tcl_session::loop(int fl) {
       int finish = 0;
       while ( !session::_quit && ( !finish && // 0 or TK_DONT_WAIT
		( fl ) )) {
	   while ( !session::_quit //AE && dvtcl::doevent(_mode)
	  							 )
				if (session::_quit) return 0;

	   finish = _session->body(fl);
       }
return finish;
}

//We discovered (the hard way) that it is essential to process 
//all pending events before relinquishing the thread otherwise
//events can built up faster than they get processed.

//In our system we allow only the thread scheduler to relinquish 
//the Unix process (other than by preemption), so the TK_DONT_WAIT was 
//added to prevent wish from blocking.  If there are any other
//blocking i/o functions in wish then we will need to modify those
//too, but we haven't found any yet.

//Hope this helps.   John Ellson AT&T Bell Labs


int tk_tcl_session::run(int _proc(class kit*,int,char**)) {
char *args, *p, *msg;
char buf[20];
int result = 1001;

int argc = _argc;
char** argv = _argv;


    require( tk );

    void* interp = tk->interp();

    //AE dvtcl::check(interp, argc, argv, _name ); /// check args
    
    if (!_option("nowin")) {
	_session->map(_flag);
		//AE init_ht( tk );
	}

    //AE dvtcl::application(tk);

    if (_init) {
		char buf[BUFSIZ];
		sprintf(buf,"%s",_init);
		tk->eval(buf );
		}

    tk->bind("go-back", this);
    tk->bind("quit", this);


    _session->prelude(); //

    //AE dvtcl::process(interp);

    if (!_option("noprog")) {
	if (_proc)
		result = _proc(tk,_argc,_argv);
	else
	        result = _session->main();
	}
    
    _session->loop(_flag);

    return( result );
}

int tk_tcl_session::operator()() {
        string s = _event->arg(0);
        if ( s ==  (char*) "quit" ) session::_quit = 1;
        else if ( s == (char*) "go-back" ) _option("noprog",1);
        else
                err() << "ERROR: tk_tcl_session -- " << (char*) s << endl;
        return 0;
}



