// kit.c  -- tk_kit

#include <hush/dv/tk/tk/kit.h>
#include <hush/dv/tk/tk/tk.h>

#include <hush/dv/tk/tk/event.h>

#include <hush/session.h>
#include <hush/widget.h>
#include <hush/event.h>
#include <hush/sys/bind.h>

#include <hush/assert.h>

#include <hush/flags.h>
#include <hush/sys/port.h>

#include <hush/io.h>
//#define endl "\n"

#include <hush/widgets/toplevel.h>
#include <hush/dv/tk/tk/quit.h>

#include <stdlib.h>

#include <string.h>

/// Change this for a different tk file

extern "C" {
#include <tcl.h>
}

//struct TkWindow;

void init_tk(kit*); /// defined below


int tk_kit::_no = 0;

int tk_kit::initialized = 0;

int tk_kit::initialize() {
	if ( kit::lookup("tk") ) return 1;
	cerr << "tk_kit::initialize" << endl;
	kit* tk = new tk_kit;
	session* s = session::_default;
	if (s) s->_register(tk);
	tk->rename("tk");
	kit::declare("tk",tk);
	kit::declare("tcl",tk);
	kit::_default = tk;
	event* e = new tk_tcl_event;
	event::declare("tcl",e);
	tk->_register(e);
	//cerr << "tk_kit::initialized = 1" << endl;
	return tk_kit::initialized = 1;
	}

void tk_kit::font(char *) {
	err() << "OBSOLETE: use widget::font" << endl;
	//Tk_GetFontStruct(INTERP, (Tk_Window) root()->tkwin(), Tk_GetUid(s));
	}

int tk_kit::alias( char* s, handler* h ) {
	dvtk::alias(s,(widget*) h);
	return 1;
	}

//// The tcl kit
	
tk_kit::tk_kit(void* x) : tk_tcl_kit(x) { }
tk_kit::tk_kit() : tk_tcl_kit() { }

tk_kit::~tk_kit() { }

char* tk_kit::selection(const char* options) const {
        char buf[BUFSIZ]; //AE
	sprintf(buf,"selection get %s", options);
	return ((tk_kit*)this)->evaluate( buf );
	}

void tk_kit::update(const char* options) { 
        char buf[BUFSIZ]; //AE
	sprintf(buf,"update %s", options);
	eval( buf );
	}

binding* tk_kit::bind(handler* h) {
         return bind(gensym("tk-anonymous"), h);
	 }



binding* tk_kit::bind(const char* name, handler* h) {
       	return tk_tcl_kit::bind(name, (void*) tk_event::callback, h );
        }


widget* tk_kit::root() const  {
	widget* w = new widget(".");
	_register( w );
	return w;
	/* AE -- not the code below due to Netscape crashes
	if (!_root) {
		((tk_kit*)this)->_root = new toplevel(".",0);
		_register(_root);
		}
	require( _root );
	return _root;
	*/
	}

widget* tk_kit::pack(widget* w, const char* options) {
        if (tracelevel()>5) err() << "packing to root (W)" << endl;
	return root()->pack(w,options);
	}

widget* tk_kit::pack(const char* p, const char* options) {
	err() << "tk_kit::pack " << p << endl;
	widget* w;
	if (!strcmp(p,"quit") || !strcmp(p,".quit")) 
		w = new tk_quit("quit");
	else
        	w = new widget(p);
	_register(w);
        if (tracelevel()>5) err() << "packing to root (*)" << endl;
	return w->pack(options);
	}


void* tk_kit::tkwin(const char* path) const {
	session* x = session::lookup("tk");
	if (x && !path)
		return (void*) x->_resource("mainwindow");
	else return thewindow((kit*)this,path);
	//else return 0;
	}

