// session.c  -- (no session.c because of namemangling conflicts)
// rename into tclsession.c for old Cfront --  Richard A. Rausch

#include <hush/dv/tk/tk/session.h>
#include <hush/dv/tk/tk/kit.h>
#include <hush/dv/tk/tk/tk.h>

//#include <hush/dv/tk/tk/tkhtext.h>

extern "C" {
#include <tk.h>
}

#include <hush/event.h>
#include <hush/string.h>
#include <hush/assert.h>
#include <hush/io.h>
//#define endl "\n"

#include <stdlib.h>
#include <string.h>

int tk_session::initialized = 0;

int tk_session::initialize() {
	if (!tk_session::initialized) {
	    cerr << "tk_session::initialize" << endl;
	    tk_kit::initialize();
	    kit::_default = kit::lookup("tk");
	    session* s = new tk_session();
	    //cerr << "tk_session::initialize (1)" << endl;
            session* d = session::_default;
	    if (d) d->_register(s);
	    s->rename("tk");
	    session::declare("tk",s);
	    //x session::declare("tcl",s);
	    //cerr << "tk_session::initialize (2)" << endl;
	    //AE session::_default = s;
	    //cerr << "tk_session::initialize (3)" << endl;
	    //init_ht( kit::_default );
	    //cerr << "tk_session::initialized=1" << endl;
	    }
	return tk_session::initialized = 1;
	}

tk_session::tk_session() : session(this) { }

int 
tk_session::create(int argc_, char** argv_, const char* name, int fl) {
	_argc = argc_;
	_argv = argv_;
	_name = (char*) name;
	_init = 0;
	_runflag = fl;
	_mode = 0;

	if (!name) _runflag = 1;
	if (!name) session::_nowin = 1;
	//if (!name) _option("nowin",1);
	return 1;
	}

void tk_session::init(const char* f, void*) {  
	_init = new char[ strlen(f) + 1 ];
        strcpy(_init, f);
	}

void tk_session::install(void* p) {
	_session = (session*) p;
	tk = kit::lookup("tk");
	if (!tk)
	   tk = _session->thekit(); //TODO tk = ?
	promise( tk && _session );
	}







// run map loop body

void tk_session::map(int fl) {
    if (!fl && _name) {
    void* win = _resource("mainwindow");
    if (!win) {
     	 win = dvtk::mainwindow(0,0,_name);
	 _resource("mainwindow",(handler*)win);
	 }
    }
}



int tk_session::mode() const { return _mode; }
int tk_session::mode(int i) { int tmp = _mode; _mode = i; return tmp; }
int tk_session::mode(const char* s) {
	int tmp = _mode;
	if (!strcmp(s,"real")) _mode = TK_DONT_WAIT;
	else if (!strcmp(s,"dont_wait")) _mode = TK_DONT_WAIT;
	else _mode = 0;
	return tmp;
	}


int tk_session::body(int fl) { return fl; }

int tk_session::loop(int fl) {
       int finish = 0;
       while ( !session::_quit && ( !finish && // 0 or TK_DONT_WAIT
		( fl || ( dvtk::windows() > 0)) )) {
	   while ( !session::_quit && dvtk::doevent(_mode) )
				if (session::_quit) return 0;

	   finish = _session->body(fl);
       }
return finish;
}

//We discovered (the hard way) that it is essential to process 
//all pending events before relinquishing the thread otherwise
//events can built up faster than they get processed.

//In our system we allow only the thread scheduler to relinquish 
//the Unix process (other than by preemption), so the TK_DONT_WAIT was 
//added to prevent wish from blocking.  If there are any other
//blocking i/o functions in wish then we will need to modify those
//too, but we haven't found any yet.

//Hope this helps.   John Ellson AT&T Bell Labs


int tk_session::run(int _proc(class kit*,int,char**)) {
// char *args, *p;
//AE char buf[20];
int result = 1001;

int argc = _argc;
char** argv = _argv;


    require( tk );

    void* interp = tk->interp();

    dvtk::check(this,interp, argc, argv, _name ); /// check args
    
    if (!_session) _session = session::lookup("global");;

    if (!session::_nowin) {
	if (_session) _session->map(_runflag);
	else err() << "Error: mapping tk widgets" << endl;
		//AE init_ht( tk );
	}

    dvtk::application(tk);

    if (_init) {
		char buf[BUFSIZ];
		sprintf(buf,"%s",_init);
		tk->eval(buf );
		}

    tk->bind("go-back", this);
    tk->bind("quit", this);
    //tk->bind("exit", this);

    dvtk::xtracer(tk);

    _session->prelude(); //

    dvtk::process(interp);

    if (!_option("noprog")) {
	if (_proc)
		result = _proc(tk,_argc,_argv);
	else
	        result = _session->main();
	}
    
    _session->loop(_runflag);

    return( result );
}

int tk_session::operator()() {
        string s = _event->arg(0);
	cerr << "tk_session () " << (char*) s << endl;
        if ( s == (char*)"quit" ) session::_quit = 1;
        //else if ( s == (char*)"exit" ) session::_quit = 1;
        else if ( s == (char*)"go-back" ) _option("noprog",1);
        else
                err() << "ERROR: tk_session -- " << (char*) s << endl;
        return 0;
}



