#ifndef HUSH
#define HUSH
#endif

#include <hush/dv/tk/tk/shell.h>
#include <hush/dv/tk/tk/session.h>
#include <hush/widgets/tk/widget.h>
#include <hush/sim.h>
#include <iostream.h>
#include <hush/io.h>


extern "C" {
int init_tk() { return tk_shell::initialize(); }
}

static void checkflush(ostream& os, const char* s) {
        if (s[0]=='\n') os.flush();
	}

static void printerr(const char* s) { cerr << s; checkflush(cerr,s); }
static void printout(const char* s) { cout << s; checkflush(cerr,s); }

int tk_shell::initialized = 0;

int tk_shell::initialize() {
	if (tk_shell::initialized) return 1;
	if (!session::_default)
		session::_default = new session();

	cerr << "tk_shell::initialize" << endl;
	handler::initialize();

	simulation::hush_enabled = 1; // requires sim

	if (!tk_session::initialize()) {
	        cerr << "Cannot occur" << endl;
		}
	//AE tk_widget::initialize();
	cerr << "tk_shell::initialized" << endl;
	return tk_shell::initialized = 1;
	}
