//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
#ifndef _VLIST_
#define _VLIST_
//
//  List class (replacement for STL list/stack templates)
//  Not type safe, ugly, but portable and no code bloat.

class VList {

public:
  VList();
  ~VList();

  void push_front(void *);
  void push_back(void *);

  int size();

  void *first();
  void *last();
  void *next();
  void *prev();

  void remove(void *);

private:

  struct VListNode {
    void *data;
    VListNode *prev;
    VListNode *next;
  };

  VListNode *d_first;
  VListNode *d_last;
  VListNode *d_current;
  int d_size;
};

#endif // _VList_
