//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  %W% %G%
//  ViewerGlut.h
//  GLUT version of OpenGL class for display of VRML models.
//

#ifndef _VIEWERGLUT_
#define _VIEWERGLUT_

#include "config.h"
#include "ViewerOpenGL.h"


class ViewerGlut : public ViewerOpenGL {

public:

  // Class initialization
  static void initialize( int *argcp, char *argv[] );

  ViewerGlut(VrmlScene *);
  virtual ~ViewerGlut();

  // Event loop
  virtual void eventLoop();

  void timerUpdate();

protected:

  // Window system specific methods

  virtual void wsPostRedraw();
  virtual void wsSetCursor( CursorStyle c);
  virtual void wsSwapBuffers();
  virtual void wsSetTimer( double );
  virtual void wsText2(int w, int h, int x, int y, float scale,
		       char* format, ...);
  virtual void wsText3(int *justify, float size,
		       float x, float y, float z, int, char *s[]);

private:

  int d_window;
  bool d_timerPending;

};

#endif // _VIEWERGLUT_


