// GTK Viewer for Vrml 97 library
//
// Copyright (C) 1998 by Erik Andersen <andersee@debian.org>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

#ifndef _VIEWERGTK_
#define _VIEWERGTK_

#if HAVE_GTK

#include "config.h"
#include "ViewerOpenGL.h"
#include <gtk/gtk.h>
#include <GL/glx.h>		// GLXContext
#include <gtkglarea.h>



class ViewerGtk : public ViewerOpenGL {

public:

  // Create a named OpenGL drawing area widget
  ViewerGtk(VrmlScene *, const char *, GtkWidget* parent);
  virtual ~ViewerGtk();

  // Event loop
  void eventLoop();
  void timerUpdate();
  void setContext();

  void flushEvents();

protected:

  // Window system specific methods

  virtual void wsPostRedraw();
  virtual void wsSetCursor( CursorStyle c);
  virtual void wsSwapBuffers();
  virtual void wsSetTimer( double );
  virtual void wsText2(int w, int h, int x, int y, float scale,
		       char* format, ...);
  virtual void wsText3(int *, float,
		       float x, float y, float z, int, char *s[]);

private:
  unsigned long d_timer;

public:
  // This is public to handle a little interface issue. 
  GtkWidget* d_glarea;

};

#endif // HAVE_GTK
#endif // _VIEWERGTK_


