//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  %W% %G%
//  ViewerX11.h
//  XToolkit version of OpenGL class for display of VRML models.
//

#ifndef _VIEWERX11_
#define _VIEWERX11_

#if HAVE_X11

#include "config.h"
#include "ViewerOpenGL.h"
#include <X11/X.h>	// Window
#include <GL/glx.h>	// GLXContext



class ViewerX11 : public ViewerOpenGL {

public:

  // Create an OpenGL-capable window as a child of the specified parent
  ViewerX11(VrmlScene *, Window parent);
  virtual ~ViewerX11();

  // Event loop
  virtual void eventLoop();

  void timerUpdate();

  void flushEvents();

protected:

  // Window system specific methods

  virtual void wsPostRedraw();
  virtual void wsSetCursor( CursorStyle c);
  virtual void wsSwapBuffers();
  virtual void wsSetTimer( double );
  virtual void wsText2(int w, int h, int x, int y, float scale,
		       char* format, ...);
  virtual void wsText3(float x, float y, float z, int, char *s[]);

private:

  GLXContext d_context;
  Window d_window;
  Colormap d_cmap;
};

#endif // HAVE_X11
#endif // _VIEWERX11_


