//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  %W% %G%
//  ViewerXt.h
//  XToolkit version of OpenGL class for display of VRML models.
//

#ifndef _VIEWERXT_
#define _VIEWERXT_

#if HAVE_XT

#include "config.h"
#include "ViewerOpenGL.h"
#include <X11/Intrinsic.h>	// Widget
#include <GL/glx.h>		// GLXContext



class ViewerXt : public ViewerOpenGL {

public:

  // Create a named OpenGL drawing area widget
  ViewerXt(VrmlScene *, const char *, Widget parent);
  virtual ~ViewerXt();

  // Event loop
  virtual void eventLoop();

  void timerUpdate();
  void setContext(GLXContext glxcontext = 0);

  void flushEvents();

protected:

  // Window system specific methods

  virtual void wsPostRedraw();
  virtual void wsSetCursor( CursorStyle c);
  virtual void wsSwapBuffers();
  virtual void wsSetTimer( double );
  virtual void wsText2(int w, int h, int x, int y, float scale,
		       char* format, ...);
  virtual void wsText3(int *justify, float size,
		       float x, float y, float z, int, char *s[]);

private:

  GLXContext d_context;
  Widget d_widget;
  Colormap d_cmap;

  unsigned long d_timer;
};

#endif // HAVE_XT
#endif // _VIEWERXT_


