//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  %W% %G%
//  VrmlNodeAudioClip.h

#ifndef  _VRMLNODEAUDIOCLIP_
#define  _VRMLNODEAUDIOCLIP_

#include "VrmlNode.h"
#include "VrmlMFString.h"
#include "VrmlSFBool.h"
#include "VrmlSFFloat.h"
#include "VrmlSFString.h"
#include "VrmlSFTime.h"

class VrmlNodeAudioClip : public VrmlNode {

public:

  // Define the fields of AudioClip nodes
  static VrmlNodeType *defineType(VrmlNodeType *t = 0);
  virtual VrmlNodeType *nodeType() const;

  VrmlNodeAudioClip(VrmlScene *);
  virtual ~VrmlNodeAudioClip();

  virtual bool isAudioClipNode() const;

  virtual ostream& printFields(ostream& os, int indent);

  virtual void setField(const char *fieldName, const VrmlField &fieldValue);

private:

  VrmlSFString d_description;
  VrmlSFBool d_loop;
  VrmlSFFloat d_pitch;
  VrmlSFTime d_startTime;
  VrmlSFTime d_stopTime;
  VrmlMFString d_url;

  VrmlSFTime d_duration;
  VrmlSFBool d_isActive;
};

#endif _VRMLNODEAUDIOCLIP_

