//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  %W% %G%
//  VrmlNodeCone.h

#ifndef  _VRMLNODECONE_
#define  _VRMLNODECONE_

#include "VrmlNodeGeometry.h"
#include "VrmlSFBool.h"
#include "VrmlSFFloat.h"

class VrmlScene;

class VrmlNodeCone : public VrmlNodeGeometry {

public:

  // Define the fields of cone nodes
  static VrmlNodeType *defineType(VrmlNodeType *t = 0);
  virtual VrmlNodeType *nodeType() const;

  VrmlNodeCone(VrmlScene *);
  virtual ~VrmlNodeCone();

  virtual ostream& printFields(ostream& os, int indent);

  virtual Viewer::Object insertGeometry(Viewer *);

  virtual void setField(const char *fieldName, const VrmlField &fieldValue);

protected:

  VrmlSFBool d_bottom;
  VrmlSFFloat d_bottomRadius;
  VrmlSFFloat d_height;
  VrmlSFBool d_side;

};

#endif _VRMLNODECONE_
