//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//  %W% %G%
//  VrmlNodeElevationGrid.h

#ifndef  _VRMLNODEELEVATIONGRID_
#define  _VRMLNODEELEVATIONGRID_

#include "VrmlNodeGeometry.h"

#include "VrmlSFBool.h"
#include "VrmlSFFloat.h"
#include "VrmlSFInt.h"
#include "VrmlSFNode.h"

#include "VrmlMFFloat.h"


class VrmlNodeElevationGrid : public VrmlNodeGeometry {

public:

  // Define the fields of elevationGrid nodes
  static VrmlNodeType *defineType(VrmlNodeType *t = 0);
  virtual VrmlNodeType *nodeType() const;

  VrmlNodeElevationGrid(VrmlScene *);
  virtual ~VrmlNodeElevationGrid();

  virtual bool isModified();

  virtual void addToScene( VrmlScene *s );

  virtual ostream& printFields(ostream& os, int indent);

  virtual Viewer::Object insertGeometry(Viewer *);

  virtual void setField(const char *fieldName, const VrmlField &fieldValue);

  virtual VrmlNodeColor *color();

protected:

  VrmlSFNode d_color;
  VrmlSFNode d_normal;
  VrmlSFNode d_texCoord;

  VrmlSFBool d_ccw;
  VrmlSFBool d_colorPerVertex;
  VrmlSFFloat d_creaseAngle;
  VrmlMFFloat d_height;
  VrmlSFBool d_normalPerVertex;
  VrmlSFBool d_solid;
  VrmlSFInt d_xDimension;
  VrmlSFFloat d_xSpacing;
  VrmlSFInt d_zDimension;
  VrmlSFFloat d_zSpacing;

};

#endif _VRMLNODEELEVATIONGRID_
