//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  %W% %G%
//  VrmlNodeInline.h

#ifndef  _VRMLNODEINLINE_
#define  _VRMLNODEINLINE_

#include "VrmlNodeGroup.h"
#include "VrmlMFString.h"

class VrmlNodeType;
class VrmlScene;

class VrmlNodeInline : public VrmlNodeGroup {

public:

  // Define the built in VrmlNodeType:: "Inline"
  static VrmlNodeType *defineType(VrmlNodeType *t = 0);
  virtual VrmlNodeType *nodeType() const;

  VrmlNodeInline(VrmlScene*);
  virtual ~VrmlNodeInline();

  virtual bool isInlineNode() const;

  virtual ostream& printFields(ostream& os, int indent);

  // Add to a scene. A node can belong to at most one scene for now.
  // If it doesn't belong to a scene, it can't be rendererd.
  // Bindable nodes must notify the scene of their existence.
  virtual void addToScene( VrmlScene *s );

  virtual void setField(const char *fieldName,
			const VrmlField &fieldValue);

  void load();

protected:

  VrmlMFString d_url;

  bool d_hasLoaded;

};

#endif // _VRMLNODEINLINE_

