//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  %W% %G%
//  VrmlNodeLight.h

#ifndef  _VRMLNODELIGHT_
#define  _VRMLNODELIGHT_

#include "VrmlNodeChild.h"
#include "VrmlSFBool.h"
#include "VrmlSFColor.h"
#include "VrmlSFFloat.h"


class VrmlNodeLight : public VrmlNodeChild {

public:

  // Define the fields of light nodes
  static VrmlNodeType *defineType(VrmlNodeType *t = 0);
  virtual VrmlNodeType *nodeType() const;

  VrmlNodeLight(VrmlScene *);
  virtual ~VrmlNodeLight();

  virtual bool isLightNode() const;

  virtual ostream& printFields(ostream& os, int indent);

  virtual void renderScoped(Viewer *);

  virtual void setField(const char *fieldName,
			const VrmlField &fieldValue);

protected:

  VrmlSFFloat d_ambientIntensity;
  VrmlSFColor d_color;
  VrmlSFFloat d_intensity;
  VrmlSFBool d_on;
};

#endif _VRMLNODELIGHT_
