//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  %W% %G%
//  VrmlNodeSpotLight.h

#ifndef  _VRMLNODESPOTLIGHT_
#define  _VRMLNODESPOTLIGHT_

#include "VrmlNodeLight.h"
#include "VrmlSFFloat.h"
#include "VrmlSFVec3f.h"


class VrmlNodeSpotLight : public VrmlNodeLight {

public:

  // Define the fields of spotLight nodes
  static VrmlNodeType *defineType(VrmlNodeType *t = 0);
  virtual VrmlNodeType *nodeType() const;

  VrmlNodeSpotLight(VrmlScene *);
  virtual ~VrmlNodeSpotLight();

  virtual bool isScopedLightNode() const;

  // Add to a scene. A node can belong to at most one scene for now.
  // If it doesn't belong to a scene, it can't be rendererd.
  // Bindable nodes must notify the scene of their existence.
  virtual void addToScene( VrmlScene *s );

  virtual ostream& printFields(ostream& os, int indent);

  virtual void renderScoped(Viewer *);

  virtual void setField(const char *fieldName, const VrmlField &fieldValue);

protected:

  VrmlSFVec3f d_attenuation;
  VrmlSFFloat d_beamWidth;
  VrmlSFFloat d_cutOffAngle;
  VrmlSFVec3f d_direction;
  VrmlSFVec3f d_location;
  VrmlSFFloat d_radius;

};

#endif _VRMLNODESPOTLIGHT_
