//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  %W% %G%
//  VrmlNodeTransform.h

#ifndef  _VRMLNODETRANSFORM_
#define  _VRMLNODETRANSFORM_

#include "VrmlNodeGroup.h"
#include "VrmlSFRotation.h"
#include "VrmlSFVec3f.h"

class VrmlNodeTransform : public VrmlNodeGroup {

public:

  // Define the fields of Transform nodes
  static VrmlNodeType *defineType(VrmlNodeType *t = 0);
  virtual VrmlNodeType *nodeType() const;

  VrmlNodeTransform(VrmlScene *);
  virtual ~VrmlNodeTransform();

  virtual ostream& printFields(ostream& os, int indent);

  virtual void render(Viewer *);

  virtual void setField(const char *fieldName, const VrmlField &fieldValue);

  virtual void accumulateTransform(VrmlNode*);

  virtual VrmlNode* getParentTransform();
  virtual void renderAccumulatedTransforms(Viewer *);

private:

  VrmlSFVec3f d_center;
  VrmlSFRotation d_rotation;
  VrmlSFVec3f d_scale;
  VrmlSFRotation d_scaleOrientation;
  VrmlSFVec3f d_translation;

  VrmlNode *d_parentTransform;
  Viewer::Object d_xformObject;
  
};

#endif _VRMLNODETRANSFORM_

