#include <hush/hush.h>
#include <hush/dv/vrml/kit.h>

#include <hush/dv/vrml/vrml.h>

#include <hush/export.h>

dictionary<handler>* vrml_kit::_handlers = 0;

#define HANDLERS ((dictionary<handler>*)_handlers)


int vrml_kit::initialized = 0;

int vrml_kit::initialize() {
        if ( vrml_kit::initialized ) return 1;
        if ( kit::lookup("vrml") ) return 1;
	cerr << "creating vrml_kit" << endl;
        kit* tk = new vrml_kit;
	cerr << "created vrml_kit" << endl;
        session* s = session::_default;
        if (s) s->_register(tk);
        tk->rename("vrml");
        kit::declare("vrml",tk);
        if (!kit::_default) kit::_default = tk;
        return vrml_kit::initialized = 1;
        }


extern int vrml_main(int argc, char* argv[]);

static int argc = 1;
static char* argv[] = { "hush", 0 };

vrml_kit::vrml_kit() {
        vrml_main(argc,argv);
	}

vrml_kit::~vrml_kit() { }

int vrml_kit::source(const char* s ) { return vrml_open_file(s); }
long vrml_kit::eval(const char* s ) { return vrml_eval_command(s); }
char* vrml_kit::result(long) { return vrml_result(); }

binding* vrml_kit::bind(const char* s, handler* h) {
        cerr << (const char*) "vrml_kit binding " << s << endl;
        if (!vrml_kit::_handlers) {
                vrml_kit::_handlers = new dictionary<handler>();
                _register(HANDLERS);
                }
        (*vrml_kit::_handlers)[s] = h;
        return 0;
        }

