//
//  Vrml 97 library
//  Copyright (C) 1998 Chris Morley
//
//  Program to exercise the VrmlScene and Viewer classes.
//

#include "config.h"
#include <iostream.h>

#include "System.h"
#include "VrmlScene.h"
#include "Viewer.h"		// Not needed if HOOPS or GL is present.



int   vrml_eval_command(const char* ) { return 0;}
char* vrml_result() { return 0; }

int
vrml_main(int argc, char **argv)
{
  Viewer::initialize( &argc, argv );
  return 0;
  }

int   vrml_open_file(const char* file) {
  char *inputUrl = file;
  char *inputName = file;
  char *outputName = "@vrml-out.wrl";


  if (! inputName)
    {
      if (inputUrl)
	inputName = inputUrl;
      else
	inputName = inputUrl = "-";		// Read stdin
    }
  else
    cerr << "Loading " << inputName << " ...";

  if (!inputUrl) inputUrl = inputName;

  VrmlScene vrmlScene( inputUrl, inputName );

  if (outputName)
    {
      cerr << "  Saving scene to " << outputName << endl;
      if (! vrmlScene.save(outputName))
	cerr << "\nError: couldn't write to " << outputName << endl;
    }

  Viewer *viewer = Viewer::create( &vrmlScene );
  if (viewer)
    {
      //viewer->updateDisplay();
      if (*inputName != '-')
	cerr << " done.\n";
      viewer->eventLoop();
    }

  return 0;
}
