#include <hush/dv/objects/lily.h>
#include <hush/event.h>
#include <hush/vm.h>

int lily_object::operator()() {
	event* e = _event;
	//cerr << category() << "::(" << e->argc() << ") " << _event->ask() << endl;

	vm<lily_handler> self(e); 
	int argc = e->argc();
	string method = e->_method();
	//cerr << "lily_object::" << (char*) method << endl; 

	if (method == "lily") {
		//cerr << "new: " << e->ask() << endl;
		lily_handler* q = new lily_handler();
		_register(q);
		result( reference((void*)q) );
	} else if (method == "open") {
		self->open(e->arg(1));
	} else if (method == "header") {
		self->write_header();
	} else if (method == "version") {
		self->write_version();
	} else if (method == "footer") {
		self->write_footer();
	} else if (method == "time") {
		self->write_time(e->arg(1));
	} else if (method == "note" && argc==2) { //AE
		self->write_note(atoi(e->arg(1)));
	} else if (method == "note" && argc==3) { //AE
		result( self->note(atoi(e->arg(1))) );
	} else if (method == "melody") {
		self->write_melody(e->arg(1));
	} else if (method == "true") {
		;//Wall
	} else {
		return handler_object::operator()();
	}

	return 0;
	}
