#include <hush/dv/objects/midi.h>
#include <hush/event.h>
#include <hush/vm.h>

int midi_object::operator()() {
	event* e = _event;
	//cerr << category() << "::(" << e->argc() << ") " << _event->ask() << endl;

	vm<midi_handler> self(e); 
	int argc = e->argc();
	string method = e->_method();
	//cerr << "midi_object::" << (char*) method << endl; 

	if (method == "midi") {
		//cerr << "new: " << e->ask() << endl;
		midi_handler* q = new midi_handler();
		_register(q);
		result( reference((void*)q) );
	} else if (method == "analyse") {
		if (argc==3) self->read(e->arg(1),e->arg(2));
		else self->read(e->arg(1));
	} else if (method == "open") {
		self->open(e->arg(1));
	} else if (method == "header" && argc == 4) {
		self->write_header(atoi(e->arg(1)),
				   atoi(e->arg(2)),
				   atoi(e->arg(3)));
	} else if (method == "tempo") {
		self->write_tempo(atoi(e->arg(1)));
	} else if (method == "track") {
		string a1 = e->arg(1);
		if (a1 == "start") self->begin_track();
		else if (a1 == "end") self->end_track();
	} else if (method == "event") {
		char data[2];
		data[0] = (char) atoi(e->arg(4));
		data[1] = (char) atoi(e->arg(5));
		string a3 = e->arg(3);
		if (a3 == "note_on")
		   self->write_event(atoi(e->arg(1)), 
				     atoi(e->arg(2)),
				     note_on, data,2);
		else if (a3 == "note_off")
		   self->write_event(atoi(e->arg(1)), 
				     atoi(e->arg(2)),
				     note_off, data,2);
	} else if (method == "note" && argc==3) { //AE
		char *res = self->note(atoi(e->arg(1)));
		//cerr << "midi:object note " << res << endl;
		result( res );
	} else if (method == "true") {
		;//Wall
	} else {
		return handler_object::operator()();
	}

	return 0;
	}
