#include <hush/source.h>
#include <hush/dv/pl/kit.h>

#include <hush/dv/pl/pl.h>
#include <hush/dv/pl/event.h>
#include <hush/dv/pl/term.h>

#include <hush/hush.h>
#include <hush/dictionary.h>
#include <stdio.h>

//#include <hush/io.h>
#include <hush/dv/pl/cout.h>
#include <hush/scene.h>
	

//int IO::silent = 0;
dictionary<handler>* pl_kit::_handlers = 0;

//#define HANDLERS ((dictionary<handler>*)pl_kit::_handlers)
#define HANDLERS pl_kit::_handlers


int pl_kit::initialized = 0;

int pl_kit::initialize() {
	if ( pl_kit::initialized ) return 1;
        if ( kit::lookup("pl") ) return 1;
	dvpl::init();
        kit* tk = new pl_kit;
        session* s = session::get_default();
        if (s) s->_register(tk);
        //tk->rename("pl");
        kit::declare("pl",tk);
        kit::declare("prolog",tk);
        if (!kit::get_default()) kit::set_default(tk);
        return pl_kit::initialized = 1;
        }



//#define BP (dv_pl*) pl;

static int _period = 10;
static int _cycles = 10000;
static int _slices = 5;

static void dummy() { }

static int _initflag = 0;

static void _init(kit* tk) {
if (!_initflag) {
	_initflag = 1;
	char buf[256];
	
	//sprintf(buf,"%s%s/%s.pl","/vip/lib/hush/pl",dvscene::_drive(),"hush");
	//sprintf(buf,"d:/%s/%s.pl","/vip/lib/hush/pl","hush");
	//tk->consult(buf);
	handler* h = new pl_cout_handler();
	tk->_register(h);
	tk->bind("cout",h);
	h = new pl_cerr_handler();
	tk->_register(h);
	tk->bind("cerr",h);
	h = new pl_source_handler((pl_kit*)tk);
	tk->_register(h);
	tk->bind("source",h);
	}
}

pl_kit::pl_kit() : kit(this) {
	_period =  ::_period;
	_handler = (handler*) this;
	_slices  = ::_slices;
	_cycles  = ::_cycles;
	tk = kit::lookup("tcl"); // new kit("tcl");
	if (!tk) tk = kit::get_default();
	_md = 0;
	::_init(this);
	}

pl_kit::~pl_kit() {  }


term* pl_kit::query(const char* pred, int md) {
	term* tmp = 0;
	int _mode = mode();
	if (md)  _md = md; //this->mode(md);
	this->eval(pred);
	tmp = (term*) result();
	_md = _mode; //this->mode(_mode);
	return tmp;
	}

int pl_kit::consult(const char* pred) {
	return this->source(pred);
	}

int pl_kit::source(const char* s) {
	if (!pl_kit::initialized) pl_kit::initialize();
	//cerr << "pl_kit::source " << s << endl;
	return dvpl::consult(s);
	}

long pl_kit::eval(const char* s ) {
	if (!pl_kit::initialized) pl_kit::initialize();
	//cerr << "Evaluating " << s << " " << mode() << endl;
	_result = 0;
	if (s[0]==':') {
		dvpl::exec("dv_exec",s+1);
		return 1;
	} else {
		term* pl = (term*) dvpl::eval(s, mode());
		_result = pl; 
		//cerr << "pl_kit::eval -> " << (void*) _result << endl;
		if (_result) _register(_result);
		return (long) _result;
	}
	return 0;
	}

char* pl_kit::result(long id) {
	if (id) {
		term* x = (term*) id;
		return x->next();
		}
	else
	return _result?((term*)_result)->next():0;
	}

void pl_kit::result(const char* s) {
	//cerr << "No result setting " << s << for << " pl_kit" << endl;
	}

/*
binding* kit::bind(int fd, handler* h, int mask) {
	if (fd && h && mask); //Wall
	//cerr << "pl_kit binding error " << endl;
	return 0;
	}

binding* pl_kit::bind(handler*) {
	return 0;
	}

*/

binding* pl_kit::bind(const char* s, handler* h) {
	//cerr << (const char*) "pl_kit binding " << s << endl;
	if (!HANDLERS) {
		pl_kit::_handlers = new dictionary<handler>();
		_register(HANDLERS);
	        cerr << "pl_kit creating handler table" << endl;
		}
	(*HANDLERS)[s] = h;
	cerr << (const char*) "pl_kit binding " << s << " !" << endl;
	return 0;
	}

int pl_kit::schedule(int pd , handler* h , int cls, int sl ) {
	_period = pd?pd : ::_period;
	_handler = h?h: this;
	_slices  = sl?sl: ::_slices;
	_cycles  = cls?cls: ::_cycles;
	/*
	plref main_0;
	pl->init( main_0 );
	tk->after(_period,_handler);
	*/
	return _period;
	}

int pl_kit::operator()() {
   if (--_cycles) {
      //dp -> exec(_slices);       // start/continue execution.
      if (_cycles > 0 )
                tk->after(_period,this);
      }
   return 0;
   }
