#include <hush/source.h>
#include <hush/dv/pl/pl.h>

#include <hush/session.h>
#include <hush/handler.h>
#include <hush/scene.h>

#include <hush/dictionary.h>

#include <hush/dv/pl/kit.h>
#include <hush/dv/pl/term.h>
#include <hush/dv/pl/event.h>

#include <hush/dv/pl/native.h>

//#include <hush/io.h>
#include <stdio.h>

static session* _session = 0;
static int _running = 0;
static int _initialized = 0;

extern "C" {
#include <hush/dv/pl/swi.h>
}

void handle11(int) { 
	//cerr << "caught 11" << endl; 
	}

#define HANDLERS ((dictionary<handler>*)pl_kit::_handlers)

static handler* _pl_handler = 0;

handler* set_pl_handler(handler* h) {
	handler* tmp = _pl_handler;
	_pl_handler = h;
	return tmp;
        }

struct pl_context {
static int num;
pl_context() { noback=0; name[0]='\0'; cmd[0]='\0'; t = 0; n = 0; h = 0; }
char name[24];
char cmd[256];
term* t;
int n;
handler* h;
int noback;
};

int pl_context::num = 0;

foreign_t
hush_pl_function(term_t a0, term_t a1, term_t ans, control_t handle)
{
struct pl_context * ctx = 0;

  switch( PL_foreign_control(handle) )
  { case PL_FIRST_CALL:
	{
	//char buf[1024];
        ctx = new pl_context(); // malloc(sizeof(struct pl_context));
	char* p; PL_get_atom_chars(a0,&p); strcpy(ctx->name,p);
	char* q; PL_get_atom_chars(a1,&q); strcpy(ctx->cmd,q); 
	ctx->n = ++pl_context::num;
	// if (strcmp(p,"cerr"))     cerr << "Calling FIRST " << ctx->n << " " << ctx->name << " " << ctx->cmd << endl;
	char xbuf[1024];
	sprintf(xbuf,"pl(%d): %s %s",ctx->n, p,q);
	//dvscene::_log(xbuf);
	event* x = 0;
	if (pl_kit::_handlers && (ctx->h = (*HANDLERS)[ctx->name])) {
		kit* k = kit::lookup("pl");
		pl_event* e = new pl_event(k,ctx->name,"call",ctx->cmd);
		//k->_register(e);
		//dvscene::_log(xbuf);
		e->_type = 1;
		//e->_ask = ctx->cmd;
		x = ctx->h->dispatch(e);
		if (e->_tell) {
			term_t ares = PL_new_term_ref();
			//cerr << "**telling** " << e->_tell << endl;
			static char buf[1024];
			strcpy(buf,e->_tell);
			sprintf(xbuf,"(x) pl: (%s) %s %s",e->_tell,p,q);
			
			PL_put_atom_chars(ares,buf);
			//cerr << "Now, unify ..." << endl;
			PL_unify(ans,ares); /* This does not work as it shold - no undoing on backtracking */
			//dvscene::_log(xbuf);
			//cerr << "And return ..." << endl;
			//PL_succeed; // AE
			}
		delete e;
		}
	else 
	   cerr << "No handler for " << ctx->name << endl;
	if (x) {
		ctx->noback = 1;
		//AE:delete ctx;
		PL_succeed;
		}
        else PL_retry_address(ctx);
	PL_succeed;
	}; break; // superflu!
    case PL_REDO:
	{
        ctx = (pl_context*) PL_foreign_context_address(handle);
	char* p; PL_get_atom_chars(a0,&p); 
	char* q; PL_get_atom_chars(a1,&q); strcpy(ctx->cmd,q);
        //cerr << "Calling REDO " << ctx->n << " " << p << " " << q << endl;
	event* x = 0;
	if ( !ctx->noback && ctx->h ) {
		kit* k = kit::lookup("pl");
		pl_event* e = new pl_event(k,ctx->name,"redo",ctx->cmd);
		//k->_register(e);
		e->_type = 2;
		//e->_ask = ctx->cmd;
		x = ctx->h->dispatch(e);
		if (e->_tell) {
			term_t a = PL_new_term_ref();
			//cerr << "*retry tell** " << e->_tell << endl;
			PL_put_atom_chars(a,e->_tell);
			//cerr << "Now, unify ..." << endl;
			PL_unify(a,ans);
			}
		delete e;
		}
        // one or the other -->
	if (!x) { 
		//AE delete ctx;
		PL_fail;
		ctx->noback = 1;
		}
        else PL_retry_address(ctx);
	//PL_succeed;
	}; break; // superflu!
    case PL_CUTTED:
	{
        ctx = (pl_context*) PL_foreign_context_address(handle);
        //cerr << "Calling CUTTED " << ctx->n << " " << ctx->name << endl;
	if ( !ctx->noback && ctx->h ) {
		static int xxx=0;
		//cerr << "CUT: " << xxx++ << endl;
		ctx->noback = 1;
		kit* k = kit::lookup("pl");
		pl_event* e = new pl_event(k,ctx->name,"cut",ctx->cmd);
		//k->_register(e);
		e->_type = 0;
		//e->_ask = ctx->cmd;
		ctx->h->dispatch(e);
		delete e;
		}
        // one or the other -->
        //AE delete ctx; // gives an error
        PL_succeed;
	}; break;
     default:
	;//cerr << "ERROR ERROR ERROR ERROR" << endl;
	break;
  }
}

static qid_t* _qid = 0; // to control queries
static qid_t* _qids[12];
static int _qidp = 0;

PL_extension predicates[] =
{
/*{ "name",   arity,  function,       PL_FA_<flags> },*/
  //{ "dv_hush",  3,  hush_pl_function, PL_FA_TRANSPARENT | PL_FA_NONDETERMINISTIC },
  { "dv_hush",  3,  hush_pl_function, PL_FA_NONDETERMINISTIC },
  { "count", 1, swi_count, PL_FA_NONDETERMINISTIC },
  { NULL,       0,      NULL,           0 }     /* terminating line */
  };

// dvpl -- direct interface to pl

static char _buf[2048];
static int argc;
static char* argv[3];

void dvpl::dummy() { }

void dvpl::reset() { _buf[0] = '\0'; }

char* dvpl::unparse(term* x) {
term_t t = (term_t) x;
char *p = 0;
PL_get_atom_chars(t,&p);
strcpy(_buf,p);
return (char*) _buf;
}


char* dvpl::next(void* x,void* a) {
  if (!x) return 0;
  qid_t goal = (qid_t) x;
  term_t ans = (term_t) a;
  char* p = 0; // = "**no solution**"; //AE
  if (PL_next_solution(goal)) {
	dvpl::reset(); // puts _buf[0]=0;
	p = dvpl::unparse((term*)ans);
	//cerr << "*> " << p << endl;
	}
  else
	;//cerr << "No more solutions " << endl;
  if (!p) PL_close_query(goal);
  return p;
  }

void dvpl::destroy(void* x) {
  if (x) { 
  	qid_t goal = (qid_t) x;
  	//PL_close_query(goal);
	}
  }


void dvpl::init(void* x) {
	_session = (session*) x;
	static char *av[] = { "d:/vip/bin/libpl.dll", NULL };

	if (!_initialized) {
		//cerr << "Initializing PL" << endl;
		PL_register_extensions(predicates);
		argc = 1;
		//argv[0] = new char[64]; // is this needed
		//argv[1] = new char[64];
		//argv[2] = new char[64];
		//strcpy(argv[0],"hush");
		//strcpy(argv[1],"dummy");
		//strcpy(argv[2],"dummy");
		PL_initialise(1,av);
		//predicate_t mainpred = PL_predicate("hush_main", 0, "user");
		//PL_call_predicate(NULL, TRUE, mainpred, 0);
		PL_signal(11,handle11);
		_initialized = 1;
		}
	_running = 1;
	}

void dvpl::load(const char* cmd) {
	//cerr << "dvpl::loading nop " << cmd << endl;
	}

void* dvpl::eval(const char* cmd, int _mode) {
 //if (_qid) PL_close_query(*_qid); _qid = 0; 
 predicate_t pred;
 qid_t goal; _qid = &goal;

 //cerr << "Calling " << _mode << " " << cmd << endl;
 term_t args = PL_new_term_refs(2);
 PL_put_atom_chars(args, cmd);
 PL_put_variable(args+1);
 if (_mode) // with result projection
 	pred = PL_predicate("dv_dispatch",2,"");
	//pred = PL_predicate("dv_call_project",2,"");
 else
	//pred = PL_predicate("dv_call",2,"");
	pred = PL_predicate("dv_dispatch",2,"");
 goal = PL_open_query(NULL,PL_Q_NORMAL,pred,args);
 term* result = new pl_term((void*)goal,(void*)(args+1));
 return (term*) result;
}


int dvpl::consult(const char* cmd) {
 //if (_qid) PL_close_query(*_qid); _qid = 0; 
  term_t args = PL_new_term_ref(); //s(2);
  PL_put_atom_chars(args,cmd);
  term_t q = PL_new_term_ref();
  PL_cons_functor(q, PL_new_functor(PL_new_atom("consult"), 1), args);
  PL_call(q,NULL);
  return 1;
  }

int dvpl::exec(const char* goal, const char* cmd) {
 //if (_qid) PL_close_query(*_qid); _qid = 0; 
  term_t args = PL_new_term_ref(); //s(2);
  PL_put_atom_chars(args,cmd);
  term_t q = PL_new_term_ref();
  PL_cons_functor(q, PL_new_functor(PL_new_atom(goal), 1), args);
  PL_call(q,NULL);
  return 1;
  }
