%{
//@auto=0
//@class inc
%}
%class lex
%{
char* ext = ".pvl";
static int pr = 0;
static int in_proto = 0;
static int nol = 0;
static char name[256];
static char proto[256];

#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <hush/iostream.h>

char* placeof(char* x) {
static char buf[1024];
	strcpy(buf,x);
	char* p = buf;
	while (*p != '\0' && *p != '.') {
		if (*p == '-') *p = '/';
	p++;
	}
	return (char*) buf+4;
}

char* depthof(char* x) {
static char buf[1024];
	char* p = x;
	int n = 0;
	while (*p != '\0' && *p != '.') {
		if (*p == '-') n++;
	p++;
	}
	if (n==1) return "../";
	else if (n==2) return "../../";
	else if (n==3) return "../../../";
	else if (n==4) return "../../../../";
	else if (n==5) return "../../../../../";
}

%}
%%@ rules
^"#@require ".*\n { cout << yytext << endl; }
^"#@proto ".*\n { cout << "#@require-proto " << yytext+8 << endl; }
^"#@extern ".*\n { cout << "#@require-extern " << yytext+9 << endl; }
^"#@load ".*\n { cout << "#@require-load " << yytext+9 << endl; }
^"PROTO"[ \t]+[A-Za-z\-\_\+\:\@\0-9]+[ \t]*"[" {
	char *p = yytext+6;
	while (*p == ' ') p++;
	char buf[256];
	strcpy(buf,p);
	char* q = buf;
	while ( *q != ' ' && *q != '[' ) q++;
	*q = '\0';
	strcpy(proto,buf);
	in_proto = 1;
	pr = 1;
	cout << "##@ interface" << endl;
	cout << "EXTERN" << yytext;
	//cout << " ## " << "@vr-" << name  << ".wrl";
	}
^[ \t]*"exposedField"[ \t]+[A-Z0-9a-z]+[ \t]+[A-Za-z0-9\_\-\@]+ {
	pr = 0;
	if (in_proto) cout << yytext;
	}
^[ \t]*"field"[ \t]+[A-Z0-9a-z]+[ \t]+[A-Za-z0-9\_\-\@]+ {
	pr = 0;
	if (in_proto) cout << yytext;
	}
^[ \t]*"eventIn".\n { if (pr) cout << yytext; }
^[ \t]*"eventOut".\n { if (pr) cout << yytext; }
"]"[ \t]*"{" {
	pr = 0;
	char buf[1024];
	sprintf(buf,"@vr-%s.wrl#%s",(char*)name,(char*)proto);
	char* q = placeof(buf);
	if (in_proto)
	  cout << "][ " << endl; 
	  cout << "  \"" << buf <<"\"" << endl;
	  cout << "  \"" << depthof(buf) <<  q << "\"" << endl;
	  cout << "  \"../" << depthof(buf) << "@vr/" <<  q << "\"" << endl;
	  cout << "  \"file:C:/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"file:D:/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"file:E:/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"file:F:/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"file:R:/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"file:Z:/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"file:C:/www/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"file:D:/www/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"http://localhost/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"file:C:/www/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"http://www.cs.vu.nl/online/@share/vr/" << q <<"\"" << endl;
	  cout << "  \"http://hush.cs.vu.nl/vr/" << q <<"\"" << endl;
	  cout << " ]" << endl;
	in_proto = 0;
	}

\n { if (in_proto) pr = 1; if (pr) ECHO; }
. { if (pr) ECHO; }
%%
//@ main

int main(int argc, char* argv[]) {
lex l;
strcpy(name,"temp");
argc--; argv++;
while ((argc > 0) && (argv[0][0] == '-')) {
//	cerr << argv[0] << endl;
       if ( argv[0][1] == 'N' ) {
		strcpy(name,&argv[0][2]);
		cerr << "FILE: " << name << endl;
		}
	argc--; argv++;
	}

cout << "#VRMLV2.0 utf8" << endl;
cout << "##:@* " << name <<  endl;
if ( argc == 0 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
cout << "##</>" << endl;
return 0;
}
//</>
