%{
//@auto=0
//@class inc-html
%}
%class lex
%{
char* ext = "html";

#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <hush/iostream.h>
%}
name [\~\/A-Za-z0-9\.][A-Za-z0-9\.\/\-\+]*
names [ \t]*{name}({name}|[ \t])*
atts [^\>]*
C (\%|\@|\.)

%%@ rules
"<so "{names}">" { yytext[yyleng-1]='\0'; files(yytext+4,ext); }
"<cd "{names}">" { yytext[yyleng-1]='\0'; directories(yytext+4,ext); }
"\\so "{names}/("-->"|"}"|\n) { files(yytext+4,ext); }
"\\cd "{names}/("-->"|"}"|\n) { directories(yytext+4,ext); }
^{C}"so "{names}/("-->"|"}"|\n) { files(yytext+4,ext); }
^{C}"cd "{names}/("-->"|"}"|\n) { directories(yytext+4,ext); }


"<include "{atts}">" {
   int choice = 0;
   yytext[yyleng-1] = '\0';
   string dir = "";
   string ext = "";
   string file = "@temp";
   string cmd = "";
   string_converter x(yytext+8);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("file") ) { 
			if ((choice !=3) && (choice!=2)) choice = 1;
			file = p.value();
			}
           if ( p.matches("files") ) { choice = 1; file = p.value(); }
           if ( p.matches("dir") ) { choice = 2; dir = p.value(); }
           if ( p.matches("dirs") ) { choice = 2; dir = p.value(); }
           if ( p.matches("ext") ) { ext = p.value(); }
           if ( p.matches("cmd") ) { choice = 3; cmd = p.value(); }
           }
   if (choice == 0) file = yytext+9;
   if (choice == 2 && !strcmp(ext,"")) ext = ::ext;
   //cerr << "FILE:" << file << " EXT:" << (char*) ext << endl;
   if (choice==2) directories(dir,ext,file); 
   else if(choice==3) {
		char buf[BUFSIZ];
		sprintf(buf,"%s > %s",(char*)cmd,(char*)file);
		system(buf); files(file,"");
		}
   else files(file,ext);
   }

. { ECHO; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
int _argc = 0;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
	argc--; argv++;
	}

l.paths(_argc, _argv);
if ( argc == 1 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
return 0;
}

//</>
