%{
//@auto=0
//@class txt-t
%}
%class lex
%p 10000
%e 1500
%{
#include <hush/grammar/lex.h>

void initnames(int);

int pr = 1;
char endline[1024];
int dp = 0;
int in_slide = 0;
int mode=0; // requirements
static int n = 0;
%}
meta \#\#
compound (functional|function|class|component)
htmltag (address|ul|li|dl|dt|dd|ol|em|i|b|h1|h2|h3|h4|pre|title)
tag ("<"("/")?[a-z]*">")
int n = 0;
%%@ rules
"<!doctype req".* { mode=0;
	initnames(mode);
	}
"<!doctype design".* { mode=1;
	initnames(mode);
	cerr << "Design mode" << endl;
	}
{meta}"@"[a-z].*  { }
{meta}"@ ".*  {
	      char buf[1024]; char* p = yytext+4;
	      //sprintf(buf,"<%s id=\"%s\" cap=\"%s\">","slide",p,p);
	      //if (pr) cout << buf;
	    }
{meta}"</>"     { if (pr) cout << "</slide>"; }
"<!--"      { pr = 0; }
"-->"       { pr = 1; }
"<?".*      { }
"<"("/")?{htmltag}">"       { if (pr) cout << yytext; }
"<"{compound}" "[^\>]*">" {
	char head[64]; char* p = yytext+1; int i = 0;
	while (*p != ' ') head[i++] = *p++;
	head[i]='\0';
	//if (strcmp("component",head)) {
		if (pr) cout << "</slide><slide" << yytext+i << endl;
	//	}
	yytext[yyleng-1]='\0';
	p = &yytext[yyleng-1];
	while ((*p != '=') && (p != yytext)) p--;
	char* x = alias(head); 
	if (!x) x = head;
	if (pr) cout << "<h3>" << x << " " << p+1 << "</h3>";
	}

{tag}       {
		if (yyleng < 5 && pr) cout << yytext;
		else {
		char* p = alias(yytext);
		if (p && pr) cout << "</slide>" << p;
		else if (pr) {
			yytext[yyleng-1]='\0';
			if (pr) cout << "<h4><a name=\"" << yytext+1 << "\">"; 
			if (pr) cout << yytext+1 << "</a></h4><p>"; 
			}
		}
	    }
"\$"[A-Za-z\-]+ { if (pr) cout << "<b>" << yytext << "</b>"; }
"\$("[A-Za-z\-]+")" { yytext[yyleng-1]='\0'; 
	if (pr) cout << "<b>" << yytext+2 << "</b>"; }
"<a href="[^>]+">" { if (pr) cout << yytext; }
\n { if (pr) cout << "\n"; }
\n\n { 
     if (!dp && pr) cout << "<p>" << endl; 
     else if (dp && pr) cout << "\n" << endl;
     }
\n\n\n {
	if (pr) cout << "<p>";
	/*
	if (!dp) dp=1; else dp=0;
	if (dp && pr) cout << "\n<display>\n" << endl;
	else if (!dp && pr) cout << "\n</display>\n" << endl;
	*/
	}
\t { if (pr) cout << "        "; }
. { if (pr) cout << yytext[0]; }
%%
//@ main
static scanner* _scanner;

int main() {
cout << "<document>";
_scanner = new lex();
(*_scanner)();
cout << "</document>" << endl;
return 0;
}

char firstchar(char* s) {
while ( *s != 0 && ( *s == ' ' || *s == '\t' || *s == '\n' ) ) s++;
return *s;
}

//@ init

void initnames(int mode) {

if (mode==0) {
_scanner->alias("<library>","<slide id=. cap=Library><h2><a name=library>The library:</a></h2>");
_scanner->alias("<configuration>","<slide id=. cap=Configuration><h2><a name=configuration>Configuration</a></h2>");
_scanner->alias("<main>","<slide id=. cap=Main><h2><a name=main>The main program:</a></h2>");
_scanner->alias("<disclaimer>","<slide id=. cap=disclaimer><h2><a name=disclaimer>Disclaimer</a></h2>");

_scanner->alias("<introduction>","<slide id=. cap=Introduction><h2><a name=introduction>Introduction</a></h2>");
_scanner->alias("<description>","<slide id=. cap=Description><h2><a name=description>Description</a></h2>");
_scanner->alias("<interface>","<slide id=. cap=Interface><h2><a name=interface>Interface</a></h2>");
_scanner->alias("<specific>","<h2><a name=specifics>Specifics</a></h2>");
_scanner->alias("functional","Function:");
} else if (mode==1) {

_scanner->alias("<introduction>","<slide id=. cap=Introduction><h2><a name=introduction>Introduction</a></h2>");
_scanner->alias("component","Component:");
_scanner->alias("class","Class:");
}
}
//</>
