%{
//@auto=0
//@class inc
%}
%class lex
%{
char* ext = ".t";
static int pr = 0;

#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <hush/iostream.h>

#define out if (pr) cout

static char _slide[512];  
static char name[64];

static int instr(char c, char* s) {
	while ( *s && *s++ != c );
	return (int) *s;
	}

static char _symbols[] = " (-\t\n.,;:{}%$!`^#/\\\"'!%&[]()~<>*";

static int symbol(char c) { return instr(c,_symbols); }


const char* slide() {
static int _slideno = 0;
static char _slideref[4024];
_slideref[0] = '\0';
sprintf(_slideref,"%s%s-%d-%s","tm",name,_slideno++,_slide);
char* b  = _slideref;
char* p = b;
while ( *p && symbol(*p) ) p++;
int i = 0;
while (*p && i <= 18 ) {
	int yes=0;
	if (symbol(*p) || *p == ' ') {
		yes = 1;
		*b = '-';
		}
	else *b = *p;
	b++; p++;
	if (yes) while (symbol(*p) || *p == ' ') p++;
	i++;
	}
*b='\0';
if (*(b-1) == '-') *(b-1) = '\0';
_slideref[18]='\0';
return (char*) _slideref;
}

static int slino = 0;

void deprecated(char* s) {
	//cerr << "## DEPRECATED " << s << endl; 
	cout << "## DEPRECATED " << s << endl; 
	}

%}
name [\~\/\@A-Za-z0-9\.][\_\@A-Za-z0-9\.\/\-\+]*
names [ \t]*{name}({name}|[ \t])*
atts [^\>]*
C \@
%%@ rules
^"xxxx:"[A-Za-z0-9\/\(\)\,\.\-\<\>\=\;\<\>\ \t][A-Za-z0-9\/\(\)\,\.\-\<\>\=\:\;\<\>\@\ \t]* {
	int b = 0;
	if (yytext[1] == '@') b = 1;
	if (slino !=0 ) out << "</slide>" << endl;
	out << "<slide bg=0 bgcolor=blue fontcolor=white id=tm-" << name << "-" << slino << " mode=hide>";
	out << "<h4 textcolor=\"0 1 1\"><a href=@slide-tm-" << name << "-" << slino << ".html>";
	out << yytext+ (b?3:1) << "</a></h4><p>" << endl;
	slino++;
	}
^"::@ ".* {
	int b = 0;
	strcpy(_slide,yytext+4);
	string id = slide();
	if (slino != 0 ) out << "</slide>" << endl;
	out << "<slide id=" << (char*) id << ">";
	out << "<p align=right><a href=@slide-" << id << ".html><red>";
	out << _slide << "</font></a></p><p>" << endl;
	slino++;
	}
^"::</>" { out << "</slide>" << endl; slino = 0; }
^"%%".* { }
^"xx%%</>" { out << "</slide>" << endl; }
^"xx%%/:" { out << "</slide>" << endl; }
^"xx%%:/" { out << "</slide>" << endl; }
\n { out << endl; }
. { ECHO; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
//align = "BEGIN";
strcpy(name,"temp");
int _argc = 0;
cerr << "ARGC " << argc << endl;
argc--; argv++;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( argv[0][1] == 'N' ) {
	strcpy(name,argv[0]+2);
	} else if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
        cerr << "ARGC " << argc << endl;
	argc--; argv++;
	}

cerr << "ARGC " << argc << endl;
l.paths(_argc, _argv);
pr = 1;
//out << "<document>" << endl;
//out << "/// <box>" << "<a href=@talk-" << name << ".html target=_top>";
//out << "<gold>" << name << "</gold></box>" << endl;
//out << "<p align=right>";
//out << "<a href=@talk-" << name << ".html target=_top>";
//out << "<img src=@base/eye.gif width=25 height=25></a></p>" << endl;
if ( argc == 0 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
//out << "</slide>" << endl;
//out << "</document>" << endl;
return 0;
}
//</>
