%{
//@auto=0
//@class inc
%}
%class lex
%{
char* ext = ".pvl";
static int pr = 0;
static int old = 0;

char yytext[10*1024];

static int in_right = 0;
static float un_break = 0;

static int font_no = 0;

static int items[9];
static int list_type[9];

static char name[64];
static int empty_line = 0;
static int no_style = 0;
static int es_mode = 0;
static int bk_mode = 0;
static int x_mode = 0;
static int pvl_mode = 0;

static int do_pop = 0;

static int in_object = 0;
static int in_slide = 0;
static int in_channel = 0;
static int slideno = 0;

static int centered = 0;
static int in_list = 0;

static int in_font = 0;
static int in_link = 0;
static int in_header = 0;
static int in_line = 0;
static int in_li = 0;
static int in_p = 0;
static int in_q = 0;

static int old_p = 0;

static int is_aligned = 0;

static int in_display = 0;



#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <iostream.h>

#include <hush/dictionary.h>
#include <hush/stack.h>

static int hold_level = -1;
static int the_level = 0;

static string start_level = "-1";
static string end_level = "-1";


//static string align = "BEGIN";

static float levelsize[] = { 1, 3, 2.5 , 2.0, 1.5, 1, 1 , 1, 1,1,1 };
static dictionary<string> colors; 
static string linkcolor= "1 1 0";

static string the_url;

static string display_size = "1";

static stack<int>* st_inlink= 0;
static stack<string>* st_link = 0;

static stack<string>* st_style = 0;
static stack<string>* st_family = 0;
static stack<string>* st_color = 0;
static stack<string>* st_size = 0;

static string df_size = "1";
static string df_color= "1 1 1";
static string df_justify = "BEGIN";
static string df_family = "SERIF";
static string df_style = "PLAIN";
static string dl_bgcolor = "0.7 0.7 1";
static string dl_bgtrans = "1";

static string f_size = "1";
static string f_color= "1 1 1";
static string f_justify = "BEGIN";
static string f_family = "SERIF";
static string f_style = "PLAIN";
static string l_bgcolor = "0.7 0.7 1";
static string l_bgtrans = "1";

static string old_size = "1 1 1";
static string old_color = "1 1 1";
static string old_justify = "BEGIN";
static string old_family = "SERIF";
static string old_style = "PLAIN";
static string old_bgcolor = "0.7 0.7 1";
static string old_bgtrans = "1";

static int level_display = 0;
static int auto_level = 0;
static int list_level[8];

void font_push();
void font_pop();


struct context : public string {
int n;
context() {
	n = 0;
	}

//context(context& x) { n = x.n; }
context(context* x) { 
	n = x->n;
	}

void push() {
   font_push();
   }

void pop() {
   font_pop();
   }


//context& operator=(context& x) { n = x.n; }
//context& operator=(context* x) { n = x->n; }
//int operator==(const context&) { return 1; }
};

//int operator<<(const context*, const context*) {
	//return 0;
	//}
//ostream& operator<<(ostream& o, const context& x) {
	//o << "## context " << endl;
	//return o;
	//}

static stack<context>* st_context;
static context* context0;
static context* ctx;

void reset_level() {
start_level = "-1";
end_level = "-1";
auto_level = 0;
list_level[0] = auto_level;
}

void set_start(const char* x) {
char buf[64];
char* s = (char*) start_level;
int n; sscanf(s,"%d",&n);
if (!strcmp(x,"++")) {
	n++; sprintf(buf,"%d",n);
	start_level = (char*) buf;
	}
else if (!strcmp(x,"--")) {
	n--; sprintf(buf,"%d",n);
	start_level = (char*) buf;
	}
else start_level = x;
}

void set_end(const char* x) {
char buf[64];
char* s = (char*) end_level;
int n; sscanf(s,"%d",&n);
if (!strcmp(x,"++")) {
	n++; sprintf(buf,"%d",n);
	end_level = (char*) buf;
	}
else if (!strcmp(x,"--")) {
	n--; sprintf(buf,"%d",n);
	end_level = (char*) buf;
	}
else if (!strcmp(x,"start")) {
	char buf1[64];
	char* st = (char*) start_level;
	int m; sscanf(st,"%d",&m);
	sprintf(buf,"%d",m);
	end_level = (char*) buf;
	}
else if (x[0] == '+') {
	char buf1[64];
	char* st = (char*) start_level;
	int m; sscanf(st,"%d",&m);
	char buf2[64];
	char* sk = (char*) x+1;
	int k; sscanf(sk,"%d",&k);
	int lx = m + k;
	sprintf(buf,"%d",lx);
	end_level = (char*) buf;
	}
else end_level = x;
}

void set_level(const char* x = 0) {
//cerr << "## set_level " << x << " " << auto_level << endl;
if (x && !strcmp(x,"auto")) {
	auto_level = 1;
	}
else if (x && !strcmp(x,"on")) {
	auto_level = 1;
	}
else if (x && !strcmp(x,"off")) {
	auto_level = 0;
	}
else if (x && x[0] == '+') {
	set_start(x);
	}
else if (!x) {
	if (auto_level) set_start("++");
	}
if (x) { list_level[in_list] = auto_level; }
}

void display_level(const char* x = 0) {
//cerr << "## set_level " << x << " " << auto_level << endl;
if (x && !strcmp(x,"auto")) {
	level_display = 1;
	}
else if (x && !strcmp(x,"on")) {
	level_display = 1;
	}
else if (x && !strcmp(x,"off")) {
	level_display = 0;
	}
}

char* kleur(const char* x) {
string* p = colors[x];
if (p) return (char*) *p;
else
if (!strcmp("red",x)) return "1 0 0";
else if (!strcmp("yellow",x)) return "1 1 0";
else if (!strcmp("orange",x)) return "1 0.7 0";
else if (!strcmp("blue",x)) return "0 0 1";
else if (!strcmp("green",x)) return "0 1 1";
else if (!strcmp("white",x)) return "1 1 1";
else if (!strcmp("black",x)) return "0 0 0";
else if (!strcmp("gold",x)) return "1 1 0";
else if (!strcmp("silver",x)) return "0.9 0.9 0.9";
else return "1 1 1";
}

void font_push() {
        if (!st_context) st_context = new stack<context>;
	if (!st_inlink) st_inlink = new stack<int>;
	if (!st_link) st_link = new stack<string>;
	if (!st_style) st_style = new stack<string>;
	if (!st_family) st_family = new stack<string>;
	if (!st_color) st_color = new stack<string>;
	if (!st_size) st_size = new stack<string>;
	st_context->push(new context(ctx));
	st_inlink->push(new int(in_link));
	st_link->push(new string((char*)the_url));
	st_style->push( new string((char*)f_style));
	st_family->push( new string((char*)f_family));
	st_color->push( new string((char*)f_color));
	st_size->push( new string((char*)f_size));
	font_no = 0;
	}

#define out if (pr) cout

void font_pop() {
if (!st_context) st_context = new stack<context>;
string* p; char buf[64]; int*pn; int n;
if (!st_inlink) st_inlink = new stack<int>;
if (!st_link) st_link = new stack<string>;
if (!st_style) st_style = new stack<string>;
if (!st_family) st_family = new stack<string>;
if (!st_color) st_color = new stack<string>;
if (!st_size) st_size = new stack<string>;

context* pc = st_context->pop(); if (!pc) out << "##error context (pop)" << font_no  << endl;
else ctx = pc;
if (!pc) ctx = context0;
else delete pc;
pn = st_inlink->pop(); if (!pn) out << "##error inlink (pop)" << font_no  << endl;
if (pn) in_link = *pn; else in_link = 0;
p = st_link->pop(); if (!p) out << "##error link (pop)" << font_no  << endl;
if (p) the_url = (char*) *p; else the_url = (char*) ""; 
p = st_style->pop(); if (!p) out << "##error font style (pop)" << font_no << endl;
if (p) f_style = (char*) *p; else f_style = (char*) df_style; 
p = st_family->pop(); if (!p) out << "##error font family (pop)" << font_no << endl;
if (p) f_family = (char*) *p; else f_family = (char*) df_family;
p = st_color->pop(); if (!p) out << "##error font color (pop)" << font_no << endl;
if (p) f_color = (char*) *p; else f_color = (char*) df_color;
p = st_size->pop(); if (!p) out << "##error font size (pop)" << font_no << endl;
if (p) f_size = (char*) *p; else f_size = (char*) df_size;
}


void reset(){
f_size = "1";
f_color= "1 1 1";
f_justify = "BEGIN";
f_family = "SERIF";
f_style = "PLAIN";
l_bgcolor = "0.7 0.7 1";
l_bgtrans = "1";
}

void deprecated(char* s) {
	//cerr << "## DEPRECATED " << s << endl; 
	out << "## DEPRECATED " << s << endl; 
	}

char* xsize(float x) {
static char buf[20*512];
float f;
char fbuf[64];
sprintf(fbuf,"%s", (char*) f_size);
sscanf(fbuf,"%f",&f);
sprintf(buf,"%f",f * x);
return (char*) buf;
}

void prline(const char* x = 0) {
if (x) out << "## line " << x << endl;
}

void prbegin(const char* x = 0) {
if (x) out << "## begin " << x << endl;
}

void prend(const char* x = 0) {
if (x) out << "## end " << x << endl;
}

char* lp(int x = 0) {
static char buf[20*512];
static char buf1[20*512];
static char buf2[20*512];
char* p = &buf2[0];
sprintf(buf," justify [\"%s\"] startLevel %s endLevel %s ", (char*) f_justify, (char*) start_level, (char*) end_level);
if (!x) { 
if (old) {
sprintf(buf1," %s family [\"%s\"] style \"%s\" color %s size %s string \"", 
	(char*) buf,
	(char*) f_family,
	(char*) f_style,
	(char*) f_color,
	(char*) f_size);
} else {
sprintf(buf1," %s family [\"%s\"] style \"%s\" color %s height %s string \"", 
	(char*) buf,
	(char*) f_family,
	(char*) f_style,
	(char*) f_color,
	(char*) f_size);
}
} else sprintf(buf1,"%s",buf);
if (in_link && (x != 2)) {
	sprintf(buf2," href \"%s\" %s",(char*) the_url, (char*) buf1);
	//p = &buf2[0];
} else sprintf(buf2,"%s",buf1);
in_line = 1;
if (x != 0) in_line = 0;
return (char*) p;
}


void check(char* x);

inline void dobreak(float x = 0, float y = 0, char* s = "", int br = 0) {
if (!s) s = " --- s ----";
//check("dobreak");
if (old) out << "break { br " << (br?"FALSE":"TRUE") << " size " << y << " length " << x << lp(2) << " } ## " << s << endl;
if (!old) out << "Break { width " << x << " height " << y << lp(2) << " } ## " << s << endl;
}

//inline void vspace(string f, char* x = "") { dobreak(0,atof((char*)f),x); }
inline void vspace(float f, char* x = "") { dobreak(0,f,x); }
inline void hspace(float f, char* x = "") { dobreak(f,0,x,1); }

inline void check(char* x = 0) {
        empty_line = 0;
        if (in_line) { // || in_li || in_p || in_header ) {
		out << "\" } ## check *** " << (char*) (x?x:"") << " " << yytext << endl; 
		}
	else {
		//out << " ## check (0) " << (char*) (x?x:"") << " " << yytext << endl; 
		}
	in_line = 0;
	if (old) in_li = 0;
	if (un_break != 0) {
		vspace(un_break,x);
		//if (old) out << "break { size " << un_break << lp(2) << " } ## " << yytext << endl;
		//if (!old) out << "Break { height " << un_break << lp(2) << " } ## " << yytext << endl;
		un_break = 0;
		in_line = 0;
		}
	}

void un_p() {
	check("un_p");
	in_p = 0;
	}


char* uq(char* x) {
static char buf[20*512];
buf[0]='\0';
char* p = x;
char* q = (char*) buf;
while ( *p != '\0' ) {
	if (*p == '"') *q++ = '\\';
	*q++ = *p++;
	}
*q = '\0';
return (char*) buf;
}

static int has_name = 0; static string xname = "anonymous";
static int has_size = 0; static string size = "17.0 9.0";
static int has_width = 0; static string width = "30";
static int has_height = 0; static string height = "15";
static int has_scale = 0; static string scale;
static int has_loc = 0; static string loc;
static int has_rot = 0; static string rot;
static int has_align = 0; static string align = "BEGIN";
static int has_ref = 0; static string ref;
static int has_href = 0; static string href;

void reset_has() {
has_size = has_width = has_height =
has_scale = has_loc = 
has_align = 
has_rot =
has_ref = has_href =
has_name =
0;
}

void check_context(char* type, int pos, char* yytext, int yyleng) {
   string_converter x(yytext+pos);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
	   if ( p.matches("url") ) {in_link=1; the_url = p.value(); }
           else if ( p.matches("level") ) { set_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("align") ) { 
		 char* s =  (char*) p.value();
		 if (!strcmp(s,"right")) f_justify = "END"; /*AE*/
		 else if (!strcmp(s,"center")) f_justify = "MIDDLE"; /*AE*/
		 else if (!strcmp(s,"left")) f_justify = "BEGIN"; /*AE*/
		 }
           else if ( p.matches("justify") ) { f_justify = p.value(); }
           else if ( p.matches("family") ) { f_family = p.value(); }
           else if ( p.matches("color") ) { f_color = p.value(); }
           else if ( p.matches("name") ) { has_name=1; xname = p.value(); }
           else if ( p.matches("size") ) { has_size=1; size = p.value(); }
           else if ( p.matches("width") ) { has_width = 1; width = p.value(); }
           else if ( p.matches("height") ) { has_height = 1; height = p.value(); }
           else if ( p.matches("scale") ) { has_scale = 1; scale = p.value(); }
           else if ( p.matches("loc") ) { has_loc = 1; loc = p.value(); }
           else if ( p.matches("location") ) { has_loc = 1; loc = p.value(); }
           else if ( p.matches("rot") ) { has_rot = 1; rot = p.value(); }
           else if ( p.matches("rotation") ) { has_rot = 1; rot = p.value(); }
           else if ( p.matches("align") ) { has_align = 1; align = p.value(); }
           else if ( p.matches("ref") ) { has_ref = 1; ref = p.value(); }
           else if ( p.matches("href") ) { has_href = 1; href = p.value(); }
           }
}

void print_attributes() {
      if (!old && has_width) out << "width " << width << " ";
      if (!old && has_height) out << "height " << height << " ";
      if (!old && has_loc) out << "location " << loc << " ";
      if (!old && has_rot) out << "rotation " << rot << " ";
      if (!old && has_scale) out << "scale " << scale << " ";
      }

void print_line() {
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"TextElement {") << lp(); 
	}


void begin_channel(char* type, int pos, char* yytext, int yyleng) {
if (in_display) { out << uq(yytext); }
else {
   in_channel++;
   check(yytext);
   ctx->push();
   prbegin(yytext);
   if (in_channel == 1) reset();
   yytext[yyleng-1] = '\0';
   check_context(type,pos,yytext,yyleng);

   if (!strcmp(type,"text")) {
      	if (old) out << "text { \n";
      	if (!old) out << "TextBlock { \n";
      if (old && has_size) out << "size " << (char*) size << "\n";
      print_attributes();
      out << (old?"\nlines [":"\nelements [ ") << endl;
      }
   }
}

void end_channel(char* type = "()") {
if (in_display) { out << uq(yytext); }
else {
      check(yytext);
      out << "] } ## end " << yytext << endl;
      in_channel--;
      is_aligned = 0;
      ctx->pop();
      }
}


//extern "C" system(char*);
%}
name [\~\/\@A-Za-z0-9\.][\_\@A-Za-z0-9\.\/\-\+]*
names [ \t]*{name}({name}|[ \t])*
atts [^\>]*
C \@

lightcolors (white|lightred|lightgreen|lightblue|lightyerllow) 
darkcolors (red|green|blue|yellow|orange|silver|gold|black)
colors ({lightcolors}|{darkcolors})
%%@ rules

"%%".*\n { }

"<c-nonum>" { }
"</c-nonum>".* { }

"<!--" { }
"-->" { }

"<!--%" { }
"%-->" { }


"<pre>" {}
"</pre>" {}

"<world>" { }
"</body></document>" { }

"#@include @proto/slide/slide.wrl" {}
"#@include @vrml/slideset-begin.wrl" {}
"#@include @vrml/slideset-end.wrl" {}

"<novr>".* { pr=1;  }
"</novr>" { pr=1; }
"<html>" {  }
"</html>" {  }
"<control>"|"<c>" { }
"</control>"|"</c>" { }
"<quote>" { }
"</quote>" { }

"<!--\\fbox{-->" { }
"<!--}-->" { }

"<!--\\chapter{".*\n { }

^"x<html><control>".* { }

"<hr>"  { ; }

"&gt;" { out << ">"; }
"&lt;" { out << "<"; }
"&ge;" { out << ">="; }
"&le;" { out << "<="; }

"&"[a-z]"uml;" { out << yytext[1]; }

"<vrml>" { ; }
"</vrml>" { ; }

"<ignore>" { pr = 0; }
"</ignore>" { pr = 1; }

"<center>" { centered = 1; ctx->push(); f_justify = "MIDDLE"; }
"</center>" { centered = 0; ctx->pop(); }

"<ol"{atts}">"|"<ul"{atts}">" {
	check(yytext);
	prbegin(yytext);
	//un_p(); 
	if (old) un_break = -0.2; // -0.5; // -0.5;
	in_list++; 
	items[in_list] = 0;
	list_type[in_list] = 0; 
	if (yytext[1] == 'o') list_type[in_list] = 1; 
	yytext[yyleng-1] = '\0';
	check_context("ul",3,yytext,yyleng);
	out << " ## " << in_list << " " << yytext << endl;
	list_level[in_list] = auto_level; 
	} 

"</ol>"|"</ul>" {
	check(yytext);
	prend(yytext);
	out << " ## " << in_list << " " << endl; in_list--;
	if (in_list < 0) in_list = 0;
	auto_level = list_level[in_list];
	}

"xxx##" { if (!in_display)  out << yytext; }
"##"|"<xfont color=green><i>##" {
	if (!in_display) {
		out << yytext;
	} else {
	out << "\" } ##" << endl;
	font_push();
	f_color = "0 1 1";
	f_size = xsize(0.8);
	f_style = "ITALIC";
	do_pop = 1;
	prline(yytext);
	out << (old?"line {":"TextElement {") << lp();
	}
}



"<a "{atts}">" { 
	ctx->push();
	if (!in_object) {
	yytext[yyleng-1] = '\0';
	has_name = 0;
	check_context("a",2,yytext,yyleng);
	if (!has_name && (has_ref || (x_mode && (has_href)))) {
		in_link = 1;
		char buf[1024];
		sprintf(buf,"%s%s",(char*)(has_ref?ref:href),(has_ref?".wrl":""));
		the_url = (char*)buf;
		out << "\" }\n";
		prline(yytext);
		//out << (old?"aline { href ":"TextElement { href ");
		out << (old?"aline {":"TextElement {");
		//out << "\"" << the_url << "\"";
		//if (in_right) { // AE
		//	f_justify = "END";
		//	}
		out << lp();
		//f_justify = (char*) old_justify;
		}
	}
}
"</a>" {
	ctx->pop();
	if (!in_object && in_link && x_mode) {
	   in_link = 0;
	   if (1 || !in_header) {
		out << "\" }\n";
		prline(yytext);
		out << (old?"line {":"TextElement {");
                out << lp();  
		}
	}
}

"<p"{atts}">"  {
	yytext[yyleng-1] = '\0';
	set_level();
	ctx->push();
	check_context("p",2,yytext,yyleng);
	if (1) {
	un_p();
	if (!in_display) un_break = 0; // was 0
	// if (old) out << " break { size 0.5 " << lp(2) << "}" << endl;
	vspace(old?0.5:1,yytext);
	print_line();
	//prline(yytext);
	//if (in_link && old) out << "a";
	//out << (old?"line {":"TextElement {") << lp(); 
	in_p = 1;
	}
}
"</p>" { if (1) un_p(); font_pop(); }
"</p><br>" { font_pop(); f_justify = "BEGIN"; if (1) un_p(); font_pop(); }

"<def"{atts}">"  {
	yytext[yyleng-1] = '\0';
	string id = "";
	int has_id = 0;
        string_converter x(yytext+4);
        for (int i = 1; i <= x.argc(); i++ ) {
           attribute p(x[i]);
           if ( p.matches("level") ) { set_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("id") ) { has_id = 1; id = p.value(); }
           else if ( p.matches("name") ) { has_id = 1; id = p.value(); }
	   }
	if (has_id) {
	//out << "\" }" << endl;
	check(yytext);
	prline(yytext);
	out << " DEF " << (char*) id << " ";
	out << (old?" line {":" TextElement {") << lp(); 
	}
}

"</def>" { 
	check(yytext);
	prline(yytext);
	out << (old?"line { ":"TextElement {") << lp();
	}

"\"" {
	if ((in_display||in_line) && !in_q)  {
		out << "\\\"";
	} else {
		out << "\"";
	}
}

"<"[\+\-][0-9\.]+">"  {
	yytext[yyleng-1] = '\0';
	char sign = yytext[1];
	char* s = (char*) yytext+2;
	float  k; sscanf(s,"%f",&k);
	if (sign == '-') k = -k;
	if (1) {
	out << "\" }" << endl;
	if (old) out << "break { br FALSE length " << k << lp(2) << "}" << endl;
	else hspace(k);
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"TextElement {") << lp();
	}
}

"#<l++>" { set_start("++"); }
"<l++>"  {
	yytext[yyleng-1] = '\0';
	set_start("++");
	if (1) {
	out << "\" }" << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line { ":"TextElement {") << lp();
	}
	}

"<q>"  {
	yytext[yyleng-1] = '\0';
	in_q ++;
	string id = "";
	int has_id = 0;
        string_converter x(yytext+2);
        for (int i = 1; i <= x.argc(); i++ ) {
           attribute p(x[i]);
           if ( p.matches("level") ) { set_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("id") ) { has_id = 1; id = p.value(); }
           else if ( p.matches("name") ) { has_id = 1; id = p.value(); }
	   }
	if (1) {
	out << "\" }" << endl;
	}
	}
"</q>" { 
	in_q--;
	prline(yytext);
	out << (old?" line { ":" TextElement {") << lp();
	}
	

"<display"{atts}">"[ \t\n]* { 
	un_p();
	prbegin(yytext);
	font_push();
	set_level();
	in_display++; 
	char* p = &yytext[yyleng];
	while ((*p) != '>')  p--;
	*p = '\0';
	yytext[yyleng-1] = '\0';
	if (in_display==1) { 
	f_size = "1";
        string_converter x(yytext+8);
        for (int i = 1; i <= x.argc(); i++ ) {
           //cerr << "ATTR:" << x[i] << endl;
           attribute p(x[i]);
	   if (p.matches("size")) { 
		display_size =(char*) p.value();
	   	f_size = (char*) p.value();
		}
           else if ( p.matches("level") ) { display_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
	   }
	   prline(yytext);
	   out << (old?"\nline {":"\nTextElement {") << lp();
	} else if (in_display > 1) {
	         out << uq(yytext) << "\" }" << endl;
		 prline(yytext);
		 out << (old?"line {":"TextElement {") << lp();
	}
	}

\n*"</display>" {
	if (in_display==1) {
		out << "\"} " << endl;
		prend(yytext);
		}
	else if (in_display > 1) { 
		out << "\" }" << endl;
		prline(yytext);
		if (old) out << "line { size " << f_size << " string \"" << yytext; 
		out << "TextElement { height " << f_size << " string \"" << yytext; 
		}
	level_display = 0;
	font_pop();
	in_display--;
	}

"<i>"|"<b>"|"<em>"|"<tt>" {
	yytext[yyleng-1] = '\0';
	int old_p = in_p;
	string c_style = (char*) f_style;
	string c_family = (char*) f_family;
	font_push();
	if (!strcmp(yytext+1,"i"))  {
		if (c_style == "BOLD") f_style = "BOLDITALIC";
		else f_style = "ITALIC";
		}
	else if (!strcmp(yytext+1,"b"))  {
		if (c_style == "ITALIC") f_style = "BOLDITALIC";
		else f_style ="BOLD";
		}
	else if (!strcmp(yytext+1,"em"))  {
		if (c_style == "ITALIC") f_style = "PLAIN";
		else if (c_style == "PLAIN") f_style = "ITALIC";
		else if (c_style == "BOLD") f_style = "BOLDITALIC";
		else if (c_style == "BOLDITALIC") f_style = "ITALIC";
		else f_style = "ITALIC";
		}
	else if (!strcmp(yytext+1,"tt"))  {
		f_family = "TYPEWRITER";	
	}
	out << "\" }" << endl;
	out << " ## " << yytext << " " << f_family << " " << f_style << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"TextElement {") << lp();
	in_p = old_p;
	}

"</i>"|"</b>"|"</em>"|"</tt>" { 
	int old_p = in_p;
	check(yytext);
	font_pop();
	out << " ## " << yytext << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"TextElement {") << lp();
	in_p = old_p;
	}


"<"{colors}">" {
if (!in_object) {
	yytext[yyleng-1]='\0';
	font_push();
	f_color = kleur(yytext+1); // (char*) *colors[yytext+1]; 
	int old_p = in_p;
	//if (1 || in_line || in_font > 0) out << "\" }" << endl;
	check(yytext); // AE
	out << " ## " << yytext << " " << f_color << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"TextElement {") << lp();
	in_p = old_p;
	in_font++;
	}
	}

"<font"{atts}">" { 
if (!in_object) {
	yytext[yyleng-1] = '\0';
        string_converter x(yytext+5);
	int old_p = in_p;
	string pv;
	//check();
	font_push();
        for (int i = 1; i <= x.argc(); i++ ) {
           attribute p(x[i]);
	   if (p.matches("size")) { f_size = p.value(); }
	   else if (p.matches("color")) { f_color = kleur(p.value()); }
	   else if (p.matches("family")) { f_family = p.value(); }
	   else if (p.matches("style")) { f_style = p.value(); }
	   else if (p.matches("size")) { f_size = p.value(); }
	}
	//if (1 || in_line || in_font > 0) out << "\" }" << endl;
	check(yytext); // AE
	out << " ## " << yytext << " " << f_color << " " << pv << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"TextElement {") << lp();
	in_p = old_p;
	in_font++;
	}
}

"</font>" {
if (!in_object) {
	int old_p = in_p;
	//cerr << ">>>" << yytext << " " << in_p << endl;
	check(yytext);
	font_pop();
	out << " ## " << yytext << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"TextElement {") << lp();
	in_p = old_p;
	in_font --;
	}
}

"</"{colors}">" {
if (!in_object) {
	int old_p = in_p;
	//cerr << ">>>" << yytext << " " << in_p << endl;
	check(yytext);
	font_pop();
	out << " ## " << yytext << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"TextElement {") << lp();
	in_p = old_p;
	in_font--;
	}
}

"<example"{atts}">" {
un_p();
if (in_display) { out << uq(yytext); }
else {
   yytext[yyleng-1] = '\0';
   int has_name = 0;
   int has_scale = 0;
   int has_trans = 0;
   int has_orient = 0;
   int has_src = 0;
   string scale = "1 1 1";
   string trans = "0 -1 4";
   string orient = "0 1 0 0";
   string sl_name = "X";
   string_converter x(yytext+8);
   for (int i = 1; i <= x.argc(); i++ ) {
       cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("scale") ) { has_scale = 1; scale = p.value(); }
           else if ( p.matches("trans") ) { has_trans = 1; trans = p.value(); }
           else if ( p.matches("translation") ) { has_trans = 1; trans = p.value(); }
           else if ( p.matches("orient") ) { has_orient = 1; orient = p.value(); }
           else if ( p.matches("name") ) { has_name = 1; sl_name = p.value(); }
           else if ( p.matches("src") ) { has_name = 1; sl_name = p.value(); }
           else if ( p.matches("id") ) { has_name = 1; sl_name = p.value(); }
           }
   if (0) {
   out << "EXAMPLE " << (char*) sl_name << "\n"
       // << "SCALE " << (char*) scale << "\n" 
       << "TRANSFORM " << (char*) trans << "\n"
       << "ORIENTATION " << (char*) orient << "\n"
       << "#@include Example.pre" << endl;
   } 
   if (1) {
     cerr << yytext<< ">" << endl;
     out << "vrmlblock { children [" << endl;
     out << "Transform {" << "\n"
	 << "translation " <<  (char*) trans << "\n"
	 << "scale " <<  (char*) scale << "\n"
	 << "rotation " <<  (char*) orient << "\n"
	 << "children  AnnotatedPillar { " << "\n"
	 << "radius 1 " << "\n"
	 << "height 1 " << "\n"
	 << "material  YellowMaterial {} " << "\n"
	 << "description  " << (char*) sl_name << "\n"
	 << "textBlock [ " << "\n";
     soinc((char*) sl_name,".pvl");
     out << "]  " << "\n"
	 << "infoParam targetwindow \n"
	 << "infoHref \"@tm-" << (char*) sl_name << ".html\"" << "\n"
	 << "children [ \n";
     soinc((char*) sl_name,".wrl");
     out << "]  " << "\n" << "} }" << endl;
     out << "] } # end vrmlblock " << endl;
     }
   }
}

"<scene"{atts}">"|"<slide"{atts}">" {
if (in_display) { out << uq(yytext); }
else {
   reset_level();
   font_push();
   //check(yytext);
   in_slide = 1;
   slideno ++;
   yytext[yyleng-1] = '\0';
   int has_src = 0;
   int has_trans = 0; string trans = "0 0 0";
   int has_size = 0; string size = "17 9";
   if (slideno == 1) has_trans = 1;
   //string scale = "SCALE";
   int has_width = 0; string width = "30";
   int has_height = 0; string height = "15";
   int has_loc=0; string loc = "0 0 0";
   int has_rot=0; string rot;
   int has_scale=0; string scale="1 1 1";
   if (old) scale="SCALE";
   string src = "";
   string_converter x(yytext+7);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("scale") ) { has_scale = 1; scale = p.value(); }
           else if ( p.matches("trans") ) { has_trans = 1; trans = p.value(); }
           else if ( p.matches("size") ) { has_size = 1; size = p.value(); }
           else if ( p.matches("loc") ) { has_loc = 1; loc = p.value(); }
           else if ( p.matches("location") ) { has_loc = 1; loc = p.value(); }
           else if ( p.matches("rot") ) { has_rot = 1; rot = p.value(); }
           else if ( p.matches("rotation") ) { has_rot = 1; rot = p.value(); }
           else if ( p.matches("width") ) { has_width = 1; width = p.value(); }
           else if ( p.matches("height") ) { has_height = 1; height = p.value(); }
           else if ( p.matches("level") ) { set_level(p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("src") ) { has_src = 1; src = p.value(); }
           }
   prbegin(yytext);
   out << "Slide { \n";
   if (old) out << "scale " << scale << "\n";
   if (old && has_trans) out << "translation " << trans << "\n";
   if (!old && has_width) out << "width " << width << " ";
   if (!old && has_height) out << "height " << height << " ";
   if (!old && has_scale) out << "scale " << scale << " ";
   if (!old && has_loc) out << "location " << loc << " ";
   if (!old && has_rot) out << "rotation " << rot << " ";
   if (old) out << "children [" << endl; 
   if (!old) out << "blocks [" << endl;
   if (has_src && pr) soinc((char*)src);
   }
}

"</slide>"|"</scene>" {
if (in_display) { out << yytext; }
else {
	//check(yytext);
	if (in_slide) out << "] } " << endl; in_slide = 0;
	prend(yytext);
	font_pop();
	}
}

"<li>"|"<li "{atts}">" {
if (in_display) { out << uq(yytext); }
else {
   un_p();
   set_level(); // AE
   in_li = 1;
   int is_simple = 0;
   if (yyleng==4) is_simple = 1;
   yytext[yyleng-1] = '\0';
   string url = "";
   int has_url = 0;
   old_size = (char*) f_size;
   old_justify = (char*) f_justify;
   string br = "FALSE";
   f_size = "1.0";
   string translation = "0 0 0";
   int has_symbol=1;
   if (list_type[in_list] == 1) has_symbol = 0;
   string symbol = "S";
   string nesting = "0";
   if (in_list == 2) {
	symbol = "C";
   	nesting = "2";
	f_size = "0.8";
   } else if (in_list == 3) {
	symbol = "P";
	nesting = "4";
	f_size = "0.6";
   	}
   //f_justify = "BEGIN";
   //if (centered) f_justify = "MIDDLE";
   //if (is_aligned) f_justify = (char*) align;
   string_converter x(yytext+3);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("size") ) { f_size = p.value(); }
           else if ( p.matches("translation") ) { translation = p.value(); }
           else if ( p.matches("level") ) { set_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("trans") ) { translation = p.value(); }
	   else if ( p.matches("url") ) { has_url = 1; url = p.value(); }
           else if ( p.matches("symbol") ) { has_symbol=1; symbol = p.value(); }
           else if ( p.matches("nesting") ) { nesting = p.value(); }
           }
   if (items[in_list]++ > 0) {
   //if (old) out << "\n break { size " << f_size << lp(2)  << "}\n";
   vspace(atof((char*)f_size),yytext);
   }
   prline(yytext);
   if (old && (has_url || in_link)) out << "a";
   out << (old?"line { ":"TextElement {");
       // << "translation " << (char*) translation << "\n";
   if (has_url) out << "href [ \"" << (char*) url << " ]\"\n";
   if (old && has_symbol) out << "symbol USE " << (char*) symbol << "\n";
   if (!old && has_symbol) out << " Bullet { } ";
   if (old) out << "nesting " << (char*) nesting << "\n";
   out << lp();
   if (list_type[in_list] == 1)
	out << items[in_list] << ".";
   }
}
"</li>" {
if (in_display) { out << uq(yytext); }
else {
	check(yytext);
	}
}

"<h"[0-9]">"|"<h"[0-9]" "{atts}">" {
if (0 && in_display) { out << uq(yytext); }
else {
   font_push();
   set_level();
   check(yytext); // AE
   in_header = 1;
   int level = 0;
   level = yytext[2] - '0';
   yytext[yyleng-1] = '\0';
   if (level == 1 ) {
   	f_size = "2.5";
   } else if (level == 2) {
   	f_size = "2.0";
   } else if (level == 3) {
   	f_size = "1.5";
   } else {
	f_size = "1.0";
   	}
   float f = levelsize[level];
   char buf[64]; sprintf(buf,"%f",f);
   f_size = (char*) buf;
   check_context("header",3,yytext,yyleng);
   out << "\n## " << yytext << endl;
   //if (old) out << " break { size 0.5 " << lp(2) << "}" << endl;
   vspace(0.5,yytext);
   prline(yytext);
   if (old && in_link) out << "a";
   out << (old?"line { ":"TextElement {"); 
   out << lp();
   }
}
"</h"[0-9]">" {
if (0 && in_display) { out << uq(yytext); }
else {
if (old) un_break = -0.2;
else un_break = (10-(yytext[3]-'0')) / 4; 
check(yytext);
font_pop();
in_header = 0;
in_right = 0;
if (in_display) { 
	prline(yytext);
	out << (old?"line {":"TextElement {") << lp(); }
//if (!in_display) { f_justify = "BEGIN"; }
}
}

"<channel"{atts}">" { begin_channel("text",8,yytext,yyleng); }
"</channel>" { end_channel(); }

"<vrmlblock"{atts}">" {
if (in_display) { out << uq(yytext); }
else {
   reset();
   yytext[yyleng-1] = '\0';
   string size = "17.0 9.0";
   string align = "BEGIN";
   string_converter x(yytext+6);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("size") ) { size = p.value(); }
           else if ( p.matches("level") ) { set_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("align") ) {
		is_aligned = 1;
	   	align = p.value();
		}
           }
        
      out << "vrmlblock { \n"
      << "children [ " << endl;
      }
}

"</vrmlblock>" {
if (in_display) { out << uq(yytext); }
else {
      check(yytext);
      out << "] } ## end text" << endl;
      is_aligned = 0;
      }
}

"<br>"|"<br "{atts}">"|"<break"{atts}">" {
if (0 && in_display) { out << uq(yytext); }
else {
   int old_p = in_p;
   check(yytext);
   in_p = old_p;
   yytext[yyleng-1] = '\0';
   string size = "0.5";
   int has_size = 0;
   int n = strlen(yytext);
   int m = 6;
   if (n > 5) {
    if ( yytext[3] == ' ' ) m = 3;
    string_converter x(yytext+6);
    for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("size") ) { has_size = 1; size = p.value(); }
           else if ( p.matches("level") ) { set_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           }
   }
   if (!in_display) { 
       if (old) out << "break { size " << (char*) size << lp(2) << " } ##" << yytext << endl;
       if (!old) vspace(atof(has_size?size:f_size),yytext);
       in_line = 0;
       if (in_p) { 
	     prline(yytext);
	     if (in_link && old) out << "a"; 
	     out << (old?"line {":"TextElement {") << lp(); }
   } else { out << (old?"line {":"TextElement {") << lp(); } 
   }
}
   
"<line"{atts}">" {
if (in_display) { out << uq(yytext); }
else {
   check(yytext);
   in_line = 1;
   yytext[yyleng-1] = '\0';
   old_size = (char*) f_size;
   old_justify = (char*) f_justify;
   string url = "";
   int has_url = 0;
   string translation = "0 0 0";
   int has_symbol=0;
   string symbol = "S";
   string nesting = "0";
   f_justify = "BEGIN";
   string br = "FALSE";
   string bgcolor; int has_bgcolor=0;
   string bgtrans; int has_bgtrans=0;
   if (centered) 
	f_justify = "MIDDLE";
   if (is_aligned)
   	f_justify = (char*) align;
   if (in_list == 2) {
        nesting = "2";
        f_size = "0.8";
   } else if (in_list == 3) {
        nesting = "4";
        f_size = "0.8";
   } else if (in_list == 4) {
        nesting = "6";
        f_size = "0.6";
        }                 
   string_converter x(yytext+6);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("size") ) { f_size = p.value(); }
           else if ( p.matches("translation") ) { translation = p.value(); }
           else if ( p.matches("trans") ) { translation = p.value(); }
           else if ( p.matches("url") ) { has_url = 1; url = p.value(); }
           else if ( p.matches("symbol") ) { has_symbol=1; symbol = p.value(); }
           else if ( p.matches("bgcolor") ) { has_bgcolor=1; bgcolor = p.value(); }
           else if ( p.matches("bgtrans") ) { has_bgtrans=1; bgtrans = p.value(); }
           else if ( p.matches("level") ) { set_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("nesting") ) { nesting = p.value(); }
           else if ( p.matches("justify") ) { f_justify = p.value(); }
           else if ( p.matches("br") ) { br = p.value(); }
           }
   prline(yytext);
   if (old && (has_url || in_link)) out << "a";
   out << (old?"line {":"TextElement {") << " ";
   if (old) out << "translation " << (char*) translation << "\n";
   if (has_url) out << "href " << (char*) url << "\n";
   if (has_symbol) out << "symbol USE " << (char*) symbol << "\n";
   if (old && has_bgcolor) {
	out << "backgroundColor " << (char*) bgcolor << "\n";
	if (!has_bgtrans)
		out << "backgroundTransparency " << 0 << "\n";
        if (has_bgtrans)
		out << "backgroundTransparency " << (char*) bgtrans << "\n";
   }
   if (old) out << "nesting " << (char*) nesting << "\n"
       << "br " << (char*) br << "\n";
   out << lp();
   }
}
   
"</line>" {
if (in_display) { out << yytext; }
else {
check(yytext);
//if (in_line) out << "\" } " << endl; in_line = 0; deprecated(yytext);
}
}


"<img"{atts}">"|"<image"{atts}">" {
if (in_display) { out << uq(yytext); }
else {
   int is_short = 0;
   if (yytext[3]=='g') is_short = 1;
   check(yytext);
   //if (in_line) out << "\" } " << endl;
   in_line = 1;
   yytext[yyleng-1] = '\0';
   old_size = (char*) f_size;
   old_justify = (char*) f_justify;
   string url = "";
   int has_url = 0;
   int has_src = 0;
   int has_name = 0;
   int has_width = 0;
   int has_height = 0;
   int has_size = 0;
   int has_length = 0;
   string translation = "0 0 0";
   int has_symbol=0;
   string symbol = "S";
   string nesting = "0";
   string size = "1";
   string length = "1";
   string width = "1";
   string height = "1";
   string src = "x.gif";
   string name = "x";
   f_justify = "BEGIN";
   string br = "FALSE";
   if (centered) 
	f_justify = "MIDDLE";
   if (is_aligned)
   	f_justify = (char*) align;
   if (in_list == 1) {
        nesting = "2";
        f_size = "0.8";
   } else if (in_list == 2) {
        nesting = "4";
        f_size = "0.8";
   } else if (in_list == 3) {
        nesting = "6";
        f_size = "0.6";
        }                 
   int nl = is_short?4:6; 
   string_converter x(yytext+nl);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("translation") ) { translation = p.value(); }
           else if ( p.matches("translation") ) { translation = p.value(); }
           else if ( p.matches("trans") ) { translation = p.value(); }
           else if ( p.matches("url") ) { has_url = 1; url = p.value(); }
           else if ( p.matches("width") ) { has_width = 1; width = p.value(); }
           else if ( p.matches("height") ) { has_height = 1; height = p.value(); }
           else if ( p.matches("length") ) { has_length = 1; length = p.value(); }
           else if ( p.matches("size") ) { has_size = 1; size = p.value(); }
           else if ( p.matches("src") ) { has_src = 1; src = p.value(); }
           else if ( p.matches("level") ) { set_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("name") ) { has_name = 1; name = p.value(); }
           else if ( p.matches("symbol") ) { has_symbol=1; symbol = p.value(); }
           else if ( p.matches("nesting") ) { nesting = p.value(); }
           else if ( p.matches("justify") ) { f_justify = p.value(); }
           else if ( p.matches("br") ) { br = p.value(); }
           }
   if (has_url || in_link) out << "a";
   out << "image { \n"
       << "translation " << (char*) translation << "\n";
   if (has_url)
       out << "href " << (char*) url << "\n";
   if (has_src)
       out << "imageUrl [ \"" << (char*) src << "\" ] \n";
   if (has_name)
       out << "imageUrl [ \"" << (char*) name << ".gif\" ] \n";
   if (has_size) out << "size " << (char*) size << "\n";
   if (has_length) out << "length " << (char*) length << "\n";
   if (has_width) out << "size " << (char*) width << "\n";
   if (has_height) out << "length " << (char*) height << "\n";
   if (has_symbol)
       out << "symbol USE " << (char*) symbol << "\n";
   out << "nesting " << (char*) nesting << "\n"
       << "br " << (char*) br << "\n"
       << lp(1);
   out << "}" << endl;
   in_line = 0;
   }
}
   
"</image>" {
//if (in_display) { out << yytext; }
//else {
//check(yytext);
//}
}


"<object"{atts}">" {
if (in_display) { out << uq(yytext); }
else {
   in_object++;
   check(yytext);
   //if (in_line) out << "\" } " << endl;
   string old_justify = (char*) f_justify;
   in_line = 0;
   old_p = in_p;
   in_p = 0;
   yytext[yyleng-1] = '\0';
   old_size = (char*) f_size;
   string url = "";
   int has_url = 0;
   string translation = "0 0 0";
   string scale = "1 1 1";
   int has_symbol=0;
   int has_scale=0;
   string symbol = "S";
   string nesting = "0";
   //f_justify = "BEGIN";
   string br = "FALSE";
   if (centered) 
	f_justify = "MIDDLE";
   if (is_aligned)
   	f_justify = (char*) align;
   if (in_list == 1) {
        nesting = "2";
        f_size = "0.8";
   } else if (in_list == 2) {
        nesting = "4";
        f_size = "0.8";
   } else if (in_list == 3) {
        nesting = "6";
        f_size = "0.6";
        }                 
   string_converter x(yytext+7);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("size") ) { f_size = p.value(); }
           else if ( p.matches("translation") ) { translation = p.value(); }
           else if ( p.matches("trans") ) { translation = p.value(); }
           else if ( p.matches("scale") ) { has_scale = 1; scale = p.value(); }
           else if ( p.matches("url") ) { has_url = 1; url = p.value(); }
           else if ( p.matches("symbol") ) { has_symbol=1; symbol = p.value(); }
           else if ( p.matches("nesting") ) { nesting = p.value(); }
           else if ( p.matches("justify") ) { f_justify = p.value(); }
           else if ( p.matches("level") ) { set_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
           else if ( p.matches("br") ) { br = p.value(); }
           }
   out << "##nol++" << endl;
   if (has_url || in_link) out << "a";
   out << "object { \n"
       << "translation " << (char*) translation << "\n";
   if (has_scale)
       out << "scale " << (char*) scale << "\n";
   if (has_url)
       out << "href " << (char*) url << "\n";
   out  << lp(1);
   f_justify = old_justify;
   in_line = 0;
   out << " children [ " << endl;
   }
}
   
"</object>" {
if (in_display) { out << yytext; }
else {
out << "] } " << endl;
in_line = 0; 
out << "##nol--" << endl;
in_p = 0; // old_p;
//out << "line {" << lp() << "## end object" << endl;
in_object--;
}
}

"#@" { out << yytext; }
\#\#\@.* { ; }
"<so "{names}">" { yytext[yyleng-1]='\0'; if (pr) files(yytext+4,ext); }
"<cd "{names}">" { yytext[yyleng-1]='\0'; if (pr) directories(yytext+4,ext); }
"@so "{names}/\n { if (pr) files(yytext+4,ext); }
"@include "{names}/\n { if (pr) files(yytext+9,""); }
"@slide "{names}/\n {
	if (!bk_mode) { out << "Slide { scale SCALE\n children [ " << endl; }
	if (pr) files(yytext+7,"");
	if (!bk_mode) { out << " ]}" << endl; }
	}
"@inline "{names}/\n {
	if (!bk_mode) { out << "Slide { scale SCALE\n children [ " << endl; }
	out << "Inline { url [ " <<  yytext+8 << " ]}";
	if (!bk_mode) out << " ]}" << endl;
	}
"@cd "{names}/(\n) { if (pr) directories(yytext+4,ext); }


"<include "{atts}">" {
   int choice = 0;
   yytext[yyleng-1] = '\0';
   string dir = "";
   string ext = "";
   string file = "@temp";
   string cmd = "";
   string_converter x(yytext+8);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("file") ) { 
			if ((choice !=3) && (choice!=2)) choice = 1;
			file = p.value();
			}
           if ( p.matches("src") ) { choice = 1; file = p.value(); }
           if ( p.matches("files") ) { choice = 1; file = p.value(); }
           if ( p.matches("dir") ) { choice = 2; dir = p.value(); }
           if ( p.matches("dirs") ) { choice = 2; dir = p.value(); }
           if ( p.matches("ext") ) { ext = p.value(); }
           if ( p.matches("cmd") ) { choice = 3; cmd = p.value(); }
           }
   if (choice == 0) file = yytext+9;
   if (choice == 2 && !strcmp(ext,"")) ext = ::ext;
   //cerr << "FILE:" << file << " EXT:" << (char*) ext << endl;
   if (choice==2) directories(dir,ext,file); 
   else if(choice==3) {
		char buf[BUFSIZ];
		sprintf(buf,"%s > %s",(char*)cmd,(char*)file);
		system(buf); 
		if (pr) files(file,"");
		}
   else if (pr) files(file,ext);
   }

[ \t] { out << yytext; }
\n|\n[ ][ ]\n|\n[ ][ ]\n[ ][ ]\n|\n[ ][ ]\n[ ][ ]\n[ ][ ]\n { 
	if (in_channel > 0) {
	int x = strlen(yytext);
	int n = 1;
        if (x == 4) n = 2;
	else if (x == 7) n = 3;
	else if (x == 10) n = 4;
	//if ( (in_display) || in_line || in_p) out << "\" } ## n " << endl; 
	//if ( (in_display) || in_line ) out << "\" } ## n " << endl; 
	//in_line = 0;
	if (!in_line) out << endl;
	check("newline");
	if (do_pop) { font_pop(); do_pop=0; } 
	if (in_p) {
		prline("newline -- in_p");
		if (in_link && old) out << "a";
		out << (old?"line {":"TextElement {") << lp(); 
	} else if (in_display) { 
		if (level_display && !empty_line) set_start("++"); // AE
		for (int i=1; i <= n; i++)
		//if (old) out << "break { size " << xsize(0.8) << lp(2) << " } ## n" << endl;
		vspace(atof(xsize(0.8)),"newline");
		prline("newline -- in_display");
		if (in_link && old) out << "a";
		out << (old?"line {":"TextElement {") << lp(); 
		}
	//in_li = in_line = 0;
	//out << endl;
	empty_line = 0;
	} else out << endl;
}
. { ECHO; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
context0 = new context();
ctx = new context(context0);
list_level[0] = auto_level;
colors["red"] = new string( "1 0 0");
colors["blue"] =  new string("0 0 1");
colors["yellow"] = new string( "1 1 0");
colors["orange"] = new string( "1 0.7 0");
colors["green"] = new string( "0 1 1");
colors["black"] = new string( "0 0 0");
colors["white"] = new string( "1 1 1");
colors["silver"] = new string( "0.8 0.8 0.8");
colors["gold"] = new string( "0.9 0.9 0");
//f_color="1 1 1";
//linkcolor="1 1 0";
//align = "BEGIN";
strcpy(name,"temp");
int _argc = 0;
argc--; argv++;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( argv[0][1] == 'N'  ) {
	     strcpy(name,argv[0]+2);
	} else if ( argv[0][1] == 'e'  ) {
	     es_mode=1;
	} else if ( argv[0][1] == 'p'  ) {
	     pvl_mode=1;
	} else if ( argv[0][1] == 'o'  ) {
	     old=1;
	} else if ( argv[0][1] == 'b'  ) {
	     bk_mode = 1;
	} else if ( argv[0][1] == 'x'  ) {
	     x_mode = 1;
	} else if ( argv[0][1] == 'S'  ) {
	     no_style = 1;
	} else if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
	argc--; argv++;
	}

l.paths(_argc, _argv);
pr = 1;
out << "#VRML V2.0 utf8                ##  " << name <<  endl; 
if (pvl_mode && !es_mode && !no_style) { 
  if (old) l.soinc("style.wrl"); 
  else {
	out << "\n#@search @proto/pvl-2.0" << endl;
	}
  }
if (pvl_mode && !es_mode) {
  out << "#@include SlideBegin.wrl" << endl;
}
if ( argc == 0 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
check("main");
if (pvl_mode && !es_mode) {
  out << "#@include SlideEnd.wrl" << endl;
  }
return 0;
}
//</>
