#include <hush/session.h>
#include <hush/io.h>


#ifndef CREATE_I
#define CREATE_I

#ifndef CLASS
#define CLASS TYPE
#endif

#ifndef ANCESTOR
#define ANCESTOR TYPE
#endif

#ifndef OPTS
#define OPTS 0 /*AE: was opts */
#endif

#ifndef CTX
#define CTX ctx
#endif

#ifndef INIT
#define INIT if (opts && *opts != '*') init(opts); 
#endif

#ifndef DEFAULT
#define DEFAULT
#endif

#ifndef CONSTRUCTOR
#define CONSTRUCTOR
#endif

#ifndef DESTRUCTOR
#define DESTRUCTOR
#endif

char* CLASS::category() const { return "tk"; }

#ifndef DONTINITIALIZE
#ifndef INITIALIZE
#define INITIALIZE
#endif
#endif

#ifdef INITIALIZE
TYPE* CLASS::_default = 0;
int CLASS::initialized = 0;

int CLASS::initialize() {
	if (CLASS::initialized) return 1;
	else {
		TYPE* h = new CLASS;
		session* s = session::_default;
		if (s)
			s->_register(h);
		else h->_error("no session");
		TYPE::_default = h;
		CLASS::_default = h; 
		tk_widget::_default->_resource(h->type(),h); 
		CLASS::initialized = 1;
		INITIALIZE;
		}
	return 1;
}
#endif

CLASS::CLASS() { DEFAULT;; }

CLASS::CLASS(const char* p, const char* opts, TYPE* ctx)
				: ANCESTOR(p,OPTS,CTX) {
	CONSTRUCTOR; INIT;
	}

CLASS::CLASS(const widget* w, const char* p, const char* opts,
				TYPE* ctx) : ANCESTOR(w,p,OPTS,CTX) {
	CONSTRUCTOR; INIT;
	}


widget* CLASS::_create(const char* p, const char* opts, widget* ctx) {
	return new CLASS(p,opts,(TYPE*)ctx);
	}

widget* CLASS::_create(const widget* w, const char* p,
			const char* opts, widget* ctx) {
	return new CLASS(w,p,opts,(TYPE*)ctx);
	}

CLASS::~CLASS() { DESTRUCTOR; }

#undef CTX

#endif
