//@ scene.c -- I like scenes, I make them myself
// See scene(4), issues(4), <hush/scene.h>.

#include <hush/source.h>

#include <hush/scene.h>
#include <hush/agent/loader.h>
#include <hush/query.h>
//#include <varargs.h>
//#include <tchar.h>
#include <string.h>

#define scene dvscene


//#include <iostream.h>
#include <stdio.h>

#ifndef menu
#define menu dvmenu
#endif

scene* thescene() { return 0; /* scene::_default; */ }

scene* scene::_default = 0;
void* scene::_create = 0;

typedef scene* (*createf)(char*);
#define CREATE (scene*) ((createf)scene::_create)




void scene::set_default(scene* x) { _default = x; }
scene* scene::get_default() { return _default; }

char scene::__drive[256] = "d:";
char* scene::_drive(char* x) {
	char* tmp = __drive; if (x) strcpy(__drive,x); return tmp; 
}


char scene::__cache[256] = "d:/vip/cache";
char* scene::_cache(char* x) {
	char* tmp = __cache; if (x) strcpy(__cache,x); return tmp; 
}

char scene::__log[256] = "empty";
char* scene::_log(char* x) {
	char* tmp = __log; if (x) strcpy(__log,x); return tmp; 
}

static
scene* a_new_scene( const char* mode ) {
        scene* tk =  scene::_default;
	    if (!tk) tk = scene::lookup(mode);
        if (!tk) tk = scene::lookup("tk");
        if (!tk) tk = scene::lookup("tcl");
        if (!tk) tk = scene::lookup("hush");
        if (!tk) tk = scene::lookup("global");
	else tk = scene::_default;
        return tk;
        }

#define TYPE scene
//#define TABLE handlers
#include "hush/sys/table.i"


//query* scene::__tk = 0;
//query* scene::tk(query* x) { query* tmp = __tk; if (x) __tk = x; return tmp; }

scene::scene(scene*)
     // : event(0) 
     { scene::created++; _mode=0;}
scene::scene(const char* x) { 
	 _mode=0;
     //if (!scene::_create) scene::_create = (void*) a_new_scene;
	 //_scene = CREATE((char*)x);
	// _tk = scene::tk();
	 _scene = 0;
	 scene::created++;
	 }

scene::~scene() { 
	scene::deleted++;
	}

// scene (proper

#define S_OK 0

   HRESULT scene::init(IDirect3DDevice9* device) { return _scene?_scene->init(device):S_OK; }
   HRESULT scene::restore(IDirect3DDevice9* device) { return _scene?_scene->restore(device):S_OK; }
   HRESULT scene::compose(IDirect3DDevice9* device, DWORD t) { return _scene?_scene->compose(device,t):S_OK; }

   HRESULT scene::render_begin(IDirect3DDevice9* device) { return _scene?_scene->render_begin(device):S_OK; }
   HRESULT scene::render_end(IDirect3DDevice9* device) { return _scene?_scene->render_end(device):S_OK; }


   HRESULT scene::render(IDirect3DDevice9*  device,
                               IDirect3DTexture9* texture ) { return _scene?_scene->render(device,texture):S_OK; }


// loader

int scene::load(const char* lib) {
	string s = lib;
	s.split(":");
        string* p = 0;
	iter<string>& it = s;
	loader l;
	while ( (p = it()) ) {
		l.load(*p);
		}
	return 1;
	}

scene* scene::check(const char* kind) {
	scene* __scene = 0;
	string s = kind;
	s.split(":");
        string* p = 0;
	iter<string>& it = s;
	while ( !__scene && (p = it()) ) {
	        char* k = (char*) *p;
		load(k);
		__scene = scene::lookup(k);
		}
	return __scene;
	}



// evaluation -- tcl/tk (basically)


void scene::option(const char* k, const char* v) {
	if (_scene) _scene->option(k,v);
	else handler::option(k,v);
	}


void scene::ioption(const char* k, const int v) {
	char buf[64];
	sprintf(buf,"%d",v);
	option(k,buf);
	}

void scene::foption(const char* k, const float v) {
	char buf[64];
	sprintf(buf,"%f",v);
	option(k,buf);
	}

void scene::poption(const char* k, const void* v) {
	char buf[64];
	sprintf(buf,"%d",v);
	option(k,buf);
	}



char* scene::option(const char* k) {
	return _scene?_scene->option(k):handler::option(k);
	}


int scene::ioption(const char* k) {
	int r = 0;
	char* x = option(k);
	if (x) { sscanf(x,"%d",&r); }
	return r;
}
float scene::foption(const char* k) {
	float r = 0;
	char* x = option(k);
	if (x) { sscanf(x,"%f",&r); }
	return r;
}

void* scene::poption(const char* k) {
	int r = ioption(k);
	return (void*) r;
}

void scene::process(char* x) {  options(x);  }
void scene::options(char* x) {  if (_scene) _scene->options(x);  }

#undef event
void scene::process(event* e) {  if (_scene) _scene->process(e);  }


int scene::mode() const { return _scene?_scene->mode():_mode; }
int scene::mode(int m) { 
	        if (_scene)  return _scene->mode(m);
		int tmp = _mode; _mode = m; return tmp;
		}
	

//// Experimental -- role switching



scene* scene::become(char* s, scene* k) {
	if (s && k); //Wall
	;//AE err() << "NYET : scene::become " << s << " " << k << endl;
	return _scene;
	}

void scene::restore(scene* k) {
	if (k); //Wall
	//err() << "NYET : scene::restore " << k << endl;
	}


