#ifndef SCENE_H
#define SCENE_H


#include <hush/export.h>

#include <hush/event.h>
#include <hush/sim/entity.h>

#ifndef PTCHAR
#define PTCHAR TCHAR*
#endif

typedef long HRESULT;
typedef unsigned long DWORD;
struct IMediaSample;
struct IDirect3DDevice9;
struct IDirect3DTexture9;


#ifndef scene
#define scene dvscene
#endif

//class query;

class HUSH_API scene
	: public entity {
	//: public event {

public:




scene(const char* = "");
scene(scene*);
virtual ~scene();

	static char __drive[256];
	static char* _drive(char* x = 0);

	static char __cache[256];
	static char* _cache(char* x = 0);
	//static char* loc(char* x);

	static char __log[256];
	static char* _log(char* x = 0);


    virtual HRESULT init(IDirect3DDevice9* device);
    virtual HRESULT restore(IDirect3DDevice9* device);
	virtual HRESULT compose(IDirect3DDevice9* device, DWORD t);

	virtual HRESULT render_begin(IDirect3DDevice9* device);
	virtual HRESULT render_end(IDirect3DDevice9* device);


    virtual HRESULT render(IDirect3DDevice9*  device,
                               IDirect3DTexture9* texture );

public: //@ experimental

virtual int mode(int fl);
virtual int mode() const;

public: //@ scene management

virtual int load(const char* libs);
virtual scene* check(const char* kind);


public: //@ options

virtual void options(char* x);

virtual void process(char* x);
virtual void process(event* e);

virtual void option(const char* k, const char* v);
virtual void ioption(const char* k, const int v);
virtual void foption(const char* k, const float v);
virtual void poption(const char* k, const void* v);


virtual char* option(const char* k);

int ioption(const char* k);
float foption(const char* k);
void* poption(const char* k);


// Experimental -- role switching

scene* become(char* s, scene* k = 0);
void restore(scene* k = 0);

private:
int _mode;
scene* _scene;

//<hr>

public: //@ defaults

static scene* _default;
static void* _create;

static void set_default(scene* x);// { _default = x; }
static scene* get_default();// { return _default; }

static int created;
static int deleted;

static void* table;
static void declare(const char*, void*, int flag = 0);
static scene* lookup(const char*);
static void destroy();

};


extern HUSH_API scene* thescene();
#undef scene
#endif
