include resource.mk

## component = hush

x-test:
	echo SHARE=$(SHARE) 
	echo hush-share=`hush-share`

ext = .o
##ext = .obj

component = hush
packages = java-*.cpp
objects = `ls $(component)-*.cpp $(packages) | sed -e "s:\.cpp:$(ext):g"`
library = lib$(component)

java-home = /home/eliens/hush/java/jdk
java-flags = -I$(java-home)/include -I$(java-home)/include/`hush-platform` -DJAVA

purge = 

component-cflags = -DHUSH $(java-flags) -DREGEX -UNOLIST -DDL_ENABLED \
		   -DINSTALLED="\"`hush-lib-platform`\"" -DBIN="\"\""
component-ldflags = 

make = $(MAKE) -f $(component).mk

##

all: purge compile link install

CFLAGS = $(component-cflags) -I../include -DVERSION="\"hush-4.0\""
LDFLAGS = $(component-ldflags) -L../lib -lsocket -lnsl -ldl

purge:; rm -f $(purge)

compile:; $(make) $(objects)

link:; $(LD) -o $(library).so $(objects) $(LDFLAGS)

static:; $(AR) $(library).a $(objects)

install:
	cp $(library).so `hush-lib-platform`
	cp $(library).so `hush-share`/lib


clean:; rm -f $(library).* $(component)*.o
