/*----------------------------------------------------------------------------*/
/*                                                                            */
/*  Copyright (c) 1999 by                                               */
/*  blaxxun interactive Inc, San Francisco, Califoria, USA                    */
/*  All rights reserved                                                       */
/*                                                                            */
/*  This software is furnished under a license  and may be  used and  copied  */
/*  only in  accordance of the  terms of such license and with the inclusion  */
/*  of the above copyright notice.  This software or any other copies therof  */
/*  may not be provided or otherwise made available to any other person.  No  */
/*  title to and ownership of the software is hereby transferred.             */
/*                                                                            */
/*  The information in this software is subject to change without notice and  */
/*  should not be construed as a commitment by blaxxun interactive Inc.       */
/*                                                                            */
/*----------------------------------------------------------------------------*/

    #include <string.h> 
    #include "agentapi.h"  
    //#include "iostream.h"
#ifdef HUSH
    #include <hush/hush.h>
    #include <hush/query.h>
#endif

    static char outputBuf[512];

    //static query* _query;

#ifdef HUSH
    //#include "simple.c"
#endif

    // Constructor
    AgentApi::AgentApi( CSHandle_t sessionHdl ) : hbAPI( sessionHdl )
    {
        int rc;
            
        // here we register the function we want to call from within the
        // blaxxun Agent script.       
        //rc = registerFunc( "testFunction", ( hbFuncType ) &AgentApi::testFunction );
        rc = registerFunc( "agent", ( hbFuncType) &( AgentApi::agentFunction ));
        if ( rc != 0 )
        {
             writeLog( "Error: register agent function failed\n" );
        }
	writeLog("RIF: Agent started\n");
    }

    // Destructor
    AgentApi::~AgentApi()
    { 
        // nothing to do in our example
    }

    //
    // Returns the name of our class.
    //
    const char * AgentApi::className() const
    {
        return "AgentApi";
    }

    //
    //  This is the entry point function for blaxxun Agent.
    //  It is called for each blaxxun Agent script session.
    //  This function creates an instance of the current blaxxun Agent API class.
    //  You can create an instance of your class for special sessions only, if you need.
    //  Do this by checking the session name.
    //
    CSB_EXPORT hbAPI * createInstance( CSHandle_t sessionHdl, const char *name )
    {
        hbInitAPISession();
        if ( name != ( char * ) 0 )
        {
           return new AgentApi( sessionHdl );
        }

        return 0;
    }

    // This is the function which can be called by the blaxxun Agent script
    // in a  *Call* action or %%Call%% clause.
    //
    // The input parameter "input" must not be modified by this function.
    // The result returned is a string which also can be a null pointer.
    // If the result string is not null, it is immediately copied into 
    // blaxxun Agent memory.
    //
    // This function has to make sure to free memory allocated for the
    // result strings or pass pointers to static memory as result 
    //

    char * AgentApi::testFunction( const char * input )
    {
        if ( ! input || !strlen(input) ) 
        { 
            writeLog( "testFunction called without parameter\n" );
            strcpy ( outputBuf, "testFunction: called without parameter" );
            return outputBuf;
        }
        else
        {
            writeLog( "testFunction called with <%s>\n", input );
            strcpy ( outputBuf, "testFunction called with :" );
            strcat ( outputBuf, input );
            return outputBuf;
        }
    }

    char * AgentApi::agentFunction( const char * input )
    {
	static int n = 0;
	char* x = 0;
#ifdef HUSH
	static query* _query = 0;
	if (!_query) _query = new query("kit=pl");
	if (!x) x = _query->evaluate("X:member(X,[1])");
		//cerr << "query succeeded" << endl;
#endif
	//cerr << "starting main" << endl;
	//--simple_main();
	//cerr << "ending main" << endl;
        writeLog( "RIF (%d): agent called with <%s>\n",++n, input );
	//return "OK";

        if ( ! input || !strlen(input) ) 
        { 
            writeLog( "agent called without parameter\n" );
            strcpy ( outputBuf, "agent: called without parameter" );
	    strcat ( outputBuf, x?x:" ");
            return outputBuf;
        }
        else
        {
            writeLog( "agent called with <%s>\n", input );
            sprintf ( outputBuf, "%d: agent(TM) called with :",n );
            strcat ( outputBuf, input );
	    strcat ( outputBuf, " ");
	    strcat ( outputBuf, x?x:" ");
            writeLog( "agent responds with <%s>\n", outputBuf );
            return outputBuf;
        }
    }
