#include <hush/source.h>

#include <hush/agent/broker.h>
#include <hush/io.h>

broker* broker::_default = 0;

#define TYPE broker
#include <hush/sys/table.i>

broker::broker() {
	_broker = 0; 
	}

broker::broker(int& argc, char**& argv, int fl) {
	_broker = 0;
	init(argc,argv,fl);
	}

void broker::init(int& argc, char**& argv, int fl) {
if (!_broker) {
	kit* tk = 0;
	if (!tk) {
		tk = new kit();
		_register(tk);
		}
	
	tk->load("orb");
	_broker = broker::lookup("orb");
	if (!_broker) {
	     cerr << "broker::broker looking for orb" << endl; 
	     _broker = broker::lookup("broker");
	     if (_broker) {
	        cerr << "broker::broker creating orb" << endl; 
		_broker = _broker->create(argc,argv,fl);
		broker::declare("orb",_broker);
		broker::_default = this;
	        cerr << "broker::broker created orb" << endl; 
	     } else 
		cerr << "broker::broker no orb found" << endl;
	 } else
		cerr << "broker::broker orb found" << endl;
                _broker->init(argc,argv,fl);
	}
}

broker::~broker() {
	}

broker* broker::create(int& argc, char**& argv, int fl) { 
	cerr << "broker::create should not occur" << endl;
	if (_broker) return _broker->create(argc,argv,fl);
	else return 0;
	}

char* broker::category() const { return "broker"; }

char* broker::ref(void* x) {
	return _broker?_broker->ref(x):0;
	}
void* broker::object(char* url) { 
	return _broker?_broker->object(url):0;
	}


int broker::operator()() {
	if (_broker) return _broker->operator()();
	else return -1;
	}

void* broker::orb() { return 0; }
void* broker::boa() { return 0; }
