#include <hush/source.h>
#include <hush/agent/event.h>

#include <stdio.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>

#ifdef WIN32
#include <string.h>
static int index(const char* s, char c) {
	int l = strlen(s);
	for(int i = 0; i < l; i++) {
		if (*s++ == c) return i;
		i++;
		}
	return -1;
	}
#else
#include <strings.h>
#endif


//// event

query_event::query_event(
		kit* k,
		const char* name,
		const char* box,
		const char* args,
		const char* info) : event(this) {
	if (k) tk = k;
	_full = 0;
	_argc = 0;
	option("handler",name);
	option("box",box);
	if (info) option("info",info);
        _full = index(name,':')?1:0;
	if (!_full) _full = index(name,'_')?1:0;
	_ask = (char*) args;
	_tell = 0;
	if (_full) {
	string_converter x(unquote(args));
	int in_args = 0; 
        for (int i = 1; i <= x.argc(); i++ ) {
		int iskey = index(x[i],'=')?1:0;
		if (iskey) {
		    // cerr << "pl: " <<  x[i] << endl;
        	attribute p(x[i]);
			//cerr << "event: " << p.key() << "--" << p.value() << endl;
		if (!strcmp((char*)p.key(),"method")) {
			option("0",p.value());
			in_args = 1;
			}
		else if (!strcmp((char*)p.key(),"1")) {
			if (!option("method")) {
				option("method",option("handler"));
				_argc = 1;
				}
			in_args = 1;
			}
        	if (p.key()) 
			option((char*)p.key(),(char*)unquote(p.value()));
		if (in_args) _argc++;
		} else {
			;// don't bother 
			}
		}
	} else {  // !_full
		_argc = 2;
	}
	_argc = 0; while( arg(_argc) ) _argc++;
	}

query_event::query_event(void*) : event(this) {
	}

char* query_event::name() const { return "query_event"; }

query_event::~query_event() { }

int query_event::type() const { return _type; }
int query_event::eventclass() const { return 2001; } // AE
int query_event::argc() const { return _argc; }
char* query_event::arg(int i  ) const { 
	if (!_full) {
		if (i==0) return ((event*)this)->option("handler");
		else if (i==1) return ((event*)this)->ask();
		else return 0;
	}
	char buf[8]; 
	sprintf(buf,"%d",i);
	return ((query_event*)this)->option(buf);
	}

char* query_event::ask() { return _ask; }
//void query_event::tell(const char* msg) { _tell = (char*) msg; }
void query_event::tell(const char* msg) { strcpy(__tell,msg); _tell = (char*) __tell; }

char** query_event::argv(int ) const {
	cerr << "Warning:  query_event::argv obsolete" << endl;
	return  (char**) 0;
	} 

event* query_event::get() const { return (event*) this; }
void* query_event::rawevent() { return 0; }
