#include <hush/source.h>
#include <hush/agent/loader.h>

#include <hush/sys/dlfcn.h>

#include <hush/io.h>
#include <stdio.h>
#include <ctype.h>

//#ifndef INSTALLED
#ifdef WIN32
//#define INSTALLED "d:/hush/bin"
#define INSTALLED "d:\\vip\\bin"
#else
#define INSTALLED "/home/eliens/hush/hush-4.0/lib/solaris"
#endif
//#endif

loader* loader::_default = 0;

#define TYPE loader
#include <hush/sys/table.i>

loader::loader(const char* kind) {
	_loader = 0;
	if (kind)
	    _loader = loader::lookup(kind);
	}


static int separator(char c) {
        return c == '/' || c == '~' || c == ':';
        }

static char* strip(char* s) {
char *b = s;
char *p = b;
         while (*p != '\0') p++;
         p--; while ( p != b && !separator(*p) ) p--;
         if ( p != b ) p++;
         return p;
         }


static char* at( char* n ) { return (n[0] == '@')? n+1:n; }

int loader::load(const char* name, const char* call, int flag) {
//#ifndef DL_ENABLED
  //      cerr << "Sorry cannot do dynamic loading for " << name
	//     << " on this platform" << endl;
//	return 0;
//#else
#ifdef WIN32
	char* ext=".dll";
#else
	char* ext=".so";
#endif
	if (_loader) return _loader->load(name,call,flag);
	if (!name) {
		cerr << "Error: Cannot load from 0 " << endl; 
		return 0;
		}
	if (marked(name)) {
		//cerr << "Loader: " << name << " already loaded" << endl;
		return 0;
		}
	else mark(name);
	char* aliass= alias(name);
	if (aliass) name = aliass;
	void* handle;
	function fptr;
	char key[512]; strcpy(key,name); // AE use dictionary!
	char* lib = flag?key:strip(key);
	char* fun = (char*) (call?call:lib);
	char buf[1024];
	sprintf(buf,"%s%s",lib,flag?"":ext);        // name v name.so
	cerr << "Opening (load) " << buf << endl;
    handle = hush_dlopen(buf);
	//handle = hush_dlopen("dv-pl.dll");
	//if (handle) cerr << "OK 1" << endl;
	//else cerr << "NO" << endl;
	if (!flag && !handle) {
		sprintf(buf,"dv-%s%s",lib,ext);        // libdvname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"vip-%s%s",lib,ext);        // libdvname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"libdv-%s%s",lib,ext);        // libdvname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"libdv%s%s",lib,ext);        // libdvname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"lib%s%s",lib,ext);        // libname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"%s\\dv-%s%s",INSTALLED,lib,ext);          //libname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"%s/%s%s",INSTALLED,lib,ext);          //libname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"%s/libdv-%s%s",INSTALLED,lib,ext);          //libname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"%s/libdv-%s%s",INSTALLED,lib,ext);          //libname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"%s/libdv%s%s",INSTALLED,lib,ext);          //libname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"%s/lib%s%s",INSTALLED,lib,ext);          //libname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"%s%s",lib,ext);          //libname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"lib%s%s",lib,ext);          //libname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!flag && !handle) {
		sprintf(buf,"%s%s",lib,ext);          //libname.so
		cerr << "Trying  (load) " << buf << endl;
        	handle = hush_dlopen(buf);
		}
	if (!handle) {
		cerr << "Warning: Couldn t load " << buf << endl;
		return 0;
		}
	if (handle) {
		cerr << "got handle:" << endl; 
	  fun = at(strip(fun)); // strip and remove @
	  sprintf(buf,"load_%s",fun);
	  cerr << "Calling (load) " << buf << endl;
	  fptr = (function) hush_dlsym(handle,buf);
	  if (!fptr) {
	  	sprintf(buf,"load_%s",fun);
	  	cerr << "Calling (load) " << buf << endl;
	  	fptr = (function) hush_dlsym(handle,buf);
		}
	  if (!fptr) {
	  	sprintf(buf,"init_%s",fun);
	  	cerr << "Calling (load) " << buf << endl;
	  	fptr = (function) hush_dlsym(handle,buf);
		}
	  if (!fptr) {
	  	sprintf(buf,"Init_%c%s",toupper(*fun),fun+1);
	  	cerr << "Calling (load) " << buf << endl;
	  	fptr = (function) hush_dlsym(handle,buf);
		}
	  if (fptr) return (*fptr)();
	  else cerr << "Warning: Failed calling " << buf << " " << endl;
	  return 0;
	}
//#endif // !DL_ENABLED
return 0;
}
