#include <hush/source.h>
#include <hush/agent/locator.h>
#include <hush/dictionary.h>
#include <hush/string.h>


locator* locator::_default = 0;

#define TYPE locator
#include <hush/sys/table.i>

#define ALIAS ((dictionary<string>*)_alias)
#define MARKED  ((dictionary<string>*)_marked)

locator::locator(const char* kind) {
	_locator = 0; _alias = 0; _marked = 0;
	if (kind) _locator = locator::lookup(kind);
	}

void locator::alias(const char* k, const char* v) {
if (_locator) _locator->alias(k,v);
else {
	if ((!k) || (!v) ) cerr << "ERROR: locator::alias" << endl;
	else {
	   if (!ALIAS) {
		_alias = new dictionary<string>(1); // auto on
		_register(ALIAS);
		}
	   (*ALIAS)[k] = new string(v);
	   }
	}
}

char* locator::alias(const char* k) {
	if (_locator) return _locator->alias(k);
	if (!k || !ALIAS) return 0;
	else if (ALIAS) {
		string* p = (*ALIAS)[k];
		if (p) return (char*) *p;
		else return 0;
		}
	else return 0;
	}

void locator::mark(const char* k, const char* v) {
if (_locator) _locator->mark(k,v);
else {
	if (!k) cerr << "ERROR: locator::mark" << endl;
	else {
	   if (!MARKED) {
		_marked = new dictionary<string>(1); // auto on
		_register(MARKED);
		}
	   (*MARKED)[k] = new string(v);
	   }
	}
}

char* locator::marked(const char* k) {
	if (_locator) return _locator->marked(k);
	if (!k || !MARKED) return 0;
	else if (MARKED) {
		string* p = (*MARKED)[k];
		if (p) return (char*) *p;
		else return 0;
		}
	else return 0;
	}


