#include <hush/source.h>
#include <hush/agent/object.h>
#include <hush/session.h>
#include <hush/kit.h>
#include <hush/event.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int object_handler::_initialized = 0;
dictionary<handler>* object_handler::_objects = 0;


int object_handler::initialize() {
	if (!object_handler::_initialized) {
		object_handler::_initialized = 1;
		object_handler::_objects = new dictionary<handler>;
		handler* h = new object_handler;
		h->_register(object_handler::_objects);
		handler::declare("object",h);
		//session::_default->_register(h);
		return 1;
	} else return 1;
	}

object_handler::object_handler(kit* q, char* name) {
	if (name) {
		_category = new char[strlen(name)+1];
		_register(_category);
		strcpy(_category,name);
	} else _category = 0;
	_kit = q;
	object_handler::initialize();
	if (_kit) {
		_kit->bind(category(),this);
		_kit->_register(this);
	} else {
		if (session::_default) 
			session::_default->_register(this);
		if (object_handler::_objects)
			(*object_handler::_objects)[category()] = this;
	        //cerr << "object_handler::object_handler ..." << endl;
		}
	}

object_handler* object_handler::_create(kit* q, char* name) {
	return new object_handler(q,name);
	}

char* object_handler::category() const {
	if (!_category) return "unknown:object";
	else return _category;
	}

int object_handler::load_objects(kit* q) {
	if (object_handler::_objects &&
		(*object_handler::_objects)["obscure"]) {
		handler* h = (*object_handler::_objects)["obscure"];
		return ((object_handler*)h)->load_objects(q);
		}
	return 0;
	}

int object_handler::operator()() {
	return 0;
	}

char* object_handler::reference(void* x) {
	static char buf[16];
	sprintf(buf,"%d",(int)x);
	return buf;
	}

void* object_handler::reference(char* x) {
	int p = atoi(x);
	return (void*) p;
	}

char* object_handler::itoa(int x) {
	static char buf[16];
	sprintf(buf,"%d",(int)x);
	return buf;
	}

int object_handler::atoi(char* x) {
	int p = ::atoi(x);
	return p;
	}

static char argsbuf[1024*4];

char* object_handler::args(event* e) {
	if (!e) return 0;
	int argc = e->argc();
	strcpy(argsbuf,"");
	int i = 1;
	while ( i < argc ) {
		//cerr << "object_handler::args " << i << " " << e->arg(i) << endl; 
		strcat(argsbuf," ");
		strcat(argsbuf,e->arg(i));
		//cerr << "got " << argsbuf << endl;
		i++;
		}
	return (char*) argsbuf;
	}
