#include <hush/source.h>
#include <hush/iostream.h>
#ifndef WIN32
//#include <strstream.h>
#else
//#include <strstrea.h>
#endif
#include <hush/api/io.h>
#include <hush/java.h>

#undef ostream
#undef cout
#undef cerr

hush_ostream* hush_ostream::coutp = 0;
hush_ostream* hush_ostream::cerrp = 0;

#define maxstream 4 
#define bufsiz 1024*20

static char hush_buf[maxstream][bufsiz];
static strstreambuf* hush_str[maxstream];
static ostream* hush_of[maxstream];


#define TYPE hush_ostream
#include "hush/sys/table.i"

int hush_ostream::no = 0;
int hush_ostream::pr = 0;

int hush_ostream::initialized = 0;

int hush_ostream::initialize() {
        if (!hush_ostream::initialized) {
	   for (int i=0; i < maxstream; i++ ) {
		hush_str[i] = new strstreambuf(hush_buf[i],bufsiz);
#ifndef WIN32
	        hush_of[i] = new ostream(hush_str[i],i==1?&cout:&cerr);
#endif
		}
		hush_ostream::coutp = new hush_ostream(0);
		hush_ostream::cerrp = new hush_ostream(1);
	        hush_ostream::no = 2;
		//cerr << "initializing hush_ostream" << endl;
                }
	return hush_ostream::initialized = 1;
}

/* AEDEBUG
hush_ostream::hush_ostream(ostream* os)
//#ifndef WIN32
   : 
		 ostream(hush_of[hush_ostream::no]->_Strbuf) {
			
		//	 ostream(hush_of[hush_ostream::no]->_Traits) {
//#else
// {
//#endif
	id = hush_ostream::no++;
	hush_buf[id][0] = '\0';
        _buf = hush_buf[id];
        _out = os;
        }

		*/
hush_ostream::hush_ostream(int os)
//#ifndef WIN32
	//:
      //  	ostream(hush_of[os]->_strbuf) {
//#else
  {
//#endif
	id = os;
        _buf = hush_buf[id];
        _out = os?&cerr:&cout;
        }


hush_ostream& hush_ostream::operator<<(int x) {
	sprintf(_buf,"%s%d",_buf,x);
	//_buf->operator<<(x);
	return (*this);
	}

hush_ostream& hush_ostream::operator<<(double x) {
	sprintf(_buf,"%s%f",_buf,(float)x);
	//_buf->operator<<(x);
	return (*this);
	}

hush_ostream& hush_ostream::operator<<(const char* x) {
	//_buf->operator<<(x);
	if (!strcmp(x,"\n")) {
		(*this) << endl;
	} else if ( x[strlen(x)-1] == '\n' ) {
		((char*)x)[strlen(x)-1] = '\0';
		sprintf(_buf,"%s%s",_buf,x);
		(*this) << endl;
	} else {
		sprintf(_buf,"%s%s",_buf,x);
		}
	return (*this);
	}


hush_ostream& hush_ostream::operator<<(ostream& (fun)(ostream&)) {
        //cerr << "calling (out) endl" << endl;
	if (session::_java && !id) {
#ifdef JAVA
		java_vm_cout((handler*)session::_default,hush_buf[id]);
#endif
	} else if (session::_java && id) {
#ifdef JAVA
		java_vm_cerr((handler*)session::_default,hush_buf[id]);
#endif
	} else {
        	(*_out) << hush_buf[id] << fun;
                //cerr << hush_buf[id] << fun;
	}
	hush_buf[id][0] = '\0';
        return (*this);
        }

