#include <hush/c/query.h>
#include <hush/hush.h>
#include <hush/query.h>
#include <hush/io.h>

#undef query

static session* s = 0;
static kit* tk = 0;
static dvquery* _query;
static int _init = 0;


extern "C" {

static int init() {
if (_init) return _init;
if (!s) s = new session();
if (!tk) tk = new kit();
tk->load("pl");
_init = 1;
cerr << "query -- features -- initialized" << endl;
return _init;
}


void* query_query(const char* s) {
	//init();
	_query = new dvquery(s);
	return (void*) _query;
	}
int query_execute(void* q) {
	if (!q) return 0;
	return (*(dvquery*)q)();
	}
int query_source(void* q, const char* s) {
	if (!q) return 0;
	return ((dvquery*)q)->source(s);
	}
int query_eval(void* q, const char* s ) {
	if (!q) return 0;
	return ((dvquery*)q)->eval(s);
	}
char* query_result(void* q, int id) {
	dvquery* x = (dvquery*) q;
	if (!q) return 0;
	return x->unquote(((dvquery*)q)->result(id));
	}
char* query_unqote(void* q, char* s) {
	dvquery* x = (dvquery*) q;
	return x->unquote(s);
	}
}
