#include <hush/source.h>
#include <hush/midi/lily.h>

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

//#include <hush/io.h>
#include <hush/iostream.h>


lily_handler::lily_handler() {
	fp_in = stdin;
	fp_out = stdout;
	}


int lily_handler::open(const char* f, const char* mode) {
	if (f) fp_out = fopen(f,"w");
	return 1;
	}

int lily_handler::close() {
	return 1;
	}

FILE* lily_handler::in_file() { return fp_in; }
FILE* lily_handler::out_file() { return fp_out; }

int lily_handler::write_version() { 
	fprintf(out_file(),"\\version \"1.0.0\";\n\n");
	return 1;
	}

int lily_handler::write_header() 
{
	fprintf(out_file(),"%s = \\melodic {\n","melody");
	return 1;
}

int lily_handler::write_footer(int t) 
{
	if (t < 0) t = 0;
	fprintf(out_file(),"}\n\t\\score {\n\n");
	fprintf(out_file(),"\t\\melody \n");
	fprintf(out_file(),"\t\\paper{} \n");
	fprintf(out_file(),"\t\\midi{\\tempo = %d; } \n\n",t?t:120);
	fprintf(out_file(),"}\n");
	return 1;
}

int lily_handler::write_time(const char* s) {
	fprintf(out_file(),"\\time %s;",s);
	return 1;
	}

int lily_handler::write_melody(const char* m) {
	fprintf(out_file(),"%s \n",m);
	return 1;
	}

int lily_handler::write_note(int v) {
	fprintf(out_file()," %s ",note(v));
	return 1;
	}

char* lily_handler::note(int v)
{
	static char out[24];
	char* primes[] = { "", "'","''","'''","''''","'''''" };
	char* notes[] = { "c", "cis", "d", "dis", "e",
			"f", "fis", "g", "gis", "a",
			"ais", "b" };
	int x = v;
	int p = 0;
	if (v > 59) {
		while (x > 59) {
			x -= 12;
			p++;
			}
		}
	if (v < 48) {
		while (x < 48) {
			x += 12;
			p++;
			}
		}
	if (x >= 48  && x < 60) {
		sprintf(out,"%s%s",notes[x-48],primes[p]);
		}
	return (char*) out;
}

