
// MIME.c
//
// Bastiaan Sch\"onhage

#include <hush/source.h>

#include <hush/net/client/MIME.h>
#include <string.h>

MIME::MIME()
{
	Type = SubType = String = 0;
}

MIME::MIME(const char* t, const char* st)
{
	Type = SubType = String = 0;
	type(t);
	subtype(st);
}

MIME::MIME(const MIME &m)
{
	Type = SubType = String = 0;
	if(m.Type) type(m.Type);
	if(m.SubType) subtype( m.SubType);
}

MIME::~MIME()
{
	if(Type) delete[] Type;
	if(SubType) delete[] SubType;
	if(String) delete[] String;
}

MIME& MIME::operator=(const MIME &m)
{
	if(this != &m)
	{
		if(m.Type) type(m.Type);
		if(m.SubType) subtype(m.SubType);
	}
	return *this;
}

int MIME::operator==(const MIME &m) const
{
	if (strcmp(Type, m.Type)!=0) return 0;
	if (strcmp(SubType, m.SubType)!=0) return 0;
	return 1;
}

MIME::operator char*()
{
	if(String) delete[] String;
	String = new char[strlen(Type)+strlen(SubType)+2];
	strcpy(String, Type);
	strcat(String, "/");
	strcat(String, SubType);
	return String;
}
	

const char* MIME::type() const
{
	return Type;
}

void MIME::type(const char* t)
{
	if(Type) delete[] Type;
	Type = new char[ 1+strlen(t) ];
	strcpy(Type, t);
}

const char* MIME::subtype() const
{
	return SubType;
}

void MIME::subtype(const char* t)
{
	if(SubType) delete[] SubType;
	SubType = new char[1+ strlen(t) ];
	strcpy(SubType, t);
}
