// client.c
//
// nofactory-like file for the netclient class
// the interface for real netclients (like http, ftp)
//
// September, October 1995
// Bastiaan Sch\"onhage

#include <hush/source.h>

#include <hush/net/client/client.h>
#include <hush/net/client/http_client.h>
#include <hush/net/client/file_client.h>
#include <hush/net/client/any_client.h>
#include <string.h>

void client::get(const char* URL)
{
	url* urlptr = new url(URL);

	if ( (!client_) || (strcasecmp(client_->type(),urlptr->protocol())!=0))
	{
		if  (( strcasecmp(urlptr->protocol(), "http")==0 ) ||
		    ( strcasecmp(urlptr->protocol(), "hush")==0 )) {
			if (!(client_ = client_dict["http"])) {
				client_ = new http_client();
				client_dict["http"] = client_;
			}
		} else if( strcasecmp(urlptr->protocol(), "file")==0 ) {
			if (!(client_ = client_dict["file"])) {
				client_ = new file_client();
				client_dict["file"] = client_;
			}
		} else if( 1 ) {
			if (!(client_ = client_dict["any"])) {
				client_ = new any_client();
				client_dict["any"] = client_;
			}
		}
	}
	if (client_) client_->get(URL);
	delete urlptr;
}

client::client() : client_(0)
{}

client::client(int): client_(0)
{}

client::~client()
{
	// if(client_) delete client_; jrvosse
	iter<string>& it = client_dict; // obtain iter by assignment;
    	string* sp = 0;
	client* c = 0;
    	while((sp=it())) { c = client_dict[*sp]; delete c; }

	// cerr << "Client deleted " << endl;
}

const char* client::type(void) const
{
	if(client_) return client_->type();
	else return (char*)0;
}

bool client::send_request()
{
	if(client_) return client_->send_request();
	else return false;
}

bool client::get_reply(char* &buffer, int &length)
{
	if(client_) return client_->get_reply(buffer, length);
	else return false;
}

bool client::get_reply_header(char* &buffer, int &length)
{
	if(client_) return client_->get_reply_header(buffer, length);
	else return false;
}

bool client::get_reply_body(char* &buffer, int &length)
{
	if(client_) return client_->get_reply_body(buffer, length);
	else return false;
}

bool client::get_reply_trailer(char* &buffer, int &length)
{
	if(client_) return client_->get_reply_trailer(buffer, length);
	else return false;
}

bool client::get_reply()
{
	if(client_) return client_->get_reply();
	else return false;
}

bool client::get_reply_body(int &fd)
{
	if(client_) return client_->get_reply_body(fd);
	else return false;
}

MIME* client::media()
{
	if(client_) return client_->media();
	else return 0;
}

int client::length(void)
{
	if(client_) return client_->length();
	else return 0;
}

int client::errorcode(void)
{
	if(client_) return client_->errorcode();
	else return 0;
}

