#include <hush/source.h>

#include <hush/sys/cell.h>
//#include <iostream.h>

#define TYPE iter_type
#include "hush/sys/table.i"

celliter::celliter( cell* c ) : iter<void>(this) { p = c; } 
celliter::~celliter() { }
void* celliter::operator()() {
  void* result = p?p->el:0;
  if (p) p = p->next;
  return result;
}

int cell::created = 0;
int cell::deleted = 0;

cell::cell(const void* hd, cell* tl) {
  cell::created++;
  el = (void*) hd;
  next = tl; prev = 0;
  if (tl) tl->prev = this;
  refs = 0;
}

cell::~cell() {
  cell::deleted++;
  if (next) delete next;
  next = 0; prev = 0;
}

int cell::length() const { 
  return el?(1 + (next?next->length():0)):0; 
}

cell* cell::first() const { 
  if (!prev) return (cell*) this;
  else return (cell*) prev->first();
}

cell* cell::last() const { 
  if (!next) return (cell*) this;
  else return (cell*) next->last();
}

int cell::contains(void* p) const {
  if (p == el) return 1;
  else if (next) return next->contains(p);
  else return 0;
}

cell* cell::find(void* p) const {
  if (p == el) return (cell*) this;
  else if (next) return next->find(p);
  else return 0;
}

cell* cell::remove(const void* e, const dvcell_type* ) {
  if (e) {
    cell* p = this;
    while (p) {
      if (e==el) el = 0;
      p = p->next;
    }
    return this;
  } else {
    if (prev) prev->next = next;
    if (next) next->prev = prev;
    next = 0;
    prev = 0;
    el = 0;
    return this;
  }
}

cell* cell::insert(const void* e, const dvcell_type* me) {
  cell* p = this;
  if (!el) el = (void*) e;
  else if (me || !next) {
    cell* p = new cell((void*)e);
    p->prev = this; p->next = next;
    if (next) { next->prev = p; }
    next = p;
    return p;
  }
  else if (next) p = next->insert(e,me);
  return p;
}
