#include <widgets/source.h>

#include <hush/widgets/canvas.h>
#include <hush/sys/bind.h>


#define text dvtext

char* canvas::type() const { return "canvas"; }

#define TYPE canvas
#include "hush/widgets/create.i"


void canvas::region(int x1, int y1, int x2, int y2 ) {
	if (_exists()) _this()->region(x1,y1,x2,y2);
	else _error("region");
	}


int canvas::canvasx(int screenx) const { // returns x relative to canvas
	if (_exists()) return _this()->canvasx(screenx);
	else return (int) _error("canvasx");
        }

int canvas::canvasy(int screeny) const { // returns y relative to canvas
	if (_exists()) return _this()->canvasy(screeny);
	else return (int) _error("canvasy");
        }

void canvas::install(binding* ac, const char* args) {
	if (_exists()) _this()->install(ac,args);
	else _error("install");
	}

/*
	bind("<Any-ButtonPress>",ac, args);
	bind("<Any-ButtonRelease>",ac, args);
	bind("<Any-Motion>",ac, args );
	bind("<Enter>",ac, args );
	bind("<Leave>",ac, args );
	}
*/

void canvas::raise(const char* tag, const char* abovethis) {
	if (_exists()) _this()->raise(tag,abovethis);
	else _error("raise");
	}

void canvas::lower(const char* tag, const char* belowthis) {
	if (_exists()) _this()->lower(tag, belowthis);
	else _error("lower");
	}

void canvas::tag(int id, const char* tag) {
	if (_exists()) _this()->tag(id,tag);
	else _error("tag");
	}

char* canvas::tags(int id) const {
	if (_exists()) return _this()->tags(id);
	else return (char*) _error("tags"); 
	}

char* canvas::coords(int id) const {
	if (_exists()) return _this()->coords(id);
	else return (char*) _error("coords"); 
	}

char* canvas::coords(const char* id) const {
	if (_exists()) return _this()->coords(id);
	else return (char*) _error("coords"); 
	}

char* canvas::bbox(int id) const {
	if (_exists()) return _this()->bbox(id);
	else return (char*) _error("bbox"); 
	}

char* canvas::bbox(const char* id) const {
	if (_exists()) return _this()->bbox(id);
	else return (char*) _error("bbox"); 
	}

void canvas::del(int id) {
	if (_exists()) _this()->del(id);
	else _error("id");
	}

void canvas::del(const char* id) {
	if (_exists()) _this()->del(id);
	else _error("id");
	}

void canvas::move(int id, int x, int y) {
	if (_exists()) _this()->move(id,x,y);
	else _error("move");
	}

void canvas::move(const char* id, int x, int y) {
	if (_exists()) _this()->move(id,x,y);
	else _error("move");
	}

item* canvas::bitmap(int x1, int y1, const char* bitmap, const char* options ) {
	if (_exists()) return _this()->bitmap(x1,y1,bitmap,options);
	else return (item*) _error("bitmap");
	}

item* canvas::image(int x1, int y1, const char* image, const char* options ) {
	if (_exists()) return _this()->image(x1,y1,image,options);
	else return (item*) _error("image");
	}

item* canvas::photo(int x1, int y1, int x2, int y2, const char* options) {
	_obsolete("photo");
	if (_exists()) return _this()->photo(x1,y1,x2,y2,options);
	else return (item*) _error("photo");
	}

void canvas::readppm(int id, const char* file) {
	_obsolete("readppm");
	if (_exists()) _this()->readppm(id,file);
	else _error("readppm");
	}

item* canvas::line(int x1, int y1, int x2, int y2, const char* options) {
	if (_exists()) return _this()->line(x1,y1,x2,y2,options);
	else return (item*) _error("line");
	}

item* canvas::line(const char* linespec, const char* options) {
	if (_exists()) return _this()->line(linespec,options);
	else return (item*) _error("line");
	}

item* canvas::arc(int x1, int y1, int x2, int y2, const char* options) {
	if (_exists()) return _this()->arc(x1,y1,x2,y2,options);
	else return (item*) _error("arc");
	}

item* canvas::oval(int x1, int y1, int x2, int y2, const char* options) {
	if (_exists()) return _this()->oval(x1,y1,x2,y2,options);
	else return (item*) _error("oval");
	}


item* canvas::circle(int x1, int y1, int r, const char* options) {
	if (_exists()) return _this()->circle(x1,y1,r,options);
	else return (item*) _error("circle");
	}

item* canvas::polygon(const char* linespec, const char* options) {
	if (_exists()) return _this()->polygon(linespec,options);
	else return (item*) _error("polygon");
	}

item* canvas::rectangle(int x1, int y1, int x2, int y2, const char* options) {
	if (_exists()) return _this()->rectangle(x1,y1,x2,y2,options);
	else return (item*) _error("rectangle");
	}


item* canvas::text(int x1, int y1, const char* txt, const char* options) {
	if (_exists()) return _this()->text(x1,y1,txt,options);
	else return (item*) _error("text");
	}

item* canvas::window(int x1, int y1, const char* win, const char* options) {
	if (_exists()) return _this()->window(x1,y1,win,options);
	else return (item*) _error("window");
	}


item* canvas::window(int x1, int y1, widget* win, const char* options) {
	if (_exists()) return _this()->window(x1,y1,win,options);
	else return (item*) _error("window");
	}

item* canvas::current() {
	if (_exists()) return _this()->current();
	else return (item*) _error("current");
	}
	
item* canvas::overlapping(int x, int y, const char* options) {
	if (_exists()) return _this()->overlapping(x,y,options);
	else return (item*) _error("overlapping");
	}

item* canvas::overlapping(int x, int y) {
	if (_exists()) return _this()->overlapping(x,y);
	else return (item*) _error("overlapping");
	}

char* canvas::items(int x, int y) {
	if (_exists()) return _this()->items(x,y);
	else return (char*) _error("items");
	}

char* canvas::items(int x1, int y1, int x2, int y2) {
	if (_exists()) return _this()->items(x1,y1,x2,y2);
	else return (char*) _error("items");
	}


void canvas::itemconfigure(int it, const char* options) {
	if (_exists()) _this()->itemconfigure(it,options);
	else _error("itemconfigure");
	}

void canvas::itemconfigure(const char* tag, const char* options) {
	if (_exists()) _this()->itemconfigure(tag,options);
	else _error("itemconfigure");
	}

int canvas::itembind(int i, const char* s, binding* a, const char* args) {
        return itemdirect(i,s,a,args);
	}

int canvas::itembind(const char *i, const char* s, binding* a, const char* args) {
        return itemdirect(i,s,a,args);
	}

void canvas::postscript(const char* file, const char* options) {
	if (_exists()) _this()->postscript(file,options);
	else _error("postscript");
	}
	
void canvas::fontmap(const char *xfontname, const char *printerfont,int ptsize) {
	if (_exists()) _this()->fontmap(xfontname, printerfont, ptsize);
	else _error("fontmap");
	}


int canvas::itemdirect(int i, const char *s, binding* ac, const char* args) {
	if (_exists()) return _this()->itemdirect(i,s,ac,args);
	else return (int) _error("itemdirect");
	}

int canvas::itemdirect(const char* i, const char *s, binding* ac, const char* args) {
	if (_exists()) return _this()->itemdirect(i,s,ac,args);
	else return (int) _error("itemdirect");
	}

#define SELF (((canvas*) self()))

int canvas::coordsystem() const { 
  if (_exists()) return _this()->coordsystem(); 
  else return (int) _error("coordsystem");
}


void canvas::coordsystem(int cs) { 
  if (_exists()) _this()->coordsystem(cs); 
  else _error("coordsystem");; 
}

int canvas::convertx(int x) const { 
  if (_exists()) return _this()->convertx(x);
  else return (int) _error("convertx");
}

int canvas::converty(int y) const { 
  if (_exists()) return _this()->converty(y);
  else return (int) _error("converty");
}

#undef SELF
