#include <widgets/source.h>

#include <hush/widgets/listbox.h>
#include <hush/sys/bind.h>

char* listbox::type() const { return "listbox"; }

#define TYPE listbox
#include "hush/widgets/create.i"



void listbox::insert(const char* s) {
	if (_exists()) _this()->insert(s);
	else _error("insert");
	}

void listbox::insert(int i, const char* s) {
	if (_exists()) _this()->insert(i,s);
	else _error("insert");
	}

void listbox::del() {
	if (_exists()) _this()->del();
	else _error("del");
	}

void listbox::del(int i) {
	if (_exists()) _this()->del(i);
	else _error("del");
	}

void listbox::del(int first, int last) {
	if (_exists()) _this()->del(first,last);
	else _error("del");
	}

void listbox::see(int index) {
	if (_exists()) _this()->see(index);
	else _error("see");
	}

char* listbox::get(int n) const {
	if (_exists()) return _this()->get(n);
	else return (char*) _error("get");
	}

int listbox::selection() const {
	if (_exists()) return _this()->selection();
	else return (int) _error("selection");
	}

int listbox::selected(int index) const {
	if (_exists()) return _this()->selected(index);
	else return (int) _error("selected");
	}

void listbox::select() {
	if (_exists()) _this()->select();
	else _error("select");
	}

void listbox::select(int first, int last) {
	if (_exists()) _this()->select(first,last);
	else _error("select");
	}

void listbox::unselect() {
	if (_exists()) _this()->unselect();
	else _error("unselect");
	}

void listbox::unselect(int first, int last) {
	if (_exists()) _this()->unselect(first,last);
	else _error("unselect");
	}

int listbox::size() const {
	if (_exists()) return _this()->size();
	else return (int) _error("size");
	}

void listbox::singleselect() {
	if (_exists()) _this()->singleselect();
	else _error("singleselect");
	}


void listbox::install(binding* ac, const char* args ) {
	if (_exists()) _this()->install(ac,args);
	else _error("install");
	}


void listbox::init(const char* options) {
	if (_exists()) _this()->init(options);
	else _error("init");
	}
