#include <hush/java.h>
#include <hush/event.h>
#include <hush/string.h>

#undef string

#include <hush/io.h>

#include <native/hush_dv_api_event.h>

#define method(X) Java_hush_dv_api_event_##X


JNIEXPORT jint JNICALL method(type)(JNIEnv *env, jobject obj)
{
	java_vm<event> vm(env,obj);
	return vm.self()?vm->type():0;
}

JNIEXPORT jint JNICALL method(x)(JNIEnv *env, jobject obj)
{
	java_vm<event> vm(env,obj);
	return vm.self()?vm->x():0;
}

JNIEXPORT jint JNICALL method(y)(JNIEnv *env, jobject obj)
{
	java_vm<event> vm(env,obj);
	return vm.self()?vm->y():0;
}

JNIEXPORT jint JNICALL method(keycode)(JNIEnv *env, jobject obj)
{
	java_vm<event> vm(env,obj);
	return vm.self()?vm->keycode():0;
}

JNIEXPORT jint JNICALL method(argc)(JNIEnv *env, jobject obj)
{
	java_vm<event> vm(env,obj);
	return vm.self()?vm->argc():0;
}

JNIEXPORT jstring JNICALL method(args)(JNIEnv *env, jobject obj, jint i)
{
	java_vm<event> vm(env,obj);
	char* p = vm->args((int)i);
	return vm.string(p);
}

JNIEXPORT jstring JNICALL method(arg)(JNIEnv *env, jobject obj, jint i)
{
	java_vm<event> vm(env,obj);
	char* s = (char*) (vm.self()?vm->arg((int)i):"");
	return vm.string(s); // env->NewStringUTF(s);
}
