#include <hush/java.h>
#include <hush/handler.h>
#include <hush/session.h>

#include <hush/io.h>

#include <native/hush_dv_api_handler.h>

#define method(X) Java_hush_dv_api_handler_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj)
{
  java_vm<handler>* vmp = new java_vm<handler>(env,obj,"Handler");
  handler* h = new handler();
  h->_vmp = vmp;
  h->_register(vmp);
  session::_default->_register(h);
  return (jint) h;
}


JNIEXPORT jstring JNICALL method(getoption)(JNIEnv *env, jobject obj, jstring k)
{
  java_vm<handler> vm(env,obj);
  char *jk = vm.get(k);
  char *s = vm->option(jk);
  if (s) return vm.string(s);
  else return vm.string("-");
}

JNIEXPORT void JNICALL method(setoption)(JNIEnv *env, jobject obj, jstring k, jstring v)
{
  java_vm<handler> vm(env,obj);
  char *jk = vm.get(k);
  char *jv = vm.get(v);
  vm->option(jk,jv);
  vm.release(v);
  vm.release(k);
}

