#include <hush/sim/generator.h>
#include <hush/string.h>

#undef string

#include <hush/io.h>
#include <hush/java.h>

#include <native/hush_dv_sim_generator.h>

#define method(X) Java_hush_dv_sim_generator_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj,
       jint s1, jint s2, jint s3 ) 
{
  java_vm<generator>vm(env,obj);
  int result = (int)  new generator((unsigned int)s1,(unsigned int)s2,(unsigned int)s3);
  return (jint) result;
}

JNIEXPORT void JNICALL method(antithetic)(JNIEnv *env, jobject obj)
{
  java_vm<generator>vm(env,obj);
  vm->antithetic();
}

JNIEXPORT void JNICALL method(reset)(JNIEnv *env, jobject obj)
{
  java_vm<generator>vm(env,obj);
  vm->reset();
}

JNIEXPORT jint JNICALL method(nprobability)(JNIEnv *env, jobject obj,
    jdouble p)
{
  java_vm<generator>vm(env,obj);
  int result = vm->probability((double)p);
  return (jint) result;
}

JNIEXPORT jdouble JNICALL method(uniform)(JNIEnv *env, jobject obj,
    jdouble a, jdouble b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->uniform((double)a,(double)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(exponential)(JNIEnv *env, jobject obj,
    jdouble a)
{
  java_vm<generator>vm(env,obj);
  double result = vm->exponential((double)a);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(hyperexponential)(JNIEnv *env, jobject obj,
    jdouble p, jdouble a, jdouble b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->hyperexponential((double)p,(double)a,(double)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(laplace)(JNIEnv *env, jobject obj,
    jdouble a)
{
  java_vm<generator>vm(env,obj);
  double result = vm->laplace((double)a);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(normal)(JNIEnv *env, jobject obj,
    jdouble a, jdouble b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->normal((double)a,(double)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(chisquare)(JNIEnv *env, jobject obj,
    jint n)
{
  java_vm<generator>vm(env,obj);
  double result = vm->chisquare((int)n);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(student)(JNIEnv *env, jobject obj,
    jint n)
{
  java_vm<generator>vm(env,obj);
  double result = vm->student((int)n);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(lognormal)(JNIEnv *env, jobject obj,
    jdouble a, jdouble b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->lognormal((double)a,(double)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(erlang)(JNIEnv *env, jobject obj,
    jint n, jdouble b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->erlang((int)n,(double)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(gamma)(JNIEnv *env, jobject obj,
    jdouble a, jdouble b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->gamma((double)a,(double)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(beta)(JNIEnv *env, jobject obj,
    jdouble a, jdouble b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->beta((double)a,(double)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(fdistribution)(JNIEnv *env, jobject obj,
    jint a, jint b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->beta((int)a,(int)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(poisson)(JNIEnv *env, jobject obj,
    jdouble a)
{
  java_vm<generator>vm(env,obj);
  double result = vm->poisson((double)a);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(geometric)(JNIEnv *env, jobject obj,
    jdouble a)
{
  java_vm<generator>vm(env,obj);
  double result = vm->geometric((double)a);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(hypergeometric)(JNIEnv *env, jobject obj,
    jint a, jint b, jdouble p)
{
  java_vm<generator>vm(env,obj);
  double result = vm->hypergeometric((int)a,(int)b,(double)p);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(weibull)(JNIEnv *env, jobject obj,
    jdouble a, jdouble b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->weibull((double)a,(double)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(binomial)(JNIEnv *env, jobject obj,
    jdouble a, jint b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->binomial((double)a,(int)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(negativebinomial)(JNIEnv *env, jobject obj,
    jdouble a, jint b)
{
  java_vm<generator>vm(env,obj);
  double result = vm->negativebinomial((double)a,(int)b);
  return (jdouble) result;
}

JNIEXPORT jdouble JNICALL method(triangular)(JNIEnv *env, jobject obj,
    jdouble a)
{
  java_vm<generator>vm(env,obj);
  double result = vm->triangular((double)a);
  return (jdouble) result;
}
