#include <hush/session.h>
#include <hush/sim/histogram.h>

#include <hush/java.h>
#include <hush/io.h>

#include <native/hush_dv_sim_histogram.h>

#define method(X) Java_hush_dv_sim_histogram_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<histogram>* vmp = new java_vm<histogram>(env,obj,"Histogram");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  histogram* result = 0;
  if (r)
  	result =  new histogram((widget*)r,path,opts);
  else {
	result = new histogram(path,opts);
        session::_default->_register(result);
	result->_register(vmp);
  }
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}

JNIEXPORT void JNICALL method(setSample)(JNIEnv *env, jobject obj,
  jdouble x, jdouble y)
{
  java_vm<histogram> vm(env,obj);
  vm->sample((double)x,(double)y);
}

JNIEXPORT void JNICALL method(reset)(JNIEnv *env, jobject obj)
{
  java_vm<histogram> vm(env,obj);
  vm->reset();
}

JNIEXPORT jdouble JNICALL method(mean)(JNIEnv *env, jobject obj)
{
  java_vm<histogram> vm(env,obj);
  return (double) vm->mean();
}

JNIEXPORT jdouble JNICALL method(variance)(JNIEnv *env, jobject obj)
{
  java_vm<histogram> vm(env,obj);
  return (double) vm->variance();
}

JNIEXPORT jdouble JNICALL method(standarddeviation)(JNIEnv *env, jobject obj)
{
  java_vm<histogram> vm(env,obj);
  return (double) vm->standarddeviation();
}

JNIEXPORT jdouble JNICALL method(sumfrequencies)(JNIEnv *env, jobject obj)
{
  java_vm<histogram> vm(env,obj);
  return (double) vm->sumfrequencies();
}

JNIEXPORT jdouble JNICALL method(minimum)(JNIEnv *env, jobject obj)
{
  java_vm<histogram> vm(env,obj);
  return (double) vm->minimum();
}

JNIEXPORT jdouble JNICALL method(maximum)(JNIEnv *env, jobject obj)
{
  java_vm<histogram> vm(env,obj);
  return (double) vm->maximum();
}



JNIEXPORT void JNICALL method(cout)(JNIEnv *env, jobject obj)
{
  java_vm<histogram> vm(env,obj);
  cout << *(vm.self()) << endl;
}
