#include <hush/string.h>

#undef string

#include <hush/io.h>
#include <hush/java.h>

#include <hush/sim/resource.h>

#include <native/hush_dv_sim_resource.h>


#define method(X) Java_hush_dv_sim_resource_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj,
  jint am) 
{
  java_vm<resource> vm(env,obj);
  int result = (int) new resource((int) am);
  return (jint) result;
}


JNIEXPORT jint JNICALL method(nreport)(JNIEnv *env, jobject obj,
   jobject hist, jdouble interv)
{
  java_vm<resource> vm(env,obj);
  java_vm<histogram> vmh(env,hist);
  histogram* h = vmh.self();
  return (jint) vm->report(h,(double)interv);
}

JNIEXPORT void JNICALL method(reset)(JNIEnv *env, jobject obj) 
{
  java_vm<resource> vm(env,obj);
  vm->reset();
}

JNIEXPORT void JNICALL method(nrelease)(JNIEnv *env, jobject obj,
  jdouble am)
{
  java_vm<resource> vm(env,obj);
  vm->release(am);
}

JNIEXPORT void JNICALL method(nacquire)(JNIEnv *env, jobject obj,
  jdouble am)
{
  java_vm<resource> vm(env,obj);
  vm->acquire(am);
}

JNIEXPORT jboolean JNICALL method(navailable)(JNIEnv *env, jobject obj,
  jdouble am)
{
  java_vm<resource> vm(env,obj);
  return (jboolean) vm->available(am);
}

JNIEXPORT jboolean JNICALL method(full)(JNIEnv *env, jobject obj)
{
  java_vm<resource> vm(env,obj);
  return (jboolean) vm->full();
}

JNIEXPORT jboolean JNICALL method(empty)(JNIEnv *env, jobject obj)
{
  java_vm<resource> vm(env,obj);
  return (jboolean) vm->empty();
}

JNIEXPORT jdouble JNICALL method(left)(JNIEnv *env, jobject obj)
{
  java_vm<resource> vm(env,obj);
  return (jdouble) vm->left();
}

JNIEXPORT jdouble JNICALL method(used)(JNIEnv *env, jobject obj)
{
  java_vm<resource> vm(env,obj);
  return (jdouble) vm->used();
}

JNIEXPORT jdouble JNICALL method(occupied)(JNIEnv *env, jobject obj)
{
  java_vm<resource> vm(env,obj);
  return (jdouble) vm->occupied();
}


JNIEXPORT void JNICALL method(cout)(JNIEnv *env, jobject obj)
{
  java_vm<resource> vm(env,obj);
  cout << *(vm.self()) << endl;
}
