#include <hush/java.h>
#include <hush/io.h>

#include <widgets/browser.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_browser.h>

#define method(X) Java_hush_dv_widgets_browser_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<browser>* vmp = new java_vm<browser>(env,obj,"Browser");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  browser* result = 0;
  if (r)
  	result =  new browser((widget*)r,path,opts);
  else {
	result = new browser(path,opts);
        session::_default->_register(result);
  }
  //AE result->_vmp = vmp;
  result->_register(vmp);
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}

JNIEXPORT void JNICALL method(load)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<browser> vm(env,obj);
  char* s = vm.get(txt);
  vm->load(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(home)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<browser> vm(env,obj);
  char* s = vm.get(txt);
  vm->home(s);
  vm.release(txt);;
}
