#include <hush/java.h>
#include <hush/io.h>

#include <widgets/checkbutton.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_checkbutton.h>

#define method(X) Java_hush_dv_widgets_checkbutton_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<checkbutton>* vmp = new java_vm<checkbutton>(env,obj,"CheckButton");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  checkbutton* result = 0;
  cerr << "creating checkbutton " <<  endl;
  if (r)
  	result =  new checkbutton((widget*)r,path,opts);
  else {
	result = new checkbutton(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}


JNIEXPORT void JNICALL method(variable)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<checkbutton> vm(env,obj);
  char* s = vm.get(txt);
  vm->text(s);
  vm.release(txt);;
}

JNIEXPORT jint JNICALL method(value)(JNIEnv *env, jobject obj)
{
  java_vm<checkbutton> vm(env,obj);
  return vm->value();
}

JNIEXPORT void JNICALL method(toggle)(JNIEnv *env, jobject obj)
{
  java_vm<checkbutton> vm(env,obj);
  vm->toggle();
}

JNIEXPORT void JNICALL method(select)(JNIEnv *env, jobject obj)
{
  java_vm<checkbutton> vm(env,obj);
  vm->select();
}

JNIEXPORT void JNICALL method(deselect)(JNIEnv *env, jobject obj)
{
  java_vm<checkbutton> vm(env,obj);
  vm->deselect();
}
