#include <hush/java.h>
#include <hush/io.h>

#include <widgets/menu.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_menu.h>

#define method(X) Java_hush_dv_widgets_menu_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<menu>* vmp = new java_vm<menu>(env,obj,"Menu");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  menu* result = 0;
  cerr << "creating menu " <<  endl;
  if (r)
  	result =  new menu((widget*)r,path,opts);
  else {
	result = new menu(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}


JNIEXPORT void JNICALL method(entry)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<menu> vm(env,obj);
  char* s = vm.get(txt);
  vm->entry(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(checkbutton)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<menu> vm(env,obj);
  char* s = vm.get(txt);
  vm->checkbutton(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(radiobutton)(JNIEnv *env, jobject obj, 
	   jstring txt, jstring var)
{
  java_vm<menu> vm(env,obj);
  char* _txt = vm.get(txt);
  char* _var = vm.get(var);
  vm->radiobutton(_txt,_var);
  vm.release(txt,_txt);;
  vm.release(var,_var);;
}

JNIEXPORT void JNICALL method(cascade)(JNIEnv *env, jobject obj, 
	   jstring txt, jobject x)
{
  java_vm<menu> vm(env,obj);
  java_vm<menu> vx(env,x);
  char* s = vm.get(txt);
  vm->cascade(s,vx.self());
  vm.release(txt);;
}

JNIEXPORT jstring JNICALL method(entryconfigure)(JNIEnv *env, jobject obj,
	jint i, jstring opts)
{
  java_vm<menu> vm(env,obj);
  char* _opts = vm.get(opts);
  char* s = vm->entryconfigure(i,_opts);
  vm.release(opts);
  return vm.string(s);
}

JNIEXPORT jint JNICALL method(index)(JNIEnv *env, jobject obj,
	jstring opts)
{
  java_vm<menu> vm(env,obj);
  char* _opts = vm.get(opts);
  int n = vm->index(_opts);
  vm.release(opts);
  return n;
}

JNIEXPORT jint JNICALL method(isactive)(JNIEnv *env, jobject obj)
{
  java_vm<menu> vm(env,obj);
  return vm->active();
}

JNIEXPORT void JNICALL method(dodel)(JNIEnv *env, jobject obj,
	jint i)
{
  java_vm<menu> vm(env,obj);
  vm->del(i);
}

JNIEXPORT void JNICALL method(dodels)(JNIEnv *env, jobject obj,
	jstring s)
{
  java_vm<menu> vm(env,obj);
  char* _s = vm.get(s);
  vm->del(_s);
  vm.release(s);
}

JNIEXPORT void JNICALL method(doinvoke)(JNIEnv *env, jobject obj,
	jint i)
{
  java_vm<menu> vm(env,obj);
  vm->invoke(i);
}

JNIEXPORT void JNICALL method(doinvokes)(JNIEnv *env, jobject obj,
	jstring s)
{
  java_vm<menu> vm(env,obj);
  char* _s = vm.get(s);
  vm->invoke(_s);
  vm.release(s);
}

JNIEXPORT void JNICALL method(post)(JNIEnv *env, jobject obj,
	jint x, jint y)
{
  java_vm<menu> vm(env,obj);
  vm->post(x,y);
}

JNIEXPORT void JNICALL method(unpost)(JNIEnv *env, jobject obj)
{
  java_vm<menu> vm(env,obj);
  vm->unpost();
}
