#include <hush/java.h>
#include <hush/io.h>

#include <widgets/menubutton.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_menubutton.h>

#define method(X) Java_hush_dv_widgets_menubutton_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<menubutton>* vmp = new java_vm<menubutton>(env,obj,"MenuButton");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  menubutton* result = 0;
  cerr << "creating menubutton " <<  endl;
  if (r)
  	result =  new menubutton((widget*)r,path,opts);
  else {
	result = new menubutton(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}


JNIEXPORT void JNICALL method(text)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<menubutton> vm(env,obj);
  char* s = vm.get(txt);
  vm->text(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(bitmap)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<menubutton> vm(env,obj);
  char* s = vm.get(txt);
  vm->bitmap(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(image)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<menubutton> vm(env,obj);
  char* s = vm.get(txt);
  vm->image(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(menu)(JNIEnv *env, jobject obj, 
	   jobject x)
{
  java_vm<menubutton> vm(env,obj);
  java_vm<menu> vx(env,x);
  vm->menu(vx.self());
}
