#include <hush/java.h>
#include <hush/io.h>

#include <widgets/scale.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_scale.h>

#define method(X) Java_widgets_scale_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<scale>* vmp = new java_vm<scale>(env,obj,"Scale");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  scale* result = 0;
  cerr << "creating scale " <<  endl;
  if (r)
  	result =  new scale((widget*)r,path,opts);
  else {
	result = new scale(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}


JNIEXPORT void JNICALL method(text)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<scale> vm(env,obj);
  char* s = vm.get(txt);
  vm->text(s);
  vm.release(txt);;
}

JNIEXPORT void JNICALL method(from)(JNIEnv *env, jobject obj, 
	   jint i)
{
  java_vm<scale> vm(env,obj);
  vm->from((int)i);
}

JNIEXPORT void JNICALL method(to)(JNIEnv *env, jobject obj, 
	   jint i)
{
  java_vm<scale> vm(env,obj);
  vm->to((int)i);
}

JNIEXPORT void JNICALL method(set)(JNIEnv *env, jobject obj, 
	   jint i)
{
  java_vm<scale> vm(env,obj);
  vm->set((int)i);
}

JNIEXPORT jint JNICALL method(get)(JNIEnv *env, jobject obj)
{
  java_vm<scale> vm(env,obj);
  return (jint) vm->get();
}
