#include <hush/java.h>
#include <hush/io.h>

#include <widgets/text.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_text.h>

#define method(X) Java_hush_dv_widgets_text_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<text>* vmp = new java_vm<text>(env,obj,"Text");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  text* result = 0;
  if (r)
  	result =  new text((widget*)r,path,opts);
  else {
	result = new text(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}

JNIEXPORT void JNICALL method(doinsert)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<text> vm(env,obj);
  char* s = vm.get(txt);
  vm->insert(s);
  vm.release(txt);;
}


JNIEXPORT void JNICALL method(doinsertp)(JNIEnv *env, jobject obj, 
	   jint l, jint n, jstring txt, jstring tags)
{
  java_vm<text> vm(env,obj);
  char* _txt = vm.get(txt);
  char* _tags = vm.get(tags);
  vm->insert(l,n,_txt,_tags);
  vm.release(txt,_txt);;
  vm.release(tags,_tags);;
}


JNIEXPORT void JNICALL method(doinserti)(JNIEnv *env, jobject obj, 
	   jstring ind, jstring txt, jstring tags)
{
  java_vm<text> vm(env,obj);
  char* _ind = vm.get(ind);
  char* _txt = vm.get(txt);
  char* _tags = vm.get(tags);
  vm->insert(_ind,_txt,_tags);
  vm.release(ind,_ind);;
  vm.release(txt,_txt);;
  vm.release(tags,_tags);;
}

JNIEXPORT void JNICALL method(dodel)(JNIEnv *env, jobject obj, 
	   jint fl, jint fc, jint tl, jint tc)
{
  java_vm<text> vm(env,obj);
  vm->del(fl,fc,tl,tc);
}


JNIEXPORT void JNICALL method(dodeli)(JNIEnv *env, jobject obj, 
	   jstring from, jstring to)
{
  java_vm<text> vm(env,obj);
  char* _from = vm.get(from);
  char* _to = vm.get(to);
  vm->del(_from,_to);
  vm.release(from,_from);;
  vm.release(to,_to);;
}


JNIEXPORT void JNICALL method(enable)(JNIEnv *env, jobject obj)
{
  java_vm<text> vm(env,obj);
  vm->enable();
}

JNIEXPORT void JNICALL method(disable)(JNIEnv *env, jobject obj)
{
  java_vm<text> vm(env,obj);
  vm->disable();
}

JNIEXPORT jint JNICALL method(isenabled)(JNIEnv *env, jobject obj)
{
  java_vm<text> vm(env,obj);
  return vm->enabled();
}

