## component = hush

include resource.mk

CC = /opt/gcc-2.7.2/bin/gcc  
#LD = ld -G -dy
LD = $(CC) -G -dy

SHARE = /home/eliens/hush
HUSH = $(SHARE)/version/4.0

ext = .o
##ext = .obj
platform = mk
name = slush

component = hush
packages =  dv-pl-*.cpp 
objects = `ls $(component)-*.cpp $(packages) | sed -e "s:\.cpp:$(ext):g"`

library = lib$(name)
dv-pl-cflags = -DLIBRARY="\"$(HUSH)/library/pl\""


java-home = /home/eliens/hush/java/jdk
java-flags = -I$(java-home)/include -I$(java-home)/include/solaris -UJAVA

#purge = hush-java-* hush-gl-* hush-net-cs*
purge = hush-gl-* hush-net-cs*

component-cflags = -DHUSH $(java-flags) -DREGEX -UNOLIST -UDL_ENABLED \
		   -DINSTALLED="\"\"" -DBIN="\"\"" \
		$(dv-pl-cflags)
component-ldflags = # -L$(SHARE)/lib -lpl 

make = $(MAKE) -f $(name).$(platform)

##

all: purge compile link install

CFLAGS = -fPIC $(component-cflags) -I../include -DVERSION="\"hush-4.0\""
LDFLAGS = $(component-ldflags) -lsocket -lnsl -ldl

purge:
	#rm -f $(purge)

compile:; $(make) $(objects)

link:
	##$(LD) $(LDFLAGS) $(objects)
	$(LD) -o $(library).so $(objects) $(LDFLAGS)

static:
	$(AR) $(library).a $(objects)
	cp $(library).a /home/eliens/blaxxun/work/agent/src

install:
	cp $(library).so ../lib
	cp $(library).so $(SHARE)/lib

clean:; rm -f $(library).* $(component)*.o
