#include <hush/source.h>
#include <hush/widgets/tk/listbox.h>
#include <hush/sys/bind.h>


#define TYPE listbox
#define CLASS tk_listbox
#include <hush/widgets/tk/create.i>

#include <stdio.h>
#include <stdlib.h>


void CLASS::insert(const char* s) {
    sprintf(buf,"%s insert end \"%s\"",thepath(),s);
    tk->eval( buf );
}

void CLASS::insert(int i, const char* s) {
    sprintf(buf,"%s insert %d \"%s\"",thepath(),i,s);
    tk->eval( buf );
}

void CLASS::del() {
    sprintf(buf,"%s delete 0 end",thepath());
    tk->eval( buf );
}

void CLASS::del(int i) {
    sprintf(buf,"%s delete %d",thepath(),i);
    tk->eval( buf );
}

void CLASS::del(int first, int last) {
    sprintf(buf,"%s delete %d %d",thepath(), first, last);
    tk->eval( buf );
}

void CLASS::see(int index) {
    sprintf(buf,"%s see %d",thepath(), index);
    tk->eval( buf );
}

char* CLASS::get(int n) const {
    sprintf(buf,"%s get %d",thepath(),n);
    return tk->evaluate( buf );
}

int CLASS::selection() const {
    sprintf(buf, "%s curselection", thepath());
    return atoi(tk->evaluate(buf));	// can be a list!
}

int CLASS::selected(int index) const {
    sprintf(buf, "%s selection includes %d", thepath(), index);
    return atoi(tk->evaluate(buf));
}

void CLASS::select() {
    sprintf(buf, "%s selection set 0 end", thepath());
    tk->eval(buf);
}

void CLASS::select(int first, int last) {
    sprintf(buf, "%s selection set %d %d", thepath(), first, last);
    tk->eval(buf);
}

void CLASS::unselect() {
    sprintf(buf, "%s selection clear 0 end", thepath());
    tk->eval(buf);
}
void CLASS::unselect(int first, int last) {
    sprintf(buf, "%s selection clear %d %d", thepath(), first, last);
    tk->eval(buf);
}

int CLASS::size() const {
    sprintf(buf, "%s size", thepath());
    return atoi(tk->evaluate(buf));
}

void CLASS::singleselect() {
    sprintf(buf,"tk_CLASSSingleSelect %s",thepath());
    tk->eval( buf );
}


void CLASS::install(binding* ac, const char* args ) {
    sprintf(buf," bind %s <Double-Button-1> { "
	"set indices [ %s curselection ] ; "
	"foreach i $indices {%s %s [ %s get $i ] }}"
	,thepath(), thepath(), ac->name(), args, thepath());
    tk->eval( buf );
}


void CLASS::init(const char* options) {
    sprintf(buf,"listbox %s %s",path(),options);
    tk->eval(buf);


    // Change default behaviour ... is this ok ?
    // Anyway: my fileselector depends on this ...
    // jacco
    sprintf(buf,"bindtags %s { Listbox %s . all }", path(), path());
    tk->eval( buf );
}
