#include <hush/source.h>
#include <hush/widgets/tk/menu.h>
#include <hush/sys/bind.h>

#define TYPE menu
#define CLASS tk_menu
#define CONSTRUCTOR _name = ""; _args = "";
#include <hush/widgets/tk/create.i>

#include <string.h>
#include <stdio.h>


// AE static char* empty = "";



menu* CLASS::oldadd(const char* s, const char* options) {
	sprintf(buf,"%s add %s %s", path(),s,options);
	tk->eval( buf );
	return this;
	}

menu* CLASS::entry(const char* s, binding* ac,
			const char* args,const char* options) {
	return add(s,ac,args,options);
	}

menu* CLASS::entry(const char* s, const char* args,
					 const char* options) {
	return add(s,args,options);
	}

menu* CLASS::add(const char* s, binding* ac,
		       const char* args, const char* options) {
	sprintf(buf,"%s add command -label \"%s\" -command \"catch {%s {%s} %s}\" -state active %s",
		path(),s,ac->name(),s,args,options);
	tk->eval( buf );
	return this;
	}

menu* CLASS::add(const char* s, const char* args, const char* options) {
	sprintf(buf,"%s add command -label \"%s\" -command \"catch {%s {%s} %s %s}\" -state active %s",
		(char*)path(),s,_name,s,args,(char*) _args,options);
	tk->eval( buf );
	return this;
	}

menu* CLASS::checkbutton(const char* s, const char* args, const char* options) {
        sprintf(buf,"%s add checkbutton -label \"%s\" -command \"catch {%s {%s} %s %s}\" -state active %s", (char*)path(),s,_name,s,args,(char*) _args,options);
        tk->eval( buf );
        return this;
}    

menu* CLASS::radiobutton(const char* s, const char* var, const char* args, const char* options) {
        sprintf(buf,"%s add radiobutton -label \"%s\" -variable \"%s\" -command \"catch {%s {%s} %s %s}\" -state active %s", (char*)path(),s,var,_name,s,args,(char*) _args,options);
        tk->eval( buf );
        return this;
}    


menu* CLASS::cascade(const char* s, const char* m, const char* options) {
	sprintf(buf,"%s add cascade -label \"%s\" -menu %s %s",
		path(),s,m,options);
	tk->eval( buf );
	return this;
	}

menu* CLASS::cascade(const char* s, menu* m, const char* options) {
	sprintf(buf,"%s add cascade -label \"%s\" -menu %s -state active %s",
		path(),s,m->path(),options);
	tk->eval( buf );
	return this;
	}

menu* CLASS::separator(const char* options) {
          sprintf(buf,"%s add separator %s",path(), options);
          tk->eval(buf);
          return this;
        }


char* CLASS::entryconfigure(int i, const char* options) {
	sprintf(buf,"%s entryconfigure %d %s",path(),i,options);
	return tk->evaluate( buf );
	}

int CLASS::index(const char *s) const {
	sprintf(buf,"%s index %s",path(),s);
	int n = -1; sscanf(tk->evaluate( buf ),"%d",&n);
	return n;
	}

int CLASS::active() const { return index("active"); }


void CLASS::del(int i) {
	sprintf(buf,"%s delete %d",path(),i);
	tk->eval( buf );
	}

void CLASS::del(const char* s) {
	sprintf(buf,"%s delete %s",path(),s);
	tk->eval( buf );
	}

void CLASS::invoke(int i) {
	sprintf(buf,"%s invoke @%d",path(),i);
	tk->eval( buf ); 
	}

void CLASS::invoke(const char *s ) {
	sprintf(buf,"%s invoke %s",path(),s);
	tk->eval( buf );
	}

void CLASS::post(int x, int y) {
	sprintf(buf,"%s post %d %d",path(),x,y);
	tk->eval( buf );
	}

void CLASS::unpost() {
	sprintf(buf,"%s unpost",path());
	tk->eval( buf );
	}


void CLASS::install(binding* ac, const char* args) {
	_name = new char[strlen(ac->name())+1];
	strcpy(_name,ac->name());
	_args = new char[ strlen(ac->name())+1];
	strcpy(_args,args);
	}
