#include <hush/source.h>
#include <hush/widgets/tk/text.h>
#include <hush/sys/bind.h>

#define TYPE text
#define CLASS tk_text
#define CONSTRUCTOR _enabled = 1;
#include <hush/widgets/tk/create.i>


#include <string.h>
#include <stdio.h>



void CLASS::insert(const char* s) {
  int was_enabled = enabled();
  if (!enabled()) enable();
  char *buf = new char[strlen(s) + 100];
  sprintf(buf,"%s insert insert \"%s\"",thepath(),s);
  tk->eval( buf );
  delete buf;
  if (!was_enabled) disable();
}

void CLASS::insert(int l, int n, const char* s, const char* tags) {
  int was_enabled = enabled();
  if (!enabled()) enable();
  char *buf = new char[strlen(s) + 100];
  sprintf(buf,"%s insert %d.%d \"%s\" \"%s\"",thepath(),l,n,s,tags);
  tk->eval( buf );
  delete buf;
  if (!was_enabled) disable();
}

void CLASS::insert(const char* ind, const char* s, const char* tags) {
  int was_enabled = enabled();
  if (!enabled()) enable(); 
  char *buf = new char[strlen(s) + 100];
  sprintf(buf,"%s insert %s \"%s\" \"%s\"",thepath(),ind,s,tags);
  tk->eval( buf );
  delete buf;
  if (!was_enabled) disable();
}

void CLASS::del(const char* from, const char* to) {
  int was_enabled = enabled();
  if (!enabled()) enable(); 
  sprintf(buf, "%s delete \"%s\" \"%s\"", thepath(), from, to);
  tk->eval(buf);
  if (!was_enabled) disable();
}

void CLASS::del(int fromline, int fromcol, int toline, int tocol) {
  int was_enabled = enabled();
  if (!enabled()) enable(); 
  sprintf(buf, "%s delete %d.%d %d.%d", thepath(), fromline, fromcol, toline, tocol);
  tk->eval(buf);
  if (!was_enabled) disable();
}

char* CLASS::get(const char* from, const char* to) const {
  sprintf(buf, "%s get \"%s\" \"%s\"", thepath(), from, to);
  return tk->evaluate(buf);
}

char* CLASS::get(int fromline, int fromcol, int toline, int tocol) const {
  sprintf(buf, "%s get %d.%d %d.%d", thepath(), fromline, fromcol, toline, tocol);
  return tk->evaluate(buf);
}

void CLASS::install(binding* ac, const char* args ) {
  sprintf(buf," bind %s <Double-Button-1> {foreach i [selection get] {%s $i %s}}",thepath(),ac->name(),args);
  tk->eval( buf );
}

void CLASS::enable() {
  _enabled = 1;
  sprintf(buf, "%s configure -state normal", thepath());
  tk->eval( buf );
}

void CLASS::disable() {
  _enabled = 0;
  sprintf(buf, "%s configure -state disabled", thepath());
  tk->eval( buf );
}
