#!/bin/sh
##@ mk-ciao

. @BIN/ciao-env

##@ options

while [ $# -ge 1 ]; do case $1 in
	-c)    mode=cc;;
	-cc)   mode=CC;;
	-I*)   cargs="$cargs $1";;
	-html) mode=html;;
	-url)  url=$2; shift;;
	-mode) mode=$2; shift;;
	-query) query=$2; shift;;
	-text)   output=text;;
	-graph)  output=graph;;
	-output) output=$2; shift;;
	-gif)  gif=gif;;
	-ps)  gif=ps;;
	*) break;;
	esac;
	shift;
done;

##@ process

CIAOLANG=$mode
CIAOTYPE=$mode

if [ "$mode" = "cc" ]; then
	cmd="$cia $cargs -c";
elif [ "$mode" = "CC" ]; then
	cmd="$ccia $cargs -c";
elif [ "$mode" = "html" ]; then
	cmd="$hia $url";
fi;

args=$*

if [ "$query" != "false" ]; then 
	$SHELL -c "ciao_query_$mode $output $query $args" > @tmp-$$;
	if [ "$gif" != "false" ]; then
		cat @tmp-$$ | $dot -T$gif
	else
		cat @tmp-$$
	fi;
	exit;

else

for i in $args; do
	$SHELL -c "$cmd  $i";
	done

if [ "$mode" = "c" -o "$mode" = "cc" ]; then

if [ "$mode" = "c" ]; then
$SHELL -c "$cia *.A";
$SHELL -c "$BIN/ciao_packvdb entity.db relationship.db \> ciao.db"
else
$SHELL -c "$ccia *.A";
$SHELL -c "$ciald -o @ciao.db entity.db relationship.db";
fi;

for i in $args; do
	$BIN/incl -R $i;
	S=`suffix $i`;
	B=`basename $i $S`;
	f=dummy;
	if [ -f $B.d ]; then f=$B.d; 
	elif [ -f $B.D ]; then f=$B.D;
	fi;
	if [ "$f" != "dummy" ]; then
		$dot -Tgif $f > $i.gif;
	fi;
	done;

elif [ "$mode" = "html" ]; then

for i in $args; do
	$SHELL -c "$cmd  $i";
	S=`suffix $i`;
	B=`basename $i $S`;

	f=@entity-$B.dot
	echo "Writing dot in $f"
	$SHELL -c "$BIN/ciao_query_html graph eset  "   > $f
	$SHARE/bin/dot -Tgif $f > $f.gif;

	f=@graph-$B.dot
	echo "Writing dot in $f"
	$SHELL -c "$BIN/ciao_query_html graph rset - - - -  "   > $f
	$SHARE/bin/dot -Tgif $f > $f.gif;

	f=@map-$B.dot
	echo "Writing dot in $f"
	$SHELL -c "$BIN/ciao_query_html graph rset - - - -  "   > $f
	$SHARE/bin/dot -Tismap $f > $f.map;

	done;

fi;

fi; ## query
