#!/bin/sh

##@ exec-sh

sh=/bin/sh

pwd=`pwd`;
cmd=
src=
out=
err=
par=
echo=
halt=
program=


while [ $# -ge 1 ]; do case $1 in
	-echo) echo=echo;;
	-src|-f) src="$src $2"; shift;;
	-pwd) pwd=$2; shift;;
	-program|-x) program="$program $2"; shift;;
	-c*|-g*) if [ "$2" != "nl" ]; then 
			cmd="$cmd $2;";
		 fi; shift;;
	-out|-file) out=" > $2 "; shift;;
	-err) err=" 2> $2 "; shift;;
	-par) par=" & ";shift;;
	-halt|halt) if [ "$2" != "nl" ]; then
			halt=$2;
		    fi; shift;;
	-sh) sh=$2; shift;;
	*) shift;;
	esac;
	shift;
done;

tmp="@tmp-exec-sh-$$"

echo " " > $tmp;

if [ "-$src" != "-" ]; then
	for i in $src; do
		cat $i >> $tmp;
	done
fi;
if [ "-$program" != "-" ]; then
	for i in $program; do
		cat $i >> $tmp;
	done
fi;
if [ "-$cmd" != "-" ]; then
		echo "$cmd" >> $tmp;
fi;
if [ "-$sh" = "-xterm" ]; then
	(cd $pwd; $sh);
else
	$sh $tmp;
fi;
if [ "-$halt" != "-halt" ]; then $halt; fi;
##</>
