%{
//@auto=0
//@class inc
%}
%class lex
%{
char* ext = ".pvl";
static int pr = 0;
static int old = 0;

char yytext[10*1024];

static int in_right = 0;
static float un_break = 0;

static int font_no = 0;

static int items[9];
static int list_type[9];

static char name[64];
static int empty_line = 0;
static int no_style = 0;
static int es_mode = 0;
static int bk_mode = 0;
static int x_mode = 0;
static int pvl_mode = 0;

static int do_pop = 0;

static int in_object = 0;
static int in_slide = 0;
static int slideno = 0;

static int centered = 0;
static int in_list = 0;

static int in_font = 0;
static int in_link = 0;
static int in_header = 0;
static int in_line = 0;
static int in_li = 0;
static int in_p = 0;
static int in_q = 0;

static int old_p = 0;

static int is_aligned = 0;

static int in_display = 0;



#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <iostream.h>

#include <hush/dictionary.h>
#include <hush/stack.h>

static int hold_level = -1;
static int the_level = 0;

static string start_level = "-1";
static string end_level = "-1";


static string align = "BEGIN";

static dictionary<string> colors; 
static string linkcolor= "1 1 0";

static string the_url;

static string display_size = "1";

static stack<string>* st_style = 0;
static stack<string>* st_family = 0;
static stack<string>* st_color = 0;
static stack<string>* st_size = 0;

static string df_size = "1";
static string df_color= "1 1 1";
static string df_justify = "BEGIN";
static string df_family = "SERIF";
static string df_style = "PLAIN";
static string dl_bgcolor = "0.7 0.7 1";
static string dl_bgtrans = "1";

static string f_size = "1";
static string f_color= "1 1 1";
static string f_justify = "BEGIN";
static string f_family = "SERIF";
static string f_style = "PLAIN";
static string l_bgcolor = "0.7 0.7 1";
static string l_bgtrans = "1";

static string old_size = "1 1 1";
static string old_color = "1 1 1";
static string old_justify = "BEGIN";
static string old_family = "SERIF";
static string old_style = "PLAIN";
static string old_bgcolor = "0.7 0.7 1";
static string old_bgtrans = "1";

static int level_display = 0;
static int auto_level = 0;
static int list_level[8];

void reset_level() {
start_level = "-1";
end_level = "-1";
auto_level = 0;
list_level[0] = auto_level;
}

void set_start(const char* x) {
char buf[64];
char* s = (char*) start_level;
int n; sscanf(s,"%d",&n);
if (!strcmp(x,"++")) {
	n++; sprintf(buf,"%d",n);
	start_level = (char*) buf;
	}
else if (!strcmp(x,"--")) {
	n--; sprintf(buf,"%d",n);
	start_level = (char*) buf;
	}
else start_level = x;
}

void set_end(const char* x) {
char buf[64];
char* s = (char*) end_level;
int n; sscanf(s,"%d",&n);
if (!strcmp(x,"++")) {
	n++; sprintf(buf,"%d",n);
	end_level = (char*) buf;
	}
else if (!strcmp(x,"--")) {
	n--; sprintf(buf,"%d",n);
	end_level = (char*) buf;
	}
else if (!strcmp(x,"start")) {
	char buf1[64];
	char* st = (char*) start_level;
	int m; sscanf(st,"%d",&m);
	sprintf(buf,"%d",m);
	end_level = (char*) buf;
	}
else if (x[0] == '+') {
	char buf1[64];
	char* st = (char*) start_level;
	int m; sscanf(st,"%d",&m);
	char buf2[64];
	char* sk = (char*) x+1;
	int k; sscanf(sk,"%d",&k);
	int lx = m + k;
	sprintf(buf,"%d",lx);
	end_level = (char*) buf;
	}
else end_level = x;
}

void set_level(const char* x = 0) {
//cerr << "## set_level " << x << " " << auto_level << endl;
if (x && !strcmp(x,"auto")) {
	auto_level = 1;
	}
else if (x && !strcmp(x,"on")) {
	auto_level = 1;
	}
else if (x && !strcmp(x,"off")) {
	auto_level = 0;
	}
else if (x && x[0] == '+') {
	set_start(x);
	}
else if (!x) {
	if (auto_level) set_start("++");
	}
if (x) { list_level[in_list] = auto_level; }
}

void display_level(const char* x = 0) {
//cerr << "## set_level " << x << " " << auto_level << endl;
if (x && !strcmp(x,"auto")) {
	level_display = 1;
	}
else if (x && !strcmp(x,"on")) {
	level_display = 1;
	}
else if (x && !strcmp(x,"off")) {
	level_display = 0;
	}
}

char* kleur(const char* x) {
if (!strcmp("red",x)) return "1 0 0";
else if (!strcmp("yellow",x)) return "1 1 0";
else if (!strcmp("blue",x)) return "0 0 1";
else if (!strcmp("green",x)) return "0 1 1";
else if (!strcmp("white",x)) return "1 1 1";
else if (!strcmp("black",x)) return "0 0 0";
else if (!strcmp("gold",x)) return "1 1 0";
else if (!strcmp("silver",x)) return "0.9 0.9 0.9";
else return "1 1 1";
}

void font_push() {
	if (!st_style) st_style = new stack<string>;
	if (!st_family) st_family = new stack<string>;
	if (!st_color) st_color = new stack<string>;
	if (!st_size) st_size = new stack<string>;
	st_style->push( new string((char*)f_style));
	st_family->push( new string((char*)f_family));
	st_color->push( new string((char*)f_color));
	st_size->push( new string((char*)f_size));
	font_no = 0;
	}

#define out if (pr) cout

void font_pop() {
string* p;
if (!st_style) st_style = new stack<string>;
if (!st_family) st_family = new stack<string>;
if (!st_color) st_color = new stack<string>;
if (!st_size) st_size = new stack<string>;
p = st_style->pop(); if (!p) out << "##error font style (pop)" << font_no << endl;
if (p) f_style = (char*) *p; else f_style = (char*) df_style; 
p = st_family->pop(); if (!p) out << "##error font family (pop)" << font_no << endl;
if (p) f_family = (char*) *p; else f_family = (char*) df_family;
p = st_color->pop(); if (!p) out << "##error font color (pop)" << font_no << endl;
if (p) f_color = (char*) *p; else f_color = (char*) df_color;
p = st_size->pop(); if (!p) out << "##error font size (pop)" << font_no << endl;
if (p) f_size = (char*) *p; else f_size = (char*) df_size;
}


void reset(){
f_size = "1";
f_color= "1 1 1";
f_justify = "BEGIN";
f_family = "SERIF";
f_style = "PLAIN";
l_bgcolor = "0.7 0.7 1";
l_bgtrans = "1";
}

void deprecated(char* s) {
	//cerr << "## DEPRECATED " << s << endl; 
	out << "## DEPRECATED " << s << endl; 
	}

char* xsize(float x) {
static char buf[20*512];
float f;
char fbuf[64];
sprintf(fbuf,"%s", (char*) f_size);
sscanf(fbuf,"%f",&f);
sprintf(buf,"%f",f * x);
return (char*) buf;
}


char* lp(int x = 0) {
static char buf[20*512];
static char buf1[20*512];
static char buf2[20*512];
char* p = &buf2[0];
sprintf(buf," justify [\"%s\"] startLevel %s endLevel %s ", (char*) f_justify, (char*) start_level, (char*) end_level);
if (!x) { 
sprintf(buf1," %s family [\"%s\"] style \"%s\" color %s size %s string \"", 
	(char*) buf,
	(char*) f_family,
	(char*) f_style,
	(char*) f_color,
	(char*) f_size);
} else sprintf(buf1,"%s",buf);
if (in_link && (x != 2)) {
	sprintf(buf2," href %s %s",(char*) the_url, (char*) buf1);
	//p = &buf2[0];
} else sprintf(buf2,"%s",buf1);
in_line = 1;
return (char*) p;
}

inline void check(char* x = 0) {
        empty_line = 0;
        if (in_line || in_li || in_p || in_header ) {
		out << "\" } ## check " << (char*) (x?x:"") << " " << yytext << endl; 
		}
	in_li = in_line = 0; in_p = 0;
	if (un_break != 0) {
		out << "break { size " << un_break << lp(2) << " } ## " << yytext << endl;
		un_break = 0;
		}
	}

void un_p() {
	check();
	in_p = 0;
	}


char* uq(char* x) {
static char buf[20*512];
buf[0]='\0';
char* p = x;
char* q = (char*) buf;
while ( *p != '\0' ) {
	if (*p == '"') *q++ = '\\';
	*q++ = *p++;
	}
*q = '\0';
return (char*) buf;
}

//extern "C" system(char*);
%}
name [\~\/\@A-Za-z0-9\.][\_\@A-Za-z0-9\.\/\-\+]*
names [ \t]*{name}({name}|[ \t])*
atts [^\>]*
C \@
%%@ rules




"<a "{atts}">" { 
	if (!in_object) {
	yytext[yyleng-1] = '\0';
        int has_href = 0; string href;
        int has_ref = 0; string ref;
        string_converter x(yytext+2);
        for (int i = 1; i <= x.argc(); i++ ) {
           attribute p(x[i]);
	   if (p.matches("ref")) { has_ref = 1; ref = p.value(); }
	   else if (p.matches("href")) { has_href = 1; href = p.value(); }
           else if ( p.matches("level") ) { set_level( p.value()); }
           else if ( p.matches("start") ) { set_start( p.value()); }
           else if ( p.matches("end") ) { set_end( p.value()); }
	   }
	if (has_ref || (x_mode && (has_href))) {
		in_link = 1;
		char buf[1024];
		sprintf(buf,"%s%s",(char*)(has_ref?ref:href),(has_ref?".wrl":""));
		the_url = (char*)buf;
		out << "\" }\n";
		out << (old?"aline { href ":"TextElement { href ");
		out << the_url;
		if (in_right) { // AE
			f_justify = "END";
			}
		out << lp();
		f_justify = (char*) old_justify;
		}
	}
}
"</a>" {
	if (!in_object && in_link && x_mode) {
	   in_link = 0;
	   if (1 || !in_header) {
		out << "\" }\n";
		out << (old?"line {":"TextElement {");
                out << lp();  
		}
	}
}

. { ECHO; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
list_level[0] = auto_level;
colors["red"] = new string( "1 0 0");
colors["blue"] =  new string("0 0 1");
colors["yellow"] = new string( "1 1 0");
colors["green"] = new string( "0 1 1");
colors["black"] = new string( "0 0 0");
colors["white"] = new string( "1 1 1");
colors["silver"] = new string( "0.8 0.8 0.8");
colors["gold"] = new string( "0.9 0.9 0");
//f_color="1 1 1";
//linkcolor="1 1 0";
//align = "BEGIN";
strcpy(name,"temp");
int _argc = 0;
argc--; argv++;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( argv[0][1] == 'N'  ) {
	     strcpy(name,argv[0]+2);
	} else if ( argv[0][1] == 'e'  ) {
	     es_mode=1;
	} else if ( argv[0][1] == 'p'  ) {
	     pvl_mode=1;
	} else if ( argv[0][1] == 'o'  ) {
	     old=1;
	} else if ( argv[0][1] == 'b'  ) {
	     bk_mode = 1;
	} else if ( argv[0][1] == 'x'  ) {
	     x_mode = 1;
	} else if ( argv[0][1] == 'S'  ) {
	     no_style = 1;
	} else if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
	argc--; argv++;
	}

l.paths(_argc, _argv);
pr = 1;
out << "#VRML V2.0 utf8                ##  " << name <<  endl; 
if (pvl_mode && !es_mode && !no_style) { 
  l.soinc("style.wrl"); 
  }
if (pvl_mode && !es_mode) {
  out << "#@include SlideBegin.wrl" << endl;
}
if ( argc == 0 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
check();
if (pvl_mode && !es_mode) {
  out << "#@include SlideEnd.wrl" << endl;
  }
return 0;
}
//</>
