%{
//@auto=0
//@class inc
%}
%class lex
%{
char* ext = ".pvl";
static int pr = 0;

#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <hush/iostream.h>



void deprecated(char* s) {
	//cerr << "## DEPRECATED " << s << endl; 
	cout << "## DEPRECATED " << s << endl; 
	}

%}
name [\~\/\@A-Za-z0-9\.][\_\@A-Za-z0-9\.\/\-\+]*
names [ \t]*{name}({name}|[ \t])*
atts [^\>]*
C \@
s [ \t]+
w {s}*
d [0-9\.\-]+
v [A-Za-z\_\0-9]+
q {w}\"{w}
b {w}\[{w}
e {w}\]{w}
qb {b}{q}
qe {q}{e}
qv {q}{v}{q}
bqv {qb}{v}{qe}
mv  ({bqv}|{qv})
sv  ({v}|{qv})
br [ \t]*("br TRUE"|"br FALSE")[ t]*
size [ \t]*"size"[ \t]+[0-9\.\-\+]+[ \t]*
trans {w}"translation"{s}{d}{s}{d}{s}{d}{w}
color {w}"color"{s}{d}{s}{d}{s}{d}{w}
family {w}"family"{s}{mv}{w}
style {w}"style"{s}{sv}{w}
justify {w}"justify"{s}{mv}{w}
level {w}"startLevel"{s}{d}{w}"endLevel"{s}{d}{w}
line ({level}*|{br}*|{size}*|{trans}*|{color}*|{family}*|{style}*|{justify}*)*
%%@ rules
\n+\"[ \t]*"}" { cout << "\" }"; }
$\"\n+ { cout << "\""; }
"l -1 }\" }" { cout << "l -1 }"; }
"\\chapter{ \" }" { }
^"<hr>\" }" { }
"xline "[^\#\n]"##" { }
"line {"{line}"string "\"\"[ \t]*"}" {}
"xline {"{line}"string "\"[ \t\n]*\"[ \t\n]*"}" {
	//cerr << "EMPTY LINE" << endl;
	};
"line {"{line}"string "\"[ \t]*\n+ {
	char* p = &yytext[yyleng];
	while ( *p != '"' ) p--;
	*(p+1) = '\0';
	cout << yytext;
	//cout <<  "line { string \"";
	} 
\t { cout << "        "; }
. { ECHO; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
//align = "BEGIN";
int _argc = 0;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
	argc--; argv++;
	}

l.paths(_argc, _argv);
pr = 1;
if ( argc == 1 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
return 0;
}
//</>
