%{
//@auto=0
//@class ht-ml
%}
%class ht_ml_lex
%o 18000
%p 15000
%e 5000
%a 12000
%n 2000
%{
#include <hush/hush.h>
#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>

#include <hush/dictionary.h>
#include <hush/agent/resolver.h>
#include <hush/agent/query.h>

#include <hush/set.h>

#include <iostream.h>
#include <string.h>

//@ session info

ht_ml_lex* _lexer;

void text(dvstring* x) {
	_lexer->text((char*)*x);
	}

static int in_references = 0;

static int citemode = 0;
static int refstyle=0;
static query* _query = 0;
static session* thesession = 0;
static kit* tk;

static int warnings = 0;

//@ biblio/references

static int biblio_listed = 0;

static char pagestyle[1024] = "white";

static int chap_no = 0;

static int fm_nolines=0;
static int printer_state = 0;

ostream& operator<<(ostream& os, string* p) {
	if (p) os << (char*) *p;
	return os;
	}

static string  the_slide = "unknown";
static string  the_caption = "unknown";
static string* kato_mode = 0;
static string* kato_scope = 0;
static dictionary<string> aliasref;
static dictionary<string> refto;

int state;

#define entry bridge_entry

struct entry {

int _isref;

class  printer  {
public:
virtual void print(ostream&,entry&,int=0,string* k=0) { }
};

static dictionary<entry>* thereferences;
#define references (*entry::thereferences)

static dictionary<entry>* thereferenced;
#define referenced (*entry::thereferenced)



dictionary<string> info;
static dictionary<printer>* theprinters;

int is_ref() { 
              string* s = info["category"] ;
	      if (!s) return 0;
	      else return *s == "reference";
	      }

virtual void print(ostream& os, int cmt=0, string* k=0) {
	int phase = 0;
	dictionary<printer>& printers = *theprinters;
	if (cmt==1) phase=printer_state;
	if (!cmt) cerr << "***> " << *kato_mode << " <-xx-> " << *kato_scope << endl;
	printer* f = printers[(char*)*kato_mode];
	if (!f) f = printers["refs"];;
	f->print(os,*this,phase,k);
	}

class bridge_printer : public printer {
public:
void print(ostream& os, entry& e, int phase=0, string* k=0) {
if (phase==-1) {
	os << "<!DOCTYPE index PUBLIC  \"-//DejaVu//DTD Bibref//EN\" [" << endl;
        os << "<!ENTITY % userfields \"abstract?\">" << endl;
        os << "<!ELEMENT abstract - O (#PCDATA)>" << endl;
	os << "]>" << endl;
	os << "\n<index>" << endl;
	}
else if (phase==1)  os << "</index>" << endl;
else if (*e.category() == "reference") {
                entry* x1 = referenced[e.ref()];
		entry* x2 = referenced[e.key()];
                if (!x1 && !x2) {
		    entry* x = references[e.ref()];
		    referenced[e.key()] = &e;
		    if (x) x->print(os, phase, e.key());
		    }
} else {
int ok = 1;
referenced[e.key()] = &e;
string cat = (char*) *e.category();
string* x = aliasref[k?k:e.key()];
if (x) k = x;
if (*kato_scope == "strict" && !refto[(k?k:e.key())]) ok=0;
if (ok && cat=="book") {
	os << "<" << e.category(); 
	os << " bibref=\"" << (k?k:e.key()) << "\"";
	if (0 && e.ref()) os << " reference=\"" << (e.ref()?e.ref():e.key()) << "\">" << endl;
	else os << ">" << endl;
	os << "<author>" << e.author() << "</author>" << endl;
	os << "<title>" << e.title() << "</title>" << endl;
	os << "<publisher>" << e.publisher() << "</publisher>" << endl;
	os << "<year>" << e.year() << "</year>" << endl;
	if (e.softcopy()) os << "<softcopy>" << e.softcopy() << "</softcopy>" << endl;
	if (0 && e.comment()) os << "<comment>" << e.comment() << "</comment>" << endl;
	os << "</" << e.category() << ">" << endl;
} else if (ok && cat=="article") {
	os << "<" << e.category(); 
	os << " bibref=\"" << (k?k:e.key()) << "\"";
	if (0 && e.ref()) os << " reference=\"" << (e.ref()?e.ref():e.key()) << "\">" << endl;
	else os << ">" << endl;
	os << "<author>" << e.author() << "</author>" << endl;
	os << "<title>" << e.title() << "</title>" << endl;
	os << "<journal>";
	os << e.journal()?e.journal():e.publisher() ;
	os << "</journal>" << endl;
	os << "<volume>" << e.volume() << "</volume>" << endl;
	os << "<number>" << e.number() << "</number>" << endl;
	os << "<year>" << e.year() << "</year>" << endl;
	if (e.month()) os << "<month>" << e.month() << "</month>" << endl;
	if (e.softcopy()) os << "<softcopy>" << e.softcopy() << "</softcopy>" << endl;
	if (0 && e.comment()) os << "<comment>" << e.comment() << "</comment>" << endl;
	os << "</" << e.category() << ">" << endl;
} else if (ok && cat=="inproceedings") {
	os << "<" << e.category(); 
	os << " bibref=\"" << (k?k:e.key()) << "\"";
	if (0 && e.ref()) os << " reference=\"" << (e.ref()?e.ref():e.key()) << "\">" << endl;
	else os << ">" << endl;
	os << "<author>" << e.author() << "</author>" << endl;
	os << "<title>" << e.title() << "</title>" << endl;
	if (e.month()) os << "<month>" << e.month() << "</month>" << endl;
	os << "<year>" << e.year() << "</year>" << endl;
	if (e.pages()) os << "<pages>" << e.pages() << "</pages>" << endl;
	os << "<booktitle>" << e.booktitle() << "</booktitle>" << endl;
	os << "<publisher>" << e.publisher() << "</publisher>" << endl;
	if (e.address()) os << "<address>" << e.address() << "</address>" << endl;
	if (e.softcopy()) os << "<softcopy>" << e.softcopy() << "</softcopy>" << endl;
	if (0 && e.comment()) os << "<comment>" << e.comment() << "</comment>" << endl;
	os << "</" << e.category() << ">" << endl;
	}
  }

}
};


class refs_printer : public printer {
public:
void print(ostream& os, entry& e, int phase=0, string* k = 0 ) {
if (phase==-1) os << "<dl>" << endl;
else if (phase==1)  os << "</dl>" << endl;
else {
	if (*e.category() == "reference") {
		entry* x = references[e.ref()];
		if (x) x->print(os, phase, e.key());
		}
	if (e.ref()) os << "<dt>" << e.ref() << endl;
	else 
		if (k || e.key()) os << "<dt> " << (k?k:e.key()) << endl;
	if (e.author()) os << "<dd> " << e.author();
	if (e.title()) os << "," << endl;
	if (e.title()) os << (e.is_book()?"<i>":"") << e.title() << (e.is_book()?"</i>":"");
	if (e.publisher()) os << "," << endl;
	if (e.publisher()) os << e.publisher() << endl;
	//os << "%X " << e.comment() << endl;
	}
  }
};

class bk_printer : public printer {
public:
void print(ostream& os, entry& e, int phase=0, string* k = 0 ) {
in_references=1;
int ok = 1;
if (*kato_scope == "strict" && !refto[(k?k:e.key())]) ok=0;
if (ok && phase==-1) {
	os << "<c><dl></c>" << endl;
	//os << "<!-- \\begin{thebibliography}{W1} -->" << endl;
} else if (ok && phase==1) {
	os << "<c></dl></c>" << endl;
	//os << "<!-- \\end{thebibliography} -->" << endl;
} else if (ok) {
	if (*e.category() == "reference") {
		entry* x = references[e.ref()];
		if (x) x->print(os, phase, e.key());
		}
	if (e.ref() && !refstyle) {
		os << "<c><a name=" << e.key() << "></c>";
		os << "<c><dt>"; // << e.ref() << "</c>" << endl;
		text(e.ref());
		os << "</c>" << endl;
		os << "<!-- \\bibitem[";
		//os << e.ref();
		text(e.ref());
		os << "]{" << e.key() << "} -->" << endl;
	} else { 
		if (k || e.key()) os << "<a name=" << (k?k:e.key()) << ">";
		if (k || e.key()) os << "<c><dt> " << (k?k:e.key()) << "</c>"<< endl;
		if (k || e.key()) os << "<!-- \\bibitem{" << (k?k:e.key()) << "} -->" << endl;
	}
	if (*e.category() == "missing") {
		string* x = refto[(char*)*e.key()];
		if ( x && *x == "missing" ) { 
		os << "<c><dd></c>" << e.key() << " <font color=red>missing reference</font>" << endl;
		} else {
			ok = 0;
			}
		}
	if (ok && e.author()) {
		os << "<c><dd></c>"; // << e.author();
		text(e.author());
		os << ",";
		}
	if (ok && e.title()) os << " " << endl;
	if (ok && e.title()) {
		os << (e.is_book()?"<i>":""); // << e.title()
		text(e.title());
		os << (e.is_book()?"</i>":"");
		}
	if (ok && e.publisher()) os << "," << endl;
	if (ok && e.publisher()) { // os << e.publisher() << endl;
		text(e.publisher());
		os << endl;
		}
	//os << "%X " << e.comment() << endl;
	}
  }
};

class kato_printer : public printer {
public:
void print(ostream& os, entry& e, int phase, string* k) {
if (phase==-1) os << "" << endl;
else if (phase==1)  os << "" << endl;
else {
	os << "%K " << (k?k:e.key());
	if (e.ref()) os << e.ref() << endl; else os << endl;
	os << "%A " << e.author() << endl;
	os << (e.is_book()?"%B ":"%T ") << e.title() << endl;
	os << "%O " << e.publisher() << endl;
	if (e.comment()) os << "%X " << e.comment() << endl;
	}
  }
};

entry() : info(1) {
 	_isref = 0;
	state = 0;
	if (!thereferences) thereferences = new dictionary<entry>;
	if (!thereferenced) thereferenced = new dictionary<entry>;
	if (!theprinters) theprinters = new dictionary<printer>;
	dictionary<printer>& printers = *theprinters;
	if (!printers["refs"]) printers["refs"] = new refs_printer;
	if (!printers["kato"]) printers["kato"] = new kato_printer;
	if (!printers["bridge"]) printers["bridge"] = new bridge_printer;
	if (!printers["bk"]) printers["bk"] = new bk_printer;
	}

~entry() { }

void key(const char* s)   { info["key"]= new string(s); }
string* key()   { return info["key"]; }

void ref(const char* s) { info["ref"]= new string(s); }
string* ref()   { return info["ref"]; }

void category(const char* s) { info["category"]=new string(s); }
string* category() {
        string* x = info["category"];
	if (!x) info["category"] = new string("article");
	return info["category"];
	}

void title(const char* s, char c = 'T') { 
		info["title"] = new string(s);
		if (c == 'b') info["category"] = new string("book");
		else info["category"] = new string("article");
		}
string* title() { return info["title"]; }

void author(const char* s) { info["author"] = new string(s); }
string* author() { 
                 string* s =  info["author"];
		 if (s) return s; // AE
		 if (!s && is_ref()) {
		          entry* x = references[ref()];
			  if (x) return x->author();
			  else  {
				cerr << "KATO ERROR: reference " << key() <<  ref() << endl;
				}
			  }
	         else return s;
		 }

void booktitle(const char* s) { info["booktitle"] = new string(s); }
string* booktitle() { return  info["booktitle"]; }

void format(const char* s) { info["format"] = new string(s); }
string* format() { return  info["format"]; }

void url(const char* s) { info["url"] = new string(s); }
string* url() { return  info["url"]; }

void softcopy(const char* s) {
	string* p = info["softcopy"];
	if (p) *p += (char*) s;
	else info["softcopy"] = new string(s);
	}
string* softcopy() { return  info["softcopy"]; }

void address(const char* s) { info["address"] = new string(s); }
string* address() { return  info["address"]; }

void publisher(const char* s) { info["publisher"] = new string(s); }
string* publisher() { return info["publisher"]; }

void editor(const char* s) { info["editor"] = new string(s); }
string* editor() { return info["editor"]; }

void journal(const char* s) { info["journal"] = new string(s); }
string* journal() { return info["journal"]; }

void year(const char* s) { info["year"] = new string(s); }
string* year() { return info["year"]; }

void month(const char* s) { info["month"] = new string(s); }
string* month() { return info["month"]; }

void volume(const char* s) { info["volume"] = new string(s); }
string* volume() { return info["volume"]; }

void pages(const char* s) { info["pages"] = new string(s); }
string* pages() { return info["pages"]; }

void number(const char* s) { info["number"] = new string(s); }
string* number() { return info["number"]; }

void comment(const char* s) { info["comment"] = new string(s); }
string* comment()  { return info["comment"]; }

int is_book() {
	string* p = info["category"];
	if (p && (*p == "book")) return 1;
	else return 0;
	}

};

int operator==(const entry& _e1, const entry& _e2) {
	if (citemode==1) return 0;
	entry& e1 = (entry&)_e1;
	entry& e2 = (entry&)_e2;
	string* s1 = e1.author();
	string* s2 = e2.author();
	if (!s1 || !s2 ) return 0;
	//cout << "Compare:" << s1 << " " << s2 << endl;
        int result = (*s1).compare(*s2);
	if (result ) cerr << "**> Compare:" << e1.key() << " " << s1 << " :: " << e2.key() << " " << s2 << endl;
	return result;
	}

int operator<(const entry& e1, const entry& e2) { 
	string* s1 = ((entry&)e1).author();
	string* s2 = ((entry&)e2).author();
	if (!s1 || !s2) return 0;
	int result = *s1 < *s2;
	return result;
	}

ostream& operator<<(ostream& os, const entry& e) {
	((entry&)e).print(os);
	return os;
	}

dictionary<entry>* entry::thereferences = 0;
dictionary<entry>* entry::thereferenced = 0;

static entry* current=0;

#define entries (*entriesp)
static set<entry>* entriesp;

static int in_cc = 0;
static int in_biblio = 0;
static int do_biblio = 0;

dictionary<entry::printer>* entry::theprinters = 0;


//@ aliases

static int eat_n = 0;
static dictionary<string>* _alias = 0;

static void alias(const char* k, const char* v) {
	if (!_alias) _alias = new dictionary<string>(1);
	(*_alias)[k] = new string(v);
	//cerr << "Alias: " << k << " = " << v << endl;
	}

static char* thisalias(const char* k) {
	if (!_alias || !k) return 0;
	string* p = (*_alias)[k];
	if (!p) return 0;
	char* v = (char*) *p;
	//cerr << "Found: " << k << " => " << v << endl;
	return  v;
	}

static char* resolve(const char* k) {
	char *p = ::thisalias(k);
	if (!p) return (char*) k;
	else return ::resolve(p);
	}

//@ utilities

static string slidemode = "slide";
static int slideno = 0;
static int urlno = 0;

int iswhite(char c) { return ( c == ' ' || c == '\t' || c == '\n' ); } 

char* firstof(char* p) {
while ( *p && iswhite(*p) ) p++;
return p;
}

static int instring(char c, char* s) {
	while ( *s && *s++ != c );
	return (int) *s;
	}

static char _symbols[] = " <>#-,.;?@`={}$:\t\n/\\\"'{}^!%&[]()~<>*";

static int symbol(char c) { return instring(c,_symbols); }

static const char* slideref(const char* x) {
static char buf[4024];
strcpy(buf,x);
char* b = buf; //while (*b && symbol(*b)) b++;
char* p = b;
int i = 0;
while (*p && i <= 18 ) {
	int yes=0;
	if (symbol(*p) || *p == ' ') {
		yes = 1;
		*b = '-';
		}
	else *b = *p;
	b++; p++;
	if (yes) while (symbol(*p) || *p == ' ') p++;
	i++;
	}
*b='\0';
if (*(b-1) == '-') *(b-1) = '\0';
buf[18]='\0';
return (char*) buf;
}

//@ state variables and globals

static int auto_header = 0;
static int auto_footer = 0;

//@ query utils

char* unquote(const char* s) {
static char buf[1024*10];
	char* p = s; int i=0;
	while ( *p && *p != 0 ) {
		if ( *p != '\'' ) buf[i++] = *p++;
		else p++;
		}
	buf[i]='\0';
	return buf;
	}


static int in_query = 0;
static int in_pipe = 0;
static int in_raw = 0;
static int in_ignore = 0;
static int in_slide = 0;
static int slynames = 0;

static int do_all = 0;

static int pr=1;
static int bk=0;
static int in_comment = 0;
static int in_dollar = 0;
static int raw_dollar = 0;

static char begin_dollar[24];
static char end_dollar[24];

static void reset_dollar() {
	    raw_dollar = 0;
            strcpy(begin_dollar,"<math>");
            strcpy(end_dollar,"</math>");
}

static int holdpr=0;
static char docstyle[1024];
//static char slidestyle[] = "<document type=rawslide>";
static char slidestyle[] = "<!--<document type=rawslide>-->\n<head>\n<STYLE ID=\"ietssxyz\" TYPE=\"text/css\"></STYLE>\n<script language=javascript src=@base/hush.js></script>\n<script language=\"JavaScript1.2\" src=\"@base/style.js\"></script>\n<script language=\"JavaScript1.2\" src=\"@base/color.js\"></script></head>";
static char slidebody[] = "<script language=Javascript1.2>slidebody();</script>\n<link rel=stylesheet type=\"text/css\" href=\"@base/style.css\">\n<script language=JavaScript1.2>slidemode=1;</script>\n";
static char rawstyle[] = "<document type=raw>";
string slide = "";
string id = "";
string caption = "";
string citefile = "refs";

static char pipefile[1024];
static int pipecnt = 0;
static int querycnt = 0;
static int rawcnt = 0;
static char filename[BUFSIZ] = "temp";

static char online[BUFSIZ] = ONLINE;
static char documents[BUFSIZ] = DOC;
static char manuals[BUFSIZ] = MAN;
static char home[BUFSIZ] = HIT;

static int _in_script = 0;
static int in_script() {
	return _in_script;
	}

static int in_li = 0;
static int in_a = 0;
static int refmode=0;
static int nameit=0;
static int citit=0;
static int refit=0;

static int authorno = 0;
static int bookmode = 0;
static int titlemode = 0;

static char tagfile[BUFSIZ];
static char reffile[BUFSIZ];
static char slidir[BUFSIZ];

char endline[BUFSIZ];
char endbrace[BUFSIZ];

static int in_b = 0;
static int braces = 0;

static int level = 1;
static string droot = "index";
static string up = "index";
static string fwd = "index";
static string bwd = "index";

//@ io

typedef ostream& OFUN(ostream&);
typedef OFUN* IOFUN();

static int nofio = 0;

ostream& begincmt(ostream& os) {
	 if (in_comment == 1) {
	 	os << " <!--";
	 	}
	 return os;
	 }

ostream& endcmt(ostream& os) {
	 if (in_comment == 0) {
		os << "--> ";
		}
	 return os;
	 }

OFUN* bcmt() {
	 in_comment++;
	 return begincmt;
	 }

OFUN* ecmt() {
	 in_comment--;
	 return endcmt;
	 }

static char buffer[10*1024];

class io {
public:
ostream* old;
ostream* o;
int _redirect;
io(ostream* x) : o(x), next(0) { _redirect = 0; }
void cmt(char* s)  {
	print(bcmt);
	print(s);
	print(ecmt);
	}

//void print( oset<entry>& x ) {
void print( set<entry>& x ) {
	if (o) *(o) << x;
	if (next && !_redirect) next->print(x);
	}

void print( entry& x ) {
	if (o) x.print(*o,1);
	if (next && !_redirect) next->print(x);
	}

void print(OFUN f) {
        if (o) *(o) << f;
        if (next && !_redirect) next->print(f);
        }

void print(IOFUN x) {
        OFUN* f = x();
        if (o) *(o) << *f;
        if (next && !_redirect) next->print(*f);
        }

void print(char* s) {
	if (o) *(o) << s;
	if (next && !_redirect) next->print(s);
	}
void print(int& n) {
	if (o) *(o) << n;
	if (next && !_redirect) next->print(n); 
	}
void print(char& c) { 
	if (o) *(o) << c;
	if (next && !_redirect) next->print(c); 
	}

void flush() { o->flush(); }

void set(io* x) { next = x; }
io* child() { return next; }

void redirect(char* s = "@tempfile");
void hold() {
	o->flush();
	old = o;
	o = 0;
        nofio--;
	}

void reset() { 
	_redirect = 0;
	o->flush();
	((ofstream*)o)->close();
	o = old;
	old = 0;
        nofio++;
	}

char* get() { return (char*) buffer; }

void push(char* s = "@tempfile");

void pop() {
	cerr << "POP " << endl;
	if (next) {
		io* tmp = next->child();
		((ofstream*) (next->o))->flush();
		((ofstream*) (next->o))->close();
		delete next;
		next = tmp;
		nofio--;
		}
	}

int oke() { return pr; /*global!!*/ }
	
private:
io* next;
};

//@ io continued
 
inline
void io::push(char* s) {
	cerr << "PUSH " << s << endl;
	nofio++;
	ofstream* os = new ofstream();
	os->open(s,ios::out);
	assert(!os->fail());
	io* x = new io(os);
	/*
	x->print("<!-- %%%% Start ");
	x->print(s);
	x->print(" -->");
	*/
	if (!next) next = x;
	else {
	  //cerr << "NEXT " << endl;
	  x->set(next);
	  next = x;
	  }
	}

inline
void io::redirect(char* s) {
        _redirect = 1;
	o->flush();
	old = o;
if (s) {
	cerr << "RAW " << s << endl;
	ofstream* os = new ofstream();
	os->open(s,ios::out);
	o = os;
} else {
	cerr << "BIB " << endl;
	buffer[0]='\0';
	ostrstream* os = new ostrstream(buffer,0,10*1024);
	o = os;
}
}
 
io& operator<<(io& x, entry& e) { if (x.oke()) x.print(e); return x; }
//io& operator<<(io& x, oset<entry>& l) { if (x.oke()) x.print(l); return x; }
io& operator<<(io& x, set<entry>& l) { if (x.oke()) x.print(l); return x; }
io& operator<<(io& x, IOFUN f) { if (x.oke()) x.print(f); return x; }
io& operator<<(io& x, OFUN f) { if (x.oke()) x.print(f); return x; }
io& operator<<(io& x, char* s) { if (pr) x.print(s); return x; }
io& operator<<(io& x, int& n) { if (pr) x.print(n); return x; }
io& operator<<(io& x, char& c) { if (pr) x.print(c); return x; }
 
static io out(&cout);
static io* old = &out;

static io lst(&cerr);
 
//extern "C" system(const char*);
//extern "C" int atoi(char*);

//@ system

inline void execsystem(char* s) {
	//cerr << "EXEC SHELL: " << s << endl;
	system( s );
	}

//@ state variables -- continued

enum { htmlmode, textmode, slimode };

#define ifnat if (yytext[0]!='@')
#define iftext if (mode == textmode)
#define ifslide if ( mode == slimode )

int tex_mode = 0;
int ml_mode = 0;
int _in_ml = 0;

static int echo_mode = 0;
int in_escape = 0;
int in_program = 0;
int in_display = 0;

static int in_echo() {
	//return 0;
	if (echo_mode==1) return 1;
	else return 0;
	}

int in_ml() { return _in_ml; }

char* at() {
	if (ml_mode) return in_ml()?"@":"@";
	else return "@";
	}

char* dollar() {
	if (ml_mode) return in_ml()?"$":"$";
	else return "$";
	}

char* cent() {
	if (ml_mode) return in_ml()?"%":"%";
	else return "%";
	}

char* amp() {
	if (ml_mode) return in_ml()?"&":"\\&";
        else if (in_escape) return "&";
        else if (tex_mode && (in_display||in_program)) return "&amp;";
        else if (tex_mode) return "&";
 	else if (in_script() && !in_program) return "&";
	else return "&amp;";
	}

char* procent() { return cent(); }

char* ml_on() {
	if (ml_mode) {
		_in_ml++;
		return "<!--ml-on-->"; 
		}
	else return "";
	}

char* ml_off() {
	if (ml_mode) {
		_in_ml--;
		return "<!--ml-off-->"; 
		}
	else return "";
	}

int prog=0;
int in_cmode = 0;
int in_progcmt = 0;
int doc_no=0;
int mode = htmlmode;
int latexmode = 0;
char ext[12] = ".t";
int in_control = 0;

static int latex() { return latexmode; }
static int all() { return do_all; }

char buf[BUFSIZ];

//@ raw mode

void begin_raw(char* s="") {
	in_raw++;
	if (mode==htmlmode && in_raw==1 && !latex()) {
		char buf[BUFSIZ];
		sprintf(buf,"@raw-%d-%s", rawcnt++,filename);
		buf[18]='\0';
		char file[BUFSIZ];
		sprintf(file,"%s.raw",buf);
		out << "<img align=top src=" << buf << ".gif>";
		out.redirect(file);
		//out.hold();
		//out.push(file);
		//out << bcmt;
		out << rawstyle << endl;
		out << s;
		}
	else out << s;
	}

void end_raw(char* s = "") {
	  if (mode==htmlmode && in_raw==1 && !latex()) {
	     out << s;
	     out << "</document>" << endl;
	     //out << ecmt;
	     out.reset();
	     //out.pop();
	     }
	  else out << s;
	  in_raw--;
	}

//@ query mode

static char queryformat[1024*4]="\n%s ";
static char resultformat[1024*4]="\n<!--%s-->";

class out_handler : public handler {
char buf[1024*10];
int n;
public:
out_handler(query* q=0) { _query=q; n = 0; } // for later
void result(const char* msg) {
	char* s = ::_query->option("result");
	if (s) strcpy(resultformat,s);
	sprintf(buf,resultformat,msg);
	if (s && s[0]!='\0') ::out << (char*)unquote(buf);
	}
void print(const char* msg) {
	char* s = _query->option("format");
	if (!strcmp(s,"-") || (s[0]=='\0')) 
		;//cerr << "no out format: " << msg << endl;
	else {
	if (s) strcpy(queryformat,s);
	//cerr << "out_handler::print " << msg << endl;
	if ( !strcmp(msg,"nl") && queryformat[0]!='\0') {
		if (s && s[0]) ::out << endl;
	} else if (strcmp(msg,"nl") && queryformat[0]!='\0') {
		sprintf(buf,queryformat,msg);
		if (s && s[0]) ::out << (char*)unquote(buf);
		}
	}
	}
int operator()() {
        if (!strcmp(_event->arg(0),"client"))
		result(_event->arg(1));
	else 
		print(_event->arg(1));
	return 0;
	}	
private:
query* _query;
}; 

static out_handler* _out = 0;

void begin_query() {
	if (in_query==1) {
		char program[BUFSIZ];
		sprintf(program,"@query-%s-%d",filename, querycnt++);
		out.redirect(program);
	        _query->option("program",program);
		in_escape = 1;
	        //out << "/* (AE) " << program << " */" << endl;
		}
	}

void end_query(CLASS* _scanner) {
  if (in_query==1) {
     if (_query && _query->option("style")) 
	     _scanner->files(_query->option("style"),"");

     in_escape = 0;
     out.reset();
     if (_query) {
	_query->option("out","true");
	if (_query->option("display")) {
	   if (strcmp(_query->option("display"),"true")) { // display != true
			  out << _query->option("display");
			  }
			  out << "<program><pre>" << endl;
			  in_program++; in_cc = 1;
			  _scanner->files(_query->option("program"),"");
			  in_program--; in_cc = 0;
			  out << "</pre></program>" << endl;
			}
	if (_query->option("header")) out << _query->option("header");
	cerr << "ht-ml::preparing query " << _query->category() << endl;
	_query->prepare();
	if (strcmp(_query->option("mode"),"exec")) { // mode != exec
        	_out = new out_handler(_query);
		_query->bind(0);
        	_query->bind((const char*)"cout", _out);
        	//_query->bind((const char*)"tell", _out);
	        cerr << "ht-ml::eval " << _query->category() << endl;
		int res = 0;
		if ( _query->option("ask") )
			   res = _query->eval(_query->option("ask")); 
		else if (_query->option("cmd"))
			   res = _query->eval(_query->option("cmd")); 
       		char* p = 0;
       		while ( ( p = _query->result(res) ) ) {
                        	_out->result ( p );
				}
	} else {
		_scanner->files(_query->option("file"),"");
	}
	if (_query->option("footer")) out << _query->option("footer");
        } else exit(1);
        strcpy(queryformat,"\n%s ");
        strcpy(resultformat,"\n<!--%s-->");
        in_query--;
        }
}

//@ pipe

void begin_pipe(char* s=0) {
	if (in_pipe==1) {
		char file[BUFSIZ];
		if (!s) 
		   sprintf(file,"@pipe-%s-%d",filename, pipecnt++);
		else
		   strcpy(file,s);
		strcpy(pipefile,file);
		out.redirect(file);
		}
	}

void end_pipe(char* s=0) {
	  if (in_pipe==1) {
	     out.reset();

	     }
	     in_pipe--;
	}

//@ definitions
%}

lightcolors (white|lightred|lightgreen|lightblue|lightyerllow) 
darkcolors (red|green|blue|yellow|silver|gold|black)
colors ({lightcolors}|{darkcolors})


escape ("\\\"")
ident [A-Za-z0-9]+
stringelem ({escape}|[^\"\n])
string (\"{stringelem}+\")

path  [A-Za-z0-9\@\~\#\:\-\.\/\?]+

value  ({path}|{string})
attrib ({ident}|{ident}[ \t\n]*"="[ \t\n]*{value})

attribs ([ \t\n]|{attrib})*

simple   ("<"{ident}">")
begintag ("<"{ident}{attribs}">")
endtag   "</"{ident}">")
beginpr  "<?"{ident}{attribs}">"
endpr    "<?/"{ident}">"

stylesheets (stylesheet|STYLESHEET)
stylesheet "<!"{stylesheets}[^\>]">"

doctypes (doctype|DOCTYPE)
elements (element|ELEMENT)
attlists (attlist|ATTLIST)

doctype  "<!"{doctypes}[^\>]">"
element  "<!"{elements}[^\>]">"
attlist  "<!"{attlist}[^\>]">"

begincmt [ \t]*"<!--"[ \t]*
endcmt   [ \t]*"-->"[ \t]*

old-any ({beginpr}|{endpr}|{doctype}|{element}|{attlist})

any ([^\>]|{string})
atts {any}*

old-atts [^\>]*
new-atts {attribs}

prefix  (http|mailto|ftp|news)
uri {prefix}":"[^\ \t\n\,\;\)\]\<\>]*

srcdirs (examples|sources|interfaces|packages)
docdirs (papers|tutorials|resources|{srcdirs})
online  (online)

src (hush|widgets|extern|sim|native)
ext (sigma|bpsim|grammar|ml|ami)
includedirs ("ml"|"java"|{src}|{ext})

hushdirs (papers|projects|talks|ftp)
places   (hush|dejavu|eliens|jrvosse|bastiaan|martijn|oo|se)
orgs     ("cs.vu.nl")

lpath ("../../"|""|"../")
lcfg (cfg|interface|category|component|install|lib|resource|hush|orbix|"orbix-1.3"|"orbix-2.0")

cfg (interface|category|component|resource|package|examples|hush|orbix|"orbix-1.3"|"orbix-2.0")

cc ("class"|"method"|"slide"|"package"|"module")
opt ("style"|"auto")

ccname ([^ \t\n]*|{string})

API ("HUSH_API"|"WIDGETS_API")

incc (ul|li)
%% rules

^\.\".* {}

^"@cite=1" {
	citemode=1;
	entriesp = new set<entry>;
	}

"&#"[0-9]+ { out << yytext; }

"<eat-n>" { eat_n = 1; }

{begincmt} { if (in_echo()) out << yytext; else out << bcmt; }
{endcmt} { if (in_echo()) out << yytext; else out << ecmt; }

"$(" { out << yytext; }

\% { out << cent(); }
\$"dollar" { out << dollar(); }
\& { out << amp(); }
\&\& { out << amp() << amp(); }
\@ { out << at(); }

"&"[a-zA-Z]+";" { out << yytext; }


"%"[A-Za-z]+ {
	if (in_program) {
		out << "<font color=blue><i><latex>\\</latex>" << yytext << "</i></font>";
		}
	else out << yytext;
	}

"<in-cc>" { in_cc = 1; }
"</in-cc>" { in_cc = 0; }

"</h4><a " { 
	if (in_cc || (in_program && !in_comment)) {
		out << "&lt;/h4&gt;&lt;a ";
	} else out << yytext;
	}


"<"[\/]?{incc}">" {
	if ((in_cc && in_program)||(in_program && !in_comment)) {
		yytext[yyleng-1]='\0';
		out << "&lt;" << yytext+1 << "&gt;";
		} else out << yytext;
	}

"<h"[0-9]">" {
	if (in_program) {
	   char buf[4]; sprintf(buf,"%c",yytext[2]);
	   out << "&lt;h" << buf << "&gt;"; 
	   }
	else out << yytext;
	}

"</h"[0-9]">" {
	if (in_program) {
	   char buf[4]; sprintf(buf,"%c",yytext[3]);
	   out << "&lt;/h" << buf << "&gt;"; 
	   }
	else out << yytext;
	}


\""http" { out << yytext; }

"<ml>"|"<ml "{atts}">" {
	//cerr << "<ml> mode" << endl;
	if (ml_mode) {
		out << ml_on();
		}
	else pr--;
	}
"</ml>" {
	if (ml_mode) {
		out << ml_off();
		}
	else pr++;
	}

"@HUSHDOCUMENTS" { out << DOC; }

"<DT><p><img SRC=@icon2.gif>  <B></B> </B>"\n" <DD><i></></i>" {}
"<DT><p><img SRC=@icon2.gif>  <B></B> </B>"\n" <DD><i></slide></i>" {}
"<DD><i></></i>" { }
"<DD><i></slide></i>" { }
"@"{cc}[ \t]*{ccname} { if (in_echo()) out << yytext; }
"@"{opt}[ \t]*"="[ \t]*{ccname} { }
{API}  { }

%%@ syntax

"<!--<"[\/]?[a-z]+"-->" { ; }
"<!--<slide".* { ; }
"<!--///-->" { ; }
"<control><h5".* { out << yytext; }

"<b>"|"</b>"|"<tt>"|"</tt>" { out << yytext; }
"[^\\<]" { if (in_program) out << "[^\\&lt;]"; else out << yytext; }
\""<!--"\" { if (in_program) out << "\"&lt;!--\""; else out << yytext; }
\""-->"\" { if (in_program) out << "\"--&gt;\""; else out << yytext; }
\""<!"\" { if (in_program) out << "\"&lt;!\""; else out << yytext; }
\""</"\" { if (in_program) out << "\"&lt;/\""; else out << yytext; }
\"\<\" { if (in_program) out << "\"&lt;\""; else out << yytext; }

"&"[a-zA-Z]";"? { out << yytext; }




^"%/".*   { if (in_echo()) out << yytext;
	    else out << bcmt << yytext << ecmt;
	    }
^"%%%".* { if (in_program) out << yytext; }
"$"[A-Za-z0-9\-\/]+"$" { 
		if (in_ml() || in_echo() ) out << yytext;
		else {
		  yytext[yyleng-1]='\0';
		  out << "<em>" << yytext+1 << "</em>";
		}
	}

%%@ includes

{lpath}"lib.mk" {
	 char buf[BUFSIZ]; strcpy(buf,yytext);
	 buf[strlen(buf)-3]='\0';
	 if (in_program) 
		out << "<a href=\"" 
	            << documents  << "/sources/cfg/lib.mk.html\">"
		    << yytext << "</a>";
	  else out << yytext;
	  }

{lpath}{lcfg}".mk" {
	 char buf[BUFSIZ]; strcpy(buf,yytext);
	 buf[strlen(buf)-3]='\0';
	 if (in_program) 
		out << "<a href=\"" 
	            << buf << ".mk.html\">" << yytext << "</a>";
	  else out << yytext;
	  }


"interfaces" { if (pr) out << yytext; }

"module"|"interface"|"attribute"|"readonly"|"any"|"enum"|"class"|"public"|"static"|"protected"|"private"|"virtual"|"typedef"|"const"|"extern"|"operator"|"operator()"|"operator()()"|"void"|"int"|"float"|"double" {
	if (in_program && !in_display && !in_progcmt) { out << "<font color=blue><i>" << yytext << "</i></font>"; }
	else out << yytext;
	}

%%@ latex stuff

^\%\%.*\n { }
^"\\ifsli{".* { out << bcmt << yytext << ecmt; }
^"\\noid".* { out << bcmt << yytext << ecmt; }
^"\\index".* { out << bcmt << yytext << ecmt; }
^"\\newpage".* { out << bcmt << yytext << ecmt; }
^"\\slyname{".* { /*if (slynames++ == 0)*/
		  out << bcmt << yytext << ecmt;
		  }
^"\\ln".* { out << bcmt << yytext << ecmt; }
^"\\foot".* { out << bcmt << yytext << ecmt; }
^"\\noindent".* { out << bcmt << yytext << ecmt; }
^"\\vspace".* { out << bcmt << yytext << ecmt; }
^"\\clear".* { out << bcmt << yytext << ecmt; }
^"\\mark".* { out << bcmt << yytext << ecmt; }
^"\\slilarge".* { out << bcmt << yytext << ecmt; }
^"\\hline".* { out << bcmt << yytext << ecmt; }
"\\addcontent".* { out << bcmt << yytext << ecmt; }
"\\setcounter".* { out << bcmt << yytext << ecmt; }
^"\\def\\".* { out << bcmt << yytext << ecmt; }
"\\vstr{"[0-9\.]+"}" { out << bcmt << yytext << ecmt; }
"\\vfig{"[0-9\.]+"}" { out << bcmt << yytext << ecmt; }
"\\label{"[A-Za-z0-9\-]+"}" {
	yytext[yyleng-1]='\0';
	out << "<a name=" << yytext+7 << ">";
	}
"\\ref{"[A-Za-z0-9\-]+"}" {
	yytext[yyleng-1]='\0';
	out << "<ref><a href=\"#" << yytext+5 <<
	"\">" << yytext+5 << "</a></ref>";
	}
"\\see{"[A-Za-z0-9\-]+"}" {
	yytext[yyleng-1]='\0';
	out << "See slide <ref><a href=\"" << at() << "slide-" << yytext+5 <<
	".html\">" << "<!--slide--->" << yytext+5 << "</a></ref>.";
	}
"\\sliref{"[A-Za-z0-9\-]+"}" {
	yytext[yyleng-1]='\0';
	//out << "slide <ref><a href=\"" << at() << "slide-" << yytext+8 <<
	//".html\">" << "<!--slide--->" << yytext+8 << "</a></ref>";
	out << "slide <ref><a href=\"";
	int indir = (slidir[0] != '.');
	if (indir)
	     out << slidir << ".html#" << yytext+8 << "\">";
	else 
	     out << "#" << yytext+8 << "\">";

	out << "<!--slide--->" << yytext+8 << "</a></ref>";
	}
"\\index{"[A-Za-z0-9\-]+"}" {
	out << bcmt << yytext << ecmt;
	}
"{\\tt "[\ A-Za-z\-\/\,0-9]+"}" { yytext[yyleng-1]='\0'; out << "<tt>" << yytext+5 << "</tt>"; } 
"{\\em "[\ A-Za-z\-\/\,0-9]+"}" { yytext[yyleng-1]='\0'; out << "<em>" << yytext+5 << "</em>"; } 
"{\\it "[\ A-Za-z\-\/\,0-9]+"}" { yytext[yyleng-1]='\0'; out << "<i>" << yytext+5 << "</i>"; } 
"{\\bf "[\ A-Za-z\-\/\,0-9]+"}" { yytext[yyleng-1]='\0'; out << "<b>" << yytext+5 << "</b>"; } 
"{\\rm "[\ A-Za-z\-\/\,0-9]+"}" { yytext[yyleng-1]='\0'; out << "<rm>" << yytext+5 << "</rm>"; } 
^"# "[0-9]+.*\n { ;}
"<!--<slide" { out << yytext; }
"<!--</slide>-->" { out << yytext; }
"<!--<program>-->" { out << yytext; }
"<!--</program>-->" { out << yytext; }
"<a href=\"@slide-" { out << yytext; } 
"<"[aA]" "{atts}">" { 
	in_a = 1;
	if (in_cc && in_program && !in_comment) {
		yytext[yyleng-1]='\0';
		out << "&lt;" << yytext+1 << "&gt;";	
	} else {
	 out << yytext;
	}
}
"</"[aA]">" { 
	in_a = 0;
	if ( in_cc && in_program && !in_comment) {
		out << "&lt;/a&gt;";
	} else {
		out << yytext; 
	}
}

%%@ urls

{uri} {
	if (! in_a && !in_echo() && !in_cc)
          out << "<A HREF=\"" << yytext << "\">" << yytext << "</A>";
	else
	  out << yytext;
        }

%%@ names

"Eliens"[0-9]+ { out << yytext; }
"\\Eliens" { out << yytext; }
"Eliens" { out << "Eli&euml;ns"; }
"Schonhage" { out << "Sch&ouml;nhage"; }
"Vitanyi"  { out << "Vit&aacute;nyi"; }
[A-Za-z0-9\-]+ {
	if (in_references) out << yytext;
	else if (nameit) out << "<a name=" << yytext << ">" << yytext 
		      << "</a>";
	else if (citit) out << "<a href=\"" << tagfile 
		      << "#" << yytext << "\">" << yytext << "</a>";
	else if (refit) out << "<a href=\"" << reffile 
		      << "#" << yytext << "\">" << yytext << "</a>";
	else out << yytext;
	}

%%@ control

"<cl>"   { out << bcmt << "\\c{" << ecmt; }
"</cl>"  { out << bcmt << "}" << ecmt; }
"<control>"|"<c>" {
  if (0 && in_program) {
     yytext[yyleng-1] = '\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
	in_control = 1; out << bcmt <<  yytext << ecmt;
	}
  }
"</control>"|"</c>" {
  if (0 && in_program) {
     yytext[yyleng-1] = '\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
	in_control = 0; out << bcmt <<  yytext << ecmt;
	}
 }

%%@ scripts -- will be extended

"<script"{atts}">" {
  if (in_program) {
     yytext[yyleng-1] = '\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
	_in_script = 1; out <<  yytext ;
	}
  }
"</script>" {
  if (in_program) {
     yytext[yyleng-1] = '\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
	_in_script = 0; out << yytext ;
	}
 }

%%@ latex (again)

"<?latex>"|"<latex>" { 
  if (in_program) {
     yytext[yyleng-1] = '\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
		  tex_mode = 1; 
		  holdpr = pr;
		  if (!do_all && mode==htmlmode) pr = 0;
		  out << bcmt;
		  }
  }
"<?/latex>"|"</latex>" {
  if (in_program) {
     yytext[yyleng-1] = '\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
		 tex_mode = 0;
		 out << ecmt;
		 if (!do_all && mode==htmlmode) pr = holdpr;
		 }
  }

%%@ document

"<ignore>" { in_ignore++; pr--; }
"</ignore>" { in_ignore--; pr++; }

"<base"{atts}">" { out << yytext; }

"<document"{atts}">" {
reset_dollar();
int tmp = pr;
if (doc_no++ == 0) {
   string style = "";
   int n_style = 0;
   string_converter x(yytext+10);
   for (int i = 1; i <= x.argc(); i++ ) {
        attribute p(x[i]);
           if ( p.matches("style") ) { 
			style=p.value();
	                n_style=1;
	   }
    }
	if (0 && ml_mode) {
		out << ml_on();
		out << "$HEADER";
	} else {
	pr = 1;
	char buf[BUFSIZ];
	if (strlen(yytext) <= 10) {
  	   if (latexmode) 
		if (mode==textmode)
		    sprintf(docstyle,"<document type=text>");
		else if (mode==slimode) 
		    sprintf(docstyle,"<document type=slide>");
		else
		  sprintf(docstyle,"<document type=style>");
	    else
		sprintf(docstyle,"<document type=style>");

	} else
        	sprintf(docstyle,"%s",yytext);
	out << bcmt << docstyle << ecmt;
	if (auto_header) soinc("header","");
	if (n_style) {
	        strcpy(pagestyle,(char*) style );
		out << "<control><script language=javascript>";
	        out << "\npagestyle=\"" << (char*) style << ";";
	        out << "\n</script></control>" << endl;
		}
	}
   }
pr = tmp;
}

"</document>" {
reset_dollar();
int tmp = pr;
if (--doc_no == 0) {
	if (0 && ml_mode) {
		out << "$FOOTER";
		out << ml_off();
	} else {
	pr = 1;
	if (auto_footer) soinc("footer","");
	out << bcmt << yytext << ecmt;
	}
   }
pr = tmp;
}

%%@ text

"<abstract>" {
	if (!in_program)
	out << "<!--<control>--><h4>Abstract</h4><!--</control>-->" << yytext;
	else {
	yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
	}
}

%%@ file and dir inclusion

"@so ".*\n {
  if (in_program) {
	yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else if (!tex_mode) {
	yytext[yyleng-1]='\0'; files(yytext+4,ext);
	}
  else if (mode != htmlmode && !in_control) {
	yytext[yyleng-1]='\0'; files(yytext+4,ext);
	}
  else out << yytext;
}

"@ds ".*\n {
  if (in_program) {
	yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
  out << "<program><pre>\n  ";
  in_program = 1;
  if (!tex_mode) {
	yytext[yyleng-1]='\0'; files(yytext+4,"");
	}
  else if (mode != htmlmode && !in_control) {
	yytext[yyleng-1]='\0'; files(yytext+4,"");
	}
  else out << yytext;
  out << "</pre></program>" << endl;
  in_program = 0;
  }
}

"<so "{atts}">" {
  if (in_program) {
	yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else if (!tex_mode || do_all) {
	yytext[yyleng-1]='\0'; files(yytext+4,ext);
	}
  else if (mode != htmlmode && !in_control) {
	yytext[yyleng-1]='\0'; files(yytext+4,ext);
	}
  else out << yytext;
}

"<include "{atts}">" {
if (0 && in_program) {
//yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
} else {
   int choice = 0;
   yytext[yyleng-1] = '\0';
   string dir = "";
   string ext = "";
   string file = "";
   string url = "";
   int get_url = 0;
   string cmd = "";
   string_converter x(yytext+8);
   for (int i = 1; i <= x.argc(); i++ ) {
       cerr << "ATTR: <include>" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("file") ) { 
			if ((choice !=3) && (choice!=2)) choice = 1;
			file = p.value();
			if (file == "pipe")
				file = pipefile;
			}
           if ( p.matches("files") ) { choice = 1; file = p.value(); }
	   if ( p.matches("url") ) {
			char buf[1024];
			sprintf(buf,"@url-%s-%d",filename,urlno++);
			file = buf;
			resolver* r = new resolver();
		        r->file((char*)p.value(),buf);
			delete r;
			choice = 1;
			}
           if ( p.matches("dir") ) { choice = 2; dir = p.value(); }
           if ( p.matches("dirs") ) { choice = 2; dir = p.value(); }
           if ( p.matches("ext") ) { ext = p.value(); }
           if ( p.matches("cmd") ) { choice = 3; cmd = p.value(); }
           }
   if (choice == 0) file = yytext+9;
   if (choice == 2 && !strcmp(ext,"")) ext = ::ext;
   if (!tex_mode || do_all) {
	if (choice==2) directories(dir,ext,(char*)file); 
	else if(choice==3) {
		char buf[BUFSIZ];
		sprintf(buf,"%s > %s",(char*)cmd,(char*)file);
		execsystem(buf); files(file,"");
		}
	else files(file,ext);
	}
   else if (mode != htmlmode && !in_control) {
	if (choice==2) directories(dir,ext,(char*)file);
	else if(choice==3) {
		char buf[BUFSIZ];
		sprintf(buf,"%s > %s",(char*)cmd,(char*)file);
		execsystem(buf); files(file,"");
		}
	else files(file,ext);
	}
   else out << yytext << ">";
 }
}

%%@ index

"<"(index|select)" "{atts}">" {
  if (in_program) {
	yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
   int choice = 0;
   yytext[yyleng-1] = '\0';
   string dir = "."; int b_dir = 0;
   string sel = ""; int b_sel = 0;
   string opt = ""; int b_opt = 0;
   string menu = "select"; int b_menu = 1;
   string mode = "ls"; int b_mode = 0;
   string tr = "";  int b_tr = 0;
   string_converter x(yytext+8);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("dir") ) { b_dir = 1; dir = p.value(); } 
           else if ( p.matches("sel") ) { b_sel=1; sel=p.value(); }
           else if ( p.matches("opt") ) { b_opt=1; opt=p.value(); }
           else if ( p.matches("options") ) { b_opt=1; opt=p.value(); }
           else if ( p.matches("menu") ) { b_menu=1; menu=p.value(); }
           else if ( p.matches("mode") ) { b_mode=1; mode=p.value(); }
           else if ( p.matches("tr") ) { b_tr=1; tr=p.value(); }
           }
   if (!tex_mode || do_all) {
	static int _select = 0;
	char file[BUFSIZ];
	sprintf(file,"@tmp-select-",_select++);
	char command[BUFSIZ]; 
	sprintf(command,"selector");
	if (b_dir) sprintf(command,"%s -dir %s",command,(char*)dir); 
	if (b_menu) sprintf(command,"%s -menu %s",command,(char*)menu); 
	if (b_mode) sprintf(command,"%s -mode %s",command,(char*)mode); 
	if (b_tr) sprintf(command,"%s -tr %s",command,(char*)tr); 
	if (b_opt) sprintf(command,"%s %s",command,(char*)opt); 
	char buf[BUFSIZ];
	sprintf(buf,"%s > %s",command,file);
	execsystem(buf);
	files(file,"");
    }
 }
}

%%@ directories

"@cd ".*\n {
  if (in_program) {
	yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else if (!tex_mode || do_all) {
	yytext[yyleng-1]='\0'; directories(yytext+4,ext);
	}
  else if (mode != htmlmode && !in_control) {
	yytext[yyleng-1]='\0'; directories(yytext+4,ext);
	}
  else out << yytext;
}

"<cd "{atts}">" {
  if (in_program) {
	yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else if (!tex_mode || do_all) {
	yytext[yyleng-1]='\0'; directories(yytext+4,ext);
	}
  else if (mode != htmlmode && !in_control) {
	yytext[yyleng-1]='\0'; directories(yytext+4,ext);
	}
  else out << yytext;
}

^"@#!".*\n {
  if (in_program) {
	yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
	yytext[yyleng-1]='\0';
		execsystem(yytext+3);
 }
}

%%@ fonts - really, at this level?

"<"{colors}">" {
	yytext[yyleng-1] = '\0';
	out << "<font color=" << yytext+1 << ">";
	} 

"</"{colors}">" {
	out << "</font>";
	}

%%@ what was this again?

("///"|"%%%"|"###")[\/\%\#]* {
	if ( 1 || (in_program && !in_progcmt)) {
		in_progcmt = 1;
		out << "<h5 align=right>";
		out << "<font color=red><i>";
		//AEout << "<control>" << yytext+3 << "</control>";
		out << "" << yytext+3 << "";
		//out << bcmt <<  yytext << ecmt;
		strcat(endline,"</i></font></h5><br>");
		}
	else out << yytext;
	}
("//"|"%%"|"##") {
	if (in_program && !in_progcmt) {
		in_progcmt = 1;
		out << "<font color=green><i>";
		out << yytext;
		strcat(endline,"</i></font>");
		}
	else out << yytext;
	}
"/*" {
	if (in_program) { /*AE: in_progcmt? */
	        in_cmode=1;
		in_progcmt = 1;
		out << "<font color=green><i>";
		out << yytext;
		}
	else out << yytext;
	}
"*/" {
	if (in_program && in_progcmt) {
		in_progcmt = 0;
		out << yytext;
		out << "</i></font>";
		}
	else out << yytext;
	}



"<exec"{atts}">" {
  if (in_program) {
	yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
       if (mode != tex_mode && !in_control) { 
		int infile = 0;
		yytext[yyleng-1] = 0;
		string cmd = "date";
		string file = "@temp";
	        string_converter x(yytext+6);
   		for (int i = 1; i <= x.argc(); i++ ) {
       		  attribute p(x[i]);
           	  if ( p.matches("cmd") ) cmd = p.value();
           	  if ( p.matches("file") )  {
				file = p.value();
				infile = 1;
				}
		}
		char buf[BUFSIZ];
		if (infile)
			sprintf(buf,"%s > %s",(char*)cmd,(char*)file);
		else
			sprintf(buf,"%s",(char*) cmd );
       		execsystem(buf);
		if (infile) files((char*)file,"");
       		out.flush();
       }
   }
}

^"@exec ".* {
  if (in_program) {
	//yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else
	execsystem(yytext+5); out.flush();
  }

%%@ navigate

^"@navigate"{atts}/("-->"|"}"|\n) |
"<navigate"{atts}">" {
  if (in_program) {
	yytext[yyleng-1]='\0'; out << "&lt;" << yytext+1 << "&gt;";
  } else {
	ifnat yytext[yyleng-1]='\0';
	string_converter s(yytext+9);
	int i = 1;
	for (i = 1; i <= s.argc(); i++ ) {
	  attribute p(s[i]);
	  //cerr << "ATT:" << i << " "  << s[i] << " " << p.key() << " " <<  p.value()  << endl; 
	  if ( p.matches("level") ) { level= atoi(p.value()); }
	  else if ( p.matches("up") ) { up = p.value(); }
	  else if ( p.matches("fwd") ) { fwd = p.value(); }
	  else if ( p.matches("next") ) { fwd = p.value(); }
	  else if ( p.matches("bwd") ) { bwd = p.value(); }
	  else if ( p.matches("back") ) { bwd = p.value(); }
	  else if ( p.matches("top") ) { droot = p.value(); }
	  else if ( p.matches("contents") ) { droot = p.value(); }
	  else if ( p.matches("root") ) { droot = p.value(); }
	  else if ( p.matches("index") ) { droot = p.value(); }
	}
  	  out << bcmt << "<control>" << ecmt;
  	  for (i=1; i <= level; i++) out << "[";
  	  if ( ((char*) bwd)[0] =='#' )
  	     out << "-<a href=\"" << bwd << "\"><</a>";
  	  else 
  	     out << "-<a href=\"" << bwd <<  ".html\"><</a>";
  	  if ( ((char*)droot)[0] == '#' )
  	     out << "--<a href=\"" << droot << "\">%</a>";
  	  else
  	     out << "--<a href=\"" << droot << ".html\">%</a>";
  	  if ( ((char*)up)[0] == '#' )
  	     out << "--<a href=\"" << up << "\">^</a>";
  	  else
  	     out << "--<a href=\"" << up << ".html\">^</a>";
  	  if ( ((char*)fwd)[0] == '#' )
  	     out << "--<a href=\"" << fwd << "\">></a>-";
  	  else
  	     out << "--<a href=\"" << fwd << ".html\">></a>-";
  	  for (i=1; i <= level; i++) out << "]";
  	  out << bcmt << "</control>" << ecmt;
  }
}

%%@ format -- isn't that obsolete?

"<slipar>" { ifslide pr = 1; else iftext pr = 0; }
"</slipar>" { ifslide pr = 0; else iftext pr = 1; }
"<text>" { ifslide pr = 0; else iftext pr = 1; }
"</text>" { ifslide pr = 1; else iftext pr = 0; }

"<format"{atts}">" {
	char buf[BUFSIZ];
        yytext[yyleng-1] = '\0';
        string_converter x(yytext+7);
        for (int i = 1; i <= x.argc(); i++ ) {
                attribute p(x[i]);
                if ( p.matches("mode") ) 
			if (!strcmp(p.value(),"text"))
				mode = textmode;
			else if (!strcmp(p.value(),"slide"))
				mode = slimode;
                else if ( p.matches("ref") ) 
			if (!strcmp(p.value(),"bk"))
				citemode = 0;
			else if (!strcmp(p.value(),"art"))
				citemode = 1;
			else if (!strcmp(p.value(),"cite"))
				citemode = 1;
                }
	cerr << yytext+1 << " :" << citemode << endl;
	//sprintf(buf,"<%s %%%% fm %s %s>","--",(char*)mode,"--");
        }

%%@ image


"<image"{atts}">" {
        yytext[yyleng-1] = '\0';
	int fl=0;
	string s;
	string src="@images/logo.gif";
        string width="450";
        string height="275";
        string pre="";
        string post="";
        string_converter x(yytext+6);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("name") ) {
		      char buf[64];
                      fl = 1;
		      sprintf(buf,"%s.gif",p.value());
                      src = (char*) buf;
		      sprintf(buf,"%s.eps",p.value());
		      s = (char*) buf;
                      }
          else if ( p.matches("eps") ) {
                      fl = 1;
                      s = p.value();
                      }
	  else if ( p.matches("v") ) { 
		char buf[128];
		sprintf(buf,"\\vspace{%scm}",p.value());
		post=(char*)buf;
		}
	  else if ( p.matches("src") ) src = p.value();
	  else if ( p.matches("width") ) width = p.value();
	  else if ( p.matches("height") ) height = p.value();
	  else if ( p.matches("pre") ) pre = p.value();
	  else if ( p.matches("post") ) post = p.value();
        }
	//out << "<a href=" << (char*) src << ">";
	out << "<control><center>";
	out << "<script language=javascript>";
	out << "document.write(\"<img src=" << (char*) src << " ";
	out << " width=\" + imgw(" << (char*) width << ") + ";
	out << "\" height=\" + imgh(" << (char*) height << ") + ";
	out << "\">\");";
	out << "</script>";
	out << "</center></control>";
	//out << "</a>";
        //if (fl) out << "<!--\\epsfbox{" << s << "}\\vspace{0.5cm}-->";
        if (fl) out << (char*) pre << 
		"<center><!--\\epsfig{file=" << s 
		<< ",width=9.5cm}\\vspace{-2.5cm}--></center>" << 
		(char*) post;
   }


%%@ slide

"<slide"{atts}">"[ \t\n]*"</slide>" { }
"<slide"{atts}">"\n"<dl>"\n"</dl>"\n"</slide>" { }
"<slide"{atts}">" {
    in_comment = 0; // AE clean start
    in_slide++;
    //if (!in_ignore && latex()) { out << yytext; } 
    if (!in_ignore) {
	ifslide pr = 1;
	char buf[BUFSIZ];
        yytext[yyleng-1] = '\0';
	int slcolor=0;
        string color=(char*) pagestyle;
	string mode = "slide";
        string id = "X";
        string caption = "X";
        string file = "tempfile";
        string_converter x(yytext+6);
        for (int i = 1; i <= x.argc(); i++ ) {
                attribute p(x[i]);
                if ( p.matches("id") ) {
				id = slideref(p.value());
				file = (char*) id; // slideref( p.value());
			        if (id == "contents" || id == "title")
						color = "black";
				}
                if ( p.matches("caption") ) caption = p.value();
                if ( p.matches("cap") ) caption = p.value();
                if ( p.matches("name") ) caption = p.value();
                if ( p.matches("color") ) color = p.value();
                if ( p.matches("mode") ) mode = p.value();
                if ( p.matches("style") ) color = p.value();
                if ( p.matches("file") ) file = slideref( p.value() );
		if ( p.matches("dir") ) {
		  sprintf(buf,"%s/%s", slideref(p.value()),(char*)file);
		  file = buf;
		  }
                }
	slidemode = mode;
	char* idp = (char*) id;
	if (*idp == 'X') {
		file = slideref(caption);
		id = (char*) file; //slideref(caption);
		}
	else if (*idp == '.') {
		char buf[1024];
		sprintf(buf,"%s-%d",(char*)caption,slideno++);
		file = slideref(buf);
		id = (char*) file; // slideref(buf);
		}
	if (slidemode=="control") out << "<control>";
	sprintf(buf,"@slide-%s.html",(char*) id);
	if (!all() && !latex()) out.push(buf);
	sprintf(buf,"@slide-%s.html",(char*) id);
	the_slide = (char*) buf;
	::caption = caption;
	the_caption = (char*) caption;
	::id = id;
	if (!all() && !latex()) {
	*(out.child()) << "\n" << slidestyle << "\n";
	*(out.child()) << "\n<script language=Javascript1.2>" <<
               "slidestyle=\"" << color << "\";\n</script>\n";
	*(out.child()) << "\n" << slidebody << "\n";
	}
	if (!latex()) {
	if (slidemode=="slide")
	   out << "<hr><a name=\"" << (char*) id << "\">\n";
	out << "<a name=\"" << (char*) id << "\">\n";
	}
        out << bcmt << yytext << ">" << ecmt << endl;
	lst << "slide(\"" << prefix() << "@slide-" << (char*) id << "\");" << endl;
        }
}

"</slide>" { 
     if (!in_ignore && in_slide==1 && latex()) {
	    out << yytext;
     } else if (!in_ignore && in_slide==1 && !latex()) {
	    if (mode==htmlmode && slidemode=="slide") {
	    	out << "<!--<control>--><hr><center>"
		  << "<a href=" << "contents" << ".html>"
		  << "<i>slide</i>: </a>" // << (char*)id << ": "
	          << "<a href=\"" << (char*) the_slide << "\">"
	          << (char*) the_caption << "</a></center><hr><!--</control>-->";
		  }
	    out << "<!--" << yytext << "-->"; *(out.child()) << "\n</body></document>"; 
	    if (!all()) out.pop();
	    if (slidemode=="control") out << "</control>" << endl;
	    ifslide pr = 0;
	    }
      if (in_slide == 0) cerr << "Warning: superfluous </slide>" << endl;
      else in_slide--;
      }

%%@ query

^"#"("sh"|"/bin/sh") {
	if (in_query) {
		_query->option("sh","sh");
		}
	out << yytext;
	}

"<query>" {
	in_query++;
	if (in_query==1) {
		 _query = new query("");
		}
	begin_query();
	}
"</query>" { 
	end_query(this);
	}

"<param "{atts}">" {
     eat_n = 1;
     if(in_query==1) {
        yytext[yyleng-1] = '\0';
	string name="dummy";
	string value="dummy";
        string_converter x(yytext+7);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
	  if (p.matches("name"))  name=p.value();
	  else if(p.matches("value")) {
		value=p.value();
		_query->option((char*)name,(char*)value);
		}
	  else _query->option(p.key(),p.value());
	  }
     } else out << yytext;
}


"<query "{atts}">" {
in_query++;
if(in_query==1) {
        yytext[yyleng-1] = '\0';
	_query= new query(yytext+6);
        string_converter x(yytext+6);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("fm") ) {
		 strcpy(queryformat, (char*) p.value());
		 }
          else if ( p.matches("format") ) {
		 strcpy(queryformat, (char*) p.value());
		 }
          else if ( p.matches("result") ) {
		 strcpy(resultformat, (char*) p.value ());
		 }
          else if ( p.matches("res") ) { 
		 strcpy(resultformat, (char*) p.value()) ; 
		 }
          }
	begin_query();
	}
   }

%%@ raw

"<raw>" { begin_raw(); }
"</raw>" { end_raw(); }

"<raw "{atts}">" {
in_raw++;
if(in_raw==1 && !latex()) {
        yytext[yyleng-1] = '\0';
	int fl=0;
	string s;
	string src="@images/logo.gif";
        string width="626";
        string height="400";
        string pre="";
        string post="";
        string_converter x(yytext+6);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("eps") ) {
                      fl = 1;
                      s = p.value();
                      }
	  else if ( p.matches("src") ) src = p.value();
	  else if ( p.matches("width") ) width = p.value();
	  else if ( p.matches("height") ) height = p.value();
	  else if ( p.matches("pre") ) pre = p.value();
	  else if ( p.matches("post") ) post = p.value();
        }
	char file[BUFSIZ];
	if (mode==htmlmode) {
		char buf[BUFSIZ];
		sprintf(buf,"@raw-%d-%s",rawcnt++,filename);
		buf[18]='\0';
		sprintf(file,"%s.raw",buf);
		//out << "<image src=" << buf << ".gif>";

	//out << "<a href=" << (char*) src << ">";
	out << "<script language=javascript>";
	out << "document.write(\"<img src=" << (char*) buf << ".gif ";
	out << "width=\" + imgw(" << (char*) width << ") + ";
	out << "\"height=\" + imgh(" << (char*) height << ") + ";
	out << "\">\");";
	out << "</script>";
		out.redirect(file);
		//out.push(file);
                //out << bcmt;
		out << rawstyle << endl;
		}
   }
}

%%@ pipe

"<pipe>" { in_pipe++; begin_pipe(); }
"</pipe>" { end_pipe(); }

"<pipe "{atts}">" {
in_pipe++;
if(in_pipe==1) {
        yytext[yyleng-1] = '\0';
	int fl=0;
        string file="@pipe";
        string_converter x(yytext+6);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
          if ( p.matches("file") ) {
                      fl = 1;
                      file = p.value();
                      }
	}
        if (fl) begin_pipe((char*)file); else begin_pipe();
   }
}

%%@ latex again, indeed

[ \t\n]*"<cite"{atts}">" {
        yytext[yyleng-1] = '\0';
	char* yy = firstof(yytext);
	int fileb = 0;
	string id = "";
        //string file = "";
        string_converter x(yy+5);
        for (int i = 1; i <= x.argc(); i++ ) {
                attribute p(x[i]);
                if ( p.matches("id") ) id = p.value();
                else if ( p.matches("file") ) {
			fileb = 1; citefile = p.value();
			//cerr << "ID: " << (char*) id;
			//cerr << " TAGFILE: " << (char*) file << endl;
			}
                }
	if ( fileb )
		sprintf(tagfile,"%s.html", (char*) citefile);
        out << "&nbsp;" << yy;
	out << ">";
	citit = 1;
        }

"</cite>" { citit = 0; out << yytext; }

"<ref"{atts}">" {
        yytext[yyleng-1] = '\0';
	int fileb = 0;
	string id = "";
        string file = "";
        string_converter x(yytext+5);
        for (int i = 1; i <= x.argc(); i++ ) {
                attribute p(x[i]);
                if ( p.matches("id") ) id = p.value();
                else if ( p.matches("file") ) {
			fileb = 1; file = p.value();
			//cerr << "ID: " << (char*) id;
			//cerr << " TAGFILE: " << (char*) file << endl;
			}
                }
	if ( fileb )
		sprintf(reffile,"%s.html", (char*) file);
        out << yytext;
	out << ">";
	refit = 1;
        }

"</ref>" { refit = 0; out << yytext; }

"<sliref"{atts}">" {
        yytext[yyleng-1] = '\0';
	int fileb = 0;
	string id = "";
        string file = "";
        string_converter x(yytext+7);
        for (int i = 1; i <= x.argc(); i++ ) {
                attribute p(x[i]);
                if ( p.matches("id") ) id = p.value();
                else if ( p.matches("file") ) {
			fileb = 1; file = p.value();
			cerr << "ID: " << (char*) id;
			cerr << " SLIFILE: " << (char*) file << endl;
			}
                }
	if ( fileb )
		sprintf(slidir,"%s", (char*) file);
	int indir = (slidir[0] != '.');
	out << "slide <ref><a href=\"";
	if (indir)
	     out << slidir << ".html#" << (char*) id << "\">";
	else 
	     out << "#" << (char*) id << "\">";

	out << "<!--slide--->" << (char*) id << "</a></ref>";
        //out << "slide <ref><a href=\"" << (indir?slidir:"") << at() << "slide-" << (char*) id <<
	//".html\">" << "<!--slide--->" << (char*) id << "</a></ref>";

        //out << yytext;
	//out << ">";
        }


%%@ in remembrance of troff

"<display"{atts}">" { in_display=1; in_program=1; out << yytext << "<pre>"; } 
"</display>" { in_display=0; in_program=0; out << "</pre>" <<  yytext; }

"<escape>"|"<esc>" { in_escape=1; }
"</escape>"|"</esc>" { in_escape=0; }
"<program"{atts}">" { 
	in_program=1; in_progcmt = 0;
	out << bcmt << yytext << ecmt << "<pre>";
	} 
"</program>" { 
	in_program=0; 
	out << "</pre>" << bcmt << yytext << ecmt; 
	}

"<pre>" { if (!in_program) out << yytext; }
"</pre>" { if (!in_program) out << yytext; }
"<i>"|"</i>"|"<b>"|"</b>"|"</font>" { out << yytext; }
"<font"{atts}">"|"</font>" { out << yytext; }
"<p"{atts}">"|"</p>" { out << yytext; }
"\\zline{\\fbox{"[a-zA-Z0-9]+"}}" {
    yytext[yyleng-2]='\0';
    out << "<c><p align=right><font color=red>";
    out << yytext+13 << "</font></c>";
    out << bcmt << yytext << "}}" << ecmt;
    }
"<zline>"  { 
	     out << "<control><p align=right></control><font color=red>";
             out << bcmt << "\\zline{" << ecmt;
	   }
"</zline>"  {
	    out << "</font><control></p><br></control>";
	    out << bcmt << "}" << ecmt;
            }
"<box>"  { 
	     out << "<control><b></control>";
             out << bcmt << "\\fbox{" << ecmt;
	   }
"</box>"      { 
	        out << "<control></b></control>";
		out << bcmt << "}" << ecmt;
	 }
"</>"      { out << bcmt << "}" << ecmt; }

%%@ and latex

"<rf>"|"<references>" { in_references = 1; citit=0; refit=0;  out << "<dl>"; }
"</rf>"|"</references>" { in_references=0; out << "</dl>"; }

"<bibliography"{atts}">"|"<refs>" { 
  in_references=1;
  in_biblio++;
  if (in_biblio==1) {
	do_biblio=1;
        yytext[yyleng-1] = '\0';
	int fl=0;
	string s;
	string type="present";
        string style="book";
        string mode="refs";
        string scope="local";
        string pre="";
        string post="";
	string fm = "";
        string_converter x(yytext+13);
        for (int i = 1; i <= x.argc(); i++ ) {
          attribute p(x[i]);
	  if ( p.matches("type") ) type = p.value();
	  else if ( p.matches("style") ) style = p.value();
	  else if ( p.matches("mode") ) mode = p.value();
	  else if ( p.matches("scope") ) {
				 scope = p.value();
				 cerr << "KATO: " << scope << endl;
				 }
	  else if ( p.matches("pre") ) pre = p.value();
	  else if ( p.matches("post") ) post = p.value();
	  else if ( p.matches("fm") ) fm = p.value();
        }
	if (style == "art") refstyle=1;
	kato_scope = 0;
	kato_mode = 0;
	kato_scope = new string( (char*) scope);
	kato_mode = new string( (char*) mode);
	refmode = 1;
	if (*kato_mode != "declare") {
	  if (*kato_mode!="bridge")
		out << yytext << ">"; // << "<dl>";
	}
        if ((*kato_mode=="bridge" || fm=="nolines") ) fm_nolines = 1;
       }
      }

"</bibliography>"|"</refs>" { // xxx
	if (in_biblio==1) {
		if (current) {
			entries.insert(current);
			references[current->key()] = current;
			}
		if (*kato_mode != "declare") {
		  printer_state = -1;
		  if (!biblio_listed && current) out << *current;
		  printer_state = 0;
		  if (!biblio_listed) out << entries;
		  printer_state = 1;
		  if (!biblio_listed && current) out << *current;
        	  if (*kato_mode != "bridge") out << yytext;
		  //out << "</a>";
		  biblio_listed = 1;
		}
		current = 0;
		refmode = 0;
	} 
	in_biblio -= 1;
      in_references=0;
      }

"<dt>" { 
	if (in_program) out << "&lt;dt&gt;";
	else {
		if (refmode) nameit = 1; out << yytext;
		}
	} 
"<dd>" {
	if (in_program) out << "&lt;dt&gt;";
	else {
		nameit = 0; out << yytext;
		}
	} 

%%@ doing maths?

^[\:]?"@"[ 0-9\@\#\*\+\-\!\%].*   {
		int tmp = pr;
	        int _level = 0;
	        string color = "gold";
		char buf[BUFSIZ];
		int star = 0;
		char *py = yytext;
		char *phold = py;
		char bx[2];
		bx[0] = '\0'; bx[1] = '\0';
		if (py[0]==':') { bx[0]='*'; star=1; py++; }
		//docon=1; ln=0; testip();
		char* s = py + 2;
		switch(py[1]) {
		case '%': _level=-2; break;
		case '@': _level = -1; break;
		case '#':  _level = 0; break;
		case '0': 
		case '*':
		case '1': _level = 1; color = "gold"; break;
		case '+':
		case '2': _level =2; color = "silver"; break;
		case '-':
		case '3': _level = 3; color = "silver"; break; 
		case ' ':
		case '4': _level = 4; color = "silver"; break;
		case '!': 
		default : _level = 5; break;
		}
	   {
	   pr = 1;
	   if (star) out << "<c-nonum>";
	   if ( in_slide==0 && _level>-2 && _level<4) {
		  char buf[256];
		  sprintf(buf,"%s-ch-%d",filename,chap_no++);
		  string id = slideref(buf);
                          char fn[256];
	          sprintf(fn,"@slide-%s.html", (char*) id);
		  out.push(fn);
		  *(out.child()) << "\n" << slidestyle << "\n";
                  *(out.child()) << "\n<script language=Javascript1.2>"
                          << "slidestyle=\"" << color << "\";\n</script>\n";
                          *(out.child()) << "\n" << slidebody << "\n";
                          lst << "slide(\"" << prefix() << "@slide-" << 
                  (char*) id << "\");" << endl;
	          *(out.child()) << "<center>" << endl;
	    }
            	if (_level==-1) {
			  sprintf(buf,"<!--\\part%s{%s}-->",bx,s);
			  pr = 1;
                          out << buf;
			  if (!star && bk) {
			      sprintf(buf,"<!--\\markpart{ %s }-->",s);
			      out << buf;
			      }
		} else if (_level==0) {
			  out << "<!--<control>--><h1>" << s << "</h1><!--</control>-->";
			  out << "<!-- \\chapter{" << s << "}-->";
			  if (!star && bk) {
			     sprintf(buf,"<!--\\markchapter{ %s }-->",s);
			     out << buf; 
			     }
		} else if (_level==1) {
	    	  out << "<h1>";
		  if (s[1]!='<')
		  out << "<a href=@talk-" << filename << ".html target=_top>";
		  out << s;
		  if (s[1]!='<') out << "</a>";
		  out << "</h1>";
		  if (!star && bk) {
		     sprintf(buf,"<!--\\marksection{ %s }-->",s);
		     out << buf;
		     }
		} else if(_level==2)  {
			  out << "<h2>";
			  if (s[1]!='<')
		          out << "<a href=@talk-" << filename << ".html target=_top>";
			  out << s;
			  if (s[1]!='<') out << "</a>";
			  out << "</h2>";
			  if (!star && bk) {
			      sprintf(buf,"<!--\\marksubsection{ %s }-->",s);
			      out << buf;
			      }
		} else if (_level==3) {
			  out << "<h3>" << s << "</h3>";
		} else if (_level==4) {
		          out << "<h4>" << s << "</h4>";
			  if (!star && bk) {
				 sprintf(buf,"<!--\\index{%s}-->",s);
			  	 out << buf;
				 }
	        } else if (_level>4) {
			  out << "<h" << _level << ">" << s << "</h" << _level << ">";
			  }
            if (in_slide==0 && _level>-2 && _level<4) {
		  *(out.child()) << "</center>\n</body></document>";
	          out.pop();
	    }
	    if (star) out << "</c-nonum>";

	    };

	pr = tmp;
	}

"<text>"  { ; }
"</text>" { ; }

%%@ from the past, my past

^"<I>-" { out << "<ul><li>"; strcat(endline,"</ul>"); }
^"<*>-" { out << "<ul><li>"; strcat(endline,"</ul>"); }
^"*-" { out << "<ul><li>"; strcat(endline,"</ul>"); }
"{I " { out << "<i>"; }
" I}" { out << "</i>"; }
"{P " { out << "<tt><c-inprog>"; }
" P}" { out << "</c-inprog></tt>"; }
^"[P]" { out << "<program>\n"; strcat(endline,"</program>"); }
^"[P" { in_display=1;in_program=1; out << "<program><pre>"; }
^"P]" { in_display=0;in_program=0; out << "</pre></program>"; }
^"<I"/\n { in_li=1; out << "<ul>"; }
^"I>" { in_li=0; out << "</ul>"; }
^"<E"/\n { in_li=1; out << "<ul>"; }
^"E>" { in_li=0; out << "</ul>"; }
^"<N" { in_li=1; out << "<ol>"; }
^"N>" { in_li=0; out << "</ol>"; }
^"- "  { if (in_li) out << "<li>"; }

%%@ supporting the kato/KATO reference format


("[_"|"[:")[A-Za-z][A-Za-z0-9\-\,]+"]" {
    if (!in_program) {
	yytext[yyleng-1] = 0;
	string s = yytext+2;
	refto[s] = new string(yytext+2);
	//AE
      if ((!bk) || citemode) {
	out << "&nbsp;<c>[</c><cite>" << "<a href=" << "\"" << tagfile << "#" << yytext+2 << "\">"; 
	entry* x = references[(char*)s];
	/*
        if (x && x->ref()) {
		out << "" << *(x->ref()) << "";
        } else if (x && x->key()) {
		out << "" << *(x->key()) << "";
	} else */ out << yytext+2;
	out << "</a></cite><c>]</c>";
      } else if ( !citemode && bk && !instring(',',s)) {
	out << "&nbsp;<c>[</c>" << "<a href=" << "\"" << tagfile << "#" << yytext+2 << "\">"; 
	entry* x = references[(char*)s];
        if (x && x->ref()) {
		::text(x->ref());
		out << "<!--\\index{"; /// author index
		::text(x->ref());
		out << "}-->";
        } else if (x && x->key()) {
		out << "" << *(x->key()) << "";
	} else {
	    if (warnings) { 
	       out << "<font color=red>" << yytext+2 << "</font>";
	    } else
	       out << yytext+2;
	    refto[s] = new string("missing");
	    entry* x = new entry();
	    x->key((char*)s);
	    x->ref((char*)s);
	    x->category("missing");
	    entries.insert(x);
	    references[x->key()] = x;
	    cerr << "WARNING MISSING REFERENCE: " << yytext+2 << endl;
		}
	out << "</a><c>]</c>";
      } else if (!citemode && bk) { // refine ... AE
	s.split(",");
	iter<string>& it = s;
	string* p = 0;
	int num=0;
	while( (p = it()) ) {
		if (num>0) out << ", ";
		num++;
		refto[(char*)*p] = new string(yytext+2);
                string str = (char*) *p;
	out << "&nbsp;<c>[</c>" << "<a href=" << "\"" << tagfile << "#" << yytext+2 << "\">"; 
	entry* x = references[(char*)str];
        if (x && x->ref()) {
		//out << "" << *(x->ref()) << "";
		::text(x->ref());
        } else if (x && x->key()) {
		out << "" << *(x->key()) << "";
	} else {
           if (warnings)
	     out << "<font color=red>" << (char*)str << "</font>";
	   else
	     out << (char*)str;
	   refto[(char*)*p] = new string("missing");
            entry* x = new entry();
            x->key((char*)str);
            x->ref((char*)str);
            x->category("missing");
            entries.insert(x);
            references[x->key()] = x;

	   cerr << "WARNING MISSING REFERENCE: " << (char*)str << endl;
		}
	out << "</a><c>]</c>";
	}
	}
    } else { out << yytext; }
}

^@"K "[A-Za-z0-9\-]+ { nameit = 1; 
	in_references = 1;
	nameit = 0;
	out << "<a name=" << yytext+3 << ">";
	authorno = 0; out << "<dt>" << yytext+3;
	}
^@"A " { if (!authorno++) out << "<dd>"; nameit = 0; strcat(endline,","); }
^@"T " { if (!authorno++) out << "<dd>"; nameit = 0;
	  bookmode=0; titlemode = 1; strcat(endline,","); }
^@"B " { if (!authorno++) out << "<dd>"; nameit = 0;
	  bookmode=1; out << "<i>"; titlemode = 1; strcat(endline,","); }
^@"O " { if (bookmode) out << "</i>"; titlemode = 0; }
^@"X".* { ; }

%%@ new style kato


^\%"K ".*\n {
	      nameit = 1; authorno = 0;
	      yytext[yyleng-1]='\0';
	      char* p = yytext+3;
	      int i = 0;
	      while ( *p != ' ' && *p != '\0' ) p++;
	      char* q = p + 1;
              if (current) {
                        //current->print(cout);
                        entries.insert(current);
			references[current->key()] = current;
                        }
              current = new entry;
	      if (*p != 0) {
 			*p = '\0';
			if (*q == ':' || *q == '_') {
					current->category("reference");
					q++;
					}
			current->ref(q);
			aliasref[q] = new string(yytext+3);
			}
              current->key(yytext+3);
        }


^\%"R ".*\n { yytext[yyleng-1]='\0'; current->ref(yytext+3); }
^\%"A ".*\n { yytext[yyleng-1]='\0'; current->author(yytext+3); }
^\%"T ".*\n { yytext[yyleng-1]='\0'; current->title(yytext+3); }
^\%"B ".*\n { yytext[yyleng-1]='\0'; current->title(yytext+3); current->category("book"); }
^\%"O ".*\n { yytext[yyleng-1]='\0'; current->publisher(yytext+3); }
^\%"X ".* { current->comment(yytext+3); }

%%@ more symbols

"}"|"{" {
	if (in_program && !in_display) {
		out << "<b>" << yytext << "</b>";
		}
	else out << yytext;
	}

"\\$" { if (ml_mode && !in_ml()) {
	} else 
		out << yytext; 
      }
"$"[0-9\$] { 
	if (ml_mode && !in_ml()) {
		out << "\\" << yytext;
	} else
		out << yytext;
   }

^"@$="[\$[A-Za-z0-9].*\n {
	raw_dollar = 0;
	in_comment=0;
	in_dollar=0;
	switch (yytext[3]) {
                case 'b':
	        case 'B':
			strcpy(begin_dollar,"<b>");
			strcpy(end_dollar,"</b>");
			break;
                case 'i':
	        case 'I':
			strcpy(begin_dollar,"<i>");
			strcpy(end_dollar,"</i>");
			break;
                case 'p':
	        case 'P':
			strcpy(begin_dollar,"<tt><c-inprog>");
			strcpy(end_dollar,"</c-inprog></tt>");
			break;
                case 'm':
	        case 'M':
			strcpy(begin_dollar,"<math>");
			strcpy(end_dollar,"</math>");
			break;
		case 'r':
		case 'R':
			raw_dollar = 1;
			break;
	        case '$':
			strcpy(begin_dollar,"$");
			strcpy(end_dollar,"$");
			break;
		default:
			reset_dollar();
			break;
		};
	}

"$"   {
	if ( in_ml() || in_echo() || in_escape ) out << yytext; 
	else if (in_program && !in_display && !in_progcmt) out << "\\$";
	else {
		if (in_dollar) {
			in_dollar = 0;
			if (raw_dollar) end_raw("$");
			else out << end_dollar;
		} else {
			in_dollar = 1;
			if (raw_dollar) begin_raw("$");
			else out << begin_dollar;
		}
	}
  }

%%@ escape

"<math>"|"</math>"|"->"|"=>"|"<="|"<-"|"<=>" { out << yytext; }
"<" { if (in_program && !in_display) out << "<b>&lt;</b>"; else out << yytext; }
">" { if (in_program && !in_display) out << "<b>&gt;</b>"; else out << yytext; }
\t { out << yytext; }

%%@ to provide links

"<"{includedirs}"/"[a-z0-9A-Z\-\/]+".idl>" { 
        char buf[512]; int i = 0;
        char name[512];
	char* p = (char*)& yytext[1];
	while ( *p && *p != '/' ) name[i++] = *p++;
	name[i] = '\0';
	sprintf(buf,"interfaces/idl/%s",name);
	char* ref = ::resolve(buf);
	//cerr << "Resolved: " << buf << " => " << ref << endl;
        yytext[yyleng-1] = '\0';
        out << "<a href=\"" << documents << "/" << ref << yytext+(i+1) << ".html\">"
            << "&lt;" << yytext+1 << "&gt;" << "</a>";
        }

"<"{includedirs}"/"[a-z0-9A-Z\-\/\_]+"."[hicpx]+">" { 
	char name[512]; int i = 0;
        char buf[512];
	char* p = (char*)& yytext[1];
        //cerr << "****" << endl;
	while ( *p != '/' ) name[i++] = *p++;
	name[i] = '\0';
	//cerr << "Name: " << name << endl;
	sprintf(buf,"sources/%s",name);
	char* ref = ::resolve(buf);
	if (!ref) ref = (char*)name;
	//cerr << "Aliased: " << ref << endl;
        yytext[yyleng-1] = '\0';
        out << "<a href=\"" << documents << "/" << ref << yytext+i+1
	    << ".html\">" << "&lt;" << yytext+1 << "&gt;" << "</a>";
        }



%%@ make and configure

"<Makefile>" {
        out << "<a href=\"" << documents << "/sources/Makefile.html\">"
	    << "Makefile" << "</a>";
        }

"cfg/"[a-z0-9A-Z\-\/]+".cfg" { 
        char buf[512];
        strcpy(buf,yytext);
        out << "<a href=\"" << documents << "/sources/" << buf
	    << ".html\">" << buf << "</a>";
        }

"cfg/"[a-z0-9A-Z\-\/]+".mk" { 
        char buf[512];
        strcpy(buf,yytext+4);
        out << "<a href=\"" << documents << "/sources/cfg/" << buf
	    << ".html\">" << buf << "</a>";
        }

%%@ documents 


"//"{docdirs}"/"[A-Za-z0-9\@\-\/\.\*]+ {
	char name[1024];
	char ref[1024];
        char buf[1024];
	int x = 0; int i = 0;
	char* p = yytext+2;
	while ( *p!='\0' && x != 2 ) {
		if ( *p == '/' ) x++;
                if (x < 2) name[i++] = *p++;
		}
	name[i] = '\0';
	char* _ref = ::resolve(name);
	//if (!ref) ref = (char*) name;
	sprintf(ref,"%s%s",_ref,yytext+i+2);
	int leng = strlen(ref);
	cerr << "Lookup: " << name << " => " << ref << endl;
	if (!strcmp("sources/java",name)) {
		char* x = ref;
		while ( *x != '\0' ) {
			if (*x == '.') *x = '/';
			x++;
			}
		if (ref[strlen(ref)-1] != '/')
			sprintf(ref,"%s.java",ref);
		}
        strcpy(buf,yytext+2);
	char c = buf[strlen(buf)-1];
	if (c == '*' || c == '/') buf[strlen(buf)-1] = '\0';
	yyleng = yyleng-2;
	p = buf;
        out << "<a href=\"" << documents << "/"
	    << ref;
        if (ref[leng-1]=='/')
	    		out << "index.html";
	else if (ref[leng-1]=='*')
			out << "/index.html";
	else
	    		out << ".html";
	out << "\">" << buf << "</a>";
        }

"//"{online}"/"[A-Za-z0-9\@\-\/\.\*]+ {
	char name[1024];
	char ref[1024];
        char buf[1024];
	int x = 0; int i = 0;
	char* p = yytext+2;
	while ( *p!='\0' && x != 2 ) {
		if ( *p == '/' ) x++;
                if (x < 2) name[i++] = *p++;
		}
	name[i] = '\0';
	char* _ref = ::resolve(name);
	//if (!ref) ref = (char*) name;
	sprintf(ref,"%s%s",_ref,yytext+i+2);
	int leng = strlen(ref);
	cerr << "Lookup: " << name << " => " << ref << endl;
	if (!strcmp("sources/java",name)) {
		char* x = ref;
		while ( *x != '\0' ) {
			if (*x == '.') *x = '/';
			x++;
			}
		if (ref[strlen(ref)-1] != '/')
			sprintf(ref,"%s.java",ref);
		}
        strcpy(buf,yytext+2);
	char c = buf[strlen(buf)-1];
	if (c == '*' || c == '/') buf[strlen(buf)-1] = '\0';
	yyleng = yyleng-2;
	p = buf;
        out << "<a href=\"" << online << "/../"
	    << ref;
        if (ref[leng-1]=='/')
	    		out << "index.html";
	else if (ref[leng-1]=='*')
			out << "/index.html";
	else
	    		out << ".html";
	out << "\">" << buf << "</a>";
        }

%%@ local documentation

"//./"[A-Za-z0-9\-\/\.\*]+ {
	char name[1024];
	char ref[1024];
        char buf[1024];
	sprintf(ref,"./%s",yytext+4);
	int leng = strlen(ref);
        strcpy(buf,yytext+4);
	char c = buf[strlen(buf)-1];
	if (c == '*' || c == '/') buf[strlen(buf)-1] = '\0';
	yyleng = yyleng-2;
        out << "<a href=\"" << ref;
        if (ref[leng-1]=='/')
	    		out << "index.html";
	else if (ref[leng-1]=='*')
			out << "/index.html";
	else
	    		out << ".html";
	out << "\">" << buf << "</a>";
        }

"//@online/"[A-Za-z0-9\-\/\.\*]+ {
	char name[1024];
	char ref[1024];
        char buf[1024];
	sprintf(ref,"@online/%s",yytext+10);
	int leng = strlen(ref);
        strcpy(buf,yytext+10);
	char c = buf[strlen(buf)-1];
	if (c == '*' || c == '/') buf[strlen(buf)-1] = '\0';
	yyleng = yyleng-2;
        out << "<a href=\"" << ref;
        if (ref[leng-1]=='/')
	    		out << "index.html";
	else if (ref[leng-1]=='*')
			out << "/index.html";
	else
	    		out << ".html";
	out << "\">" << buf << "</a>";
        }

"//../"[A-Za-z0-9\-\/\.\*]+ {
	char name[1024];
	char ref[1024];
        char buf[1024];
	sprintf(ref,"../%s",yytext+5);
	int leng = strlen(ref);
        strcpy(buf,yytext+5);
	char c = buf[strlen(buf)-1];
	if (c == '*' || c == '/') buf[strlen(buf)-1] = '\0';
	yyleng = yyleng-2;
        out << "<a href=\"" << ref;
        if (ref[leng-1]=='/')
	    		out << "index.html";
	else if (ref[leng-1]=='*')
			out << "/index.html";
	else
	    		out << ".html";
	out << "\">../" << buf << "</a>";
        }

%%@ places

"//"{places}"/"[A-Za-z0-9\-\/]+ {
        char buf[128];
        strcpy(buf,yytext+2);
        out << "<a href=\"" << home << buf
	    << "" << "\">" << buf << "</a>";
        }

"//"{places}"@cs.vu.nl" {
        out << "<a href=mailto:" << yytext+2 << ">" 
	    << yytext+2 << "</a>";
        }

"//mailto:"[^\ \t\n]+ {
        out << "<a href=" << yytext+2 << ">" 
	    << yytext+9 << "</a>";
	}

"//link:"[^\ \t\n]+ {
        out << "<a href=" << yytext+7 << ">" 
	    << yytext+7 << "</a>";
	}

%%@ manuals

(man)":"[A-Za-z0-9\-]+"("[1-9ln]")" {
        char n = yytext[yyleng-2];
        char buf[64];
        strcpy(buf,yytext+4);
        buf[yyleng-3-4]='\0';
        out << "<a href=\"" << manuals << "/man" << n << "/"
	    << buf << ".html" << "\">" << yytext+4 << "</a>";
        }



%%@ newlines and dot

\n { 
     if (eat_n) eat_n = 0;
     else {
     out << endline;
     strcpy(endline,"");
     if (!titlemode) out << yytext; else out << " ";
     if (in_program) out << "  ";
     nameit = 0;
     if (!in_cmode)
     	in_progcmt = 0;
     }
}

"\\~" { if (!latexmode && !in_raw) out << "~"; else out << yytext; } 
"\\_" { if (!latexmode && !in_raw) out << "_"; else out << yytext; } 
"\\$" { if (!latexmode && !in_raw) out << "$"; else out << yytext; } 
. { out << yytext; }

%%
//@ main

static char g_argv[24][256];

static void declare(const char* pkg, const char* cat) {
char k[1024]; char v[1024];
sprintf(k,"%s",pkg); sprintf(v,"%s/%s",cat,pkg); ::alias(k,v);
sprintf(k,"sources/%s",pkg); sprintf(v,"sources/%s/%s",cat,pkg); ::alias(k,v);
sprintf(k,"packages/%s",pkg); sprintf(v,"sources/%s/%s",cat,pkg); ::alias(k,v);
sprintf(k,"interfaces/idl/%s",pkg); sprintf(v,"sources/%s/idl/%s",cat,pkg); ::alias(k,v);
sprintf(k,"interfaces/include/%s",pkg); sprintf(v,"sources/%s/%s",cat,pkg); ::alias(k,v);
sprintf(k,"examples/%s",pkg); sprintf(v,"sources/%s/examples/%s",cat,pkg); ::alias(k,v);
sprintf(k,"examples/%s",cat); sprintf(v,"sources/%s/examples",cat); ::alias(k,v);
}


int main(int argc, char* argv[]) {

sprintf(slidir,".");
entriesp = new oset<entry>;

thesession = new session();
session::declare("global",thesession);
session::initialize();
kit::initialize();
kit::_default = new kit();

nofio = 0;
int _argc = 0;

kato_mode = new string("refs");
kato_scope = new string("local");

entry::thereferences = new dictionary<entry>;

//strcpy(begin_dollar,"$");
//strcpy(end_dollar,"$");

reset_dollar();

declare("sigma","simulation");
declare("bpsim","simulation");
declare("grammar","grammar");
declare("ml","grammar");

declare("ami","web");
declare("pl","logic");

::alias("dv/pl","logic/dv/pl");
::alias("dv/bp","logic/dv/bp");
::alias("dv/sp","logic/dv/sp");
::alias("dv/ls","logic/dv/ls");

::alias("dlp","dlp/src");

argc--; argv++;

mode = 0;

strcpy(tagfile,"refs.html");
//strcpy(tagfile,"");
strcpy(endline,"");
strcpy(endbrace,"");

strcpy(online,ONLINE);
strcpy(documents,DOC);
strcpy(manuals,MAN);
strcpy(home,HIT);

//@ options

while ((argc > 0) && (argv[0][0] == '-')) {
	if ( argv[0][1] == 'N' ) { 
		strcpy(filename,&argv[0][2]);
		cerr << "NAME = " << filename << endl;
		//argv++; argc--;
		}
	if ( argv[0][1] == 'A' ) { 
		//strcpy(filename,&argv[0][2]);
		//cerr << "NAME = " << filename << endl;
		auto_header = 1;
		auto_footer = 1;
		//argv++; argc--;
		}
	if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(g_argv[_argc],argv[0]);
		//cerr << "Copied " << g_argv[_argc] << endl;
		_argc++;
		}
	if ( argv[0][1] == 'D' ) { 
		strcpy(documents,&argv[0][2]);
		cerr << "DOC = " << documents << endl;
		}
	if ( argv[0][1] == 'M' ) { 
		strcpy(manuals,&argv[0][2]);
		cerr << "MAN = " << manuals << endl;
		}
	if ( argv[0][1] == 'H' ) { 
		strcpy(home,&argv[0][2]);
		cerr << "HOME = " << home << endl;
		}
	if ( !strcmp( *argv, "-latex" ) ) { 
		latexmode = 1; 
		cerr << "LaTeX = on" << endl;
		}
	else if ( !strcmp( *argv, "-warnings" ) ) { 
		warnings = 1; 
		cerr << "warnings = on" << endl;
		}
	else if ( !strcmp( *argv, "-text" ) ) { 
		mode = textmode; 
		cerr << "MODE = text" << endl;
		}
	else if ( !strcmp( *argv, "-all" ) ) { 
		do_all = 1;
		cerr << "DO ALL" << endl;
		}
	else if ( !strcmp( *argv, "-slide" ) ) { 
		mode = slimode; 
		cerr << "MODE = slide" << endl;
		}
	else if ( !strcmp( *argv, "-bk" ) ) { 
		bk = 1;
		cerr << "BK = true" << endl;
		}
	else if ( !strcmp( *argv, "-ml" ) ) { 
		ml_mode = 1;
		cerr << "ML = true" << endl;
		//strcpy(ext,".ml");
		}
	else if ( !strcmp( *argv, "-echo" ) ) { 
		echo_mode = 1;
		cerr << "ECHO = true" << endl;
		//strcpy(ext,".ml");
		}
	argc--; argv++;
	}

//@ process

CLASS l;
_lexer = &l;
//cerr << "Which paths?" << endl;
l.paths(_argc,  g_argv);
cerr << "ARG: " << argc << endl;
char lname[1024];
sprintf(lname,"@lst-%s.js",filename);
lst.push(lname);
nofio=0;
if ( argc == 0 )  l(); 
else
	while (argc-- > 0) 
		l.soinc( *argv++ );
return 0;
}


//@ auxiliary

instr(char c, char *s)
{
while( (*s != '\0') && (c != *s )) s++;
if (*s=='\0') return(0); else return(1);
}
 
firn(char *s) {
int i=0;
//finn=0;
if (*s != '\n') return(0);
else {
while ((*s !='\0') && (*s == '\n') ) { i++; s++; } 
if (*s == '\n') return(i+1);
else return(i);
}
}

char *tol(char *s)
{
char *p = s;
while ( *p == ' ' && *p != '\0') p++;
while (*s != '\0') {
        if (isupper(*s)) *s = tolower(*s);
        s++;
        }
return(p);
}
//</>
