%{
//@auto=0
//@class index
%}
%class lex
%a 4000
%p 10000
%n 900
%e 2600
%o 10000
%{
#include <hush/grammar/lex.h>
#include "ctype.h"
int mycmp(char *s1, char *s2);
char *s,*strcpy();
char* tol(char*);
char buf[BUFSIZ];
#define scmp(X) (mycmp(X,s))
#define P(X) else if scmp(X) printf("%s\\index{%s}",yytext,X)
#define PR(N) printf("%s\\index{%s}",yytext+N+1,yytext+N+1)
#define XXXXPR(N) printf("%s\\index{%s}",yytext,yytext+N+1)
#define PRIN printf("%s\\index{%s}",yytext,yytext)
char* lastid;
char idbuf[BUFSIZ];
%}
x [A-Z]+
a [A-Za-z]+
b [A-Z][A-Za-z\-]+
key (id|slide|indexentry|label|ref|index|glossary|commentindex|paragraphindex|subparagraphindex)
%%
"["[A-Za-z][A-Za-z0-9\-]*"]" { ECHO; }
"\\item".* ECHO;
"\\fig".* ECHO;
"\\slide".* ECHO;
"\\eps".* ECHO;
"\\bibitem".* ECHO;
"\\zline".* ECHO;
"\\subitem".* ECHO;
"\\mark".* ECHO;
"\\paragraph".* ECHO;
"\\chapter".* ECHO;
"\\section".* ECHO;
"\\subsection".* ECHO;
"\\subsubsection".* ECHO;
"\\subsubitem".* ECHO;
\\"renew".* ECHO;
\\"new".* ECHO;
\\"def".* ECHO;
\\"lllllprog{"[^\}]+ printf("\\index{%s}%s",yytext+7, yytext);
\\"pprog{"[^\}]+ printf("\\index{Prolog programs! %s}%s",yytext+7, yytext);
\\"xxxxxxprog{"[^\}]+ printf("\\index{prototype implementation! %s}%s",yytext+7, yytext);
\\"lblok{"[^\$]*\$[^\$]+\$ printf("\\index{operational semantics! %s}%s",yytext+7, yytext);
\\"lbeql{"[^\$]*\$[^\$]+\$ printf("\\index{operational semantics! %s}%s",yytext+7,yytext);
\\"deno{"[^\$]*\$[^\$]+\$ printf("\\index{denotational semantics! %s}%s",yytext+6,yytext );
\\"dlpindex{" printf("\\index{distributed!");
\\"prologindex{" printf("\\index{Prolog!");
\\"oopindex{" printf("\\index{object oriented programming!");
\\"ooindex{" printf("\\index{object oriented!");
\\"seindex{" printf("\\index{software engineering!");
\\"parindex{" printf("\\index{parallel programming!");
\\"disindex{" printf("\\index{distributed programming!");
\\"semindex{" printf("\\index{declarative semantics!");
\\"opindex{" printf("\\index{operational semantics!");
\\"denoindex{" printf("\\index{denotational semantics!");
\\"sldindex{" printf("\\index{sld resolution!");
\\"langindex{" printf("\\index{programming languages!");
\\"protoindex{" printf("\\index{prototype!");
\\"implindex{" printf("\\index{prototype implementation! ");

\\"specialindex{".* { 
	char *idn();
	/*
	char *sp, buf[BUFSIZ];
	int b,nb=0;
	sp = yytext[9];
	*/
	printf("\\def\\zzzindex%s{%s\\index{\\zzzindex%s}",idn(), yytext+10, lastid);
	}
"C++" printf("\\cpp\\/\\index{programming languages!%s}",yytext,yytext);
"sC++" printf("s\\cpp\\/\\index{programming languages!%s}",yytext,yytext);
"Smalltalk" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Eiffel" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Prolog" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Ada" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Ada9X" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Active C++" printf("%s\\index{programming languages!%s}",yytext,yytext);
"POOL" printf("%s\\index{programming languages!%s}",yytext,yytext);
"POOL-X" printf("%s\\index{programming languages!%s}",yytext,yytext);
"POOL*" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Concurrent C" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Concurrent Prolog" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Parlog" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Emerald" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Linda" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Occam" printf("%s\\index{programming languages!%s}",yytext,yytext);
"CSP" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Logical Objects" printf("%s\\index{programming languages!%s}",yytext,yytext);
"SPOOL" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Communicating Prolog Units" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Vulcan" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Polka" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Delta Prolog" printf("%s\\index{programming languages!%s}",yytext,yytext);
"MultiLog" printf("%s\\index{programming languages!%s}",yytext,yytext);
"OrientK/84" printf("%s\\index{programming languages!%s}",yytext,yytext);
"ObjVProlog" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Modula-2" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Modula-3" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Emerald" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Java" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Oberon" printf("%s\\index{programming languages!%s}",yytext,yytext);
"HyperTalk" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Orca" printf("%s\\index{programming languages!%s}",yytext,yytext);
"muC++" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Mentat/C++" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Concurrent C++" printf("%s\\index{programming languages!%s}",yytext,yytext);
"Active C++" printf("%s\\index{programming languages!%s}",yytext,yytext);
"DLP" printf("%s\\index{programming languages!%s}",yytext,yytext);
"ML" printf("%s\\index{programming languages!%s}",yytext,yytext);
"CSP" printf("%s\\index{programming languages!%s}",yytext,yytext);
"CSP" printf("%s\\index{programming languages!%s}",yytext,yytext);
"CSP" printf("%s\\index{programming languages!%s}",yytext,yytext);
"CSP" printf("%s\\index{programming languages!%s}",yytext,yytext);
"CSP" printf("%s\\index{programming languages!%s}",yytext,yytext);

"OOA/D" printf("%s\\index{methods!%s}",yytext,yytext);
"OOD" printf("%s\\index{methods!%s}",yytext,yytext);
"Objectory" printf("%s\\index{methods!%s}",yytext,yytext);
"OOSA" printf("%s\\index{methods!%s}",yytext,yytext);
"OOSD" printf("%s\\index{methods!%s}",yytext,yytext);
"CRC" printf("%s\\index{methods!%s}",yytext,yytext);
"RDD" printf("%s\\index{methods!%s}",yytext,yytext);
"OMT" printf("%s\\index{methods!%s}",yytext,yytext);
"Fusion" printf("%s\\index{methods!%s}",yytext,yytext);
"OOD" printf("%s\\index{methods!%s}",yytext,yytext);
"OOD" printf("%s\\index{methods!%s}",yytext,yytext);
"OOD" printf("%s\\index{methods!%s}",yytext,yytext);
"OOD" printf("%s\\index{methods!%s}",yytext,yytext);
"OOD" printf("%s\\index{methods!%s}",yytext,yytext);
"OOD" printf("%s\\index{methods!%s}",yytext,yytext);
"OOD" printf("%s\\index{methods!%s}",yytext,yytext);
"Reactor" printf("%s\\index{patterns!%s}",yytext,yytext);
"Observer" printf("%s\\index{patterns!%s}",yytext,yytext);
"Decorator" printf("%s\\index{patterns!%s}",yytext,yytext);
"Visitor" printf("%s\\index{patterns!%s}",yytext,yytext);
"Strategy" printf("%s\\index{patterns!%s}",yytext,yytext);
"Bridge" printf("%s\\index{patterns!%s}",yytext,yytext);
"Facade" printf("%s\\index{patterns!%s}",yytext,yytext);
"Abstract Factory" printf("%s\\index{patterns!%s}",yytext,yytext);
"Factory Method" printf("%s\\index{patterns!%s}",yytext,yytext);
"Command" printf("%s\\index{patterns!%s}",yytext,yytext);
"Prototype" printf("%s\\index{patterns!%s}",yytext,yytext);
"Memento" printf("%s\\index{patterns!%s}",yytext,yytext);
"Proxy" printf("%s\\index{patterns!%s}",yytext,yytext);
"Iterator" printf("%s\\index{patterns!%s}",yytext,yytext);
"Composite" printf("%s\\index{patterns!%s}",yytext,yytext);
"Mediator" printf("%s\\index{patterns!%s}",yytext,yytext);
"Adaptor" printf("%s\\index{patterns!%s}",yytext,yytext);
"Chain of Responsibility" printf("%s\\index{patterns!%s}",yytext,yytext);
"MVC" printf("%s\\index{patterns!%s}",yytext,yytext);
"MV(C)" printf("%s\\index{patterns!%s}",yytext,yytext);
"San Francisco" printf("%s\\index{frameworks!%s}",yytext,yytext);
"SanFrancisco" printf("%s\\index{frameworks!%s}",yytext,yytext);
"ET++" printf("%s\\index{frameworks!%s}",yytext,yytext);
"Interviews" printf("%s\\index{frameworks!%s}",yytext,yytext);
"Object Web" printf("%s\\index{ObjectWeb}",yytext);
"STL" printf("%s\\index{Standard Template Library}",yytext);

\\typeout.*\n ECHO;
\\{key}\{[^\}\n]*\} ECHO; 
\\{a} ECHO;
\\{a}"["{b} ECHO;
"["{x}"]" ECHO;
"[Node" ECHO;
"[BRANCH" ECHO;
"}["{b} ECHO;
"[Eli" ECHO;
"[de "{b}[^\]\|\n]*"]" { yytext[yyleng-1]='\0'; PR(0); }
"[De "{b}[^\]\|\n]*"]" { yytext[yyleng-1]='\0'; PR(0); }
"[van "{b}[^\]\|\n]*"]" { yytext[yyleng-1]='\0'; PR(0); }
"["{b}[^\]\|\n]*"]"    { yytext[yyleng-1]='\0'; PR(0); }
"[Butler Cox"[^\]\|\n]*"]" { yytext[yyleng-1]='\0'; PR(0); }
{a}  {
   s = strcpy(buf,yytext);
   s = s;
   if (0) ECHO; 
   P("UML");
   P("IDL");
   P("CORBA");
   P("DejaVU");
   P("Web");
   P("WWW");
   P("ObjectWeb");
   P("hush");
   P("analysis");
   P("design");
   P("pattern");
   P("allocation");
   P("contract");
   P("component");
   P("continuation");
   P("distributed");
   P("exception");
   P("assertion");
   P("failure");
   P("inference");
   P("logic");
   P("module");
   P("parallel");
   P("simplification");
   P("resumption");
   P("semantics");
   P("sequential");
   else ECHO;
   }
\\\@{a} { printf("%s",yytext+2); }
\n { ECHO; }
. { ECHO; }

%%
//@ main
int main() {
lex l; l();
return 0;
}

char *tol(char *s)
{
char *p = s;
while (*s != '\0') { 
	if (isupper(*s)) *s = tolower(*s);
	s++;
	}
return(p);
}

int mycmp(char *s1, char *s2)
{
while (*s1 != '\0' && *s2 != '\0' && *s1 == tolower(*s2) ) { s1++; s2++; }
if (*s1 == '\0') return(1);
else return(0);
}



char* idn()
{
int i,n;
static int idno=0;
extern char *lastid;
char *ps = idbuf;
char* ph = idbuf;
idno += 1;
/* printf("%d\n",idno); */
for ( i=0; i <= idno; i++) {
	if ( (i % 5) == 0 ) *ps++ = 'x';
	else *ps++ = 'o';
	}
*ps='\0';
lastid=ph;
return ph;
}


