%{
//@auto=0
//@class man-t
%}
%class lex
%p 3000
%a 3000
%o 4000
%{
#include <hush/grammar/lex.h>

int pr=1;

static char slide[512];
static int slino = 0;
static int  in_slide = 0;
static int noslide = 0;

int in_math = 0;
int in_html = 0;
int in_comm = 0;
char undo[10]; 
char listundo[10]; 
char endline[24];
int liston = 0;
int dollon = 0;
int inhead = 0;
int in_nf = 0;
int nf_com = 0;

//@ convenience functions

void navig();
void endlist();

void endslide() {
	endlist();
	if (in_slide) {
		if (pr) cout << "</slide>";
		in_slide = 0;
		}
	}

void doslide(const char* name) {
	endslide();
	if (!noslide && inhead) {
		char buf[1024];
		sprintf(buf,"%s-%s",slide,name);
		if (pr)  
		  cout << "<slide id=\"" << buf << slino++ << "\" cap=\"" <<
		  name << "\"><p>";
		in_slide = 1;
		}
	}

void endlist() { if (liston) {
			liston = 0; 
			if (pr) cout << listundo; 
			}
		if (0 && in_slide) {
			if (pr) cout << "</slide>";
			in_slide = 0;
			}
		}
//@ definitions
%}
prefix  (http|mailto|ftp|news)
includedirs (hush|widgets|dv|sim|hymne|web|adt|extern|system)
hushdirs (papers|projects|talks|ftp)

entry ([A-Z][A-Z]+[A-Z0-9\ ])

%%@ rules

^\.\""noslide="[01] {
	endslide();
	char c = yytext[yyleng-1];
	noslide = (int) ( c - '0');
	}
^\.\""slide="[01] {
	endslide();
	char c = yytext[yyleng-1];
	noslide = 1 - (int) (c - '0');
	}
^\.\""slide "[A-Za-z0-9]+ {
	inhead=1;
	doslide(yytext+8);
	}
^\.\"</> { if (pr) cout << "</slide>"; in_slide=0; }
"[.]" { if (in_html) {
	if (pr) cout << "<a href=\"index.html\">[.]</a>";
       } else if (pr) cout << yytext;
       }
"[Up]" { if (in_html) {
	if (pr) cout << "<a href=\"index.html\">[index]</a>";
       } else if (pr) cout << yytext;
       }

%%@ dealing with html

"<a href="[^>]+">" { if (pr) cout << yytext; }
^"<title>"|"<document"|"<h1>"|"<h2>" {
	pr = 1; cout << yytext; 
	}

%%@ seems to be tricky troff

^.\\\} { ;}
^\.\".* { if (pr) cout << yytext+2; } 
^\'.*\n  { ;}
^".de".* { pr=0; } 
^"..".* { pr = 1; }
^".in".* { ;}
^".br".* { if (pr) cout << endl; }

%%@ headings

^".TH ".* { pr = 1; 
    if (pr) cout << "<h3><i>Manual</i>: <tt>" << yytext+4 << "</tt></h3>" << endl;
    strcpy(slide,yytext+4);
    char*p = slide;
    while (*p && *p != ' ' && *p !='\n') p++;  
    *p = '\0';
    navig();
    yytext[0]='\0';
    }
^".HS ".* {
    pr = 1; 
    if (pr) cout << "<h3><i>Manual</i>: <tt>" << yytext+4 << "</tt></h3>" << endl;
    navig();
    yytext[0]='\0';
    }

%%@ special manual keys

^".SH NAME".* {
	endslide(); if (pr) cout << "\n\n<p><h4>NAME</h4>";
	}
^".SH KEYWORDS".* {
	endslide(); if (pr) cout << "\n\n<p><h4>KEYWORDS</h4>";
	}
^".SH SEE ALSO".* {
	endslide(); if (pr) cout << "\n\n<p><h4>SEE ALSO</h4>";
	}
^".SH KEYWORDS".* {
	endslide(); if (pr) cout << "\n\n<p><h4>KEYWORDS</h4>";
	}
^".SH AUTHOR" {
	endslide(); if (pr) cout << "\n\n<p><h4>AUTHOR</h4>";
	}
^".SH ".* {
	endslide(); if (pr) cout << "\n\n<p><h4>" << yytext+4 << "</h4>";
	inhead = 1;
	doslide(yytext+4);
	}

%%@ it works, don't ask me why

^".nf".*\n { in_nf = 1; endlist(); if (pr) cout << "<program>  "; }
^".fi".*\n { in_nf = 0; if (pr) cout << "</program>"; }
^".sp".* { if (pr) cout << "<p>"; }
^".AP" { if (pr) cout << "<p><b>"; strcpy(endline,"</b>"); }
^".AS" { if (pr) cout << "<b>"; strcpy(endline,"</b>"); }
^".I " { if (pr) cout << "<i>"; strcpy(endline,"</i>"); }
^".B " { if (pr) cout << "<b>"; strcpy(endline,"</b>"); }
\\"fB" { strcat(undo,"</b>"); if (pr) cout << "<b>"; }
\\"fI" { strcat(undo,"</i>"); if (pr) cout << "<i>"; }
\\"fR" { if (pr) cout << undo; strcpy(undo,""); }
\\"fP" { if (pr) cout << undo; strcpy(undo,""); }
^".ta".* { ;}
^".IP"  { if (!liston) {
	      liston = 1; if (pr) cout << "<ul>";
	      strcpy(listundo,"</ul>");
	      }
	  if (pr) cout << "<li>";
	  }
^".TP".*  { if (!liston) {
	      liston = 1; if (pr) cout << "<ul>";
	      strcpy(listundo,"</ul>");
	      }
	  if (pr) cout << "<li>";
	  }
"\\0"  { if (pr) cout << " "; }
"\\-"  { if (pr) cout << "-"; }
".LP"  { endlist(); if (pr) cout << "<p>"; }
".PP"  { endlist(); if (pr) cout << "<p>"; }
".DS"  { endlist(); if (pr) cout << "<pre>"; }
".DE"  { if (pr) cout << "</pre>"; }
".BS"  { endlist(); if (pr) cout << "<hr>"; }
".BE"  { if (pr) cout << "<hr>"; }
".VS"  { if (pr) cout << "  "; }
".VE"  { if (pr) cout << "  "; }


%%@ comments and brackets again

\/\/   { if (in_nf && !nf_com) { nf_com = 1; if (pr) cout << yytext << "<i>"; strcpy(endline,"</i>"); }
	 else if (pr) cout << yytext; }
\/\/\/   { if (in_nf) { nf_com = 1; if (pr) cout << yytext << "<i>"; strcpy(endline,"</i>"); }
	 else if (pr) cout << yytext; }
"<" { if (in_nf && !nf_com) { if (pr) cout << "&lt;"; } 
      else if (pr) cout << yytext;  }
">" { if (in_nf && !nf_com) { if (pr) cout << "&gt;"; }
      else if (pr) cout << yytext;  }


%%@ the usual defaults

\t { if (pr) cout << "        "; }
\n {
    if (pr) cout << endline << endl; 
    strcpy(endline,""); 
    inhead = 0;
    nf_com = 0;
    }
. { if (pr) cout << yytext[0]; }

%%@ and some more tricky stuff

\$[a-zA-Z0-9\-]+\$ {
	yytext[yyleng-1] = '\0';
	if (pr) cout << "<i>" << yytext+1 << "</i>";
	}
"<"[a-z0-9A-Z\/]+">.h" { 
	char buf[512];
	strcpy(buf,yytext);
	buf[yyleng-3] = '\0';
	if (pr) cout << "&lt;" << buf+1 << "&gt;.h";
	}
"-l<"[a-z0-9A-Z\/]+">" { 
	char buf[512];
	yytext[yyleng-1] = '\0';
	strcpy(buf,yytext+3);
	if (pr) cout << "-l&lt;" << buf << "&gt;";
	}
[A-Za-z0-9\-]+"("[1-9ln]")" {
	char n = yytext[yyleng-2];
	char buf[64];
	strcpy(buf,yytext);
	buf[yyleng-3]='\0';
	if (pr) cout <<
		"<a href=\"../man" << n << "/" << buf << ".html" << "\">"
		<< yytext << "</a>";
	}

%%
//@ main
int main() {
strcpy(endline,"");
pr = 0;
cout << "<document>";
lex l; l();
cout << "</document>" << endl;
return 0;
}

void navig() {
cout << "<" << "include file=navigate>";
}
//</>
