%{
//@auto=0
//@class vr_ml
%}
%class lex
%{
char* ext = ".vr";
static int pr = 0;
static int old = 0;

char* get_from();

char yytext[10*1024];
char slideargs[1024];
static int slideargslength = 0;

static int in_frac = 0;
static int in_brac = 0;
static int in_math = 0;
static int in_url = 0;
static int in_field = 0;

static int in_xsl = 0;

static int set_includes = 0;
static int slide_includes = 0;

static int in_right = 0;
static float un_break = 0;

static int font_no = 0;

static int in_effect = 0;
static int in_template = 0;

static int items[9];
static int list_type[9];

static char filename[64];
static int empty_line = 0;
static int no_style = 0;
static int es_mode = 0;
static int bk_mode = 0;
static int x_mode = 0;
static int pvl_mode = 0;

static int do_pop = 0;

static int in_collection = 0;

static int in_object = 0;
static int in_slide = 0;
static int in_channel = 0;
static int in_slice = 0;
static int slice_level = 0;
static int slideno = 0;

static int centered = 0;
static int in_list = 0;

static int in_font = 0;
static int in_link = 0;
static int in_header = 0;
static int in_line = 0;
static int in_li = 0;
static int no_li = 0;
static int in_p = 0;
static int in_q = 0;

static int old_p = 0;

static int is_aligned = 0;

static int in_display = 0;



#include <hush/grammar/input.h>
#include <hush/grammar/string.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>
#include <hush/iostream.h>

#include <hush/dictionary.h>
#include <hush/stack.h>

static int no_auto = 0;

char* placeof(char* x) {
static char buf[1024];
	strcpy(buf,x);
	char* p = buf;
	while (*p != '\0' && *p != '#') {
		if (*p == '-') *p = '/';
	p++;
	}
	*p = '\0';
	return (char*) buf;
}

static int has_scene = 0;
static string scene = "@dlp.wrl";

static int has_shape = 0;
static string shape = "0";

static int has_size = 0;
static string size = "17.0 9.0";

static int has_asize = 0;
static string asize = "17.0 9.0";

static int has_choice =0;
static string choice;

static int has_annot = 0;
static string annot;

static int has_effect_type = 0;
static string effect_type;

static int has_template_type = 0;
static string template_type;

static int has_object_type = 0;
static string object_type;

static int has_bullet = 0; static string bullet;

static int has_channel = 0; static string channel;

static int has_novref = 0; 
static int has_ref = 0; static string ref;
static int has_href = 0; static string href;
static int has_param = 0; static string param;
static int has_bgcolor = 0; static string bgcolor;

static int has_level = 0; static string level;
static int has_start = 0; static string start;
static int has_end = 0; static string end;
static int has_slice = 0; static string slice;

static int has_from = 0; static string from;
static int has_to = 0; static string to;

static int has_width = 0; static string width = "30";
static int has_height = 0; static string height = "15";

static int hold_level = -1;
static int the_level = 0;

static string start_level = "-1";
static string end_level = "-1";

static string tag = "nil";

//static string align = "BEGIN";

static float levelsize[] = { 1, 3, 2.5 , 2.0, 1.5, 1, 1 , 1, 1,1,1 };
static dictionary<string> colors; 
static string linkcolor= "1 1 0";

static int row = 0;
static int col = 0;

static string cellwidth[12] = { 
			"5", "5", "5", "5",
			"5", "5", "5", "5",
			"5", "5", "5", "5" };
static string cellheight[12] = { 
			"1", "1", "1", "1",
			"1", "1", "1", "1",
			"1", "1", "1", "1" };
static string cellx[12] = { 
			"0", "5", "10", "15",
			"15", "15", "15", "15",
			"15", "15", "15", "15" };
static string celly[12] = { 
			"0", "0", "0", "0",
			"0", "0", "0", "0",
			"0", "0", "0", "0" };
static string cellz[12] = { 
			"0", "0", "0", "0",
			"0", "0", "0", "0",
			"0", "0", "0", "0" };
static string cellr[12] = { 
			"0", "0", "0", "0",
			"0", "0", "0", "0",
			"0", "0", "0", "0" };

static int has_url = 0; static string the_url;
static string the_link;

static string display_size = "1";

static stack<int>* st_inlink= 0;
static stack<string>* st_link = 0;

static stack<string>* st_style = 0;
static stack<string>* st_family = 0;
static stack<string>* st_color = 0;
static stack<string>* st_size = 0;
static stack<string>* st_justify = 0;

static string df_size = "1";
static string df_color= "1 1 1";
static string df_justify = "BEGIN";
static string df_family = "SERIF";
static string df_style = "PLAIN";
static string dl_bgcolor = "0.7 0.7 1";
static string dl_bgtrans = "1";

static string f_size = "1";
static string f_color= "1 1 1";
static string f_justify = "BEGIN";
static string f_family = "SERIF";
static string f_style = "PLAIN";
static string l_bgcolor = "0.7 0.7 1";
static string l_bgtrans = "1";

static string old_size = "1 1 1";
static string old_color = "1 1 1";
static string old_justify = "BEGIN";
static string old_family = "SERIF";
static string old_style = "PLAIN";
static string old_bgcolor = "0.7 0.7 1";
static string old_bgtrans = "1";

static string id;
static string slide_id;
static string set_id;
static string channel_id;
static string object_id;


static int instring(char c, char* s) {
	while ( *s && *s++ != c );
	return (int) *s;
	}

//@ loading

static dictionary<string>* _loaded = 0;

void set_loaded(char* s) {
	char buf[1024];
	sprintf(buf,"@vr/extern/proto/%s.wrl",placeof(s));
	char* x = buf;
	string* p = (*_loaded)[(char*)x];
	if (!p) {
	(*_loaded)[x]= new string((char*)x);
	cerr << "EXTERNPROTO " << x << "#" << s << endl;
	} else {
	}
	//cerr << "EXTERNPROTO " << x << "#" << s << endl;
	}

void load(char* x, lex* l) {
	string* p = (*_loaded)[(char*)x];
	if (!p) {
	cerr << "LOAD: " << x << endl; 
	(*_loaded)[x]= new string((char*)x);
	if (pr) l->files((char*) x,"");
	} else {
	cerr << "warning: " << x << " already loaded" << endl; 
	}
	}

//@ aliases (at)

static dictionary<string>* x_alias = 0;

static void set_alias(const char* k, const char* v) {
	if (!x_alias) x_alias = new dictionary<string>(1);
	(*x_alias)[k] = new string(v);
	//cerr << "Alias: " << k << " = " << v << endl;
	}

static char* get_alias(const char* k) {
	if (!x_alias || !k) return 0;
	string* p = (*x_alias)[k];
	if (!p) return 0;
	char* v = (char*) *p;
	// cerr << "Found: " << k << " => " << v << endl;
	return  v;
	}
char* get_at(const char* k);

char* resolve_at(const char* k, char* b) {
	//cerr << "Resolving " << k << endl;
	char *p = get_alias(k);
	if (!p) return (char*) k;
	strcpy(b,get_at(p));
	return b;
	}

int break_at(char c) {
if (c == '/' || c == '-' || c == '.') return 1;
else return 0;
}

char* get_at(const char* x) {
//cerr << "CHECKING--" << x << "--" << endl;
static char result[1024];
if (0 && !in_xsl) return (char*) x;
else {
result[0] = '\0';
	if (!x) return 0;
	if (x[0]=='@') {
		char buf[1024];
		char* p = (char*) x;
		char* q = (char*) buf;
		int b = 0; char c;
		while (*p != '\0' && !b ) {
			if (break_at(*p)) { c = *p; b = 1; }
			else *q++ = *p++;
			}
		*q = '\0';
		char temp[1024];
		char next[1024];
		char* s = p;
		if (*p != '\0') {
		   s = get_at(p+1);
		   strcpy(next,s);
		   s = (char*) next;
		   }
		//cerr << ">--" << buf << "--" << p << endl;
		char* r = resolve_at((char*)buf,temp);
		if (*p != '\0')
			sprintf(result,"%s%c%s",r,c,s);
		else
			sprintf(result,"%s",r);
		return (char*) result;
		}
	else {
		char temp[1024];
		return resolve_at(x,temp);
		}
	//return (char*) x;
	}
	}

//char* get(const char* x) { return get_at(x); }

void set_at(const char* k, char* v) {
char buf[1024];
sprintf(buf,"@%s",k);
set_alias((char*)buf,v);
}




//@ slideref

static char _symbols[] = " <>#-,.;?@`={}$:\t\n/\\\"'{}^!%&[]()~<>*";

static int symbol(char c) { return instring(c,_symbols); }

static const char* slideref(const char* x, int hascl = 0, char* clid="" ) {
static char buf[4024];
if (!hascl) strcpy(buf,x);
else sprintf(buf,"%s-%s",clid,x);
char* b = buf; //while (*b && symbol(*b)) b++;
char* p = b;
int i = 0;
while (*p && i <= 18 ) {
	int yes=0;
	if (symbol(*p) || *p == ' ') {
		yes = 1;
		*b = '-';
		}
	else *b = *p;
	b++; p++;
	if (yes) while (symbol(*p) || *p == ' ') p++;
	i++;
	}
*b='\0';
if (*(b-1) == '-') *(b-1) = '\0';
buf[18]='\0';
return (char*) buf;
}

void begin_channel(char* type, int pos, char* yytext, int yyleng);
void end_channel(char* type = "{}");

void begin_object(char* type, int pos, char* yytext, int yyleng, lex* l);
void end_object(char* type, lex* l);


//@ check channel

static int auto_channel = 0;

void check_channel() {
if (in_slide == 1 && in_channel == 0) { 
	auto_channel = 1;
	char buf[256];
	sprintf(buf,"%s-channel",(char*) slide_id);
	channel_id = (char*) buf;
	begin_channel("text",6,slideargs,slideargslength);
	}
}


//@ levels

static int level_display = 0;
static int auto_level = 0;
static int list_level[8];

void font_push();
void font_pop();


struct context : public string {
int n;
int in_p;
int in_slide;
int in_channel;
int in_list;
int in_object;
int row;
int col;
string slide_id;
string set_id;
string channel_id;
string object_id;
string id;
string start;
string end;
string bullet;
string effect_type;
string template_type;
string object_type;
string width;
string height;
int has_effect_type;
int has_template_type;
int has_object_type;
int extra_channel;
string tag;
context() {
	n = 0;
        extra_channel = 0;
	}

//context(context& x) { n = x.n; }
context(context* x) { 
	n = x?x->n:0;
	if (0 && in_object > 0) {
		//start = "-1";
		//end = "-1";
		}
	}

~context() {}

void push(int x = 0) {
   in_p = ::in_p;
   in_slide = ::in_slide;
   in_channel = ::in_channel;
   in_list = ::in_list;
   in_object = ::in_object;
   id = (char*) ::id;
   width = (char*) ::width;
   height = (char*) ::height;
   slide_id = (char*) ::slide_id;
   set_id = (char*) ::set_id;
   channel_id = (char*) ::channel_id;
   object_id = (char*) ::object_id;
   bullet = (char*) ::bullet;
   effect_type = (char*) ::effect_type;
   template_type = (char*) ::template_type;
   object_type = (char*) ::object_type;
   has_effect_type = ::has_effect_type;
   has_template_type = ::has_template_type;
   has_object_type = ::has_object_type;
   tag = (char*) ::tag;
   row = ::row;
   col = ::col;
   if (0 && in_object > 0) { 
	start = (char*) start_level;
	end = (char*) end_level;
   }
   font_push();
   }

void channel() {
   extra_channel = 1;
   if (extra_channel) begin_channel("text",-1,"",0);
   }

void pop() {
   if (!this) {
   cout << "##ERROR: context::pop " << (char*) ::slide_id << endl; 
   } else if (this) {
   if (0 && in_object > 0) {
   	start_level = (char*) start;
   	end_level = (char*) end;
	}
   ::in_p = in_p;
   ::in_slide = in_slide;
   //::in_channel = in_channel;
   ::in_list = in_list;
   ::in_object = in_object;
   ::width = (char*) width;
   ::height = (char*) height;
   ::id = (char*) id;
   ::slide_id = (char*) slide_id;
   ::set_id = (char*) set_id;
   ::channel_id = (char*) channel_id;
   ::object_id = (char*) object_id;
   ::bullet = (char*) bullet;
   ::effect_type = (char*) effect_type;
   ::template_type = (char*) template_type;
   ::has_effect_type = has_effect_type;
   ::has_template_type = has_template_type;
   ::tag = (char*) tag;
   ::row = row;
   ::col = col;
   font_pop();
   if (extra_channel) { extra_channel= 0; end_channel("ctx->pop()"); }
   }
   }


//context& operator=(context& x) { n = x.n; }
//context& operator=(context* x) { n = x->n; }
//int operator==(const context&) { return 1; }
};

//int operator<<(const context*, const context*) {
	//return 0;
	//}
//ostream& operator<<(ostream& o, const context& x) {
	//o << "## context " << endl;
	//return o;
	//}

static stack<context>* st_context;
static context* context0;
static context* ctx;


static string the_id = "this";
static string prev_id = "this";
static dictionary<string> prev_class;
static dictionary<string> the_class;
static dictionary<string> trails;

static string w_prefix = "@talk-";
static string s_prefix = "@slide-";
static string f_prefix = "#slide-";
static string n_prefix = "@slide-";
static string d_prefix = "@slide-";

void reset_level() {
start_level = "-1";
end_level = "-1";
auto_level = 0;
list_level[0] = auto_level;
slice_level = 0;
in_slice = 0;
}

void set_start(const char* x) {
char buf[64];
char* s = (char*) start_level;
int n; sscanf(s,"%d",&n);
if (!strcmp(x,"++")) {
	n++; sprintf(buf,"%d",n);
	start_level = (char*) buf;
	}
else if (!strcmp(x,"--")) {
	n--; sprintf(buf,"%d",n);
	start_level = (char*) buf;
	}
else if (x[0] == '+') {
	char buf1[64];
	char* st = (char*) start_level;
	int m; sscanf(st,"%d",&m);
	char buf2[64];
	char* sk = (char*) x+1;
	int k; sscanf(sk,"%d",&k);
	int lx = m + k;
	sprintf(buf,"%d",lx);
	start_level = (char*) buf;
	}
else start_level = x;
cerr << "level " << (char*) start_level << "  " << (char*) end_level <<  " (" << in_object << ")" << endl; 
}

void set_end(const char* x) {
char buf[64];
char* s = (char*) end_level;
int n; sscanf(s,"%d",&n);
if (!strcmp(x,"++")) {
	n++; sprintf(buf,"%d",n);
	end_level = (char*) buf;
	}
else if (!strcmp(x,"--")) {
	n--; sprintf(buf,"%d",n);
	end_level = (char*) buf;
	}
else if (!strcmp(x,"start")) {
	char buf1[64];
	char* st = (char*) start_level;
	int m; sscanf(st,"%d",&m);
	sprintf(buf,"%d",m);
	end_level = (char*) buf;
	}
else if (x[0] == '+') {
	char buf1[64];
	char* st = (char*) start_level;
	int m; sscanf(st,"%d",&m);
	char buf2[64];
	char* sk = (char*) x+1;
	int k; sscanf(sk,"%d",&k);
	int lx = m + k;
	sprintf(buf,"%d",lx);
	end_level = (char*) buf;
	}
else end_level = x;
}

void set_from(const char* x) {
char buf[64];
char* s = (char*) start_level;
int n; sscanf(s,"%d",&n);
if (!strcmp(x,"++")) {
	n++; sprintf(buf,"%d",n);
	from = (char*) buf;
	}
else if (!strcmp(x,"--")) {
	n--; sprintf(buf,"%d",n);
	from = (char*) buf;
	}
else if (!strcmp(x,"start")) {
	char buf1[64];
	char* st = (char*) start_level;
	int m; sscanf(st,"%d",&m);
	sprintf(buf,"%d",m);
	to = (char*) buf;
	}
else if (x[0] == '+') {
	char buf1[64];
	char* st = (char*) start_level;
	int m; sscanf(st,"%d",&m);
	char buf2[64];
	char* sk = (char*) x+1;
	int k; sscanf(sk,"%d",&k);
	int lx = m + k;
	sprintf(buf,"%d",lx);
	from = (char*) buf;
	}
else from = x;
}

void set_to(const char* x) {
char buf[64];
char* s = (char*) end_level;
int n; sscanf(s,"%d",&n);
if (!strcmp(x,"++")) {
	n++; sprintf(buf,"%d",n);
	to = (char*) buf;
	}
else if (!strcmp(x,"--")) {
	n--; sprintf(buf,"%d",n);
	to = (char*) buf;
	}
else if (!strcmp(x,"start")) {
	char buf1[64];
	char* st = (char*) start_level;
	int m; sscanf(st,"%d",&m);
	sprintf(buf,"%d",m);
	to = (char*) buf;
	}
else if (x[0] == '+') {
	char buf1[64];
	char* st = (char*) get_from();
	int m; sscanf(st,"%d",&m);
	char buf2[64];
	char* sk = (char*) x+1;
	int k; sscanf(sk,"%d",&k);
	int lx = m + k;
	sprintf(buf,"%d",lx);
	to = (char*) buf;
	}
else to = x;
}

void set_level(const char* x = 0) {
//cerr << "## set_level " << x << " " << auto_level << endl;
if (x && !strcmp(x,"auto")) {
	auto_level = 1;
	}
else if (x && !strcmp(x,"on")) {
	auto_level = 1;
	}
else if (x && !strcmp(x,"off")) {
	auto_level = 0;
	}
else if (x ) { // && x[0] == '+') {
	set_start(x);
	}
else if (!x) {
	if (auto_level) set_start("++");
	}
if (x) { list_level[in_list] = auto_level; }
}

void display_level(const char* x = 0) {
//cerr << "## set_level " << x << " " << auto_level << endl;
if (x && !strcmp(x,"auto")) {
	level_display = 1;
	}
else if (x && !strcmp(x,"on")) {
	level_display = 1;
	}
else if (x && !strcmp(x,"off")) {
	level_display = 0;
	}
}

char* kleur(const char* x) {
string* p = colors[x];
if (p) return (char*) *p;
else
if (!strcmp("match",x)) {
	if (bgcolor == "blue") return kleur("gold");
	else return "0.2 0.2 1";
	}
else if (!strcmp("bg",x)) return (char*) bgcolor;
else if (!strcmp("text",x)) return (char*) f_color;
else if (!strcmp("red",x)) return "1 0 0";
else if (!strcmp("yellow",x)) return "1 1 0";
else if (!strcmp("orange",x)) return "1 0.7 0";
else if (!strcmp("blue",x)) return "0 0 1";
else if (!strcmp("green",x)) return "0 1 1";
else if (!strcmp("lightblue",x)) return "0 1 1";
else if (!strcmp("white",x)) return "1 1 1";
else if (!strcmp("black",x)) return "0 0 0";
else if (!strcmp("gold",x)) return "1 1 0";
else if (!strcmp("silver",x)) return "0.9 0.9 0.9";
else if (!strcmp("grey",x)) return "0.4 0.4 0.4";
else if (!strcmp("gray",x)) return "0.2 0.2 0.2";
else if (!strcmp("brown",x)) return "0.5 0.3 0.3";
//else return "1 1 1";
else return (char*) x;
}

char* bgchoice(const char* x) {
string bg = x;
if (bg == "none") return  "-1";
else if (bg == "off") return  "-1";
else if (bg == "nil") return  "-1";
else if (bg == "spheres") return  "0";
else if (bg == "snow") return  "1";
return (char*) x;
}

void font_push() {
        if (!st_context) st_context = new stack<context>;
	if (st_context) {
	if (!st_inlink) st_inlink = new stack<int>;
	if (!st_link) st_link = new stack<string>;
	if (!st_style) st_style = new stack<string>;
	if (!st_family) st_family = new stack<string>;
	if (!st_color) st_color = new stack<string>;
	if (!st_size) st_size = new stack<string>;
	if (!st_justify) st_justify = new stack<string>;
	context* xx = new context(ctx);
	if (xx) {
	st_context->push(xx);
	st_inlink->push(new int(in_link));
	st_link->push(new string((char*)the_url));
	st_style->push( new string((char*)f_style));
	st_family->push( new string((char*)f_family));
	st_color->push( new string((char*)f_color));
	st_size->push( new string((char*)f_size));
	st_justify->push( new string((char*)f_justify));
	font_no = 0;
	}
	}
	}

#define out if (pr) cout

void font_pop() {
//if (!st_context) st_context = new stack<context>;
string* p; char buf[64]; int* pn; int n;
if (!st_inlink) st_inlink = new stack<int>;
if (!st_link) st_link = new stack<string>;
if (!st_style) st_style = new stack<string>;
if (!st_family) st_family = new stack<string>;
if (!st_color) st_color = new stack<string>;
if (!st_size) st_size = new stack<string>;
if (!st_justify) st_justify = new stack<string>;

if (st_context) {
context* pc = st_context->pop(); if (!pc) out << "##error context (pop)" << font_no  << endl;
else ctx = pc;
if (!pc) ctx = context0;
else delete pc;
pn = st_inlink->pop(); if (!pn) out << "##error inlink (pop)" << font_no  << endl;
if (pn) in_link = *pn; else in_link = 0;
p = st_link->pop(); if (!p) out << "##error link (pop)" << font_no  << endl;
if (p) the_url = (char*) *p; else the_url = (char*) ""; 
p = st_style->pop(); if (!p) out << "##error font style (pop)" << font_no << endl;
if (p) f_style = (char*) *p; else f_style = (char*) df_style; 
p = st_family->pop(); if (!p) out << "##error font family (pop)" << font_no << endl;
if (p) f_family = (char*) *p; else f_family = (char*) df_family;
p = st_color->pop(); if (!p) out << "##error font color (pop)" << font_no << endl;
if (p) f_color = (char*) *p; else f_color = (char*) df_color;
p = st_size->pop(); if (!p) out << "##error font size (pop)" << font_no << endl;
if (p) f_size = (char*) *p; // else f_size = (char*) df_size;
p = st_justify->pop(); if (!p) out << "##error font size (pop)" << font_no << endl;
if (p) f_justify = (char*) *p; else f_justify = (char*) df_justify;
}
}


void reset(){
f_size = "1";
f_color= "1 1 1";
f_justify = "BEGIN";
f_family = "SERIF";
f_style = "PLAIN";
l_bgcolor = "0.7 0.7 1";
l_bgtrans = "1";
in_slide = 0;
in_channel = 0;
in_list = 0;
size = "17.0 9.0";
}

void deprecated(char* s) {
	//cerr << "## DEPRECATED " << s << endl; 
	out << "## DEPRECATED " << s << endl; 
	}

char* f_str(float x) {
static char buf[128];
sprintf(buf,"%s",x);
return (char*) buf;
}

float str_f(const char* x) {
float f;
sscanf("%f",x,&f);
return f;
}

char* xsize(float x) {
static char buf[20*512];
float f;
char fbuf[64];
sprintf(fbuf,"%s", (char*) f_size);
sscanf(fbuf,"%f",&f);
sprintf(buf,"%f",f * x);
return (char*) buf;
}

void prline(const char* x = 0) {
//if (x) out << "## line " << x << endl;
}

void prbegin(const char* x = 0) {
//if (x) out << "## begin " << x << endl;
}

void prend(const char* x = 0) {
if (x) out << "## end " << x << endl;
}

static int level_change = 1;

char* lp(int x = 0) {
static char buf[20*512];
static char buf1[20*512];
static char buf2[20*512];
char* p = &buf2[0];
if (0 && level_change) {
cerr << "level: " << (char*) start_level << "-" << (char*) end_level << endl;
}
if (in_object > 0) { 
string start = (char*) start_level;
string end = (char*) end_level;
sprintf(buf," justify [\"%s\"] startLevel %s endLevel %s ", (char*) f_justify, (char*) start_level, (char*) end_level);
start_level = (char*) start;
end_level = (char*) end;
} else { 
sprintf(buf," justify [\"%s\"] startLevel %s endLevel %s ", (char*) f_justify, (char*) start_level, (char*) end_level);
}
if (!x) { 
if (old) {
sprintf(buf1," %s family [\"%s\"] style \"%s\" color %s size %s string \"", 
	(char*) buf,
	(char*) f_family,
	(char*) f_style,
	(char*) f_color,
	(char*) f_size);
} else {
sprintf(buf1," %s family [\"%s\"] style \"%s\" color %s height %s string \"", 
	(char*) buf,
	(char*) f_family,
	(char*) f_style,
	(char*) f_color,
	(char*) f_size);
}
} else sprintf(buf1,"%s",buf);
if (in_link && (x != 2)) {
  if (has_param)
  sprintf(buf2," href \"%s\" parameters %s %s",(char*) the_link, (char*)param, (char*) buf1);
  else
  sprintf(buf2," href \"%s\" %s",(char*) the_link, (char*) buf1);
} else if (has_ref) { 
  if (has_param)
  sprintf(buf2," href \"%s.wrl\" parameters %s %s",(char*) ref, (char*) param,  (char*) buf1);
  else
  sprintf(buf2," href \"%s.wrl\" %s",(char*) ref,  (char*) buf1);
} else if (has_href) { 
  if (has_param)
  sprintf(buf2," href \"%s\" parameters %s %s",(char*) href, (char*) param, (char*) buf1);
  else
  sprintf(buf2," href \"%s\" %s",(char*) href, (char*) buf1);
} else sprintf(buf2,"%s",buf1);
in_line = 1;
if (x != 0) in_line = 0;
return (char*) p;
}


void check(char* x);

inline void dobreak(float x = 0, float y = 0, char* s = "", int br = 0) {
if (!s) s = " --- s ----";
//check("dobreak");
if (old) out << "break { br " << (br?"FALSE":"TRUE") << " size " << y << " length " << x << lp(2) << " } ## " << s << endl;
if (!old) out << "\nBreak { width " << x << " height " << y << lp(2) << " } ";
if (!in_object) out << endl;
}

//inline void vspace(string f, char* x = "") { dobreak(0,atof((char*)f),x); }
inline void vspace(float f, char* x = "") { dobreak(0,f,x); }
inline void hspace(float f, char* x = "") { dobreak(f,0,x,1); }

inline void check(char* x = 0) {
//if (in_slide > 0 && in_channel > 0) {
if (1 || in_channel > 0) { // AE
        empty_line = 0;
        if (in_line) { 
		out << "\" }";
		if (!in_object) out << "## check *** " << (char*) (x?x:"") << " " << yytext << endl; 
		}
	else {
		}
	in_line = 0;
	if (old) in_li = 0;
	if (un_break != 0) {
		vspace(un_break,x);
		un_break = 0;
		in_line = 0;
		}
	}
in_line = 0;
}

void un_p() {
	check("un_p");
	in_p = 0;
	}


char* uq(char* x) {
static char buf[20*512];
buf[0]='\0';
char* p = x;
char* q = (char*) buf;
while ( *p != '\0' ) {
	if (*p == '"') *q++ = '\\';
	*q++ = *p++;
	}
*q = '\0';
return (char*) buf;
}

static int has_cw = 0; static string cw = "5";
static int has_ch = 0; static string ch = "1";


static int has_comment = 0; static string str_comment = "green";
static int has_key = 0; static string str_key = "black";
static int has_rel = 0; static string str_rel = "FALSE";
static int has_abs = 0; static string str_abs = "TRUE";
static int has_pos = 0; static string position;
static int has_name = 0; static string name = "anonymous";
static int has_scale = 0; static string scale;
static int has_trans = 0; static string trans;
static int has_loc = 0; static string loc;
static int has_rot = 0; static string rot;
static int has_align = 0; static string align = "BEGIN";
static int has_id = 0; // static string id;
static int has_use = 0; static string use;
static int has_class = 0; static string nclass;
static int has_next = 0; static string next;
static int has_prev = 0; static string prev;
static int has_view = 0; static string view;
static int has_src = 0; static string src;
static int got_drop = 0;
static int has_drop = 0; static string drop;
static int has_toc = 0; static string toc;
static int has_style = 0; static string style;
static int has_show = 0; static string show = "off";
static int has_bg = 0; static string bg = "none";
static int has_bgtrans = 0; static string bgtrans;
static int has_img = 0; static string img;
static int has_mov = 0; static string mov;
static int has_vid = 0; static string vid;
static int has_type = 0; static string ntype;
static int has_line = 0; static string line;

static int has_w = 0; static string str_w;
static int has_h = 0; static string str_h;
static int has_x = 0; static string str_x;
static int has_y = 0; static string str_y;
static int has_z = 0; static string str_z;
static int has_r = 0; static string str_r;
static int has_s = 0; static string str_s;
static int has_a = 0; static string str_a;

static int has_br = 0; static string br;

static int has_trail = 0; static string trail;
static int has_this = 0; static string nthis;
static int has_root = 0; static string droot;
static int has_up = 0; static string up;

static int has_text = 0; static string text;

void reset_has() {
has_shape = has_scene = has_text = has_annot =
has_pos = has_abs =
has_url =
has_comment =
has_trail = has_this = has_root = has_up =
has_line = has_type =
has_w = has_h = has_x = has_y = has_z = has_r = has_s =
has_size = has_asize = has_width = has_height =
has_scale = has_loc = 
has_width = has_height =
has_a = 
has_trans =
has_align = 
has_rot =
has_loc =
has_ref = has_href = has_param =
has_novref =
has_bullet =
has_name =
has_id = has_use =
has_class =
has_prev =
has_next =
has_view =
has_src = has_drop =
has_bgcolor =
has_choice =
has_style =
has_bg = has_show =
has_bgtrans =
has_img = has_mov = has_vid =
has_br =
has_level = has_start = has_end = has_slice =
has_from = has_to =
0;
}

static int is_closed = 0;

void check_context(char* type, int pos, char* yytext, int yyleng) {
   is_closed = 0;
   yytext[yyleng-1] = '\0';
   if (yytext[yyleng-2] == '/') {
	yytext[yyleng-2] = '\0';
	is_closed = 1;
	}
   reset_has();
   tag = (char*) type;
   string_converter x(yytext+pos);
   for (int i = 1; i <= x.argc(); i++ ) {
       cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
       // set_at(p.key(),p.value());
	   if ( p.matches("url") ) {has_url=1; the_url = p.value(); }
           else if ( p.matches("level") ) {
		if (0 || !in_effect) set_level( p.value());
		else { has_level=1; level = p.value(); }
		}
           else if ( p.matches("start") ) {
		if (0 || !in_effect) set_start( p.value());
		else { has_start=1; start= p.value(); }
		}
           else if ( p.matches("end") ) {
		if (0 || !in_effect) set_end( p.value());
		else { has_end=1; end = p.value(); }
		}
           else if ( p.matches("slice") ) {
		has_slice=1; slice = p.value();
		start_level = p.value(); end_level = p.value(); 
		}
           else if ( p.matches("align") || p.matches("valign") ) { 
		 char* s =  (char*) p.value();
		 if (!strcmp(s,"right")) f_justify = "END"; /*AE*/
		 else if (!strcmp(s,"center")) f_justify = "MIDDLE"; /*AE*/
		 else if (!strcmp(s,"left")) f_justify = "BEGIN"; /*AE*/
		 }
           else if ( p.matches("autoload") ) { no_auto = 1; }
           else if ( p.matches("justify") ) { f_justify = p.value(); }
           else if ( p.matches("family") ) { f_family = p.value(); }
           else if ( p.matches("textcolor") ) { f_color = kleur(p.value()); }
           else if ( p.matches("textsize") ) { f_size = p.value(); }
           else if ( p.matches("fontcolor") ) { f_color = kleur(p.value()); }
           else if ( p.matches("fontsize") ) { f_size = p.value(); }
           else if ( p.matches("text") ) { has_text = 1; text = get_at(p.value()); f_color = kleur(text); }
           else if ( p.matches("name") ) { has_name=1; name = p.value(); }
           else if ( p.matches("scene") ) { has_scene=1; scene = p.value(); }
           else if ( p.matches("shape") ) { has_shape=1; shape = p.value(); }
           else if ( p.matches("comment") ) { has_comment=1; str_comment = p.value(); }
           else if ( p.matches("size") ) { has_size=1; f_size = p.value(); size = p.value(); }
           else if ( p.matches("asize") ) { has_asize=1;  asize = p.value(); }
           else if ( p.matches("width") ) { has_width = 1; width = p.value(); }
           else if ( p.matches("height") ) { has_height = 1; height = p.value(); }
           else if ( p.matches("scale") ) { has_scale = 1; scale = p.value(); }
           else if ( p.matches("trans") ) { has_trans = 1; trans = p.value(); }
           else if ( p.matches("loc") ) { has_loc = 1; loc = p.value(); }
           else if ( p.matches("location") ) { has_loc = 1; loc = p.value(); }
           else if ( p.matches("rot") ) { has_rot = 1; rot = p.value(); }
           else if ( p.matches("rotation") ) { has_rot = 1; rot = p.value(); }
           else if ( p.matches("align") ) { has_align = 1; align = p.value(); }
           else if ( p.matches("ref") ) { has_ref = 1; ref = get_at(p.value()); }
           else if ( p.matches("novref") ) { has_novref = 1; }
           else if ( p.matches("href") ) { has_href = 1; href = p.value(); }
           else if ( p.matches("param") ) { has_param = 1; param = p.value(); }
           else if ( p.matches("id") ) { has_id = 1; id = get_at(p.value()); }
           else if ( p.matches("use") ) { has_use = 1; use = get_at(p.value()); }
           else if ( p.matches("class") ) { has_class = 1; nclass = p.value(); }
           else if ( p.matches("next") ) { has_next = 1; next = p.value(); }
           else if ( p.matches("prev") ) { has_prev = 1; prev = p.value(); }
           else if ( p.matches("src") ) { has_src = 1; src = get_at(p.value()); }
           else if ( p.matches("drop") ) { has_drop = 1; drop = get_at(p.value()); }
           else if ( p.matches("toc") ) { has_toc = 1; toc = p.value(); }
           else if ( p.matches("bgcolor") ) { has_bgcolor = 1; bgcolor = p.value(); }
           else if ( p.matches("bgtrans") ) { has_bgtrans = 1; bgtrans = p.value(); }
           else if ( p.matches("a") ) { has_a = 1; has_bgtrans = 1; bgtrans = get_at(p.value()); str_a = get_at(p.value()); }
           else if ( p.matches("color") ) { has_style = 1; style = p.value(); }
           else if ( p.matches("style") ) { has_style = 1; style = p.value(); }
           else if ( p.matches("bullet") ) { has_bullet = 1; bullet = kleur(p.value()); }
           else if ( p.matches("channel") ) { has_channel = 1; channel = p.value(); }
           else if ( p.matches("bg") ) { has_bg = 1; bg = p.value(); }
           else if ( p.matches("choice") ) { has_choice = 1; choice = p.value(); }
           else if ( p.matches("switch") ) { has_choice = 1; choice = p.value(); }
           else if ( p.matches("show") ) { has_show = 1; show = p.value(); }
           else if ( p.matches("img") ) { has_img = 1; img = p.value(); }
           else if ( p.matches("mov") ) { has_mov = 1; mov = p.value(); }
           else if ( p.matches("s") ) { has_s = 1; str_s = p.value(); }
           else if ( p.matches("br") ) { has_br = 1; br = p.value(); }
           else if ( p.matches("type") ) { has_type = 1; ntype = p.value(); }
           else if ( p.matches("line") ) { has_line = 1; line = p.value(); }
           else if ( p.matches("li") ) { has_line = 1; line = p.value(); }
           else if ( p.matches("trail") ) { has_trail = 1; trail = p.value(); }
           else if ( p.matches("this") ) { has_this = 1; nthis = p.value(); }
           else if ( p.matches("root") ) { has_root = 1; droot = p.value(); }
           else if ( p.matches("index") ) { has_root = 1; droot = p.value(); }
           else if ( p.matches("up") ) { has_up = 1; up = p.value(); }
           else if ( p.matches("annot") ) { has_annot = 1; annot = p.value(); }
           else if ( p.matches("abs") ) { has_abs = 1; str_abs = p.value(); }
           else if ( p.matches("pos") ) { has_pos = 1; position = p.value(); }
           else if ( p.matches("position") ) { has_pos = 1; position = p.value(); }
           else if ( p.matches("from") ) { has_from = 1; set_from(p.value()); }
           else if ( p.matches("to") ) { has_to = 1; set_to(p.value()); }
           else if ( p.matches("w") ) { 
		has_w = 1; str_w = p.value();
		if (tag == "th" || tag == "td") {
			cellwidth[col] = (char*) str_w;
			}
		}
           else if ( p.matches("h") ) {
		has_h = 1; str_h = p.value();
		if (tag == "tr" || tag == "th" || tag == "td") {
			cellheight[row] = (char*) str_h;
			}
		}
           else if ( p.matches("x") ) {
		has_x = 1; str_x = p.value();
		if (tag == "th" || tag == "td") {
			cellx[col] = (char*) str_x;
			}
		}
           else if ( p.matches("y") ) {
		has_y = 1; str_y = p.value();
		if (tag == "th" || tag == "td") {
			celly[col] = (char*) str_y;
			}
		}
           else if ( p.matches("z") ) {
		has_z = 1; str_z = p.value();
		if (tag == "th" || tag == "td") {
			cellz[col] = (char*) str_z;
			}
		}
           else if ( p.matches("r") ) {
		has_r = 1; str_r = p.value();
		if (tag == "th" || tag == "td") {
			cellr[col] = (char*) str_r;
			}
		}
       set_at(p.key(),get_at(p.value()));
       }
}

//@ image

void check_image() {
   //if (!has_x) { has_x = 1; str_x = "12"; }
   //if (!has_y) { has_y = 1; str_y = "-5"; }
   if (!has_style) { has_style = 1; style = "white"; }
   if (has_name && !has_src) {
        char xsrc[1024];
        sprintf(xsrc,"%s.gif",(char*) name);
        src = (char*) xsrc;
	has_src = 1;
	}
   if (has_type && has_src) {
	if (ntype == "img") { has_img = 1; img = (char*) src; }
	else if (ntype == "mov") { has_mov = 1; mov = (char*) src; }
	else if (ntype == "movie") { has_mov = 1; mov = (char*) src; }
	else if (ntype == "vid") { has_vid = 1; vid = (char*) src; }
	else if (ntype == "video") { has_vid = 1; vid = (char*) src; }
   } 
   if (!has_img && !has_mov) { has_img = 1; img = (char*) src; }
   
   if (0 && !has_y && !has_width && !has_y) {
		 has_y = 1;
		 if (is_closed)
		 	str_y = "-8";
		 else
			str_y = "-7";
		 }
   //if (!has_x && !has_width && !has_x) { has_x = 1; str_x = "1.5"; }
   //if (!has_x && !has_width && !has_x) { has_x = 0; str_x = "0"; }
   if (!has_width && !has_w) { has_width = 1; width = "25"; }
   if (!has_height && !has_h) { has_height = 1; height = "15"; }
}


//@ set

void set_br() {
if (has_br) { vspace(atof((char*)br)); }
}

void determine_size() {
if (has_w) { has_size = 1; size = (char*) str_w; }
else if (has_width) { has_size = 1; size = (char*) width; }
}

void set_width() {
int b = (tag == "td" || tag == "th");
if (has_w) { out << "width " << str_w << " "; }
else if (has_width) { out << "width " << width << " "; }
else if (b) { out << "width " << (char*) cellwidth[col] << " "; }
}

void set_height() {
int b = (tag == "td" || tag == "th" || tag == "tr");
if (has_h) { out << "height " << str_h << " "; }
else if (has_height) { out << "height " << height << " "; }
else if (b) { out << "height " << (char*) cellheight[row] << " "; }
}

char* get_from() {
int b = 0; static char buf[32];
if (has_from) { b=1; sprintf(buf,"%s",(char*) from); }
else return (char*) start_level;
if (!b) sprintf(buf,"0");
return (char*) buf;
}

char* get_to() {
int b = 0; static char buf[32];
if (has_to) { b=1; sprintf(buf,"%s",(char*) to); }
else if ( end_level != "-1") { b=1; return (char*) start_level; }
if (!b) sprintf(buf,"1000");
return (char*) buf;
}

char* get_loc() {
int b = 0; static char buf[128];
int bx = (tag == "td" || tag == "th");
int by = (tag == "td" || tag == "th");
int bz = (tag == "td" || tag == "th");
if (bx) { has_x = 1; str_x = (char*) cellx[col]; }
if (by) { has_y = 1; str_y = (char*) celly[col]; }
if (bz) { has_z = 1; str_z = (char*) cellz[col]; }
//ostream* trout = new ostrstream(buf,0,64);
//ostream& strout = *trout;
if (has_loc) { b=1; sprintf(buf,"  %s ",(char*) loc); }
else if (has_x) {
	 sprintf(buf," %s %s %s ",
	 (char*) str_x,
         (char*) (has_y?(char*)str_y:"0"),
         (char*) (has_z?(char*)str_z:"0"));
         b = 1;
	 }
else if (has_y && !b) {
	 sprintf(buf," 0 %s %s ",
	 (char*) str_y, 
         (char*) (has_z?(char*)str_z:"0"));
         b = 1;
	 }
else if (has_z && !b) { 
	sprintf(buf," 0 0 %s ",(char*) str_z);
	}
if (!b) sprintf(buf," 0 0 0 ");
//cerr << "get_loc: " << buf << endl;
return (char*) buf;
}

void set_loc(char* x = "location") {
int b = 0;
int bx = (tag == "td" || tag == "th");
int by = (tag == "td" || tag == "th");
int bz = (tag == "td" || tag == "th");
if (bx) { has_x = 1; str_x = (char*) cellx[col]; }
if (by) { has_y = 1; str_y = (char*) celly[col]; }
if (bz) { has_z = 1; str_z = (char*) cellz[col]; }
if (has_loc) { out << x <<" " << loc << " "; }
else if (has_x) {
	 out << x << " " << str_x << " ";
         out << (char*) (has_y?(char*)str_y:"0") << " ";
         out << (char*) (has_z?(char*)str_z:"0") << " ";
         b = 1;
	 }
else if (has_y && !b) {
	 out << x << " 0 " << str_y << " "; 
         out << (char*) (has_z?(char*)str_z:"0") << " ";
         b = 1;
	 }
else if (has_z && !b) { out << x <<  " 0 0 " << str_z << " "; }
}

void set_translation() { set_loc("translation"); }

char* get_rot() {
static char buf[64]; int b = 0;
if (has_rot) { b=1; sprintf(buf," %s ", (char*) rot); }
else if (has_r) { b=1; sprintf(buf," 0 1 0 %s ", (char*) str_r); }
if (!b) sprintf(buf," 0 1 0 0 ");
return (char*) buf;
}

void set_rot() {
if (has_rot) { out << "rotation " << rot << " "; }
else if (has_r) { out << "rotation  0 1 0 " << str_r << " "; }
}


char* get_scale() {
static char buf[64]; int b = 0;
if (has_scale) { b=1; sprintf(buf," %s ", (char*)scale); }
if (!b) sprintf(buf," 1 1 1 ");
return (char*) buf;
}

void set_scale() {
if (has_s) {
	out << "scale " << str_s << " " << str_s << " " << str_s << " ";
} else if (has_scale) { out << "scale " << scale << " "; }
}

void begin_transform(const char* x = 0) {
if (has_id) { out << " \nDEF " << (char*) id << " "; } 
out << "Transform { ";
      set_translation();
      set_rot();
      set_scale();
out << " children [ " << endl;
}

void end_transform() {
      out << "] } " << endl;
}

void begin_choice(const char* x = 0) {
if (has_id) { out << " \nDEF " << (char*) id << " "; } 
out << "Switch { ";
if (has_choice) out << "whichChoice " << choice << " ";
out << " choice [ " << endl;
}

void end_choice() {
      out << "] } " << endl;
}



void begin_group(const char* x = 0) {
if (has_id) { out << " \nDEF " << (char*) id << " "; } 
out << "Group { ";
out << " children [ " << endl;
}

void end_group() {
      out << endl;
      out << "] } " << endl;
}

void begin_inline(const char* x = 0) {
if (has_id) { out << " \nDEF " << (char*) id << " "; } 
out << "Inline { ";
}

void end_inline() {
      out << endl;
      out << " } " << endl;
}

void print_attributes() {
      set_width();
      set_height();
      set_loc();
      set_rot();
      set_scale();
      }

void print_line(int b = 0) {
	prline(yytext);
	if (in_link && old) out << "a";
	if (has_annot) {
	out << (old?"line {":"\nAnnotTextElement { ");
	out << "annot \"" << annot << "\"" << endl;
	if (has_a) out << " aalpha " << str_a << " " << endl;
	if (has_trans) out << " atrans " << trans << " " << endl;
	if (has_scale) out << " ascale " << scale << " " << endl;
	if (has_asize)  out << " asize " << asize << " " << endl;
	if (has_style) out << " acolor " << style << " " << endl;
	if (has_type) out << " atype " << ntype << " " << endl;
	if (has_shape) out << " atype " << shape << " " << endl;
	if (has_use) out << " anode USE " << use << " " << endl;
	if (has_rot) out << " arotation " << rot << " " << endl;
	if (has_scene) out << " ascene " << scene << " " << endl;
	has_a = has_trans = has_scale = has_asize =
	has_type = has_style = has_rot = 0;
	} else {
	out << (old?"line {":"\nTextElement { ");
	}
	if (b) print_attributes();
	if (has_a) out << " alpha " << str_a << " " << endl;
	out << lp(); 
	}


void set_style(const char*);

void set_pos(const char* val) {
	has_pos = 1;
	position = val;
	}

void begin_channel(char* type, int pos, char* yytext, int yyleng) {
if (0 && in_display) { out << uq(yytext); }
else {
   check("channel");
   ctx->push();
   in_channel++;
   prbegin(yytext);
   if (pos != -1) reset_has();
   //if (in_channel == 1) reset();
   if (yyleng != 0) {
   yytext[yyleng-1] = '\0';
   if (pos >= 0) check_context(type,pos,yytext,yyleng);
   }
   if (!strcmp(type,"image")) check_image();

   if (has_id && !auto_channel) channel_id = (char*) slideref(id);
   if (has_id || auto_channel) {
   out << "\nDEF " << (char*) channel_id << " ";
   auto_channel = 0;
   }

   if (0 && in_object > 0) {
   start_level = "-1";
   end_level = "-1";
   }

   if (!in_object && in_channel > 1 ) {
   out << "BlockElement { ";
   print_attributes();
   if (has_pos) {
	if (position == "abs" || position == "absolute") { 
   		out << "absolute " << "TRUE" << " ";
		}
   }
   out << lp(1);
   out << "block [ " << endl;
   }

   if (1 || !strcmp(type,"text")) {
      if (old) out << "text { \n";
      if (!old) out << "TextBlock { \n";
      if (old && has_size) out << "size " << (char*) size << "\n";
      print_attributes();
      if (has_style) set_style(style);
      if (!old && has_bgcolor) {
	out << "bgColor " << kleur(bgcolor) << " ";
        if (!has_bgtrans) {
		has_bgtrans = 1;
	        bgtrans = "0.2";
	}
        if (has_bgtrans)
	         out << "bgTransparency " << bgtrans << " ";
	}
      if (has_img) {
                 out << "bgType 1 ";
	         out << "url " << img << " ";
      }
      if (has_mov) {
                 out << "bgType 2 ";
	         out << "url " << mov << " ";
      }
      if (has_vid) {
                 out << "bgType 3 ";
	         out << "url " << vid << " ";
      }
      out << (old?"\nlines [":"\nelements [ ") << endl;
      if (in_object) { in_p = 1; print_line(); }
      }
   }
}

void end_channel(char* type) {
if (0 && in_display) { out << uq(yytext); }
else {
      check("end channel");
      if (!in_object && in_channel > 1) { out << " ] } ## block " << endl; }
      if (1 && in_channel > 0) {
     	 out << "] } ";
      	 out << "## end channel: " << type << " "  << yytext << " " << in_channel << " (" << (char*) channel_id << ") " << endl;
      in_channel--;
      is_aligned = 0;
      ctx->pop();
      //if (in_object) in_p = 0;
      }
      in_p = 0;
      }
}

void begin_slide(char* type, int pos, char* yytext, int yyleng, lex* l) {
   ctx->push();
   reset_has();
   reset();
   reset_level();
   //check(yytext);
   in_slide = 1;
   slideno ++;
   yytext[yyleng-1] = '\0';
   check_context(type,pos,yytext,yyleng);
   if (!has_style && !has_bgcolor) {
	has_bgtrans = 1; bgtrans = "0";
	set_style("white");
	}
   else if (has_style) set_style(style);
   prbegin(yytext);
   if (has_id) {
	 slide_id = (char*) slideref(id,has_class, nclass);
	 set_at("the_id",id);
	 set_at("slide_id",id);
	 the_id = (char*) slide_id;
	 out << "\nDEF " << slide_id << " ";

	 string* pc = the_class[nclass]; 
	 if (pc) prev_class[nclass] = new string( (char*)*pc);
	 if (pc) delete pc;
	 if (has_class) the_class[nclass] = new string((char*)id);
	 prev_id = (char*) the_id;


	 the_id = (char*) id; // (char*) buf;
	 if (has_class) the_class[nclass] = new string((char*)id);
	 }
   out << "Slide { \n";
   out << "id \"" << (char*) the_id << "\"\n";
   //print_attributes();
   if (has_show) {
	if (show == "on") out << " show TRUE ";
	}
   if (!old && has_bgcolor) {
	//out << "hasBgColor TRUE ";
	//out << "bgColor [ " << kleur(bgcolor) << " ] ";
	}
   if (!old && has_bg) {
	out << "bgChoice " << bgchoice(bg) << " ";
	}
   if (!old) out << "blocks [" << endl;
   if (has_toc && pr) l->soinc((char*)toc);
   if (has_src && pr) l->soinc((char*)src);
   if (has_drop && pr) l->soinc((char*)drop);
   }

void end_slide(char* type) {
	while (in_channel > 0) end_channel(type);
	if (1 || in_slide) out << "] } ";
	in_slide = 0;
	char buf[1024];
	sprintf(buf,"slide: %s (%s)",type, (char*) slide_id);
	prend(buf);
	ctx->pop();
	in_p = 0;
}


void set_style(const char* x) {
string sty = x;
has_bgcolor = 1; bgcolor= kleur("blue"); f_color = kleur("white");
if (sty == "red") {
	bgcolor = kleur("red");
	f_color = kleur("yellow");
} else if (sty == "blue") {
	bgcolor = kleur("blue");
	f_color = kleur("yellow");
} else if (sty == "orange") {
	bgcolor = kleur("orange");
	f_color = kleur("blue");
} else if (sty == "green") {
	bgcolor = kleur("green");
	f_color = kleur("black");
} else if (sty == "yellow") {
	bgcolor = kleur("yellow");
	f_color = kleur("blue");
} else if (sty == "gold") {
	bgcolor = kleur("black");
	f_color = kleur("gold");
} else if (sty == "silver") {
	bgcolor = kleur("black");
	f_color = kleur("silver");
} else if (sty == "grey") {
	bgcolor = kleur("grey");
	f_color = kleur("red");
} else if (sty == "white") {
	bgcolor = kleur("white");
	f_color = kleur("black");
} else if (sty == "black") {
	bgcolor = kleur("black");
	f_color = kleur("white");
}

}

void soobject(const char* type,char* ext, lex* l) {
char buf[512];
sprintf(buf,"@vr/object/%s%s.vr",type,ext);
l->soinc(buf);
}

void soeffect(const char* type,char* ext, lex* l) {
char buf[512];
sprintf(buf,"@vr/effect/%s%s.vr",type,ext);
l->soinc(buf);
}
	
void begin_effect(char* nclass, int pos, char* yytext, int yyleng, lex* l) {
in_effect++;
ctx->push();
check_context(nclass,pos,yytext,yyleng);
set_at("translation",get_loc());
set_at("rotation",get_rot());
set_at("scale",get_scale());
set_at("from",get_from());
set_at("to",get_to());
if (has_type) { 
	has_effect_type = 1;
	effect_type = (char*) ntype;
	if (is_closed) {
		soeffect(effect_type,"",l);
		in_effect--;
	} else {
		soeffect(effect_type,"_begin",l);
	}
}
if (has_src) l->soinc((char*)src);
}

void end_effect(char* nclass, lex* l) {
if (has_effect_type) {
	soeffect((char*)effect_type,"_end",l);
	}
has_effect_type = 0;
ctx->pop();
in_effect--;
}

void sotemplate(const char* type,char* ext, lex* l) {
char buf[512];
char xtype[1024];
strcpy(xtype,type);
char *p = xtype;
while (*p != '\0') { if (*p == '-') *p = '/'; p++; }
sprintf(buf,"@vr/template/%s%s.vr",xtype,ext);
l->soinc(buf);
}
	
void begin_template(char* nclass, int pos, char* yytext, int yyleng, lex* l) {
ctx->push(1); // no channel
in_template++;
in_p = 0;
check_context(nclass,pos,yytext,yyleng);
set_at("tid",(char*)id);
if (has_type) { 
	has_template_type = 1;
	template_type = (char*) ntype;
	if (is_closed) {
		sotemplate(template_type,"",l);
		in_template--;
	} else {
		sotemplate(template_type,"_begin",l);
	}
}
if (has_src) l->soinc((char*)src);
}

void end_template(char* nclass, lex* l) {
if (has_template_type) {
	sotemplate((char*)template_type,"_end",l);
	}
has_template_type = 0;
in_template--;
ctx->pop();
}

static char* prefix(char* x, int n) {
if (x[0] == '#') return x+(n+1);
else return x+n;
}



void begin_object(char* type, int pos, char* yytext, int yyleng, lex* l) {
   ctx->push();
   in_object++;
   old_p = in_p;
   check(yytext);
   in_p = 0;
   yytext[yyleng-1] = '\0';
   check_context("object",pos,yytext,yyleng);
   out << endl;
   if (has_id) object_id = (char*) id;
   if (has_id) out << "\nDEF " << id << " ";
   out << (old?"object { ":"VrmlElement { ");
   print_attributes();
   out  << lp(1);
   in_line = 0;
   out << " children [ " << endl;
   if (has_type) { 
	has_object_type = 1;
	object_type = (char*) ntype;
	if (is_closed) {
		soobject(object_type,"",l);
		has_object_type = 0;
	} else {
		soobject(object_type,"_begin",l);
	}
   }
   if (has_src && pr) l->soinc((char*)src);
   if (is_closed) {
	out << "] } " << endl;
	in_line = 0; 
	// out << "##nol--" << endl;
	in_p = old_p;
	in_object--;
	ctx->pop();
        }
}

void end_object(char* type, lex* l) {
if (has_object_type) {
	soobject((char*)object_type,"_end",l);
	}
has_object_type = 0;
out << "] } " << endl;
in_line = 0; 
// out << "##nol--" << endl;
in_p = old_p;
in_object--;
ctx->pop();
}

//extern "C" system(char*);
%}
escape ("\\\"")
ident [A-Za-z0-9]+
stringelem ({escape}|[^\"\n])
string (\"{stringelem}+\")

path  [A-Za-z0-9\@\~\#\:\-\.\/\?]+

value  ({path}|{string})
attrib ({ident}|{ident}[ \t\n]*"="[ \t\n]*{value})

attribs ([ \t\n]|{attrib})*

simple   ("<"{ident}">")
begintag ("<"{ident}{attribs}">")
endtag   "</"{ident}">")
beginpr  "<?"{ident}{attribs}">"
endpr    "<?/"{ident}">"

stylesheets (stylesheet|STYLESHEET)
stylesheet "<!"{stylesheets}[^\>]">"

doctypes (doctype|DOCTYPE)
elements (element|ELEMENT)
attlists (attlist|ATTLIST)

doctype  "<!"{doctypes}[^\>]">"
element  "<!"{elements}[^\>]">"
attlist  "<!"{attlist}[^\>]">"

begincmt [ \t]*"<!--"[ \t]*
endcmt   [ \t]*"-->"[ \t]*

old-any ({beginpr}|{endpr}|{doctype}|{element}|{attlist})

any ([^\>]|{string})
atts {any}*

name [\~\/\@A-Za-z0-9\.][\_\@A-Za-z0-9\.\/\-\+]*
names [ \t]*{name}({name}|[ \t])*
C \@

lightcolors (white|lightred|lightgreen|lightblue|lightyerllow) 
darkcolors (red|green|blue|yellow|orange|silver|gold|black)
colors ({lightcolors}|{darkcolors})

prefix ("#@"|"@")
display ("program"|"display")
%%@ rules

"EXTERNPROTO "[A-Za-z0-9\-\_\+]+ {
        set_loaded(yytext+12);
	out << yytext;
	}

^"##"[\-\@\*\+\#\<\:\ ].* { }

"xsl:"[a-z]* { in_xsl =1; out << yytext; }
"xxx%S" { out << "SUM"; }
"<latex>"\\ { }
"</latex>"  { }
"\\|" { out << "|"; }

\\"mark"[a-z]+"{"[^\}]*"}" { }
\\"index{"[^\}]*"}" { }
\\"vspace{"[^\}]*"}" { }
\\"chapter".* { }
\\"ifsli".* { }
\\"slilarge".* { }

"<math"{atts}">" { in_math = 1; }
"</math>" { in_math = 0; }
"$"  { if (in_math==0) in_math = 1; else in_math = 0; }

"%%".*\n { }

"<c-nonum>" { }
"</c-nonum>".* { }

"<c-inprog>" { }
"</c-inprog>".* { }

"<!--" { }
"-->" { }

"<!--%" { }
"%-->" { }


"<pre>" {}
"</pre>" {}

"</body></document>" { }

"#@include @proto/slide/slide.wrl" {}
"#@include @vrml/slideset-begin.wrl" {}
"#@include @vrml/slideset-end.wrl" {}

"<embed"{atts}">" { }
"<applet"{atts}">" { }
"</applet>" { }

"<effect"{atts}(\/?)">" {
	begin_effect("effect",7,yytext,yyleng,this);
	}
"</effect>" { end_effect("effect",this); }

"<template"{atts}(\/?)">" {
	begin_template("template",9,yytext,yyleng,this); 
	}
"</template>" {
cerr << "## " << has_template_type << " " << template_type << endl;
end_template("template",this);
}

"<novr>".* { pr=1;  }
"</novr>" { pr=1; }
"<html>" {  }
"</html>" {  }
"<control>"|"<c>" { }
"</control>"|"</c>" { }
"<oldquote>" { }
"</oldquote>" { check("quote"); }
"<box>" { ;}
"</box>" { ;}

"<!--\\fbox{-->" { }
"<!--}-->" { }
"\\hspace{"[^\}]+"}" { }
"xxxx\\vspace{"[^\}]+"}" { }
"\\zline{"[^\}]+"}" {
	yytext[yyleng-1] = '\0';
	out << "   --   " <<  yytext+7;
	}

"\\ffrac{"  { in_frac = 1; }
"}{" { if (in_frac == 1) {
	in_frac = 2;
	in_brac = 0;
	check("frac");
	vspace(0.5);
	print_line();
	out << "----------------------------------";
	check("frac2");
	vspace(0.5);
	print_line();
	} else out << yytext; 
}
"}"  { 
	if (in_frac == 2) {
	   if (in_brac == 0) {
	     in_frac = 0;
	     } else { in_brac--; out << yytext; }
	} else out << yytext;
}
"{"  { 
	if (in_frac == 2) {
	   in_brac++;
	}; 
	out << yytext;
}

"<!--\\chapter{".*\n { }

^"x<html><control>".* { }

"<hr>"  { ; }

"&nbsp;" { }
"~n" { out << "~"; }
"&gt;" { out << ">"; }
"&lt;" { out << "<"; }
"&ge;" { out << ">="; }
"&le;" { out << "<="; }
"&amp;" { out << "&"; }
"&AElig;" { out << "AE"; }
"&aelig;" { out << "ae"; }
"&#150;" { out << "-"; }
"&#149;" { out << "*"; }
"&#146;" { out << "'"; }
"&quot;" { out << "\\\""; }

"&"[a-z]"uml;" { out << yytext[1]; }

"<vrml>" { ; }
"</vrml>" { ; }
"<v>" { ; }
"</v>" { ; }

"<ignore>" { pr = 0; }
"</ignore>" { pr = 1; }

"<center>" { centered = 1; ctx->push(); f_justify = "MIDDLE"; }
"</center>" { centered = 0; ctx->pop(); }

"<ol"{atts}">"|"<ul"{atts}">" {
	check(yytext);
	prbegin(yytext);
	ctx->push();
	bullet = (char*) f_color;
	//un_p(); 
	if (old) un_break = -0.2; // -0.5; // -0.5;
	in_list++; 
	items[in_list] = 0;
	list_type[in_list] = 0; 
	if (yytext[1] == 'o') list_type[in_list] = 1; 
	yytext[yyleng-1] = '\0';
	check_context("ul",3,yytext,yyleng);
	// out << " ## " << in_list << " " << yytext << endl;
	if (has_line) {
		if (line == "on") no_li = 1;
		else if (line == "off") no_li = 0;
		else if (line == "auto") no_li = 0;
		}
	vspace(1,yytext);
	if (!old) {
	 //out << " Nesting { nesting " << f_size << lp(2) << " } ";
	}
	list_level[in_list] = auto_level; 
	} 

"</ol>"|"</ul>" {
	check(yytext);
	prend(yytext);
	ctx->pop();
	if (!old) {
	  //out << " Nesting { nesting -" << f_size << lp(2) << " } ";
	  }
	// out << " ## " << in_list << " " << endl; in_list--;
	if (in_list < 0) in_list = 0;
	auto_level = list_level[in_list];
	}

"xxx##" { if (!in_display)  out << yytext; }
"##"|"//"|"<xfont color=green><i>##" {
	if (!in_display) {
		out << yytext;
	} else {
	out << "\" } ##" << endl;
	font_push();
	f_color = kleur(str_comment); // "0 1 1"; 
	f_size = xsize(0.8);
	f_style = "ITALIC";
	do_pop = 1;
	prline(yytext);
	out << (old?"line {":"\nTextElement {") << lp();
	}
}



"<a "{atts}">" { 
	if (1 || !in_object) {
	ctx->push();
	yytext[yyleng-1] = '\0';
	has_name = 0;
	check_context("a",2,yytext,yyleng);
	if (!has_name && !has_novref && (has_ref || (x_mode && (has_href)))) {
		in_link = 1;
		char buf[1024];
		sprintf(buf,"%s%s",(char*)(has_ref?ref:href),(has_ref?".wrl":""));
		the_link = (char*)buf;
		//out << "\" }\n";
		check("a");
		prline(yytext);
		out << (old?"aline {":"\nTextElement {");
		out << lp();
		}
	}
}
"</a>" {
	if (1 || !in_object) {
	ctx->pop();
	if (in_link && x_mode) {
	   in_link = 0;
	   if (1 || !in_header) {
		out << "\" }\n";
		prline(yytext);
		out << (old?"line {":"\nTextElement {");
                out << lp();  
		}
	}
	}
}

"<lp"{atts}">"|"<p"{atts}">"  {
	yytext[yyleng-1] = '\0';
	int pos = 2;
	if (yytext[1] == 'l') pos = 3;
	set_level();
	check_channel();
	if (yyleng > (pos+1)) {
		ctx->push();
		check_context("p",pos,yytext,yyleng);
	}
	in_p = 1;
	if (pos == 2) {
	un_p();
	if (!in_display) un_break = 0; // was 0
	vspace(old?0.5:1,yytext);
        set_br();
	print_line();
	in_p=1;
	}
}
"</p>" { if (1) un_p(); f_justify = "BEGIN"; font_pop(); }
"</p><br>" { font_pop(); f_justify = "BEGIN"; if (1) un_p(); }

"<def"{atts}">"  {
	yytext[yyleng-1] = '\0';
	check_context("def",4,yytext,yyleng);
	if (has_id) {
	//out << "\" }" << endl;
	check(yytext);
	prline(yytext);
	out << "\nDEF " << (char*) id << " ";
	out << (old?" line {":" \nTextElement {") << lp(); 
	}
}

"</def>" { 
	check(yytext);
	prline(yytext);
	out << (old?"line { ":"\nTextElement {") << lp();
	}

"xxfield" { if (!in_line) in_field = 1; out << yytext; }

"xxurl \"" { if (!in_line) { in_url = 1; out << yytext; }
	   else { out << "url \\\""; }
	   }

"\\\"" { out << yytext; }

"\"" {
	if (in_url) { in_url = 0; out << yytext; }
	else if (in_field) { out << yytext; }
	//else if ((in_display||in_line) && !in_q) 
	if (!in_line) { out << yytext; }
	else if (in_line)  {
		out << "\\\"";
	} else {
		out << "\"";
	}
}

"<"[\+\-][0-9\.]+">"  {
	yytext[yyleng-1] = '\0';
	char sign = yytext[1];
	char* s = (char*) yytext+2;
	float  k; sscanf(s,"%f",&k);
	if (sign == '-') k = -k;
	if (1) {
	out << "\" }" << endl;
	if (old) { out << "break { br FALSE length " << k << lp(2) << "}" << endl; }
	else hspace(k);
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"\nTextElement {") << lp();
	}
}

"#<l++>" { set_start("++"); }
"<l++>"  {
	yytext[yyleng-1] = '\0';
	set_start("++");
	if (1) {
	check("<l++>");
	//out << "\" }" << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line { ":"\nTextElement {") << lp();
	}
	}

"<q>"  {
	in_q ++;
	if (1) {
	out << "\" }" << endl;
	}
	}
"</q>" { 
	in_q--;
	prline(yytext);
	out << (old?" line { ":" \nTextElement {") << lp();
	}
	

"<display"{atts}">"[ \t\n]* { 
	un_p();
	prbegin(yytext);
	ctx->push();
	set_level();
	in_display++; 
	char* p = &yytext[yyleng-1];
	while ((*p) != '>')  p--;
	*p = '\0';
	yytext[yyleng-1] = '\0';
	if (in_display==1) { 
           // out << "## check context " << yytext << endl;
	   check_context("display",8,yytext,yyleng);
           if (has_style) {
			 set_style(style);
			 ctx->extra_channel= 1;
	                 begin_channel("text",-1,"",0);
	                 //out << "## extra channel" << endl;
                         }
	   prline(yytext);
	   out << (old?"\nline {":"\nTextElement {") << lp();
	} else if (in_display > 1) {
	         out << uq(yytext) << "\" }" << endl;
		 prline(yytext);
		 out << (old?"line {":"\nTextElement {") << lp();
	}
	}

\n*"</display>" {
	if (in_display==1) {
	        check("end display");
		//out << "\"} " << endl;
		prend("</display>");
		}
	else if (in_display > 1) { 
	        check("end display (x)");
		//out << "\" }" << endl;
		prline(yytext);
		if (old) out << "line { size " << f_size << " string \"" << yytext; 
		out << "\nTextElement { height " << f_size << " string \"" << yytext; 
		}
	level_display = 0;
	in_display--;
	ctx->pop();
	}

"<program"{atts}">"[ \t\n]* { 
	un_p();
	prbegin(yytext);
	ctx->push();
	set_level();
	in_display++; 
	char* p = &yytext[yyleng-1];
	while ((*p) != '>')  p--;
	*p = '\0';
	yytext[yyleng-1] = '\0';
	if (in_display==1) { 
           // out << "## check context " << yytext << endl;
	   check_context("display",8,yytext,yyleng);
           if (has_style) {
			 set_style(style);
			 ctx->extra_channel= 1;
	                 begin_channel("text",-1,"",0);
	                 //out << "## extra channel" << endl;
                         }
	   prline(yytext);
	   out << (old?"\nline {":"\nTextElement {") << lp();
	} else if (in_display > 1) {
	         out << uq(yytext) << "\" }" << endl;
		 prline(yytext);
		 out << (old?"line {":"\nTextElement {") << lp();
	}
	}

\n*"</program>" {
	if (in_display==1) {
	        check("end display");
		//out << "\"} " << endl;
		prend("</display>");
		}
	else if (in_display > 1) { 
	        check("end display (x)");
		//out << "\" }" << endl;
		prline(yytext);
		if (old) out << "line { size " << f_size << " string \"" << yytext; 
		out << "\nTextElement { height " << f_size << " string \"" << yytext; 
		}
	level_display = 0;
	in_display--;
	ctx->pop();
	}

"<rm>"|"</rm>" { ;}
"<U>"|"</U>"|"<u>"|"</u>" { ; }
"<i>"|"<b>"|"<em>"|"<tt>" {
	yytext[yyleng-1] = '\0';
	int old_p = in_p;
	string c_style = (char*) f_style;
	string c_family = (char*) f_family;
	ctx->push();
	//font_push();
	if (!strcmp(yytext+1,"i"))  {
		if (c_style == "BOLD") f_style = "BOLDITALIC";
		else f_style = "ITALIC";
		}
	else if (!strcmp(yytext+1,"b"))  {
		if (c_style == "ITALIC") f_style = "BOLDITALIC";
		else f_style ="BOLD";
		}
	else if (!strcmp(yytext+1,"em"))  {
		if (c_style == "ITALIC") f_style = "PLAIN";
		else if (c_style == "PLAIN") f_style = "ITALIC";
		else if (c_style == "BOLD") f_style = "BOLDITALIC";
		else if (c_style == "BOLDITALIC") f_style = "ITALIC";
		else f_style = "ITALIC";
		}
	else if (!strcmp(yytext+1,"tt"))  {
		f_family = "TYPEWRITER";	
	}
	//out << "\" }" << endl;
	check(yytext);
	// out << " ## " << yytext << " " << f_family << " " << f_style << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"\nTextElement {") << lp();
	//in_p = old_p;
	}

"</i>"|"</b>"|"</em>"|"</tt>" { 
	int old_p = in_p;
	check(yytext);
	ctx->pop();
	//font_pop();
	// out << " ## " << yytext << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"\nTextElement {") << lp();
	//in_p = old_p;
	}


"<"{colors}">" {
if (1 || !in_object) {
	yytext[yyleng-1]='\0';
	font_push();
	f_color = kleur(yytext+1); // (char*) *colors[yytext+1]; 
	int old_p = in_p;
	//if (1 || in_line || in_font > 0) out << "\" }" << endl;
	check(yytext); // AE
	// out << " ## " << yytext << " " << f_color << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"\nTextElement {") << lp();
	in_p = old_p;
	in_font++;
	}
	}

"<font"{atts}">" { 
if (1 || !in_object) {
	yytext[yyleng-1] = '\0';
        string_converter x(yytext+5);
	int old_p = in_p;
	string pv;
	check(yytext); // AE
	font_push();
        for (int i = 1; i <= x.argc(); i++ ) {
           attribute p(x[i]);
	   if (p.matches("size")) { f_size = p.value(); }
	   else if (p.matches("color")) { f_color = kleur(p.value()); }
	   else if (p.matches("family")) { f_family = p.value(); }
	   else if (p.matches("style")) { f_style = p.value(); }
	   else if (p.matches("size")) { f_size = p.value(); }
	}
	//out << " ## " << yytext << " " << f_color << " " << pv << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"\nTextElement {") << lp();
	in_p = old_p;
	in_font++;
	}
}

"</font>" {
if (1 || !in_object) {
	int old_p = in_p;
	//cerr << ">>>" << yytext << " " << in_p << endl;
	check(yytext);
	font_pop();
	// out << " ## " << f_color << " " << yytext << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"\nTextElement {") << lp();
	in_p = old_p;
	in_font --;
	}
}

"</"{colors}">" {
if (1 || !in_object) {
	int old_p = in_p;
	//cerr << ">>>" << yytext << " " << in_p << endl;
	check(yytext);
	font_pop();
	// out << " ## " << yytext << endl;
	prline(yytext);
	if (in_link && old) out << "a";
	out << (old?"line {":"\nTextElement {") << lp();
	in_p = old_p;
	in_font--;
	}
}

"<example"{atts}">" {
un_p();
if (in_display) { out << uq(yytext); }
else {
   yytext[yyleng-1] = '\0';
   int has_name = 0;
   int has_scale = 0;
   int has_trans = 0;
   int has_orient = 0;
   int has_src = 0;
   string scale = "1 1 1";
   string trans = "0 -1 4";
   string orient = "0 1 0 0";
   string sl_name = "X";
   string_converter x(yytext+8);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("scale") ) { has_scale = 1; scale = p.value(); }
           else if ( p.matches("trans") ) { has_trans = 1; trans = p.value(); }
           else if ( p.matches("translation") ) { has_trans = 1; trans = p.value(); }
           else if ( p.matches("orient") ) { has_orient = 1; orient = p.value(); }
           else if ( p.matches("name") ) { has_name = 1; sl_name = p.value(); }
           else if ( p.matches("src") ) { has_name = 1; sl_name = p.value(); }
           else if ( p.matches("id") ) { has_name = 1; sl_name = p.value(); }
           }
   if (0) {
   out << "EXAMPLE " << (char*) sl_name << "\n"
       // << "SCALE " << (char*) scale << "\n" 
       << "TRANSFORM " << (char*) trans << "\n"
       << "ORIENTATION " << (char*) orient << "\n"
       << "#@include Example.pre" << endl;
   } 
   if (1) {
     cerr << yytext<< ">" << endl;
     out << "vrmlblock { children [" << endl;
     out << "Transform {" << "\n"
	 << "translation " <<  (char*) trans << "\n"
	 << "scale " <<  (char*) scale << "\n"
	 << "rotation " <<  (char*) orient << "\n"
	 << "children  AnnotatedPillar { " << "\n"
	 << "radius 1 " << "\n"
	 << "height 1 " << "\n"
	 << "material  YellowMaterial {} " << "\n"
	 << "description  " << (char*) sl_name << "\n"
	 << "textBlock [ " << "\n";
     soinc((char*) sl_name,".pvl");
     out << "]  " << "\n"
	 << "infoParam targetwindow \n"
	 << "infoHref \"@tm-" << (char*) sl_name << ".html\"" << "\n"
	 << "children [ \n";
     soinc((char*) sl_name,".wrl");
     out << "]  " << "\n" << "} }" << endl;
     out << "] } # end vrmlblock " << endl;
     }
   }
}

"<?vrml"{atts}">" {
	check_context("vrml",6,yytext,yyleng);
}


"<slideset"{atts}">" {
	check("slideset");
	char buf[1024];
	strcpy(buf,yytext);
	int xleng = yyleng;

	if (!no_auto && !set_includes) {
	set_includes = 1;
	load("@vr/proto/pvl.wrl",this);
	if (!slide_includes) load("@vr/proto/slide.wrl",this);
	slide_includes = 1;
	}

	in_p = 0;
	ctx->push();
	check_context("slideset",9,buf,xleng);
	int closed = is_closed;
	if (has_id)  set_id = (char*) id;
	else set_id = "SLIDESET";

	if (has_drop && !got_drop && pr) { 
		got_drop = 1; soinc((char*)drop);
		}

	if (has_toc && pr) soinc((char*)toc);
	has_toc = 0;
	out << "\nDEF " << (char*) set_id << " ";
	out << "SlideSet {" << endl;
	print_attributes();
	out << "slides [" << endl; 
	if (has_src && pr) soinc((char*)src);
	if (closed) {
		out << "] } ## slideset " << (char*) set_id << endl;
		//out << "SlideInterface { slide_set USE " << set_id << "}" << endl;
		ctx->pop();
		in_p = 0;
		}
	}

"</slideset>" { 
	out << "] } ## slideset " << (char*) set_id << endl;
	//out << "SlideInterface { slide_set USE " << set_id << "}" << endl;
	ctx->pop();
	in_p = 0;
	}

"<interface"{atts}"/"?">" {
	check_context("interface",10,yytext,yyleng);
	if (!has_use) use = (char*) set_id;
	if (has_id) out << "\nDEF " << id << " "; 
	out << "SlideInterface { " << endl;
	print_attributes();
        out << "slide_set USE " << use << "}" << endl;
	}

"<keyboard"{atts}"/"?">" {
	check_context("keyboard",9,yytext,yyleng);
	if (!has_use) use = (char*) set_id;
	if (has_id) out << "\nDEF " << id << " "; 
	out << "SlideKeys { " << endl;
	out << "slide_set USE " << use << "}" << endl;
	}

"<world"{atts}">" {
	in_collection = 1;
	begin_slide("world",6,yytext,yyleng,this);
	}

"</world>" { end_slide("world"); in_collection = 0; has_channel = 0; }

"<scene"{atts}">" {
	in_collection = 1;
	begin_slide("scene",6,yytext,yyleng,this);
	}

"</scene>" { end_slide("scene"); in_collection = 0; has_channel = 0; }

"<xslice"{atts}"/"?">"|"<slide"{atts}"/"?">" {
if (!no_auto && !slide_includes) {
load("@vr/proto/slide.wrl",this);
slide_includes= 1;
}
strcpy(slideargs,yytext);
slideargslength = yyleng;
if (in_display) { out << uq(yytext); }
else if (in_collection) {
	if (has_channel) {
	while (in_channel > 0) end_channel("collection");
	begin_channel("slide",6,yytext,yyleng);
	}
	}
else {
	begin_slide("slide",6,yytext,yyleng,this);
	if (is_closed) {
		end_slide("closed slide");
		}
	}
}

"</slide>"|"</xslice>" {
if (in_display) { out << yytext; }
else if (in_collection) { if (has_channel) end_channel("collection"); }
else {
	end_slide("slide");
	}
}

"<navigate"{atts}"/"*">" {
  if (in_display) {
	out << yytext;
  } else {
	if (yytext[0]!='@') yytext[yyleng-1]='\0';
	string fname = (char*) filename;
	check(yytext);
	//int has_prev = 0;
	//int has_trail = 0; string trail;
	//int has_class = 0; string nclass = "slide";
	//int has_color = 0; string color = "gray";
	//int has_this = 0; string nthis = (char*) the_slide;
	up = "this";
	next = "this";
	prev = "this";
	droot = (char*) filename;
	trail = (char*) filename;
	check_context("navigate",9,yytext,yyleng);
	string_converter s(yytext+9);
	  string l_trail = (char*) trail;
	  string l_index = (char*) droot;
	  string l_prev = (char*) prev;
	  string l_up = (char*) up;
	  string l_next = (char*) next;
	  string n_trail;
	  string n_index;
	  string n_prev;
	  string n_top;
	  string n_next;
	  //AE out << bcmt << yytext << ">" << ecmt;
  	  //out << bcmt << "<novr><control>" << ecmt;
	  if (has_class) {
		the_class[nclass] = new string((char*)the_id);;
		if (has_trail) trails[nclass] = new string((char*)trail);
		else {
			string* ps = trails[nclass];
			if (ps) trail = (char*) *ps; 
			else {
				char xbuf[128];
				sprintf(xbuf,"%s-%s",(char*)nclass,(char*)name);
				trail = (char*) xbuf;
				trails[nclass] = new string((char*)xbuf);
				}
			}
		}
	  if (!has_prev) {
	      if (has_class) {
	  	string* pc = prev_class[nclass];
		if (pc) prev = (char*) *pc;
	        else prev = (char*) prev_id;
		} else {
		    prev = (char*) prev_id;
	      }
	  }
	  if (has_class && !has_style) {
		if (nclass == "AI") style = "orange";
		else if (nclass == "I") style = "blue";
		else if (nclass == "IK") style = "purple";
		has_style = 1;
		}
	  if (has_class && !has_this) {
	        char xbuf[1024];
		sprintf(xbuf,"@trail-%s.html",(char*)trail);
		nthis = (char*) xbuf;
		}
	  if ( has_class ) has_this = 1;
	  if ( has_this ) {
	  //out << "<a href=" << nthis << ">";
	  //if (has_color) out << "<font color=" << color << ">";
	  //out << nclass << ":";
	  //out << "</a>";
	  //if (has_color) out << "</font>";
	  }
          int b = 0;
  	  if (  (((char*) n_prefix)[0] =='#' ) )  b = 1;

	  if (prev == "this") { 
		l_prev = (char*) slideref(the_id);
	  } else { 
		l_prev = (char*) slideref(prev);
		}
	  // out << "<";

	  if (droot == "this") { 
		l_index = (char*) slideref(the_id);
	  } else { 
		l_index = (char*) slideref(droot);
		}
	  // out << "%";

	  if (up == "this") { 
		l_up = (char*) slideref(the_id);
	  } else { 
		l_up = (char*) slideref(up);
		}
	  //out << "^";



	  if (next == "this") { 
		l_next = slideref(the_id);
	  } else { 
		l_next = slideref(next);
		}
	  //out << ">";
	  if (0){
	  out << "## Navigate { ";
	  out << "prev \"" << s_prefix << prev << ".wrl\" ";
	  out << "next \"" << s_prefix << next << ".wrl\" ";
	  out << "root \"" << w_prefix << droot << ".wrl\" ";
	  out << "up \"" << s_prefix << up << ".wrl\" ";
	  out << "trail \"" << w_prefix << trail << ".wrl\" ";
	  out << " }";
	  }
	  if (in_channel > 0 && in_p) print_line();

  }
}


"<quote>"|"<quote "{atts}">" {
if (in_display) { out << uq(yytext); }
else {
   //un_p();
   check(yytext);
   ctx->push();
   set_level(); // AE
   in_li = 1;
   int is_simple = 0;
   if (yyleng==7) is_simple = 1;
   yytext[yyleng-1] = '\0';
   if (!is_simple) check_context("quote",6,yytext,yyleng);
   vspace(atof((char*)f_size),yytext);
   prline(yytext);
   out << " Nesting { nesting " << f_size << lp(2) << " } " << endl;
   out << (old?"line { ":"\nTextElement {");
   out << lp();
} }

"</quote>" {
if (in_display) { out << uq(yytext); }
else {
	check(yytext);
	out << endl << " Nesting { nesting -" << f_size << lp(2) << " } ";
	ctx->pop();
	}
}

"<li>"|"<li "{atts}">" {
if (in_display) { out << uq(yytext); }
else {
   //un_p();
   check(yytext);
   ctx->push();
   set_level(); // AE
   in_li = 1;
   int is_simple = 0;
   if (yyleng==4) is_simple = 1;
   yytext[yyleng-1] = '\0';
   int has_symbol=1;
   if (list_type[in_list] == 1) has_symbol = 0;
   if (in_list == 2) {
	f_size = "0.8";
   } else if (in_list == 3) {
	f_size = "0.6";
   	}
   if (!is_simple) check_context("li",3,yytext,yyleng);
   if (has_line) {
		if (line == "on") no_li = 1;
		else if (line == "off") no_li = 0;
		else if (line == "auto") no_li = 0;
		}
   if (items[in_list]++ > 0) {
   //if (old) out << "\n break { size " << f_size << lp(2)  << "}\n";
   vspace(atof((char*)f_size),yytext);
   }
   prline(yytext);
   if (!old && has_symbol) {
	out << " Bullet {  width " << f_size
	<<  " height " << f_size 
	<< " color " << bullet << lp(2) << " } ";
	out << endl << " Nesting { nesting " << f_size << lp(2) << " } ";
	}
   out << (old?"line { ":"\nTextElement {");
   if (old && has_symbol) out << "symbol USE " << (char*) symbol << "\n";
   out << lp();
   if (list_type[in_list] == 1)
	out << items[in_list] << ".";
   }
}
"</li>" {
if (in_display) { out << uq(yytext); }
else {
	check(yytext);
	if (list_type[in_list] == 0)
	out << endl << " Nesting { nesting -" << f_size << lp(2) << " } ";
	ctx->pop();
	}
}

"<h"[0-9]">"|"<h"[0-9]" "{atts}">" {
if (0 && in_display) { out << uq(yytext); }
else {
   check_channel();
   ctx->push();
   set_level();
   check(yytext); // AE
   in_header = 1;
   int level = 0;
   level = yytext[2] - '0';
   yytext[yyleng-1] = '\0';
   if (level == 1 ) {
   	f_size = "1.5";
   } else if (level == 2) {
   	f_size = "1.3";
   } else if (level == 3) {
   	f_size = "1.2";
   } else {
	f_size = "1.0";
   	}
   float f = levelsize[level];
   char buf[64]; sprintf(buf,"%f",f);
   f_size = (char*) buf;
   if (yyleng > 3) check_context("header",3,yytext,yyleng);
   // out << "\n## " << yytext << endl;
   vspace(f,yytext); // AE h-size
   prline(yytext);
   set_br();
   if (old && in_link) out << "a";
   out << (old?"line { ":"\nTextElement {"); 
   out << lp();
   }
}
"</h"[0-9]">" {
if (0 && in_display) { out << uq(yytext); }
else {
if (old) un_break = -0.2;
else un_break = (10-(yytext[3]-'0')) / 4; 
check(yytext);
ctx->pop();
in_header = 0;
in_right = 0;
if (in_display) { 
	prline(yytext);
	out << (old?"line {":"\nTextElement {") << lp(); }
}
}

"<channel"{atts}"/"?">" { 
	begin_channel("text",8,yytext,yyleng);
	if (has_src && pr) soinc((char*)src);
	if (is_closed) end_channel("closed channel");
	}
"</channel>" { end_channel("channel"); }

"<slice"{atts}"/"?">" { 
	if (in_slide > 0) {
	in_slice++;
	check_context("slice",6,yytext,yyleng);
	if (has_level) {
	  set_start(level);
	  set_end(level);
	} else {
	  if (in_channel) end_channel("slice");
	  char buf[64]; sprintf(buf,"%d",slice_level);
	  slice_level++;
	  set_start(buf);
	  set_end(buf);
	  begin_channel("text",6,slideargs,slideargslength);
	//begin_channel("text",6,yytext,yyleng);
	}
	if (has_src && pr) soinc((char*)src);
	//if (is_closed) end_channel("closed slice");
	} }
"</slice>" { in_slice--; end_channel("slice"); }

"<text"{atts}"/"?">" { 
	ctx->push();
	check(yytext);
	check_context("text",5,yytext,yyleng);
	if (has_id) out << "\nDEF " << id << " ";
	print_line(1);
        if (has_src && pr) soinc((char*)src);
	if (is_closed) {
		check(yytext);
		ctx->pop();
        	}
	}

"</text>" {
	check(yytext);
	ctx->pop();
	}

"<transform"{atts}"/"?">" {
	check_context("text",10,yytext,yyleng);
	begin_transform();
        if (has_src && pr) soinc((char*)src);
	if (is_closed) {
		end_transform();
		}
	}

"</transform>" { end_transform(); }

"<choice"{atts}"/"?">" {
	check_context("text",7,yytext,yyleng);
	begin_choice();
        if (has_src && pr) soinc((char*)src);
	if (is_closed) {
		end_choice();
		}
	}

"</choice>" { end_choice(); }

"<switch"{atts}"/"?">" {
	check_context("text",7,yytext,yyleng);
	begin_choice();
        if (has_src && pr) soinc((char*)src);
	if (is_closed) {
		end_choice();
		}
	}

"</switch>" { end_choice(); }

"<group"{atts}"/"?">" {
	check_context("text",6,yytext,yyleng);
	begin_group();
        if (has_src && pr) soinc((char*)src);
	if (is_closed) {
		end_group();
		}
	}

"</group>" { end_group(); }

"<inline"{atts}"/"?">" {
	check_context("text",7,yytext,yyleng);
	begin_inline();
        if (has_src && pr) out << " url \"" << (char*) src << "\"" << endl;
	if (is_closed) {
		end_inline();
		}
	}

"</inline>" { end_inline(); }

"<br>"|"<br "{atts}">"|"<break"{atts}">" {
if (0 && in_display) { out << uq(yytext); }
else {
   check(yytext);
   yytext[yyleng-1] = '\0';
   size = "0.5";
   has_size = 0;
   int n = strlen(yytext);
   int m = 6;
   if (n > 4) {
    if ( yytext[3] == ' ' ) m = 3;
    check_context("br",m,yytext,yyleng);
    }
    // out << "## in_display " << in_display << endl;
    if (!in_display) { 
       determine_size();
       if (old) out << "break { size " << (char*) size << lp(2) << " } ##" << yytext << endl;
       if (!old) vspace(atof(has_size?size:f_size),yytext);
       in_line = 0;
       if (in_p) { 
	     prline(yytext);
	     if (in_link && old) out << "a"; 
	     out << (old?"line {":"\nTextElement {") << lp(); }
       } else { out << (old?"line {":"\nTextElement {") << lp(); } 
  }
}   


"<table"{atts}">" { begin_channel("table",6,yytext,yyleng); row=0; col=0; in_p = 0; }
"</table>" { end_channel("table"); }

"<tr"{atts}">" { col = 0; /*begin_channel("tr",3,yytext,yyleng); */ }
"</tr>"        { check(yytext); vspace(1); col = 0; /* end_channel("tr"); */ row++; }

"<th"{atts}">" { check(yytext); hspace(1); begin_channel("th",3,yytext,yyleng); in_p = 1; print_line(); }
"</th>" { end_channel("th"); col++; }

"<td"{atts}">" {  check(yytext); hspace(1); begin_channel("td",3,yytext,yyleng); in_p = 1; print_line(); }
"</td>" { end_channel("td"); col++; }

"<dl"{atts}">" { 
	check(yytext);
	ctx->push();
	check_context("dl",3,yytext,yyleng);
}
"</dl>" { 
	check(yytext);
	ctx->pop();
	if (in_p) print_line();
}

"<dt"{atts}">" { 
	check(yytext);
	ctx->push();
	f_style = "BOLD";
	check_context("dt",3,yytext,yyleng);
	vspace(1);
	print_line();
}
"</dt>" { }
"<dd"{atts}">" {
	check(yytext);
	ctx->pop();
	check_context("dd",3,yytext,yyleng);
	print_line();
	out << "   ";
}
"</dd>"        { }

"<img"{atts}">"|"<image"{atts}("/"*)">" {
if (in_display) { out << uq(yytext); }
else {
   int is_short = 0;
   int is_closed = 0;
   if (yytext[3]=='g') is_short = 1;
   check(yytext);
   yytext[yyleng-1] = '\0';
   if (yytext[yyleng-2] == '/') { is_closed = 1; yytext[yyleng-2]='\0'; }
   if (is_short) is_closed = 1;
   int nl = is_short?4:6; 
   check_context("image",nl,yytext,yyleng);
   if (!has_x) { has_x = 1; str_x = "12"; }
   if (!has_y) { has_y = 1; str_y = "-5"; }
   if (!has_style) { has_style = 1; style = "white"; }
   if (has_name && !has_src) {
        char xsrc[1024];
        sprintf(xsrc,"%s.gif",(char*) name);
        src = (char*) xsrc;
	has_src = 1;
	}
   if (has_type) {
	if (ntype == "img") { has_img = 1; img = (char*) src; }
	else if (ntype == "mov") { has_mov = 1; mov = (char*) src; }
	else if (ntype == "movie") { has_mov = 1; mov = (char*) src; }
   } 
   if (!has_img && !has_mov) { has_img = 1; img = (char*) src; }
   
   if (is_short) {
   if (!has_h && !has_width && !has_y) { has_y = 1; str_y="-0.20"; }
   if (!has_width && !has_w) { has_width = 1; width = "0.75"; }
   if (!has_height && !has_h) { has_height = 1; height = "1"; }
   } else {
   if (!has_y && !has_width && !has_y) { has_y = 1;
		 if (is_closed)
		 	str_y = "-8";
		 else
			str_y = "-7";
		 }
   //if (!has_x && !has_width && !has_x) { has_x = 1; str_x = "1.5"; }
   if (!has_x && !has_width && !has_x) { has_x = 0; str_x = "0"; }
   if (!has_width && !has_w) { has_width = 1; width = "25"; }
   if (!has_height && !has_h) { has_height = 1; height = "15"; }
   }
   if (!is_closed) {
   	//begin_channel("text",-1,"",0);
   	begin_channel("image",nl,yytext,yyleng);
        //if (is_closed) end_channel("image");
   } else {
   if (has_id) out << "\nDEF " << id << " ";
   out << "ImageElement { ";
   if (has_src) {
       out << "url \"" << (char*) src << "\"  ";
       }
   if (has_size) { out << "size " << size << " "; }
   else {
        char xsize[512];
        sprintf(xsize,"%s %s 0.02",(char*)(has_w?str_w:width),
			           (char*)(has_h?str_h:height));
        out << "size " << xsize << " ";
	}
   print_attributes();
   out << lp(1);
   out << "}" << endl;
   in_line = 0;
   prline(yytext);
   out << (old?"line {":"\nTextElement {") << lp();
   }
   }
}
   
"</image>" {
//prend(yytext);
end_channel("image");
//if (in_display) { out << yytext; }
//else {
//check(yytext);
//}
}


"<object"{atts}"/"?">" {
if (in_display) { out << uq(yytext); }
else if (1) {
	begin_object("object",7,yytext,yyleng,this);
} else {
   ctx->push();
   in_object++;
   old_p = in_p;
   check(yytext);
   in_p = 0;
   yytext[yyleng-1] = '\0';
   check_context("object",7,yytext,yyleng);
   //out << "##nol++" << endl;
   out << endl;
   if (has_id) object_id = (char*) id;
   if (has_id) out << "\nDEF " << id << " ";
   out << (old?"object { ":"VrmlElement { ");
   print_attributes();
   out  << lp(1);
   in_line = 0;
   out << " children [ " << endl;
   if (has_type) { 
	has_object_type = 1;
	object_type = (char*) ntype;
	if (is_closed) {
		soobject(object_type,"",this);
		has_object_type = 0;
	} else {
		soobject(object_type,"_begin",this);
	}
   }
   if (has_src && pr) soinc((char*)src);
   if (is_closed) {
	out << "] } " << endl;
	in_line = 0; 
	// out << "##nol--" << endl;
	in_p = old_p;
	in_object--;
	ctx->pop();
        }
   }
}
   
"</object>" {
if (in_display) { out << yytext; }
else if (1) {
	end_object("object",this);
} else {
    if (has_object_type) {
	soobject((char*)object_type,"_end",this);
	}
has_object_type = 0;
out << "] } " << endl;
in_line = 0; 
// out << "##nol--" << endl;
in_p = old_p;
in_object--;
ctx->pop();
}
}

"#@" { out << yytext; }
\#\#\@.* { ; }
"<so "{names}">" { yytext[yyleng-1]='\0'; if (pr) files(yytext+4,ext); }
"<cd "{names}">" { yytext[yyleng-1]='\0'; if (pr) directories(yytext+4,ext); }
{prefix}"so "{names}/\n { if (pr) files(prefix(yytext,4),ext); }
{prefix}"vr "{names}/\n { if (pr) files(prefix(yytext,4),ext); }

{prefix}"include "{names}/\n { if (pr) files(prefix(yytext,9),""); }
{prefix}"load "{names}/\n {
	string x = prefix(yytext,7);
        load(x,this);
	}
{prefix}"proto "{names}/\n {
	string x = prefix(yytext,7);
        load(x,this);
	}
{prefix}"extern "{names}/\n {
	string x = prefix(yytext,7);
	load(x,this);
	}
{prefix}"xxxxrequire "{names}/\n {
	string x = prefix(yytext,8);
	load(x,this);
	}
{prefix}"require-load "{names}/\n {
	string x = prefix(yytext,13);
	load(x,this);
	}
{prefix}"require-proto "{names}/\n {
	string x = prefix(yytext,14);
	load(x,this);
	}
{prefix}"require-extern "{names}/\n {
	string x = prefix(yytext,15);
	load(x,this);
	}

{prefix}"script "{names}/\n { if (pr) files(prefix(yytext,8),""); }
{prefix}"old-group "{names}/\n { if (pr) files(prefix(yytext,7),""); }
{prefix}"route "{names}/\n { if (pr) files(prefix(yytext,7),""); }
{prefix}"object "{names}/\n { if (pr) files(prefix(yytext,8),""); }
{prefix}"template "{names}/\n { if (pr) files(prefix(yytext,10),""); }

{prefix}"slide "{names}/\n {
	if (0 && !bk_mode) { out << "Slide { scale SCALE\n children [ " << endl; }
	if (pr) files(prefix(yytext,7),"");
	if (0 && !bk_mode) { out << " ]}" << endl; }
	}
{prefix}"inline "{names}/\n {
	if (0 && !bk_mode) { out << "Slide { scale SCALE\n children [ " << endl; }
	out << "Inline { url [ " <<  prefix(yytext,8) << " ]}";
	if (0 && !bk_mode) out << " ]}" << endl;
	}
{prefix}"group "{names}/\n {
	out << "Group { children [ " <<  prefix(yytext,7) << " ]}";
	}
{prefix}"cd "{names}/(\n) { if (pr) directories(prefix(yytext,4),ext); }

"@"[a-zA-Z0-9\-\_]+ {
	//cerr << "FOUND " << yytext << " " << ::get_at(yytext) << endl;
	char* p = ::get_at(yytext);
	out << p;
	}

"<set "{atts}">" {
   yytext[yyleng-1] = '\0';
   if (0) {
   string_converter x(yytext+5);
   for (int i = 1; i <= x.argc(); i++ ) {
       cerr << "SET:" << x[i] << endl;
       attribute p(x[i]);
	set_at(p.key(),p.value());
	}
   } else {
	check_context("set",4,yytext,yyleng);
	}
}

"<include "{atts}">" {
   int choice = 0;
   yytext[yyleng-1] = '\0';
   string dir = "";
   string ext = "";
   string file = "@temp";
   string cmd = "";
   string_converter x(yytext+8);
   for (int i = 1; i <= x.argc(); i++ ) {
       //cerr << "ATTR:" << x[i] << endl;
       attribute p(x[i]);
           if ( p.matches("file") ) { 
			if ((choice !=3) && (choice!=2)) choice = 1;
			file = ::get_at(p.value());
			}
           if ( p.matches("src") ) { choice = 1; file = p.value(); }
           if ( p.matches("files") ) { choice = 1; file = p.value(); }
           if ( p.matches("dir") ) { choice = 2; dir = p.value(); }
           if ( p.matches("dirs") ) { choice = 2; dir = p.value(); }
           if ( p.matches("ext") ) { ext = p.value(); }
           if ( p.matches("cmd") ) { choice = 3; cmd = p.value(); }
           }
   if (choice == 0) file = yytext+9;
   if (choice == 2 && !strcmp(ext,"")) ext = ::ext;
   //cerr << "FILE:" << file << " EXT:" << (char*) ext << endl;
   if (choice==2) directories(dir,ext,file); 
   else if(choice==3) {
		char buf[BUFSIZ];
		sprintf(buf,"%s > %s",(char*)cmd,(char*)file);
		system(buf); 
		if (pr) files(file,"");
		}
   else if (pr) files(file,ext);
   }

[ ] { out << yytext; }
\t  { out << "        "; }
\n|\n[ ][ ]\n|\n[ ][ ]\n[ ][ ]\n|\n[ ][ ]\n[ ][ ]\n[ ][ ]\n { 
	in_field = 0;
	if ( 1 || in_channel > 0) { //AE
	int x = strlen(yytext);
	int n = 1;
        if (x == 4) n = 2;
	else if (x == 7) n = 3;
	else if (x == 10) n = 4;
	if (!in_line) out << endl;
	check("newline");
	if (do_pop) { font_pop(); do_pop=0; } 
	if (0 && in_li && !no_li) {
	out << " Nesting { nesting -" << f_size << lp(2) << " } ";
	in_li = 0;
	}
	if (in_p) {
		prline("newline -- in_p");
		if (in_link && old) out << "a";
		out << (old?"line {":"\nTextElement {") << lp(); 
	} else if (in_display) { 
		if (level_display && !empty_line) set_start("++"); // AE
		for (int i=1; i <= n; i++)
		vspace(atof(xsize(0.8)),"newline");
		prline("newline -- in_display");
		if (in_link && old) out << "a";
		out << (old?"line {":"\nTextElement {") << lp(); 
		}
	//in_li = in_line = 0;
	//out << endl;
	empty_line = 0;
	} else out << endl;
}
. { ECHO; }
%%
//@ main

static char _argv[24][256];

int main(int argc, char* argv[]) {
lex l;
no_auto = 0;
context0 = new context();
ctx = new context(context0);
list_level[0] = auto_level;
reset();
font_push();
//set("test","@proto/slide/objects/test.wrl");
//cerr << "TEST: " << get("@test") << endl;
colors["red"] = new string( "1 0 0");
colors["blue"] =  new string("0 0 1");
colors["yellow"] = new string( "1 1 0");
colors["orange"] = new string( "1 0.7 0");
colors["green"] = new string( "0 1 1");
colors["black"] = new string( "0 0 0");
colors["white"] = new string( "1 1 1");
colors["silver"] = new string( "0.8 0.8 0.8");
colors["gold"] = new string( "0.9 0.9 0");
//f_color="1 1 1";
//linkcolor="1 1 0";
//align = "BEGIN";
set_id = (char*) "SLIDESET";
strcpy(filename,"temp");
int _argc = 0;
argc--; argv++;
while ((argc > 0) && (argv[0][0] == '-')) {
	if ( argv[0][1] == 'N'  ) {
	     strcpy(filename,argv[0]+2);
	} else if ( argv[0][1] == 'e'  ) {
	     es_mode=1;
	} else if ( argv[0][1] == 'p'  ) {
	     pvl_mode=1;
	} else if ( argv[0][1] == 'o'  ) {
	     old=1;
	} else if ( argv[0][1] == 'b'  ) {
	     bk_mode = 1;
	} else if ( argv[0][1] == 'x'  ) {
	     x_mode = 1;
	} else if ( argv[0][1] == 'S'  ) {
	     no_style = 1;
	} else if ( ( argv[0][1] == 'I' ) || ( argv[0][1] == 'R' ) ) { 
		strcpy(_argv[_argc],argv[0]);
		//cerr << "Copied " << _argv[_argc] << endl;
		_argc++;
		}
	argc--; argv++;
	}
set_at("url","@eye.gif");
set_at("scene","@dlp.wrl");
set_at("display","-1");
set_at("show","-1");
set_at("alpha","0.5");
set_at("shape","0");

set_at("a","0");
set_at("file",filename);
set_at("filename",filename);
set_at("key","black");
set_at("style","style");
set_at("bgcolor","0 1 1");
set_at("logo","@vr");
set_at("decoration","0");
set_at("drop","0");
set_at("right","red");
set_at("left","cutie");
set_at("lefturl","[]");
set_at("righturl","[]");
set_at("r_bg","[]");
set_at("l_bg","[]");
set_at("r_bulb","0");
set_at("l_bulb","0");
set_at("r_persona","0");
set_at("l_persona","0");
set_at("r_visible","0");
set_at("l_visible","0");
set_at("r_color","1 0 0");
set_at("l_color","0 0 1");
set_at("r_text","1 1 1");
set_at("l_text","1 1 0");
set_at("r_a","0.3");
set_at("l_a","0.5");
set_at("r_p","0.5 0 0");
set_at("l_p","-0.5 0 0");
set_at("pos","0 0 0");
set_at("layer","0");
_loaded = new dictionary<string>;
l.paths(_argc, _argv);
pr = 1;
in_p = 0;
out << "#VRML V2.0 utf8                ##  " << name <<  endl; 
if (pvl_mode && !es_mode && !no_style) { 
  if (old) l.soinc("style.wrl"); 
  else {
	//out << "\n#@search @proto/pvl-2.0" << endl;
	}
  }
if (pvl_mode && !es_mode) {
  if (old) {
  out << "#@include SlideBegin.wrl" << endl;
  } else {
  //l.soinc("@vr/proto/slide.wrl");
  //l.soinc("@vr/proto/slide/pvl/begin.wrl");
  //l.soinc("@vr/proto/pvl.wrl");
  //l.soinc("@vr/proto/slide.wrl");
  }
}
if ( argc == 0 )  l(); 
else
	while (--argc > 0) 
		l.soinc( *++argv );
check("main");
if (pvl_mode && !es_mode) {
  if (old) {
  out << "#@include SlideEnd.wrl" << endl;
  } else {
  //l.soinc("@vr/proto/slide/pvl/end.wrl");
  }
  }
font_pop();
return 0;
}
//</>
