#include <hush/session.h>
#include <hush/grammar/ml/dlp/parser.h>
#include <hush/grammar/ml/dlp/lex.h>
#include <hush/grammar/ml/dlp/yacc.h>
#include <iostream.h>

int dlp_parser::initialized = 0;

int dlp_parser::initialize() {
if (!dlp_parser::initialized) {
	dlp_parser::initialized = 1;
	parser* x = new dlp_parser();
	if (session::_default)
		session::_default->_register(x);
	parser::declare("dlp",x);
	cerr << "dlp_parser initialized" << endl;
	}
return parser::initialized;
}

//@class parser

dlp_parser::dlp_parser() {
	_scanner = 0;
	_parser = 0;
	}

dlp_parser::dlp_parser(istream* in, ostream* out) {
	_scanner = new dlp_lex(in,out); 
	_parser =  new dlp_yacc(_scanner);
	_init();
}

dlp_parser::~dlp_parser() {
	if (_scanner) delete _scanner;
	if (_parser) delete _parser;
	}

void dlp_parser::init(istream* in, ostream* out) {
	_scanner = new dlp_lex(in,out); 
	_parser =  new dlp_yacc(_scanner);
	_init();
}

//@ create

parser* dlp_parser::create(istream* in, ostream* out) {
	return new dlp_parser(in, out);
	}

//@ operator()

term* dlp_parser::operator()() {
	//cerr << "dlp_parser::()" << endl;
	return (*_parser)();
	}

//@method  _init

void dlp_parser::_init() {
	
	//cerr << "dlp_parser::init" << endl;

        op("<-");

	right("is");
	right(":=");

	pre("new");

	specifier("class");
	specifier("object");
	declarative("var","var");
	declarative("proc","proc");
	command(":-");
	end("end");
	}

//</>
