#include <hush/session.h>
#include <hush/grammar/ml/vr/parser.h>
#include <hush/grammar/ml/vr/lex.h>
#include <hush/grammar/ml/vr/yacc.h>
#include <iostream.h>

int vr_parser::initialized = 0;

int vr_parser::initialize() {
if (!vr_parser::initialized) {
	vr_parser::initialized = 1;
	parser* x = new vr_parser();
	if (session::_default)
		session::_default->_register(x);
	parser::declare("vr",x);
	cerr << "vr_parser initialized" << endl;
	}
return parser::initialized;
}

//@class parser

vr_parser::vr_parser() {
	_scanner = 0;
	_parser = 0;
	}

vr_parser::vr_parser(istream* in, ostream* out) {
	_scanner = new vr_lex(in,out); 
	_parser =  new vr_yacc(_scanner);
	_init();
}

vr_parser::~vr_parser() {
	if (_scanner) delete _scanner;
	if (_parser) delete _parser;
	}

void vr_parser::init(istream* in, ostream* out) {
	_scanner = new vr_lex(in,out); 
	_parser =  new vr_yacc(_scanner);
	_init();
}

//@ create

parser* vr_parser::create(istream* in, ostream* out) {
	return new vr_parser(in, out);
	}

//@ operator()

term* vr_parser::operator()() {
	//cerr << "vr_parser::()" << endl;
	return (*_parser)();
	}

//@method  _init

void vr_parser::_init() {
	
	//cerr << "vr_parser::init" << endl;

        op("<-");

	right("is");
	right(":=");

	pre("new");

	specifier("class");
	specifier("object");
	declarative("var","var");
	declarative("proc","proc");
	command(":-");
	end("end");
	}

//</>
