#!/bin/sh
export PATH; PATH="@BIN":$PATH

##@ functions
source=@BIN/source
self=@BIN/bar
listing="@BIN/selector -mode echo -bar -loc -menu "
lslisting="@BIN/selector -mode ls -bar -loc -menu "
html="@BIN/ht-ml - -notitle"
ls=@BIN/files

barring=false
indexing=""

##@ variables

doc=false
flat=false
level=3
nobar=false
index=false
menu=false
loc=false

category=""

top="@online"

topic="Select:"
subject=""
filename="xxx"

##@ options

while [ $# -ge 1 ]; do case $1 in
	-barring) barring=true;;
	-index) barring=true; index="true"; indexing="-index";;
	-bar)
		$self -flat -barring $indexing $category -doc $doc > @bar-index;
		exit;;
	-category) if [ "-$2" = "-oo" ]; then
			doc=true;
			fi;
			category="-category $2"; shift;;
	-doc) doc=$2; shift;;
	-top) top=$2; shift;;
	-flat) flat=true;;
	-level) level=$2; shift;;
	-loc)   loc=true;;
	-menu|-topic)  menu=true; topic="$2"; shift;;
	-filename|-file) filename="$2"; shift;;
	-subject) subject="$2"; shift;;
        *)  break;;
        esac;
        shift;
done;

##if [ "$category" = "-category oo" ]; then doc=true; fi;

##echo "$category  xx $doc" > @cerr

##@ check and file

if [ "$barring" = "false" ]; then

if [ ! -f @bar-index ]; then $self -bar $indexing -doc $doc $category ; fi;

else

#echo OK0

idx=@index-contents
idm=@index-make
idt=@index-text
ida=@index-auxiliary
idi=@index-interface
idh=@index-include
idc=@index-source
idj=@index-java
idz=@index-dlp
idscripts=@index-scripts
idsg=@index-grammar
idht=@index-htm
idg=@index-configure
idp=@index-package
iddots=@index-graphs
idmx=@index-mx
idmidi=@index-midi
idslides=@index-slides
idtalks=@index-talks
idscenes=@index-scenes
idworlds=@index-worlds
idreports=@index-reports
idprojects=@index-projects

fi;

##@ do the barring

if [ "$barring" = "true" -o "$index" = "true" ]; then

P="";A="";M="";I="";H="";C="";R="";SCRIPTS="";G=""; T=""; X="";
J="";Z="";
CC=""; JJ=""; II=""; MX="";
SG=""; HT=""; DOTS=""; MIDI="";
SLIDES=""; TALKS=""; WORLDS=""; REPORTS=""; PROJECTS="";

	D=`$ls @idl-INDEX.ht`
	CC=`ls @h-INDEX.ht`
	JJ=`ls @java-INDEX.ht`
	II=`ls @idl-INDEX.ht`
	R=`$ls README`
	T=`$ls *.t *.txt`
	M=`$ls Makefile *.mk`
	I=`$ls *.idl`
	H=`$ls *.h *.hh`
	A=`$ls *.i`
	Z=`$ls *.dlp *.pl *.tp *.th *.cl *.clips`
	J=`$ls *.java`
	C=`$ls *.c *.sc *.cc *.cpp *.java`
	SCRIPTS=`$ls *.tcl *.py *.sh *.lr *.mod`
	SG=`$ls *.l *.y`
	HT=`$ls *.htm`
	MX=`$ls *.mx`
	G=`$ls *.in *.cfg *.ami`
	P=`$ls module`
	DOTS=`ls *.dot`
	#X=`@BIN/subdirs`
	#X="$X `@BIN/updirs`"
	X="*"
	#C="$C $J"
	MIDI="`ls *.ly *.mid`";
	SLIDES="`ls @slide-*.html`";
	SCENES="`ls @scene-*.wrl`";
	#SLIDES="`find . -name '@slide-*.html'`";
	TALKS="`ls @talk-*.html`";
	#TALKS="`find . -name '@talk-*.html'`";
	WORLDS=`ls *.vr *.wrl`;
	REPORTS="`ls template-* @report-*.html`";
	PROJECTS="`ls project-* @project-*.html`";

fi;
#echo OK2

##echo "<!-- $CC  $JJ ${CC} -->"

##@ create indexes (mode -index)

if [ "$index" = "true" ]; then
	
   if [ -n "$A" ]; then  $listing auxiliary $A > $ida; fi;
   if [ -n "$T" ]; then  $listing text $T > $idt; fi;
   if [ -n "$X" ]; then  $lslisting contents > $idx; fi;
   if [ -n "$M" ]; then  $listing make $M > $idm; fi;
   if [ -n "$I" ]; then  $listing interface $I > $idi; fi;
   if [ -n "$H" ]; then  $listing include $H > $idh; fi;
   if [ -n "$C" ]; then  $listing source $C > $idc; fi;
   #if [ -n "$J" ]; then  $listing java $J > $idj; fi;
   if [ -n "$Z" ]; then  $listing logic $Z > $idz; fi;
   if [ -n "$SG" ]; then  $listing grammar $SG > $idsg; fi;
   if [ -n "$HT" ]; then  $listing html $HT > $idht; fi;
   if [ -n "$SCRIPTS" ]; then  $listing scripts $SCRIPTS > $idscripts; fi;
   if [ -n "$G" ]; then  $listing configure $G > $idg; fi;
   if [ -n "$DOTS" ]; then  $listing graphs $DOTS > $iddots; fi;
   if [ -n "$MX" ]; then  $listing mx $MX > $idmx; fi;
   if [ -n "$MIDI" ]; then  $listing midi $MIDI > $idmidi; fi;
   if [ -n "-$SLIDES" ]; then  $listing slides -mode slide  > $idslides; fi;
   if [ -n "-$TALKS" ]; then  $listing talks -mode talk  > $idtalks; fi;
   if [ -n "-$SCENES" ]; then  $listing scenes -mode scene  > $idscenes; fi;
   if [ -n "$WORLDS" ]; then  $listing worlds $WORLDS > $idworlds; fi;
   if [ -n "$REPORTS" ]; then  $listing reports -mode report $REPORTS > $idreports; fi;
   if [ -n "$PROJECTS" ]; then  $listing projects -mode project $PROJECTS > $idprojects; fi;


##@ process index files

id=" $idx $idt $ida $idm $idi $idh $idc $idj $idz $idscripts $idsg $idht $idg $iddots $idmx $idmidi $idslides $idscenes $idtalks $idworlds $idreports $idprojects"; 

   if [ -n "$id" ]; then
   	for i in $id; do
		if [ -f $i ]; then
			$html -sort index $category $i > $i.html;
			rm $i;
			fi;
		done
	fi;

fi;

#echo OK1
##@ logo

S=`@BIN/suffix $filename`;
B=`basename $filename $S`;
if [ "$S" = ".t" ]; then file=$B; 
else
	file=$filename;
fi;
case $S in
	.dummy)
	thesubject=$subject;;
	"*")
thesubject="<a href=@talk-$file.html target=_top><font color=red>$subject</font></a>";;
	esac;

thesubject="<a href=@talk-$file.html target=_top><font color=red>$subject</font></a>";

fm=h$level;
if [ "$loc" = "true" ]; then 
  logo="<i>$topic</i>: <tt>$thesubject  </tt> <i>`$source`</i>";
else
  logo="<b><i>$topic</i>:</b> <tt> $thesubject</tt>";
fi

if [ "$menu" = "true" ]; then
   if [ "$flat" = "true" ]; then echo "<p>$logo";
   else
       echo "<$fm>$logo</$fm>";
   fi;
fi;

if [ "$flat" != "true" -a "$index" = "false" ]; then echo "<hr>"; fi;

##@ the index bar

if [ "$barring" = "false" ]; then

   echo "<include file=this> - "
   #echo "<a href=\"index.html\" target=_top>[.]</a>"; 
   echo "[<a href=\"../index.html\" target=_top>up</a>]";
   echo "[<a href=\"$top/index.html\" target=_top>top</a>] - ";
   cat @bar-index

elif [ "$index" = "false" ]; then


if [ "-$doc" = "-false" ]; then
if [ -n "$X" ]; then echo "<a href=\"$idx.html\" target=_top>index</a>"; fi;
fi;

if [ -n "$R" ]; then echo "<a href=\"README.html\">README</a>"; fi;

if [ "-$doc" = "-false" ]; then
if [ -n "$II" ]; then echo "<a href=\"@idl-INDEX.html\">IDL</a>"; fi;
if [ -n "$JJ" ]; then echo "<a href=\"@java-INDEX.html\">Java</a>"; fi;
if [ -n "$CC" ]; then echo "<a href=\"@h-INDEX.html\">C++</a>"; fi;
if [ -n "$T" ]; then echo "<a href=\"$idt.html\">text</a>"; fi;

if [ -n "$M" ]; then echo "<a href=\"$idm.html\">make</a>"; fi;

fi;
if [ -n "$I" ]; then echo "<a href=\"$idi.html\">interface</a>"; fi;
if [ -n "$H" ]; then echo "<a href=\"$idh.html\">include</a>"; fi;
if [ -n "$C" ]; then echo "<a href=\"$idc.html\">source</a>"; fi;
if [ -n "$Z" ]; then echo "<a href=\"$idz.html\">logic</a>"; fi;
if [ -n "$SG" ]; then echo "<a href=\"$idsg.html\">grammar</a>"; fi;
if [ -n "$A" ]; then echo "<a href=\"$ida.html\">auxiliary</a>"; fi;
if [ "-$doc" = "-false" ]; then
if [ -n "$SCRIPTS" ]; then echo "<a href=\"$idscripts.html\">scripts</a>"; fi;
if [ -n "$HT" ]; then echo "<a href=\"$idht.html\">html</a>"; fi;
if [ -n "$G" ]; then echo "<a href=\"$idg.html\">configure</a>"; fi;
fi;
if [ -n "$DOTS" ]; then echo "<a href=\"$iddots.html\">graphs</a>"; fi;
if [ -n "$MX" ]; then echo "<a href=\"$idmx.html\">mx</a>"; fi;
if [ -n "$MIDI" ]; then echo "<a href=\"$idmidi.html\">midi</a>"; fi;
if [ -n "-$SLIDES" ]; then echo "<a href=\"$idslides.html\" target=_top>slides</a>"; fi;
if [ -n "-$TALKS" ]; then echo "<a href=\"$idtalks.html\" target=_top>talks</a>"; fi;
if [ -n "-$SCENES" ]; then echo "<a href=\"$idscenes.html\" target=_top>scenes</a>"; fi;
if [ -n "$WORLDS" ]; then echo "<a href=\"$idworlds.html\">worlds</a>"; fi;
if [ -n "$REPORTS" ]; then echo "<a href=\"$idreports.html\" target=_top>reports</a>"; fi;
if [ -n "$PROJECTS" ]; then echo "<a href=\"$idprojects.html\" target=_top>projects</a>"; fi;

fi;

if [ "$flat" != "true" -a "$index" = "false" ]; then echo "<hr>"; fi;
##</>
