#!/bin/sh

##@ finder

cmd="find"
dir="."
exclude="-a ! -name '@*'"
transform="s:\./::g"
sel=false
html="-"
at="-"
args=""
tr=""
all=false
omitd="dummy"
omitf="dummy"

##@ options

while [ $# -ge 1 ]; do
	case $1 in
	-type) args="$args -type $2"; shift;;
	-html) html="+"; args=$2; exclude="";sel=script-html; shift;;
	-at|-@) at="+"; html="+"; exclude="";
		sel="script-at"; args=$2;
		if [ $# -ge 2 ]; then shift; fi;;
	-dir) dir=$2; shift;;
	-ls)  cmd="ls"; sel=$cmd;;
	-cmd) cmd=$2; sel=$cmd; shift;;
	-sel|-script) sel=$2; shift;;
	-tr) tr="$tr $2"; shift;;
	-all) all=true;;
	-f)  omitf="$2"; shift;;
	-d)  omitd="$2"; shift;;
	*) break;;
	esac;
     shift;
     done

##@ process

args="$args $*"
opts="$dir $args $exclude" 
#X=`find $* -a ! -name '@*' | sed -e "s:\./::g"`
if [ "$sel" = "false" ]; then
	sel="$cmd $opts $exclude"
	fi;
#echo "$sel $args"
X=`$sel $args | sed -e $transform`
#echo $X
D=""
F=""

##@ filter

if [ -n "$X" ]; then
	for x in $X; do
	  #echo "testing $x"
	  if [ -d $x ]; then
	     case $x in
	       .) ;;
	       $omitd);;
	       *tmp*|*old*|*keep*|*bak*|*store*) ;;
	       *base*|*figures*|*bitmaps*|*images*|*screens*|*scripts*|*local*);;
	       *help*|*bin*|*doc*|*source*|*share*) ;;
	       *skel*|*inputs*|*adm*|*phrase*|*archive*|*reposit*);;
	       *Templates.DB) ;;
	       *@*);;
	       *st-*|*old-*|*new-*) ;;
	       *) D="$D $x";;
	     esac;
	  elif [ -f $x ]; then
	     case $x in
	       tmp-*|old-*|st-*) ;;
	       navigate|txt|this|guide|list|show|slides|talk|chapter);;
	       index|contents|header|footer);;
	       *[0-9][0-9]+*);;
	       *-ch-[0-9]*);;
	       *-txt*);;
	       *cfg-in*|*cfg-mk*);;
	       *guide*);;
	       *@agent*);;
	       *hush-agent*);;
	       *core|*.o|*.out);;
	       *.index-list);;
	       *.bak);;
	       *etc|*title|*body|*map|*doc|*cover);;
	       *.A|*.ii|*.db|*.DB);;
	       *keep*);;
	       *st-*);;
	       *.l.c|*.y.c|*.flt);;
	       *.srv.[ch]|*.clt.[ch]|*.srv|*.clt);;
	       *.d|*.lr.c);;
	       *.lst);;
	       *.out);;
	       *.gif|*.db) ;;
	       *.class) ;;
	       *.ht) ;;
	       *.js|*.css) F="$F $x";;
	       *.sgml.in|*.dtd.in|*.style.in) F="$F $x";;
	       *.dot|*.ami|*.cfg|*.in|*.mk|Makefile|mkfile)
		      if [ "$cmd" = "echo" ]; then F="$F $x"; fi;;
	       *.txt) if [ "$cmd" = "echo" ]; then F="$F $x"; fi;;
	       README) if [ "$cmd" = "echo" ]; then F="$F $x"; fi;;
	       *.mx|*.sh) if [ "$cmd" = "echo" ]; then F="$F $x"; fi;;
	       *.htm) if [ "$cmd" = "echo" ]; then F="$F $x"; fi;;
	       *.tex|*.dvi|*.ps|*.aux|*.log|*.idx) ;;
	       *.wrl|*.html) if [ "$html" = "+" -o "$cmd" = "echo" ]; then F="$F $x"; fi;;
	       @*);;
	       *@talk-body*|*@talk-lit*|@talk-title*|@talk-refs*);;
	       *@slide-@index*);;
	       *@slide-Make*);;
	       *@slide-Text*);;
	       *@slide-Auxiliary*);;
	       *@slide-Includes*);;
	       *@slide-ctx*);;
	       *@dummy*);;
	       @dummy.txt*);;
	       @*) if [ "$at" = "+" ]; then F="$F $x"; fi;;
	       sli-*);;
	       st-*|old-*|new-*) ;;
	       *) F="$F $x";;
	     esac;
	  elif [ "$cmd" = "echo" ]; then
	       F="$F $x";
	  fi;
	done
fi;

##@ create menu

L="$F $D"
#echo "$L"
if [ -n "$L" ]; then
 echo "<ul>"
 if [ -n "$D" ]; then
 for i in $D; do echo "<li> <a href=$i/index.html>$i</a>"; done
 fi;
 if [ -n "$F" ]; then
 for i in $F; do
	f=$i.html; n=$i;
	T=`@BIN/suffix $i`
	B=`basename $i $T`
	print=false;
	case $T in
	  .mid) f=$i; n=$B;;
	  .html) f=$i; n=$B;;
	  .wrl)  f=$i; n=$B;;
	  .htm) f=$i; n=$B;;
	  .ht  ) f=${i}ml; n=$B;;
	  .t ) f=$B.html; n=$B;;
	  .[1-9n]) f=$B.html; n=$B;;
	  .dot)
		#echo "dot $i";
		print=true; 
		tr="$tr s:@ciao-::g s:\.dot::"; print=true;;
	esac;
	case $B in
	  *@h-) ;;
	  $omitd) ;;
	  $omitf) ;;
	  *Make-[0-9]+*) ;;
	  @dummy);;
	  @slide-ctx);;
	  @slide-Make*);;
	  @slide-Text*);;
	  sli-*) ;;
	  @*) if [ "$at" = "+" ]; then print=true; fi ;;
	  *) print=true ;;
	esac;
	if [ "$print" = "true" ]; then
	prefix="`@BIN/dirof $i`/";
	if [ "$prefix" = "./" ]; then prefix=""; fi;
	if [ ! -f $i -a ! -d $i -a "$cmd" = "echo" ]; then
	   n=$i; f="$i/index.html"; prefix="";
	fi
	if [ -n "$tr" ]; then
		for t in $tr; do
			n=`echo $n | sed -e $t`;
			if [ "$all" = "true" ]; then
				f=`echo $f | sed -e $t`;
			fi;
		done;
		fi 
		#echo $tr
		#echo $n
	case $prefix in
	 *figures|*help);;
	 *) echo "<li> <a href=$f>$prefix$n</a>";;
	 esac;
	fi;
      done
 fi;
 echo "</ul>"
fi;

##</>
