#!/bin/sh
##@ ht-ml

export PATH; PATH="@BIN":$PATH
##CFG=" -I@HUSH -I@HUSH/cfg -I@HUSH/doc/@share -I@HUSH/doc/@share/inputs"
CFG=""
INC="-I. -Iinputs -I../inputs -I.. -I../../inputs -I../.. \
     -I../../../inputs -I../../.. -I../../../../inputs -I../../../.. \
	  -I../../../../../inputs -I../../../../.. \
	  -I@base -I@inputs" 

all=false;
warnings=

header=@BIN/header
footer=@BIN/footer
source=@BIN/source
location=@BIN/location

bar="@BIN/bar -loc"

menu="@BIN/selector -mode ls -bar -loc"
dirmenu=@BIN/dir-menu
listing="@BIN/selector -mode ls -bar -loc"

##@ variables

htflags=
category=""
name="anonymous"
lang=""
topic=unknown
level=source
logo=
nologo=false
make=make
loc=false
nobar=false
nomake=true
tell=silent
title=false
notitle=false
index=false
idx=false
top=false;
self=@BIN/ht-ml
root=@DOC
kind=text
sort=unknown
auto="+"
type=t
mk=null
src=$root/sources
inc=$root/sources
man=$root/manuals
idl=$root/idl
lib=$root/library
ml=""

usrinc=""

doc=$root/doc

#echo "OK-1"

##@ options

while [ $# -ge 1 ]; do case $1 in
	-) all=true;;
	-category) category=" -category $2"; shift;;
	-tk|-bk|-oo|-dv|-dlp) category="$1";;
	-inline|-vr|-both) htflags="$htflags $1";;
	-cc|-mk) type=cc; sort=program; level=source;;
	-warnings) warnings="-warnings";;
	-I*) usrinc="$usrinc $1";;
	-man) type=man; level=manpage;;
	-top) top=true;;
	-t)  type=t;;
	-txt) type=txt;;
	-nomake) nomake = true;;
	-m) mode=$2; shift;;
	-l) level=$2; shift;;
        -s) source=$2; shift;;
	-ml) ml="-ml";;
	-menu) menu=$2; shift;;
	-sort) sort=$2; shift;;
	-put)
		dest=$2 shift;shift;
		cp $* $dest;
		;;
	-notitle) notitle=true;;
	-nobar) nobar=true;;
	-title) title=true;;
	-header) header=$2; shift;;
	-footer) footer=$2; shift;;
	-logo) logo=$2; nologo=true; shift;;
	-loc) loc=true;;
	-location) location=$2; shift;;
	-source) source=$2; shift;;
	-make) make=$2; shift;;
	-ls) type=ls-menu;;
	-index) idx=true; index=true;;
	-idx)   idx=true;;
	-name) name=$2; shift;;
        *)  break;;
        esac;
        shift;
done;

#echo OK0

##@ process

#for K do 
K="$1";
filename=$K

if [ -n "$K" ]; then
if [ "$K" = index ]; then index=true; fi;
fi; 

if [ "$all" = "false" ]; then
   nobar=true
   top=true
   noindex=true
   notitle=true
fi;

E=`@BIN/suffix $K`
B=`basename $E`

#echo "$B $E"

tmp=@tmp-$B-$$-1
contents=@tmp-$B-$$-2
result=@tmp-$B-$$-3
	


#echo OK1

##@ select sort

case $sort in
	chapter)   fm=h1; topic=chapter;;
	package)   fm=h2; topic=package;;
	program)   fm=h3; topic=source;;
	example)   fm=h3; topic=example;;
	library)   fm=h3; topic=library;;
	include)   fm=h3; topic=include;;
	index)   fm=h3; topic=index;;
	idl)   fm=h3; topic=IDL;;
	java)   fm=h3; topic=java;;
	cc)   fm=h3; topic=C++;;
	dot) fm=h3; title=true; topic=graph;;
	manpage) notitle=true; type=man;  fm=h4; topic=manual;;
	      *) type=t;  fm=h3; ;;
esac;

##@ check suffix

if [ "$sort" = "unknown" ]; then
case $E in
	index) type=t; fm=h3; topic=File;;
	.t|.ht) title=true; type=t; fm=h3; topic=text;;
	module) type=module; title=true; fm=h3; topic=file;;
	contents) # nobar=true;
		  level=source; type=t; fm=h4; topic=file;;
	.txt|README) title=true; level=source; type=txt; fm=h4; topic=file;;
	enjoy) title=false;;
esac;
fi;

case $E in

	.c|.cc|.i|.cpp) lang="-c"; type=cc;
		       title=true;
		       level=source; fm=h3; topic=source;;
	.l) 
		lang="-l";
		if [ ! $type = man ]; then
		type=cc; title=true; level=source; fm=h3; topic=scanner;
		fi;;
	.y) lang="-y"; type=cc; title=true; level=source; fm=h3; topic=parser;;
	.h) lang="-h"; type=cc; title=true; level=source; fm=h3; topic=include;;
	.idl) lang="-idl"; type=cc; title=true; level=source; fm=h3; topic=interface;;
	.tcl|.py|.sh|.mod|.lr) lang="-tcl"; type=cc; title=true; level=source; fm=h3; topic=script;;
	.java) lang="-java"; type=cc; title=true; level=source; fm=h3; topic=source;;
	.dlp|.pl) lang="-pl"; type=cc; title=true; level=source; fm=h3; topic=logic;;
	.mk|Makefile) 
		 lang="-mk"; type=cc;
		       title=true;
		       level=source; fm=h3; topic=make;;
	.ami|.cfg|.in) 
		 lang="-mk"; type=cc;
		       title=true;
		       level=source; fm=h3; topic=configure;;
	.1|.2|.3|.4|.5|.6|.7|.8|.9|.n)
	 type=man; title=false; sort=manpage;;
	 *) ;; # type=man; sort=manpage;;
esac;

##@ create bar
	
if [ "$notitle" = "true" ]; then title=false; fi;

if [ "$name" != "anonymous" -a \( "$sort" = "index" -o "$loc" = "true" \) ]; then
 K=$name
fi;

if [ -n "$K" ]; then
	K=`echo $K | sed -e "s:@java-::g" \
		         -e "s:@ciao-::g" \
		         -e "s:\.dot\.bak::g" \
		         -e "s:@h-::g" \
			 -e "s:@idl-::g" \
			 -e "s:\.t::g" \
			 -e "s:\.ht::g"`;
fi;

fm=h3;
logo="<$fm><i>$topic</i>: <tt>$K</tt> <i>`$source`</i></$fm>" 


echo "" > $tmp;
if [ $title = true ]; then
$bar -topic $topic -subject $K -file $filename > $tmp;
fi;

if [ "$loc" = "true" ]; then echo $logo >> $tmp; fi;

cat $* > $contents

if [ $sort = "program" ]; then echo "</program>" >> $tmp; fi;

result=@tmp-result$$
pre=@tmp-pre$$
post=@tmp-post$$

echo "" > $pre
if [ $all = true ]; then $header$category >> $pre; fi;
cat $tmp >> $pre;

##@ create document

case $type in
	man) cat $contents | @FLT/man-t.flt > $result;;
	cc|mk) cat $contents | @FLT/cc-t.flt $auto $lang > $result;;
	txt)
		#echo "<document><display>" > $result;
		cat $contents | @FLT/txt-t.flt > $result;
		#echo "</display></document>" >> $result;
		echo " " >> $result;;

	modul*) cat $contents | @FLT/ht-ml.flt | \
		@FLT/demod.flt > $result;;
	*) echo "ERROR $K $type" > /tmp/error.log;
	   mv $contents  $result;;
      esac;

echo "" > $post;
if [ $all = true ]; then $footer$category >> $post; fi;

cat $pre $result $post | @FLT/ht-ml.flt $warnings $ml -N$name $usrinc $INC $CFG $htflags
rm -f $tmp $pre $post $contents $result

##</>
