#!/bin/sh
##@ slush-doc

up=""
level="-"
hushlevel=""
cmd=@BIN/find-doc
levelof=@BIN/levelof
files=""
filter=false

##@ options

while [ $# -ge 1 ]; do case $1 in
	-level) level=$2; shift;;
	-up) up=$2; shift;;
	-filter) filter=true; level=$2; shift;;
	-hushlevel) hushlevel=$2; shift;;
	-) filter=true;;
	*) files="$files $1";;
	esac;
	shift;
done

args=
if [ "-$files-" != "--" ]; then
	args="$files";
elif [ "$filter" = "false" ]; then 
	args=`$cmd`;
fi;

if [ "$level" = "-" ]; then level=""; fi;

for i in $args; do
	l=$level`$levelof $i`;
	mv $i $i.bak;
	echo "Changing $i with $l";
	cat $i.bak | \
		sed \
		     -e "s?@HUSH/include/??g"  \
		     -e "s?@ONLINE/?${l}?g" \
		     -e "s?@online/?${l}?g" \
		     -e "s?@hush/?${l}/hush?g" \
		     -e "s?@share/?${l}@share/?g" \
		     -e "s?@base/?${l}@share/base/?g" \
		     -e "s?@idl/?${l}@share/idl/?g" \
		     -e "s?@places/?${l}@share/places/?g" \
		     -e "s?@archive/?${l}@share/archive/?g" \
		     -e "s?@documents/?${l}@share/documents/?g" \
		     -e "s?@kanji/?${l}@share/kanji/?g" \
		     -e "s?@programs/?${l}@share/programs/?g" \
		     -e "s?@applets?${l}@share/applets?g" \
		     -e "s?@images/?${l}@share/images/?g" \
		     -e "s?@icons/?${l}@share/icons/?g" \
		     -e "s?@figures/?${l}@share/figures/?g" \
		     -e "s?@guide/?${l}@share/guide/?g" \
		     -e "s?@screens/?${l}@share/screens/?g" \
		     -e "s?@scripts/?${l}@share/scripts/?g" \
		     -e "s?@input/?${l}@share/input/?g" \
		     -e "s?@audio/?${l}@share/audio/?g" \
		     -e "s?@vrml/?${l}@share/vrml/?g" \
		     -e "s?@proto/?${l}@share/proto/?g" \
		     -e "s?@vr/?${l}@share/vr/?g" \
		     -e "s?@worlds/?${l}@share/worlds/?g" \
		     -e "s?@music/?${l}@share/music/?g" \
		     -e "s?@sound/?${l}@share/sound/?g" \
		     -e "s?@movies/?${l}@share/movies/?g" \
		     -e "s?@fotos/?${l}@share/fotos/?g" \
		     -e "s?@frames/?${l}@share/frames/?g" \
		     -e "s?@slides/?${l}@share/slides/?g" \
		     -e "s?@scenes/?${l}@share/scenes/?g" \
		     -e "s?@extern/?${l}@share/extern/?g" \
		     -e "s?@fonts/?${l}@share/fonts/?g" \
		     -e "s?@archive/?${l}@share/archive/?g" \
		     -e "s?@textures/?${l}@share/textures/?g" \
		     -e "s?@local/?${l}@share/local/?g" \
		     -e "s?@text/?${l}@share/text/?g" \
		     -e "s?@cam/?${l}@share/cam/?g" \
		     -e "s?/home/eliens/dv/online/?$l?g" \
		     -e "s?/export/home/eliens/dv/online/?$l?g" \
		     -e "s?file:@DOC/?${l}hush/?g"  \
		     -e "s?\.mk\.html?-mk.html?g" \
		     -e "s?\.mk\.js?-mk.js?g" \
		     -e "s?\.in\.html?-in.html?g" \
		     -e "s?\.in\.js?-in.js?g" \
		     -e "s?\.cfg\.html?-cfg.html?g" \
		     -e "s?\.cfg\.js?-cfg.js?g" \
		     -e "s?\.sh\.html?-sh.html?g" \
		     -e "s?\.sh\.js?-sh.js?g" \
		     -e "s?\.js\.html?-js.html?g" \
		     -e "s?\.js\.js?-js.js?g" \
		     -e "s?\.h\.html?-h.html?g" \
		     -e "s?\.h\.js?-h.js?g" \
		     -e "s?\.c\.html?-c.html?g" \
		     -e "s?\.c\.js?-c.js?g" \
		     -e "s?\.sc\.html?-sc.html?g" \
		     -e "s?\.sc\.js?-sc.js?g" \
		     -e "s?\.i\.html?-i.html?g" \
		     -e "s?\.i\.js?-i.js?g" \
		     -e "s?\.mx\.html?-mx.html?g" \
		     -e "s?\.mx\.js?-mx.js?g" \
		     -e "s?\.tm\.html?-tm.html?g" \
		     -e "s?\.es\.wrl?-es.wrl?g" \
		     -e "s?\.pvl\.wrl?-pvl.wrl?g" \
		     -e "s?\.java\.html?-java.html?g" \
		     -e "s?\.java\.js?-java.js?g" \
		     -e "s?\.idl\.html?-java.idl?g" \
		     -e "s?\.idl\.js?-idl.js?g" \
		     -e "s?\.wrl\.html?-java.idl?g" \
		     -e "s?\.wrl\.js?-wrl.js?g" \
		     -e "s?\.pl\.html?-pl.html?g" \
		     -e "s?\.pl\.js?-pl.js?g" \
		     -e "s?\.dlp\.html?-dlp.html?g" \
		     -e "s?\.dlp\.js?-dlp.js?g" \
		     -e "s?\.doc\.html?-doc.html?g" \
		     -e "s?\.doc\.js?-doc.js?g" \
		     -e "s?\.txt\.html?-txt.html?g" \
		     -e "s?\.txt\.js?-txt.js?g" \
		     -e "s?\.idl\.html?-idl.html?g" \
		     -e "s?\.idl\.js?-idl.js?g" \
		     -e "s?\.l\.html?-l.html?g" \
		     -e "s?\.l\.js?-l.js?g" \
		     -e "s?\.y\.html?-y.html?g" \
		     -e "s?\.y\.js?-y.js?g" \
		     -e "s?\.tcl\.html?-tcl.html?g" \
		     -e "s?\.tcl\.js?-tcl.js?g" \
		     -e "s?\.lr\.html?-lr.html?g" \
		     -e "s?\.lr\.js?-lr.js?g" \
		     -e "s?\.mod\.html?-mod.html?g" \
		     -e "s?\.mod\.js?-mod.js?g" \
		     -e "s?\.ami\.html?-ami.html?g" \
		     -e "s?\.ami\.js?-ami.js?g" \
		     -e "s?\.py\.html?-py.html?g" \
		     -e "s?\.py\.js?-py.js?g" \
		     -e "s?\.wrl\.html?-wrl.html?g" \
		     -e "s?\.wrl\.js?-wrl.js?g" \
		     -e "s?\.vr\.wrl\.html?vr-wrl.html?g" \
		     -e "s?\.vr\.wrl\.js?vr-wrl.js?g" \
		     -e "s?\.vr\.html?-vr.html?g" \
		     -e "s?\.vr\.js?-vr.js?g" \
		     -e "s?\.world\.html?-vr.html?g" \
		     -e "s?\.world\.js?-vr.js?g" \
		     -e "s?\.css\.html?-css.html?g" \
		     -e "s?\.css\.js?-css.js?g" \
		     -e "s?\.ly\.html?-ly.html?g" \
		     -e "s?\.ly\.js?-ly.js?g" \
		     -e "s:@DOC/:${l}${hushlevel}:g"  \
			> $i;
	rm -f $i.bak
	done;

##</>
